--- 游戏状态脚本
--- 识别背包
--local BACKPACK_RECOGNIZE_INFO = { path = "img/commonstate/refer_backpack.png", rect = { flag = Anchor().BOTTOMLEFT, left = 53, top = -121, width = 50, height = 62 }, threshold = 90};

--- 识别右侧枪支按钮
local GUN_RIGHT_RECOGNIZE_INFO = { path = "img/commonstate/refer_gun_right.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -334, top = -318, width = 110, height = 110 }, threshold = 90 };
--- 识别右侧枪支压下按钮
local GUN_RIGHT_PRESSED_RECOGNIZE_INFO = { path = "img/commonstate/refer_gun_right_pressed.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -335, top = -317, width = 110, height = 110 }, threshold = 90 };
--- 识别右侧拳头按钮
local FIST_RIGHT_RECOGNIZE_INFO = { path = "img/commonstate/refer_fist_right.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -334, top = -318, width = 110, height = 110 }, threshold = 90 };
--- 识别右侧拳头压下按钮
local FIST_RIGHT_PRESSED_RECOGNIZE_INFO = { path = "img/commonstate/refer_fist_right_pressed.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -334, top = -318, width = 110, height = 110 }, threshold = 90 };
--- 识别右侧手雷按钮
local FRAG_RIGHT_RECOGNIZE_INFO = { path = "img/commonstate/refer_frag_right.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -334, top = -318, width = 110, height = 110 }, threshold = 90 };
--- 识别右侧手雷压下按钮
local FRAG_RIGHT_PRESSED_RECOGNIZE_INFO = { path = "img/commonstate/refer_frag_right_pressed.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -334, top = -318, width = 110, height = 110 }, threshold = 90 };

--- 识别左侧枪支按钮
local GUN_LEFT_RECOGNIZE_INFO = { path = "img/commonstate/refer_gun_left.png", rect = { flag = Anchor().BOTTOMLEFT, left = 20, top = -554, width = 140, height = 140 }, threshold = 90 };
--- 识别左侧枪支按钮
local GUN_LEFT_EXPANDED_RECOGNIZE_INFO = { path = "img/commonstate/refer_gun_left_expanded.png", rect = { flag = Anchor().BOTTOMLEFT, left = 20, top = -554, width = 140, height = 140 }, threshold = 90 };
--- 识别左侧拳头按钮
local FIST_LEFT_RECOGNIZE_INFO = { path = "img/commonstate/refer_fist_left.png", rect = { flag = Anchor().BOTTOMLEFT, left = 20, top = -554, width = 140, height = 140 }, threshold = 90 };
--- 识别左侧手雷按钮
local FRAG_LEFT_RECOGNIZE_INFO = { path = "img/commonstate/refer_frag_left.png", rect = { flag = Anchor().BOTTOMLEFT, left = 20, top = -554, width = 140, height = 140 }, threshold = 90 };

local FLOAT_BALL_POSITION = { anchor = Anchor().TOPLEFT, x = 74, y = 368 }

local Tag = "common_state"
local function printLog(msg)
    commonlib_print(Tag, msg);
end

KEY_BACKPACK = "backpack"
KEY_RIGHT_GUN = "rightGun"
KEY_RIGHT_FIST = "rightFist"
KEY_LEFT_GUN = "leftGun"
KEY_LEFT_FIST = "leftFist"

local floatBall = TopSmallView();

local hasIconTable = {
    [KEY_BACKPACK] = nil,
    [KEY_RIGHT_GUN] = nil,
    [KEY_RIGHT_FIST] = nil,
    [KEY_LEFT_GUN] = nil,
    [KEY_LEFT_FIST] = nil
}

-- 用于回调到各个业务脚本的回调函数表
common_game_events_callbacks = {
    [KEY_BACKPACK] = {},
    [KEY_RIGHT_GUN] = {},
    [KEY_RIGHT_FIST] = {},
    [KEY_LEFT_GUN] = {},
    [KEY_LEFT_FIST] = {}
}

HYXD_APP_NAME = 2

local DEFAULT_ALGORITHM = 4
--local BACKPACK_ALGORITHM = 1
local INIT_INDEX = 1
local UNINIT_INDEX = 2
local hasReportGameStartData = false

local function doImageRecognize(info, algorithm)
    if algorithm == nil then
        algorithm = DEFAULT_ALGORITHM
    end
    return commonlib_doImageRecognizeByType(info, algorithm)
end

local function callLifeCircleInit()
    printLog("callLifeCircleInit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleInit common_life_circle_callbacks is nil or empty")
        return
    end
    commonlib_handleNestingTable(common_life_circle_callbacks, INIT_INDEX)
end

local function callLifeCircleUninit()
    printLog("callLifeCircleUninit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleUninit common_life_circle_callbacks is nil or empty")
        return
    end
    commonlib_handleNestingTable(common_life_circle_callbacks, UNINIT_INDEX)
end

local function setSettingViewIcon()
    commonlib_setFloatBallIcon("common://image/icon_floatball.png")
    commonlib_setSettingViewIcon("common://image/icon_settingview.png")
    commonlib_setSettingViewIconSize(97.67, 65)
    commonlib_setSettingViewIconMargin(12, 0, 0, 0)
    commonlib_setSettingViewIconExtrudeHeight(21)
end

local function init()
    printLog("init")

    --commonlib_recognizeAddImage(BACKPACK_RECOGNIZE_INFO.path)

    commonlib_recognizeAddImage(GUN_LEFT_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(GUN_LEFT_EXPANDED_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(GUN_RIGHT_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(GUN_RIGHT_PRESSED_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(FIST_RIGHT_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(FIST_RIGHT_PRESSED_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(FIST_LEFT_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(FRAG_LEFT_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(FRAG_RIGHT_RECOGNIZE_INFO.path)
    commonlib_recognizeAddImage(FRAG_RIGHT_PRESSED_RECOGNIZE_INFO.path)

    callLifeCircleInit();

    floatBall:moveCenterTo(FLOAT_BALL_POSITION.anchor, FLOAT_BALL_POSITION.x, FLOAT_BALL_POSITION.y)

    if commonlib_isScreenRatio18To9() then
        -- 在全面屏下需进行坐标偏移

        -- 左侧识别偏移
        GUN_LEFT_RECOGNIZE_INFO.rect.left = 32
        GUN_LEFT_EXPANDED_RECOGNIZE_INFO.rect.left = 32
        FIST_LEFT_RECOGNIZE_INFO.rect.left = 32
        FRAG_LEFT_RECOGNIZE_INFO.rect.left = 32

        -- 右侧识别偏移
        GUN_RIGHT_RECOGNIZE_INFO.rect.left = -382
        GUN_RIGHT_PRESSED_RECOGNIZE_INFO.rect.left = - 382
        FIST_RIGHT_RECOGNIZE_INFO.rect.left = -382
        FIST_RIGHT_PRESSED_RECOGNIZE_INFO.rect.left = -382
        FRAG_RIGHT_RECOGNIZE_INFO.rect.left = -382
        FRAG_RIGHT_PRESSED_RECOGNIZE_INFO.rect.left = -382
    end

    -- 开始设置悬浮球的外观
    setSettingViewIcon()
    commonlib_putSettingViewsEventListener()

    -- 关注设置面板的关闭事件，用于埋点上报
    commonlib_registerSettingViewCloseCallback(pressAllGameSettingsReport)
end

local function uninit()
    printLog("uninit")
    hasReportGameStartData = false
    callLifeCircleUninit();

    -- 取消关注设置面板的关闭事件
    commonlib_unRegisterSettingViewCloseCallback(pressAllGameSettingsReport)
end

local function handleEventCallbacks(iconKey, hasIcon)
    printLog("handleEventCallbacks : " .. tostring(iconKey) .. " : " .. tostring(hasIcon))
    if hasIconTable[iconKey] == nil or hasIconTable[iconKey] ~= hasIcon then
        hasIconTable[iconKey] = hasIcon;
        commonlib_setGameParam(iconKey, hasIcon)
        commonlib_handleTableWithBoolParam(common_game_events_callbacks[iconKey], hasIconTable[iconKey])
    end
end

local function reportGameStartData()
    if hasReportGameStartData then
        commonlib_report(GAMEMASTER_FUNCTION_DISABLE_REASON_TABLE,
            {
                [GAMEMASTER_FUNCTION_DISABLE_REASON_STEP] = STEP_GAME_INNER_START,
                [GAMEMASTER_FUNCTION_DISABLE_REASON_GAMENAME] = HYXD_APP_NAME,
                [GAMEMASTER_FUNCTION_DISABLE_REASON] = REASON_SUCCEED
            });
        hasReportGameStartData = true;
    end
end

local function work()
    printLog("work")

    local hasRightGunIcon = false;
    local hasRightFistIcon = false;
    local hasLeftGunIcon = false;
    local hasLeftFistIcon = false;

    -- 首先检测是否有左侧按钮，如果发现左侧按钮，直接判定右侧按钮存在，避免识别右侧按钮，优化性能
    hasLeftGunIcon = doImageRecognize(GUN_LEFT_RECOGNIZE_INFO) or doImageRecognize(GUN_LEFT_EXPANDED_RECOGNIZE_INFO) or doImageRecognize(FRAG_LEFT_RECOGNIZE_INFO);
    if hasLeftGunIcon then
        hasRightGunIcon = true
    else
        hasLeftFistIcon = doImageRecognize(FIST_LEFT_RECOGNIZE_INFO)
        if hasLeftFistIcon then
            hasRightFistIcon = true
        end
    end

    if not hasLeftGunIcon and not hasLeftFistIcon then
        hasRightGunIcon = doImageRecognize(GUN_RIGHT_RECOGNIZE_INFO) or doImageRecognize(GUN_RIGHT_PRESSED_RECOGNIZE_INFO) or doImageRecognize(FRAG_RIGHT_RECOGNIZE_INFO) or doImageRecognize(FRAG_RIGHT_PRESSED_RECOGNIZE_INFO);

        if not hasRightGunIcon then
            hasRightFistIcon = doImageRecognize(FIST_RIGHT_RECOGNIZE_INFO) or doImageRecognize(FIST_RIGHT_PRESSED_RECOGNIZE_INFO);
        end
    end

    printLog(" hasLeftFistIcon : " .. tostring(hasLeftFistIcon))
    printLog(" hasLeftGunIcon : " .. tostring(hasLeftGunIcon))
    printLog(" hasRightFistIcon : " .. tostring(hasRightFistIcon))
    printLog(" hasRightGunIcon : " .. tostring(hasRightGunIcon))

    local hasBackpackIcon = hasLeftFistIcon or hasLeftGunIcon or hasRightFistIcon or hasRightGunIcon
    commonlib_runOnUIThread(function()
        --if hasIconTable[KEY_BACKPACK] ~= hasBackpackIcon then
        printLog("开始显示悬浮球：" .. tostring(hasBackpackIcon));
        if hasBackpackIcon then
            reportGameStartData();
            if not floatBall:isShowing() then
                floatBall:show();
            end
        else
            if floatBall:isShowing() then
                floatBall:hide();
            end
        end
        --end
    end);

    handleEventCallbacks(KEY_BACKPACK, hasBackpackIcon);

    if not hasBackpackIcon then
        printLog("没有背包按钮，不做任何操作")
        for index, v in pairs(hasIconTable) do
            hasIconTable[index] = false;
            commonlib_setGameParam(index, false)
        end
        return
    end

    handleEventCallbacks(KEY_RIGHT_GUN, hasRightGunIcon);
    handleEventCallbacks(KEY_RIGHT_FIST, hasRightFistIcon);
    handleEventCallbacks(KEY_LEFT_GUN, hasLeftGunIcon);
    handleEventCallbacks(KEY_LEFT_FIST, hasLeftFistIcon);
end

table.insert(core_scripts, { init, uninit, work })