---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gaj.
--- DateTime: 2018/10/11 10:30
---

local gNewGameEngine;
local gfScaleRelativeTo1080
local gSettingView;
local TAG = "card_type_classifier_lua"
local function printLog(msg)
    commonlib_print(TAG, msg)
end
local function isOverTime()
    local overTime = commonlib_getUtilTool():getHlddzOverdueTime();
    if overTime ~= nil and overTime <= 0 then

        return true;
    end

    return false
end

function clone(object)
    local lookup_table = {}
    local function copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for key, value in pairs(object) do
            new_table[copy(key)] = copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return copy(object)
end





local CONST_VALUE = {
    TAB_NAME = "打牌助手",
    CHECKBOX_TEXT = "开启打牌助手",
    SWITCH_KEY = "hldzzPokerClassificationSwitchKey",
    SETTING_ARSENAL_DESC_TEXT = "快速分类手牌里的顺子、飞机、炸弹、对子等牌型组合数量",
    SETTING_HLDDZ_USE_TIME_TIP_A = "（仅剩%d天，快去分享续用吧~）",
    SETTING_HLDDZ_USE_TIME_TIP_B = "（还有%d天到期）",
    SETTING_HLDDZ_USE_TIME_TIP_C = "已过期，快去分享续用吧~",
    SETTING_HLDDZ_SHARE_SCCUESS_TIP = "恭喜您已获得价值15元的「牌型辅助」功能，快去体验一下吧~",
    SETTING_HLDDZ_SHARE_FAILED_TIP = "抱歉，分享失败！分享即可获得价值15元的「牌型辅助」功能，再去试试吧~"
}


local function createCardNode(value,type,count)
    printLog("crearte Card node value :" ..tostring(value) .. " || type is " .. tostring(type) .. " || count is " .. tostring(count))
    return { card_value = value, card_type = type,card_count=count }
end
local function oldConvertNew(value)


    local newValue = 0;
    if value == 0 or value == 1 then
        newValue = value + 14;
    else
        if value > 12 then
            newValue = value + 3;
        else
            if value > 1 and value < 13 then
                newValue = value + 1
            end
        end
    end
    return newValue;
end

local function getReporCardValue(value)
    if value == 17 then
        --    大王
      return "M"
    end
    if value == 16 then
        return "N"
    end
    if value == 15 then
        return "2"
    end
    if value == 14 then
        return"A"
    end
    if value == 13 then
        return "K"
    end
    if value == 12 then
        return "Q"
    end
    if value == 11 then
        return "J"
    end
    if value == 10 then
        return "X"
    end
    if value == 20 then
        --    癞子
        return "L"
    end
    return tostring(value)
end


local function getHandpoker(t)

    if commonlib_isTableEmpty(t) then
        printLog("getHandpoker table is nil")
        return ""
    end
    table.sort(t, function(a, b)
        return (oldConvertNew(a.number) > oldConvertNew(b.number))
    end)
    local result = ""
    for key, node in pairs(t) do
        local value = node["number"]
        local type = node["type"]

        value = oldConvertNew(value)
        if type >= 4 then
            value = 20;
        end
        result = result .. getReporCardValue(value)
    end
   return result;
end

local function getOutpoker(data)
    if commonlib_isTableEmpty(data) then
        printLog("getOutpoker table is nil")

        return ""
    end

    table.sort(data, function(a, b)
        return (oldConvertNew(a.number) > oldConvertNew(b.number))
    end)

    local result = ""
    for key, node in pairs(data) do
        local value = node["number"]
        local type = node["type"]
        value = oldConvertNew(value)
        if type >= 4 then
            value = 20;
        end
        result = result .. getReporCardValue(value)
    end
    return result;
end

local gViewCardTypeClassifierContentLayout
local gViewCardTypeClassifierTopLayout

local gCardTypeClassifierTopView

local gCardTypeClassifierContentView

local settingTabelSwitch = false;
local settingTabelView
local settingUseTimeTip
local settingTableDescTextView
local settingShareTipImageView
local hlddzShareLayout
local gCardTypeClassifierContentViewIsShow = false
local gCardTypeClassifierTopViewIsShow = false

local gHasLoadData = false
local gCuurentCardData = nil
local gOutCardData = nil
local gOldCardData = nil
local gFirstPlaySteps = nil
local gPlayStepsHitCount = 0
local gHasAbnormalExit = false;




local function getCardDataCount()
    if nil == gCuurentCardData then
        return 0
    end
    return #gCuurentCardData
end
local function getTextColor(enable)
    if enable == true then
        return "#FF00DEFF";
    else
        return "#FF979797";
    end
end


local function updatePlayStepsHitCount(exchange)
    if commonlib_isTableEmpty(gFirstPlaySteps) then
        printLog("updatePlayStepsHitCount gFirstPlaySteps is nil")
        return
    end

    if commonlib_isTableEmpty(exchange) then
        printLog("updatePlayStepsHitCount exchange is nil")
        return
    end

    local exchangeCount  = #exchange;
    printLog("updatePlayStepsHitCount exchangeCount is " .. tostring(exchangeCount))
    gPlayStepsHitCount = 0;
    for key, node in pairs(gFirstPlaySteps) do
        if true ~= commonlib_isTableEmpty(node) then
            local currentNodeCount = #node;
            printLog("updatePlayStepsHitCount currentNodeCount is " .. tostring(currentNodeCount))

            if currentNodeCount == exchangeCount then
                printLog("updatePlayStepsHitCount 找到数量相同的牌组节点" )
                table.sort(node, function(a, b) return (a.number < b.number) end)
                table.sort(exchange, function(a, b) return (a.number < b.number) end)
                local isSome = true;
                for index = 1 , currentNodeCount do
                    printLog("updatePlayStepsHitCount current index is " .. tostring(index))
                    local a = exchange[index]
                    local b = node[index]
                    if  a.number ~= b.number then
                        printLog("可惜了，两个值不一致 a= " .. tostring(a.number) .. "| b =" .. tostring(b.number))
                        isSome = false;
                        break;
                    end
                end

                if true == isSome then
                    gPlayStepsHitCount = 1;
                end
            end
        end
    end
    printLog("updatePlayStepsHitCount end")

end


local function getgPlayStepsCount()
    if commonlib_isTableEmpty(gFirstPlaySteps) then
        printLog("getgPlayStepsHitCount is  nill")
        return 0;
    end
    return #gFirstPlaySteps;
end

local function getgPlayStepsMatch()
    if gPlayStepsHitCount == 0 then
        return 2;
    end
    if  gPlayStepsHitCount == 1 then
        return 1;
    end
    return 0;
end
--分享成功是更新卡牌器状态
local function updateCardTypeClassifierStatus()
    printLog("updateCardTypeClassifierStatus be called")
    commonlib_runOnUIThread(function ()
        if nil ~= gCardTypeClassifierContentView then
            gCardTypeClassifierContentView:updateOverTimeStatus();
        end
    end)

end

local function printNumberTypeTabel(ntTabel, outTable, isChanged, printStr)
    if false == isChanged or commonlib_isTableEmpty(ntTabel) then
        return
    end


    local str = numberTypeTabelToString(ntTabel)
    local str1 = numberTypeTabelToString(outTable)
    if commonlib_isTableEmpty(outTable) == false then

    end

    printLog("isChanged=" .. tostring(isChanged)
            .. ", printStr=" .. printStr
            .. ", size=" .. tostring(#ntTabel)
            .. ", data=" .. str
            .. ", outStr=" .. str1)
end

local function onCheckChangeListener(checkBoxId, isChecked)
    commonlib_setSharedPrefBoolean(CONST_VALUE.SWITCH_KEY, isChecked)
    settingTabelSwitch = isChecked
end

local function getShareTimeStrAndColor()
    local shareTimeStr;
    local shareTimeColor;
    local curOverTime = commonlib_getUtilTool():getHlddzOverdueTime()
    if curOverTime > 3 then
        --shareTimeStr = string.format(CONST_VALUE.SETTING_HLDDZ_USE_TIME_TIP_B, curOverTime)
        shareTimeStr = ""
        shareTimeColor = "#FF00DEFF";
    elseif curOverTime == 0 then
        shareTimeStr = CONST_VALUE.SETTING_HLDDZ_USE_TIME_TIP_C
        shareTimeColor = "#FFF8403D";
    else
        --shareTimeStr = string.format(CONST_VALUE.SETTING_HLDDZ_USE_TIME_TIP_A, curOverTime)
        shareTimeStr = ""
        shareTimeColor = "#FFF8403D";
    end
    return shareTimeStr, shareTimeColor
end

local function updateShareTime()
    printLog("excute updateShareTime")
    local shareTimeStr, shareTimeColor = getShareTimeStrAndColor()
    settingUseTimeTip:setText(shareTimeStr)
    settingUseTimeTip:setTextColor(shareTimeColor);
end

local function initSettingView()
    local tab = commonlib_getSettingView():addTableView(CONST_VALUE.TAB_NAME)
    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    relativeLayoutParam:setLayoutParam(paramValues)

    settingTabelSwitch = commonlib_getSharedPrefBoolean(CONST_VALUE.SWITCH_KEY, true)

    printLog("settingTabelSwitch:" .. tostring(settingTabelSwitch))
    settingTabelView = tab:addCheckBoxView(
            CONST_VALUE.CHECKBOX_TEXT, settingTabelSwitch, relativeLayoutParam, onCheckChangeListener)

    paramValues.layout_below = settingTabelView:getId()
    paramValues.layout_marginLeft = "52dp"
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_height = "74dp"
    paramValues.layout_width = "226dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    settingShareTipImageView = tab:addImageView("image/card_help_image_tip.png", relativeLayoutParam, nil)

    paramValues.layout_below = settingShareTipImageView:getId()
    paramValues.layout_marginLeft = "52dp"
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    relativeLayoutParam:setLayoutParam(paramValues)
    settingTableDescTextView = tab:addTextView(CONST_VALUE.SETTING_ARSENAL_DESC_TEXT,
            getTextColor(settingTabelSwitch),
            "12sp",
            relativeLayoutParam,
            nil);
    paramValues.layout_below = settingTableDescTextView:getId()
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_width = "MATCH_PARENT"
    paramValues.layout_height = "35dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    hlddzShareLayout = tab:addHlddzShareView(relativeLayoutParam);
    hlddzShareLayout:setOnEventListener(
            function(type, action)
                printLog("shard  callback type is " .. tostring(type)  .. "action is " .. tostring(action))

                if type == tostring(GAME_COMMON_SHARE_HLDDZ_SETTING) and action == "common_share_succ" then
                    printLog("shard success callback")
                    --    更新卡牌分类器状态
                    updateCardTypeClassifierStatus()

                    updateShareTime()

                end
            end)

    local shareLayoutParam = create("RelativeLayoutParam")
    local shareParamValues = {}
    shareParamValues.layout_toRightOf = settingTabelView:getId()
    shareParamValues.layout_marginLeft = "3.35dp"
    shareParamValues.layout_marginTop = "22dp"
    shareParamValues.layout_height = "WRAP_CONTENT"
    shareParamValues.layout_width = "WRAP_CONTENT"
    shareLayoutParam:setLayoutParam(shareParamValues)
    if settingUseTimeTip == nil then
        local shareTimeStr, shareTimeColor = getShareTimeStrAndColor()
        settingUseTimeTip = tab:addTextView(shareTimeStr,
            shareTimeColor,
            "10sp",
            shareLayoutParam,
            nil);
    end
end

local function destroyCardCalssifierView()
    printLog("destroyCardCalssifierView start")
    if nil ~= gCardTypeClassifierContentView then
        printLog("destroy  gCardTypeClassifierView")

        commonlib_destroyView(gCardTypeClassifierContentView)
        gCardTypeClassifierContentView = nil;
    end

    if nil ~= gViewCardTypeClassifierContentLayout then
        printLog("destroy  gViewCardTypeClassifierLayoutView")

        commonlib_destroyView(gViewCardTypeClassifierContentLayout)
        gViewCardTypeClassifierContentLayout = nil;
    end
    if nil ~= gCardTypeClassifierTopView then
        printLog("destroy  gViewCardTypeClassifierTopView")
        commonlib_destroyView(gCardTypeClassifierTopView)
        gCardTypeClassifierTopView:setOnEventListener(nil)
        gCardTypeClassifierTopView = nil;

    end
    if  nil ~= gViewCardTypeClassifierTopLayout then
        printLog("destroy  gViewCardTypeClassifierTopView")
        commonlib_destroyView(gViewCardTypeClassifierTopLayout)
        gViewCardTypeClassifierTopLayout = nil
    end


end

--展示卡片
local function realCreateTopView()
    ---自定义view

    local layoutRect = {
        flag = Anchor().TOPLEFT,
        left = commonlib_dp2Pix(3)/ commonlib_getScale(),
        top =  commonlib_dp2Pix(45)/ commonlib_getScale(),
        width = commonlib_dp2Pix(111)/ commonlib_getScale(),
        height = commonlib_dp2Pix(29)/ commonlib_getScale() }
    printLog("realCreateTopView")
    -- true 为可点击 对应 SGameFloatViewMgrExForLua这个类
    local layoutView = commonlib_getFloatViewMgrEx():create(
            layoutRect.left,
            layoutRect.top,
            layoutRect.width,
            layoutRect.height,
            layoutRect.flag,
            true)

    if nil == layoutView then
        printLog("createCardTypeHitView, addSGameFloatViewControl error")
        return
    end

    ---String src, int anchor, int x, int y, int width, int height, int zOrder
    gCardTypeClassifierTopView = layoutView:addHlddzCardTypeClassifierTopView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top)

    if nil == gCardTypeClassifierTopView then
        commonlib_destroyView(layoutView)
        printLog("createCardTypeHitView addHlddzCardTypeClassifierContentView error")
        return
    end

    printLog("createCardTypeHitView succeed")
    return layoutView
end


--展示卡片
local function realCreateContentView()
    ---自定义view

    local layoutRect = {
        flag = Anchor().TOPLEFT,
        left = commonlib_dp2Pix(3)/ commonlib_getScale(),
        top =  commonlib_dp2Pix(45)/ commonlib_getScale(),
        width = commonlib_dp2Pix(111)/ commonlib_getScale(),
        height = commonlib_dp2Pix(180)/ commonlib_getScale() }

    printLog("createCardTypeHitView")
    -- true 为可点击 对应 SGameFloatViewMgrExForLua这个类
    local layoutView = commonlib_getFloatViewMgrEx():create(
            layoutRect.left,
            layoutRect.top,
            layoutRect.width,
            layoutRect.height,
            layoutRect.flag,
            false)


    if nil == layoutView then
        printLog("createCardTypeHitView, addSGameFloatViewControl error")
        return
    end

    ---String src, int anchor, int x, int y, int width, int height, int zOrder
    gCardTypeClassifierContentView = layoutView:addHlddzCardTypeClassifierContentView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_middle)

    if nil == gCardTypeClassifierContentView then
        commonlib_destroyView(layoutView)
        printLog("createCardTypeHitView addHlddzCardTypeClassifierContentView error")
        return
    end

    printLog("createCardTypeHitView succeed")
    return layoutView
end

local function clearDataOnUI()
    printLog("clearDataOnUI")
    --commonlib_runOnUIThread(function()
    --    if  nil ~= gCardTypeClassifierContentView then
    --        gCardTypeClassifierContentView:clearData();
    --        gCardTypeClassifierContentView:hitCardView(false);
    --    end
    --    if nil ~= gCardTypeClassifierTopView then
    --        gCardTypeClassifierTopView:hitCardView(false);
    --    end
    --    report_gamemaster_plugin_hlddz_main(6, 1, 1, 0, getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData))
    --    gHasLoadData = false;
    --end)
end

local function refreshDataOnUI(data)
    printLog("refreshDataOnUI gHasLoadData:" .. tostring(gHasLoadData))
    commonlib_runOnUIThread(function()
        printLog("刷新数据了哦" .. tostring(table.getn(data)))
        gCardTypeClassifierContentView:setCardTypeClassifierData(data)
        gHasLoadData = true;
    end)
end

--创建卡牌类型顶部控制View
local function createCardTypeClassfilerTopView(animation)
    if nil ~= gViewCardTypeClassifierTopLayout then
        printLog("gViewCardTypeClassifierTopView is not nil")
        return
    end

    gViewCardTypeClassifierTopLayout = realCreateTopView()
    gViewCardTypeClassifierTopLayout:show()
    gCardTypeClassifierTopView:showCardView(animation)
    gCardTypeClassifierTopView:setOnEventListener(function(currentStatus)
        printLog("点击了缩放按钮 currentStatus:" .. tostring(currentStatus))
        if isOverTime() then
            gSettingView:show();
            return ;
        end

        if 1 == currentStatus then
            --    当前为打开状态，应该关闭
            gCardTypeClassifierContentView:hitCardView(true)
            gCardTypeClassifierTopView:hitCardView(true)
            report_gamemaster_plugin_hlddz_main(5, 1,  0, getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData),0,0)

        elseif -1 == currentStatus then
            gCardTypeClassifierContentView:showCardView(true)
            gCardTypeClassifierTopView:showCardView(true)
            report_gamemaster_plugin_hlddz_main(7, 1,  0, getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData),0,0)
        elseif 2 == currentStatus then
            printLog("切换展现模式")
            report_gamemaster_plugin_hlddz_main(9, 1,  0, getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData),0,0)
            if getCurrentGameMode() ~= HLDDZ_GAME_MODE_LAIZI then
                gCardTypeClassifierContentView:switchingShowModel();
            end

        end

    end
    )
    gCardTypeClassifierTopViewIsShow = true;

end

--创建展示卡牌类型的listview
local function createCardTypeClassifierContentView(animation)
    if nil ~= gViewCardTypeClassifierContentLayout then
        printLog("gViewCardTypeClassifierContentView is not nil")
        return
    end
    gViewCardTypeClassifierContentLayout = realCreateContentView()
    gViewCardTypeClassifierContentLayout:show()
    gCardTypeClassifierContentView:showCardView(animation)

    gCardTypeClassifierContentViewIsShow = true;
end

--初始化出卡牌展示的跟布局
local function showCardTypeClassifierViewOnUI(animation)
    printLog("showCardTypeClassifierViewOnUI start")

    if gCardTypeClassifierContentViewIsShow == true and gCardTypeClassifierTopViewIsShow == true then

        printLog("showCardTypeClassifierViewOnUI gCardViewIsShow is " .. tostring(gCardTypeClassifierContentViewIsShow))

        return
    end

    printLog("animation is :" .. tostring(animation))
    if settingTabelSwitch == false then
        printLog("settingTabelSwitch is false")
        return
    end

    commonlib_runOnUIThread(function()
        if gCardTypeClassifierContentViewIsShow == false then
            printLog("showCardTypeHitView createCardTypeClassifierContentView")

            createCardTypeClassifierContentView(animation);
        end

        if gCardTypeClassifierTopViewIsShow == false then
            printLog("showCardTypeHitView createCardTypeClassfilerTopView")

            createCardTypeClassfilerTopView(animation);
        end

        printLog("showCardTypeHitView end")

    end
    )

end

local function resetVarible()
    printLog("resetVarible")
    gCardTypeClassifierContentViewIsShow = false
    gCardTypeClassifierTopViewIsShow = false
    gHasLoadData = false
    gCuurentCardData = nil
    gOutCardData = nil
    gOldCardData = nil
    gFirstPlaySteps = nil
    gPlayStepsHitCount = 0;
end


--初始化时初始化一些变量
local function initVariable()
    printLog("initVariable")
    gfScaleRelativeTo1080 = commonlib_getScale()
    gSettingView = commonlib_getSettingView();

    gNewGameEngine = CNewGameEngine:getInstance();
    resetVarible()


end

local function destroyCardCalssifierViewOnUI()
    printLog("destroyCardCalssifierViewOnUI")
    commonlib_runOnUIThread(function()
        destroyCardCalssifierView()
    end)
end

local function lookForShunzi(sortTable,tempTable)


    table.sort(sortTable, function(a, b)
        return (a < b)
    end)

    printLog("lookForShunzi")
    local str = "";
    for key, value in pairs(tempTable) do
        str = str .. "key = " .. tostring( key) .. "count =" .. tostring(value) .. "||"
    end
    printLog("tempTable is " .. str)
    local count = 0;
    local startValue = nil;
    local currentValue = nil;
    local result = {}
    if table.getn(sortTable) > 0 then
        for index, tempValue in pairs(sortTable) do
            printLog("tempValue：" .. tostring(tempValue) .. "count:" .. tostring(count))
            if tempValue > 1 and tempValue < 15 then
                if nil == currentValue then
                    startValue = tempValue;
                    currentValue = tempValue;
                    count = count + 1;
                else

                    if tempValue == (currentValue + 1) then
                        count = count + 1;
                    else
                        if count > 4 then

                            printLog("找到顺子了")
                            for i = startValue, currentValue do
                                printLog(i)
                                table.insert(result, createCardNode(i,0,tempTable[i]))
                            end
                        else
                            printLog("不够顺子的个数")
                            printLog("tempValue：" .. tostring(tempValue) .. "count:" .. tostring(count))


                        end
                        startValue = tempValue;
                        count = 1;
                    end
                    currentValue = tempValue;

                end
            end
        end
        if count > 4 then
            printLog("最后找到顺子了")
            for i = startValue, currentValue do
                printLog(i)
                table.insert(result, createCardNode(i,0,1))
            end
        else
            printLog("不够顺子的个数要求")
            currentValue = nil;
            startValue = nil;
            count = 0;
        end
    end

    return result;
end



local function cleaningData(data)
    if commonlib_isTableEmpty(data) then
        printLog("cleaningData data is nil")
        return {};
    end
    local tempTable = {}
    local sortTable = {}
    for key, node in pairs(data) do
        local value = node["number"]

        value = oldConvertNew(value)

        if value == 16 or value == 17 then
            --当前规则，大王小王做同样处理即可
            value = 16
        end
        local temp = tempTable[value]

        if nil == temp then
            table.insert(sortTable, value)
            tempTable[value] = 1
        else
            tempTable[value] = tempTable[value] + 1;
        end

    end

    local tempBombs ={}
    local  tempThree={}
    local  tempCouple={}
    local tempShunzi = {}

    local result = {}

    -- 检查顺子


    for key ,value in pairs(tempTable) do
        --检查bomds
        if key == 16 and value == 2  then
            tempBombs[table.getn(tempBombs)+1] =  createCardNode(key,0,value);
            goto continue
        end

        if value == 4 then
            tempBombs[table.getn(tempBombs)+1] =  createCardNode(key,0,value);
            goto continue
        end


        --检查3张的

        if value ==3 then
            tempThree[table.getn(tempThree)+1] =  createCardNode(key,0,value);
            goto continue
        end

        --检查对子

        if value == 2 then
            tempCouple[table.getn(tempCouple)+1] =  createCardNode(key,0,value);
            goto continue
        end

        :: continue ::
    end


    tempShunzi = lookForShunzi(sortTable,tempTable)

    if commonlib_isTableEmpty(tempBombs) == false then
        printLog("我有炸了")
        for key, value in pairs(tempBombs) do
            printLog("value is " .. tostring(value))
        end
        table.sort(tempBombs, function(a, b)
            return (a.card_value > b.card_value)
        end)
        result["bomb"] = tempBombs
    end

    if commonlib_isTableEmpty(tempThree) == false then
        printLog("我有三条哦")
        for key, value in pairs(tempThree) do
            printLog("value is " .. tostring(value))
        end
        table.sort(tempThree, function(a, b)
            return (a.card_value > b.card_value)
        end)

        result["three"] = tempThree
    end

    if commonlib_isTableEmpty(tempCouple) == false then
        printLog("我有两条哦")
        for key, value in pairs(tempCouple) do
            printLog("value is " .. tostring(value))
        end
        table.sort(tempCouple, function(a, b)
            return (a.card_value > b.card_value)
        end)

        result["couple"] = tempCouple;
    end

    if commonlib_isTableEmpty(tempShunzi) == false then
        printLog("我有顺子哦")
        for key, value in pairs(tempShunzi) do
            printLog("value is " .. tostring(value))
        end
        table.sort(tempShunzi, function(a, b)
            return (a.card_value > b.card_value)
        end)

        result["shunzi"] = tempShunzi;
    end

    printLog("cleaningData result count is " .. table.getn(result))
    return result;

end

local function checkAndUpdateData()

   local tempCardsData = commonlib_getGameParam(HLDDZ_KEY_POKER_NUMBER_TYPE)
    if commonlib_isTableEmpty(tempCardsData) then
        printLog("checkAndUpdateData 识别到的卡片数据时空的哦！")
        return
    end
    if tempCardsData.pickPockerError == true and gHasAbnormalExit == false then
        gHasAbnormalExit = true;
        printLog("checkAndUpdateData 异常退出，销毁界面")
        report_gamemaster_plugin_hlddz_main(8, 1,  0, getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData),0,0)
        destroyCardCalssifierViewOnUI();
        resetVarible()
        return
    end

    printNumberTypeTabel(tempCardsData.ownerData, tempCardsData.playownerData, tempCardsData.isChanged, HLDDZ_KEY_POKER_NUMBER_TYPE)

    if  tempCardsData.isChanged == true  then
        if commonlib_isTableEmpty(tempCardsData.ownerData) and commonlib_isTableEmpty(tempCardsData.playSteps) then
            --    打完牌了，清掉数据
            printLog("checkAndUpdateData 打完牌了，清掉数据 " .. tostring(gCardTypeClassifierContentViewIsShow))

            showCardTypeClassifierViewOnUI(false)
            clearDataOnUI();
        else
            -- 刷新数据
            printLog("checkAndUpdateData 牌发生变化了哦，我要刷新数据  gCardViewIsShow:" .. tostring(gCardTypeClassifierContentViewIsShow))

            local data = cleaningData(tempCardsData.ownerData)

            if commonlib_isTableEmpty(gCuurentCardData) then
                printLog("checkAndUpdateData  gCuurentCardData is 空")
                gCuurentCardData = tempCardsData.ownerData
                gOutCardData = tempCardsData.playownerData;
                if commonlib_isTableEmpty(gCuurentCardData) == false and commonlib_isTableEmpty(data) == false then
                    printLog("checkAndUpdateData 此时为第一次拿到手牌，牌型分类启动成功")
                    gFirstPlaySteps = clone(tempCardsData.playSteps)
                    report_gamemaster_plugin_hlddz_main(2, 1,  0, getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData),getgPlayStepsCount(),0)

                end

            else
                gCuurentCardData = tempCardsData.ownerData
                gOutCardData = tempCardsData.playownerData;
                printLog("checkAndUpdateData 手牌发生变化")
                updatePlayStepsHitCount(clone(gOutCardData))
                gFirstPlaySteps = clone(tempCardsData.playSteps)

                report_gamemaster_plugin_hlddz_main(3, 1,  0, getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData),0,getgPlayStepsMatch())

            end

            showCardTypeClassifierViewOnUI(false)

            if commonlib_isTableEmpty(data) and commonlib_isTableEmpty(tempCardsData.playSteps) then
                clearDataOnUI();

            else
                local playStepstable = {}
                if commonlib_isTableEmpty(tempCardsData.playSteps) ~= true then
                    for key, nodetable in pairs(tempCardsData.playSteps) do
                        if commonlib_isTableEmpty(nodetable) == true then
                            return
                        end
                        local innertable = {}
                        for key, node in pairs(nodetable) do
                            printLog("playSteps" .. tostring(node.number))
                            table.insert(innertable, { number = oldConvertNew(node.number), type = node.type, playType = node.playType })
                        end
                        table.insert(playStepstable, innertable)
                    end

                end
                refreshDataOnUI({ ownerData = data, playSteps = playStepstable })
            end
        end

    end
end

local function showAllView()
    commonlib_runOnUIThread(
            function()


                if gViewCardTypeClassifierContentLayout ~= nil and not gViewCardTypeClassifierContentLayout:isShowing() then
                    printLog("showAllView  gViewCardTypeClassifierContentLayout")

                    gViewCardTypeClassifierContentLayout:show();
                end
                if gViewCardTypeClassifierTopLayout ~= nil and not gViewCardTypeClassifierTopLayout:isShowing() then
                    printLog("showAllView  gViewCardTypeClassifierTopLayout")
                    gViewCardTypeClassifierTopLayout:show();
                end


            end)

end

local function hitAllView()
    commonlib_runOnUIThread(function()

        if gViewCardTypeClassifierContentLayout ~= nil and gViewCardTypeClassifierContentLayout:isShowing() then
            printLog("hitAllView  gViewCardTypeClassifierContentLayout")
            gViewCardTypeClassifierContentLayout:hide();
        end

        if gViewCardTypeClassifierTopLayout ~= nil and gViewCardTypeClassifierTopLayout:isShowing() then
            printLog("hitAllView  gViewCardTypeClassifierTopLayout")

            gViewCardTypeClassifierTopLayout:hide();
        end


    end)

end

local function reset()
    printLog("reset")

end
-- 游戏开始了
local function onGameStart()
    printLog("onGameStart")
    gHasAbnormalExit = false;
    resetVarible()
    --生成新的UUID
    local uuid = commonlib_getUtilTool():reGenerateNewUUID()
    printLog("generate UUID is " .. tostring(uuid))

    --上报游戏开始repor
    report_gamemaster_plugin_hlddz_main(1, 1,  0, 0, "", "",0,0);

    report_gamemaster_game_pubgm_state(100,0)
    if nil ~= settingTabelSwitch and settingTabelSwitch == true then
        report_gamemaster_game_pubgm_state(101,1)

    else
        report_gamemaster_game_pubgm_state(101,2)
    end

    commonlib_setGameParam(HLDDZ_KEY_SWITCH_FLOAT_BALL_SHOW_OR_HID, false)
    checkAndUpdateData()
    --showCardTypeClassifierViewOnUI(false)
end
local function getGameResult()
    local result = commonlib_getGameParam(HLDDZ_KEY_GAME_OVER_SUCCESS)
    if nil == result then
        return 0;
    end
    if false == result then
        return 2;
    end

    if result then
        return 1
    end
end
--游戏结束
local function onGameOver()
    printLog("onGameOver")
    commonlib_setGameParam(HLDDZ_KEY_SWITCH_FLOAT_BALL_SHOW_OR_HID, true)
    if gHasAbnormalExit == false then
        report_gamemaster_plugin_hlddz_main(4, 1,  getGameResult(), getCardDataCount(), getHandpoker(gCuurentCardData), getOutpoker(gOutCardData),0,0)
    end

    destroyCardCalssifierViewOnUI()
    resetVarible()
end

--游戏运行过程中识别模式
local function onGameRunning()
    --printLog("onGameRunning")
    if gHasAbnormalExit == false then
        commonlib_setGameParam(HLDDZ_KEY_SWITCH_FLOAT_BALL_SHOW_OR_HID, false)
        local lastCoverType = commonlib_getGameParam(HLDDZ_KEY_GAME_RUNNING_COVER_STATUS);

        if HLDDZ_GAME_COVER_NONE == lastCoverType then
            showAllView();
            checkAndUpdateData();
        else
            hitAllView();
        end

    end
end

local function onSettingViewOpen()
    updateShareTime()
end

local function onSettingViewClose()
    printLog("onSettingViewClose")
end

local function registerGameEvents()
    printLog("registerGameEvents")

    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_START], onGameStart)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_OVER], onGameOver)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)

    commonlib_registerSettingViewOpenCallback(onSettingViewOpen)
    commonlib_registerSettingViewCloseCallback(onSettingViewClose)

end

local function unregisterGameEvents()
    printLog("unregisterGameEvents")

    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_GAME], onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_OVER], onGameOver)
end

local function destoryViews()
    --销毁卡牌提示view
    printLog("destoryViews")
    destroyCardCalssifierView()


end

local function uninitVariable()

    gHasLoadData = false
end
local function init()
    printLog("init")
    initVariable()
    initSettingView();
    reset()
    registerGameEvents()

    --showCardTypeClassifierViewOnUI(false)

end

local function uninit()
    unregisterGameEvents()
    destoryViews()
    --uninitSettingView()
    reset()
    uninitVariable()
    printLog("uninit")
end

table.insert(common_life_circle_callbacks, { init, uninit, HLDDZ_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.card_type_classifier });
