--- float_window.lua
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by libin.
--- DateTime: 2018/6/28 14:38
---

local FLOAT_BALL_POSITION = { anchor = Anchor().TOPLEFT, x = 1640, y = 280 }
local FLOAT_BALL_POSITION_ENTER = { anchor = Anchor().TOPLEFT, x = 1640, y = 280}

local floatBall;
local settingView
local gbSettingViewOpen = false
local isFloatBatllShow = false
local isShowTips = false
local TAG = "float_window"
local function printLog(msg)
    commonlib_print(TAG, msg)
end

local function setSettingViewIcon()
    commonlib_setFloatBallIcon("common://image/special_floatball_icon.png")
    commonlib_setSettingViewIcon("common://image/icon_settingview.png")
    commonlib_setSettingViewIconSize(97.67, 65)
    commonlib_setSettingViewIconMargin(12, 0, 0, 0)
    commonlib_setSettingViewIconExtrudeHeight(21)
    commonlib_setFloatBallDragAndClick(true)
end

local function showFloatBall(show)

    local float_ball_show = commonlib_getGameParam(HLDDZ_KEY_SWITCH_FLOAT_BALL_SHOW_OR_HID)
    if float_ball_show ~= nil and float_ball_show ~= show then
        printLog("it is should hid that float ball when game be running ")
        show = float_ball_show;
    end

    printLog("showFloatBall " .. tostring(show))
    if floatBall == nil then
        printLog("showFloatBall return")
        return
    end

    if isFloatBatllShow then
        printLog("isFloatBatllShow return")
    end
    commonlib_runOnUIThread(
            function()
                if floatBall == nil then
                    printLog("showFloatBall return")
                    return
                end

                if gbSettingViewOpen then
                    printLog("showFloatBall return, setting view is opened")
                    return
                end
                isFloatBatllShow = show

                if show == true then
                    if not floatBall:isShowing() then
                        floatBall:show()
                        showFloatTips()
                    end
                else
                    if floatBall:isShowing() then
                        floatBall:hide()

                    end
                end
            end);
end

function showFloatTips()
    if isShowTips then
        printLog("showed Float Tips")
        return
    end
    local overdueTime = commonlib_getUtilTool():getHlddzOverdueTime()
    if overdueTime <= 3 and overdueTime > 0 then
        --commonlib_showTipsAnimation("打牌助手: 还有" .. tostring(overdueTime) .. "天到期")
        isShowTips = true
    end
end

local function moveFloatBall()
    commonlib_runOnUIThread(function()
        if floatBall == nil then
            return
        end
        commonlib_setFloatBallIcon("common://image/special_floatball_icon.png")
        floatBall:moveCenterTo(FLOAT_BALL_POSITION.anchor, FLOAT_BALL_POSITION.x, FLOAT_BALL_POSITION.y)
    end);
end

local function displayFlatBall()
    printLog("displayFlatBall")
    gbSettingViewOpen = false
    showFloatBall(true)
    moveFloatBall()
end
local function onGameHall()
    if gbSettingViewOpen or isFloatBatllShow then
        return
    end
    showFloatBall(true)
end

local function onGameRunning()
    if gbSettingViewOpen or isFloatBatllShow then
        return
    end
    showFloatBall(true)
end

local function onGameStateChanged(lastGameState, currentState)
    if gbSettingViewOpen then
        return
    end
    showFloatBall(true)
end

local function onSettingViewOpen()
    gbSettingViewOpen = true
    printLog("onSettingViewOpen")
end

local function onSettingViewClose()
    gbSettingViewOpen = false
    printLog("onSettingViewClose")
end

local function onEnterGame()
    commonlib_runOnUIThread(function()
        if floatBall == nil then
            return
        end
        commonlib_setFloatBallIcon("common://image/special_floatball_icon.png")
        floatBall:moveCenterTo(FLOAT_BALL_POSITION_ENTER.anchor, FLOAT_BALL_POSITION_ENTER.x, FLOAT_BALL_POSITION_ENTER.y)
    end);
end

local function registerGameEvents()


    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_IN_GAME_HALL], onGameHall)

    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_STATUS_CHANGED], onGameStateChanged)

    commonlib_registerSettingViewOpenCallback(onSettingViewOpen)
    commonlib_registerSettingViewCloseCallback(onSettingViewClose)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_IN_GAME_HALL], onGameHall)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_STATUS_CHANGED], onGameStateChanged)

    commonlib_unRegisterSettingViewOpenCallback(onSettingViewOpen)
    commonlib_unRegisterSettingViewCloseCallback(onSettingViewClose)
end

local function initVariable()
    commonlib_getUtilTool():addFristHlddzTime()
    settingView = commonlib_getSettingView();
    floatBall = commonlib_getFloatBall();
    floatBall:setTargetPackage("com.qqgame.hlddz")
    floatBall:setOnClickListener(function()
        settingView:show();
    end);
    isFloatBatllShow = false
end

local function init()
    printLog("init begin")
    registerGameEvents()
    initVariable()

    -- 开始设置悬浮球的外观
    setSettingViewIcon()

    displayFlatBall()
end

local function uninit()
    printLog("uninit")
    unregisterGameEvents()
    isFloatBatllShow = false
    isShowTips = false
end

table.insert(common_life_circle_callbacks, { init, uninit, HLDDZ_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.float_window})
