--- game_mode.lua
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by cm.
--- DateTime: 2018/10/11 15:39
---

local function printLog(msg)
    commonlib_print("game_mode", msg)
end

local gNewGameEngine;
local gameMode = nil
local findTime = 0

local function resetVarible()
    findTime = 0
    gameMode = HLDDZ_GAME_MODE_UNKNOW
    commonlib_setGameParam(HLDDZ_KEY_GAME_MODE, HLDDZ_GAME_MODE_UNKNOW);
end

local function onEnterGame()
    local result = gNewGameEngine:matchCondition("cd_build_game_model_laizi")
    if result == true then
        gameMode = HLDDZ_GAME_MODE_LAIZI
    else
        local result = gNewGameEngine:matchCondition("cd_build_game_model_three_discs")
        if result == true then
            gameMode = HLDDZ_GAME_MODE_THREE_DISCS
        end
    end

    local nowTime = commonlib_getCurrentTime()
    if findTime <= 0 then
        findTime = nowTime
    end

    if result == false then
        local diffTime = nowTime - findTime
        if diffTime <= 5 * 1000 then
            gameMode = HLDDZ_GAME_MODE_UNKNOW
        else
            gameMode = HLDDZ_GAME_MODE_NORMAL
        end
    else
        findTime = nowTime
    end

    commonlib_setGameParam(HLDDZ_KEY_GAME_MODE, gameMode);
    printLog("gamemode=" .. tostring(gameMode))
end

--游戏运行过程中识别模式
local function onGameRunning()
    if gameMode == nil or gameMode == HLDDZ_GAME_MODE_UNKNOW then
        onEnterGame()
    end
end

local function onGameOver()
    --resetVarible()
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_OVER], onGameOver)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_OVER], onGameOver)
end

local function initVarible()
    gNewGameEngine = CNewGameEngine:getInstance();
    resetVarible()
end

local function init()
    initVarible()
    registerGameEvents()
end

local function uninit()
    unregisterGameEvents()
end

table.insert(common_life_circle_callbacks, { init, uninit , HLDDZ_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.game_mode})