--- pick_pocker
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by cm.
--- DateTime: 2018/10/11 17:10
---

local function printLog(msg)
    commonlib_print("pick_pocker", msg)
end

--不要调整结构，会导致C++出牌步骤失败
local POKER_NUMBER = {
    ["0"] = "A",
    ["1"] = "2",
    ["2"] = "3",
    ["3"] = "4",
    ["4"] = "5",
    ["5"] = "6",
    ["6"] = "7",
    ["7"] = "8",
    ["8"] = "9",
    ["9"] = "X",
    ["10"] = "J",
    ["11"] = "Q",
    ["12"] = "K",
    ["13"] = "M",
    ["14"] = "N",
}
--不要调整结构，会导致C++出牌步骤失败
local POKER_TYPE = {
    ["0"] = "club",
    ["1"] = "diamond",
    ["2"] = "spade",
    ["3"] = "heart",
    ["4"] = "star",
}

local gNewGameEngine;
local numberTypeTabel
local isPickerPockerError = false
local isReportCardHolder = false

local function resetVarible()
    isPickerPockerError = false
    -- whosCard: owner = 1, left = 2, right = 3
    numberTypeTabel = {
        isChanged = false,
        pickPockerError = false,
        changedTime = 0,
        whosCard = 1,
        ownerData = {},
        playownerData = {},
        playSteps = {}}

    commonlib_setGameParam(HLDDZ_KEY_POKER_NUMBER_TYPE, numberTypeTabel)
    isReportCardHolder = false
end

local function checkNumberType(pokerNumber, pokerType)
    if pokerType == nil or pokerNumber == nil then
        return false
    end
    if pokerNumber < 0 or pokerNumber > 14 then
        return false
    end
    if pokerNumber < 13 and (pokerType < 0 or pokerType > 4) then
        return false
    end
    return true
end

local function convertNumberType(pokerNumber, pokerType)
    if false == checkNumberType(pokerNumber, pokerType) then
        return "??"
    end
    if pokerNumber < 13  then
        return POKER_TYPE[tostring(pokerType)] ..  POKER_NUMBER[tostring(pokerNumber)]
    else
        return POKER_NUMBER[tostring(pokerNumber)]
    end
end

function numberTypeTabelToString(ntTabel)
    if commonlib_isTableEmpty(ntTabel) then
        return "nil"
    end
    local str = ""
    for k ,v in pairs(ntTabel) do
        str = str .. "," .. convertNumberType(v.number, v.type)
    end
    return str
end

local function printNumberTypeTabel(ntTabel, isChanged, printStr)
    if false == isChanged or commonlib_isTableEmpty(ntTabel) then
        return
    end
    local str = numberTypeTabelToString(ntTabel)
    printLog("isChanged=" .. tostring(isChanged)
            .. ", " .. printStr
            .. ", size=" .. tostring(#ntTabel)
            .. ", data=" .. str)
end

local function parseCaffe2Classify(matchString, t, threshold)
    if t == nil then
        return nil
    end
    local index = 0
    local prob = 0
    --printLog("parseCaffe2Classify" .. matchString .. ", t=" .. tostring(t) .. ", size=" .. tostring(#t))
    for key, value in pairs(t) do
        if value.prob and value.prob > prob then
            prob = value.prob
            if value.index then
                index = value.index
            end
        end
        ---[[
        local str = " "
        for k, v in pairs(value) do
            str = str .. " [" .. tostring(k) .. "=" .. tostring(v) .. tostring("] ")
        end
        --commonlib_print("parseCaffe2Classify", matchString .. "[" .. tostring(key) .. "]"  .. str)
        --]]
    end
    if prob >= threshold then
        return index
    end
    return nil
end

local function updateNumberType(ntTabel)
    if ntTabel == nil then
        return
    end
    if commonlib_isTableEmpty(numberTypeTabel.ownerData) then
        numberTypeTabel.ownerData = ntTabel
        numberTypeTabel.isChanged = true
    elseif commonlib_isTableSame(numberTypeTabel.ownerData, ntTabel) then
        numberTypeTabel.isChanged = false
    else
        numberTypeTabel.ownerData = ntTabel
        numberTypeTabel.isChanged = true
    end
end

local function isHasData(number, type, playData)
    local result = false
    if commonlib_isTableEmpty(playData) then
        return result
    end

    for k, v in pairs(playData) do
        if number == v.number and type == v.type then
            result = true
        end
    end
    return result
end

local function getNumberType(t)
    if commonlib_isTableEmpty(t) then
        return nil
    end

    local ntTabel = {}
    for k, v in pairs(t) do
        local nTabel = gNewGameEngine:matchConditionOnResultInRect("cd_build_get_poker_number", v.x1, v.y1, v.w1, v.h1)
        local pokerNumber = parseCaffe2Classify("cd_build_get_poker_number", nTabel, 0.3)
        local pokerType = -1
        if pokerNumber ~= nil and (pokerNumber < 13) then
            local isLaizi = gNewGameEngine:matchConditionOnResultInRect("cd_build_game_is_laizi", v.x2, v.y2, v.w2, v.h2)
            if isLaizi ~= nil and isLaizi == true then
                pokerType = 4
            else
                local tTabel = gNewGameEngine:matchConditionOnResultInRect("cd_build_get_poker_type", v.x2, v.y2, v.w2, v.h2)
                pokerType = parseCaffe2Classify("cd_build_get_poker_type", tTabel, 0.3)
            end
            gNewGameEngine:clearConditionCache("cd_build_game_is_laizi")
        end
        if checkNumberType(pokerNumber, pokerType) == true then
            local covertStr = convertNumberType(pokerNumber, pokerType)

            if numberTypeTabel.playownerData ~= nil then
                if isHasData(pokerNumber, pokerType, numberTypeTabel.playownerData) == true then
                    return nil
                end
            end

            --commonlib_print("numberType=", "numberType=" .. covertStr
            --        .. ", x1=" .. v.x1 .. ", y1=" .. v.y1 .. ", w1=" .. v.w1 .. ", h1=" .. v.h1
            --        .. ", x2=" .. v.x2 .. ", y2=" .. v.y2 .. ", w2=" .. v.w2 .. ", h2=" .. v.h2 )
            if pokerNumber < 13 then
                table.insert(ntTabel, #ntTabel + 1, { type = pokerType, number = pokerNumber })
            else
                table.insert(ntTabel, #ntTabel + 1, {type = -1, number = pokerNumber })
            end
        else
            return nil
        end
    end
    return ntTabel
end

local function isInNumberTypeTabel(number, type)
    if type >= 4 then
        for k ,v in pairs(numberTypeTabel.ownerData) do
            if v.type >=4 then
                return true
            end
        end
    end

    local result = false
    if commonlib_isTableEmpty(numberTypeTabel.ownerData) then
        return result
    end

    for k, v in pairs(numberTypeTabel.ownerData) do
        if number == v.number and type == v.type then
            result = true
        end
    end
    return result
end

local function isInHandCard(ntTabel)
    local result = false
    if commonlib_isTableEmpty(ntTabel) then
        return result
    end

    for k, v in pairs(ntTabel) do
        result = isInNumberTypeTabel(v.number, v.type)
        if result == false then
            return false
        end
    end
    return result
end

local function deleteNumberTypeTabel(ntDatas)
    if commonlib_isTableEmpty(ntDatas) or commonlib_isTableEmpty(numberTypeTabel.ownerData) then
        return
    end
    local ntTabel = commonlib_deepCopy(ntDatas)

    local starNumber = 0
    for k, v in pairs(ntTabel) do
        if(v.type >= 4) then
            starNumber = starNumber + 1
        end
    end

    for i=1, starNumber do
        for k, v in pairs(ntTabel) do
            if(v.type >= 4) then
                table.remove(ntTabel, k)
                break
            end
        end
        for k, v in pairs(numberTypeTabel.ownerData) do
            if(v.type >= 4) then
                table.remove(numberTypeTabel.ownerData, k)
                break
            end
        end
    end

    for k, v in pairs(ntTabel) do
        for k1, v1 in pairs(numberTypeTabel.ownerData) do
            if v.number == v1.number and v.type == v1.type then
                table.remove(numberTypeTabel.ownerData, k1)
            end
        end
    end
end

local function onEnterGame()
    resetVarible()
end

--游戏运行过程中识别模式
local function onGameRunning()
    if isPickerPockerError == true then
        local lastNumberTypeTabel = commonlib_getGameParam(HLDDZ_KEY_POKER_NUMBER_TYPE)
        if lastNumberTypeTabel ~= nil then
            lastNumberTypeTabel.pickPockerError = true
        else
            lastNumberTypeTabel = {isChanged = false, pickPockerError = true, whosCard = 1, ownerData = {}}
        end
        commonlib_setGameParam(HLDDZ_KEY_POKER_NUMBER_TYPE, lastNumberTypeTabel)
        return
    end

    local gameMode = commonlib_getGameParam(HLDDZ_KEY_GAME_MODE);
    if gameMode == HLDDZ_GAME_MODE_LAIZI then
        --return
    end

    if  commonlib_isTableEmpty(numberTypeTabel.ownerData) then
        local ownerPockerRegion = gNewGameEngine:matchConditionOnTable("cd_build_game_owner_poker")
        local ntTabel = getNumberType(ownerPockerRegion)
        updateNumberType(ntTabel)
    else
        numberTypeTabel.isChanged = false
        local matchCaffe2Result = matchCaffe2Classify("cd_build_game_run_wait_right")
        if matchCaffe2Result == false then
            matchCaffe2Result = matchCaffe2Classify("cd_build_game_run_wait_left")
        end
        if matchCaffe2Result then
            if isReportCardHolder == false then
                local gamemode = commonlib_getGameParam(HLDDZ_KEY_GAME_MODE)
                local play = 0
                if gamemode == HLDDZ_GAME_MODE_LAIZI then
                    play = 1
                elseif gamemode == HLDDZ_GAME_MODE_THREE_DISCS then
                    play = 3
                elseif gamemode == HLDDZ_GAME_MODE_LAIZI then
                    play = 4
                end

                local result = gNewGameEngine:matchCondition("cd_build_match_card_holder")
                local resultValue = 0;
                if result == true then
                    resultValue = 1
                else
                    resultValue = 2
                end
                report_gamemaster_plugin_hlddz_main(10, 1, resultValue, 0,
                        "", "",0,0)
                isReportCardHolder = true
            end

            local playOwnerPockerRegion = gNewGameEngine:matchConditionOnTable("cd_build_game_play_owner_poker")
            if commonlib_isTableEmpty(playOwnerPockerRegion) then
                return
            end

            local ntTabel = getNumberType(playOwnerPockerRegion)
            if commonlib_isTableEmpty(ntTabel) then
                return
            end
            printNumberTypeTabel(ntTabel, true, "~~~~~~~~~~~~~~~~~~~~~~playOwner~~~~~~~~~~~~~~~~~~~~~~~~~~")
            if isInHandCard(ntTabel) then
                deleteNumberTypeTabel(ntTabel)
                numberTypeTabel.playownerData = ntTabel
                numberTypeTabel.isChanged = true
            end

        end
    end

    if numberTypeTabel.isChanged == true then
        local numberTypeString = numberTypeTabelToString(numberTypeTabel.ownerData)
        printLog("landlords, numberTypeString=" .. numberTypeString)
        local cardSteps = gNewGameEngine:matchConditionOnResultInLandlords("cd_build_get_card_step", numberTypeString)
        if cardSteps ~= nil then
            printLog("landlords, cardSteps size=" .. tostring(#cardSteps))
            local index = 1
            for key, value in pairs(cardSteps) do
                local str;
                for k, v in pairs(value) do
                    if str == nil then
                        str = "playType[" .. tostring(v.playType) .. "]"
                    end
                    str = str .. "," .. convertNumberType(v.number, v.type)
                end
                printLog("landlords, step=" .. tostring(index) .. ", " .. tostring(str))
                index = index + 1
            end
            numberTypeTabel.playSteps = commonlib_deepCopy(cardSteps)
        end
        numberTypeTabel.changedTime = commonlib_getCurrentTime()
        printLog("changedTime=" .. tostring(numberTypeTabel.changedTime))
    end
    
    local lsatNumberTypeTabel = commonlib_getGameParam(HLDDZ_KEY_POKER_NUMBER_TYPE)
    if lsatNumberTypeTabel == nil or numberTypeTabel.isChanged ~= lsatNumberTypeTabel.isChanged then
        commonlib_setGameParam(HLDDZ_KEY_POKER_NUMBER_TYPE, numberTypeTabel)
    end
end

local function onGameOver()
    resetVarible()
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_OVER], onGameOver)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[HLDDZ_KEY_GAME_OVER], onGameOver)
end

local function initVarible()
    gNewGameEngine = CNewGameEngine:getInstance();
    resetVarible()
end

local function init()
    initVarible()
    registerGameEvents()
end

local function uninit()
    unregisterGameEvents()
end

table.insert(common_life_circle_callbacks, { init, uninit , HLDDZ_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.pick_poker})