-- 瞄准器脚本
local TAG = "gun_sight"
local function printLog(msg)
    commonlib_print(TAG, msg)
end

local function onBackpackIconChange(hasIcon)
    printLog("onBackpackIconChange : " .. tostring(hasIcon))
    local isCbSwitchChecked = common_gun_sight_getCbSwitchCheckState()
    local isCbAlwaysOpenChecked = common_gun_sight_getCbAlwaysOpenCheckState()
    commonlib_runOnUIThread(function()
        common_gun_sight_updateGunSight()
        if hasIcon and isCbSwitchChecked and isCbAlwaysOpenChecked then
            printLog("显示瞄准器")
            common_gun_sight_show(true)
        else
            printLog("隐藏瞄准器")
            common_gun_sight_show(false)
        end
    end)
end

local function onRightGunChange(hasIcon)
    printLog("onRightGunChange : " .. tostring(hasIcon))
    local isCbSwitchChecked = common_gun_sight_getCbSwitchCheckState()
    local isCbAlwaysOpenChecked = common_gun_sight_getCbAlwaysOpenCheckState()
    commonlib_runOnUIThread(function()
        printLog("isCbAlwaysOpenChecked : " .. tostring(isCbAlwaysOpenChecked))
        if not isCbSwitchChecked then
            printLog("Checkbox 未选中，隐藏瞄准器")
            common_gun_sight_show(false)
            return;
        end

        if hasIcon then
            printLog("有右侧拳头按钮，显示瞄准器")
            common_gun_sight_show(true)
        else
            if isCbAlwaysOpenChecked then
                printLog("始终开启瞄准器选项选中，显示瞄准器")
                common_gun_sight_show(true)
            else
                printLog("开始隐藏瞄准器")
                common_gun_sight_show(false)
            end
        end
    end)
end

local function registerEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_BACKPACK], onBackpackIconChange)
    commonlib_registerCallback(common_game_events_callbacks[KEY_RIGHT_GUN], onRightGunChange)
    printLog("事件注册成功")
end

local function unRegisterEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_BACKPACK], onBackpackIconChange)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_RIGHT_GUN], onRightGunChange)
end

local function init()
    printLog("gun_sight script init")
    common_gun_sight_init()
    common_gun_sight_show(false)
    registerEvents();
end

local function uninit()
    printLog("gun_sight script uninit")
    common_gun_sight_uninit()
    unRegisterEvents();
end

table.insert(common_life_circle_callbacks, { init, uninit });