-- 瞄准器脚本
local TAG = "gun_sight"
local function printLog(msg)
    commonlib_print(TAG, msg)
end

local function onWork()
    local isCbSwitchChecked = common_gun_sight_getCbSwitchCheckState()
    local currentState =  commonlib_getGameParam(PUBGM_KEY_GAME_STATE);
    local coverState =  commonlib_getGameParam(PUBGM_KEY_GAME_RUNNING_COVER_STATUS)

    printLog("on work, isCbSwitchChecked=" .. tostring(isCbSwitchChecked)
            .. ", currentState=" .. tostring(currentState)
            .. ", coverState=" .. tostring(coverState))

    commonlib_runOnUIThread(function()
        common_gun_sight_updateGunSight()
        if isCbSwitchChecked and coverState == PUBGM_GAME_COVER_NONE and currentState == PUBGM_GAMESTATE_RUNNING then
            printLog("显示瞄准器")
            common_gun_sight_show(true)
        else
            printLog("隐藏瞄准器")
            common_gun_sight_show(false)
        end
    end)
end


local function registerEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_WORK], onWork)
    printLog("事件注册成功")
end

local function unRegisterEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_WORK], onWork)
end

local function init()
    printLog("gun_sight script init")

    common_gun_sight_init()
    common_gun_sight_show(false)

    registerEvents();
end

local function uninit()
    printLog("gun_sight script uninit")
    common_gun_sight_uninit()
    unRegisterEvents();
end

table.insert(common_life_circle_callbacks, { init, uninit });