--- 资源地图
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by libin.
--- DateTime: 2018/8/29 15:36
---
local function printLog(msg)
    commonlib_print("map_resource", msg)
end

local CONST_VALUE = {
    TAB_NAME                   = "资源地图",
    CHECKBOX_TEXT              = "开启资源地图",
    KEY_IS_MAP_RESOURCE_ENABLE = "key_pubgm_is_map_resource_enable", --资源地图
    KEY_IS_MAP_RESOURCE_BUTTON = "key_pubgm_is_map_resource_botton",
    MAX_RESOURCE_MAP_SETTING_VIEW = 6,
    RESOURCE_MAP_SETTING_HEIGHT_DIFF = (42 + 26),
    KEY_IS_MAP_RESOURCE_SETTING = "key_pubgm_is_map_resource_setting_",
    TEXT_DEFAULT_SIZE_PX = 24 + 1.5,
    TYPE_RESOURCE_ADVANCED = 1,
    TYPE_RESOURCE_INTERMEDIATE = 2,
    TYPE_RESOURCE_GENERAL = 3,
    TYPE_CAR_FIXED = 4,
    TYPE_CAR_PROBABILITY = 5,
    TYPE_AIR_LINE_ROUNT = 6,
    CURRENT_MAP_EXTAND = 1,
    CURRENT_MAP_NORMAL = 2,
}

-------------setting-------------
local gbResMapSwitch --- 设置上的资源地图开关
local gResMapSwitchView;

local gfScaleRelativeTo1080
local gNewGameEngine

local unClickFoatView
local mapResourceView

local mapSettingClickFloat

local mapButtonClickFloat
local mapButtonView
local isMapButtonClicked = true

local mapResourceData = nil
local mapSettingTipsView

local mapType = -1 --- 地图类型, KEY_NAME_MAP_ISLAND或KEY_NAME_MAP_DESERT

local gRoute = nil
local MAX_AIR_LINE_ROUTE = 3
local airLineRouteCount = 0

local currentMapState = -1

local function reportOp(action)
    local state = 0
    if isMapButtonClicked then
        state = 1
    else
        state = 2
    end
    commonlib_report("gamemaster_pubgm_resourcesmap",
            {
                ["action"] = action,
                ["state"]  = state,
                ["map"]    = mapType,
                ["game_map"] = mapType,
                ["game_id"] = commonlib_getGameId(),
            });

    printLog("report, action:" .. tostring(action)
            .. ", state:" .. tostring(state)
            .. ", map or game_map:" .. tostring(mapType)
            .. ", gameId:" .. tostring(commonlib_getGameId()))
end

local function resetMapResourceData()
    mapResourceData = nil
    mapResourceData = {
        [CONST_VALUE.TYPE_RESOURCE_ADVANCED] = { switch = true, resourceViews = {}, settingViews = {} },
        [CONST_VALUE.TYPE_RESOURCE_INTERMEDIATE] = { switch = true, resourceViews = {}, settingViews = {} },
        [CONST_VALUE.TYPE_RESOURCE_GENERAL] = { switch = false, resourceViews = {}, settingViews = {} },
        [CONST_VALUE.TYPE_CAR_FIXED] = { switch = true, resourceViews = {}, settingViews = {} },
        [CONST_VALUE.TYPE_CAR_PROBABILITY] = { switch = false, resourceViews = {}, settingViews = {} },
        [CONST_VALUE.TYPE_AIR_LINE_ROUNT] = { switch = false, resourceViews = {}, settingViews = {} },
    }
end

local function resetData()
    resetMapResourceData()
    isMapButtonClicked = commonlib_getSharedPrefBoolean(CONST_VALUE.KEY_IS_MAP_RESOURCE_BUTTON, true)
    mapType = -1
    gRoute = nil
    airLineRouteCount = 0
    currentMapState = -1
end

local function getMapConfigData()
    if mapType == 1 then
        return GLOBAL_KEY_NAME_MAP_CLASSIC_ISLAND
    end

    if mapType == 2 then
        return GLOBAL_KEY_NAME_MAP_ISLAND
    end

    if mapType == 3 then
        return GLOBAL_KEY_NAME_MAP_DESERT
    end

    if mapType == 4 then
        return GLOBAL_KEY_NAME_MAP_RAINFOREST
    end

    return nil
end

local function getMapResourceSettingSwitchState(type)
    if mapResourceData == nil then
        resetMapResourceData()
    end
    printLog("getMapResourceSettingSwitchState, type=" .. tostring(type))
    local mapData = mapResourceData[type]
    if mapData == nil then
        printLog("getMapResourceSettingSwitchState, mapData=nil")
        return
    end

    local s = CONST_VALUE.KEY_IS_MAP_RESOURCE_SETTING .. tostring(type)
    local result = commonlib_getSharedPrefBoolean(s, mapData.switch)
    printLog("getMapResourceSettingSwitchState result=" .. tostring(result) .. ", type=" .. tostring(type) .. ", s=" .. tostring(s))
    return result
end

local function setMapResourceSettingSwitchState(type, value)
    if mapResourceData == nil then
        resetMapResourceData()
    end
    printLog("setMapResourceSettingSwitchState, type=" .. tostring(type) .. ", value=" .. tostring(value))
    local mapData = mapResourceData[type]
    if mapData == nil then
        printLog("setMapResourceSettingSwitchState, mapData=nil")
        return
    end
    local s = CONST_VALUE.KEY_IS_MAP_RESOURCE_SETTING .. tostring(type)
    mapData.switch = value
    printLog("setMapResourceSettingSwitchState s=" .. tostring(s) .. ", type=" .. tostring(type) .. ", value=" .. tostring(value))
    commonlib_setSharedPrefBoolean(s, mapData.switch)

end

local function setSettingViewToMapResourceData(type, checkboxView, imageView, circleView)
    local mapData = mapResourceData[type]
    if mapData == nil then
        printLog("setSettingViewToMapResourceData, mapData=nil")
        return
    end
    table.insert(mapData.settingViews,
            #mapData.settingViews + 1,
            {checkbox = checkboxView, image = imageView, circle = circleView} )
    printLog("setSettingViewToMapResourceData size=" .. tostring(#mapData.settingViews))
end

local function setResourceViewToMapResourceData(type, imageView, circleView, lineView)
    local mapData = mapResourceData[type]
    if mapData == nil then
        printLog("setResourceViewToMapResourceData, mapData=nil")
        return
    end
    table.insert(mapData.resourceViews,
            #mapData.resourceViews + 1,
            {image = imageView, circle = circleView, line = lineView} )
    printLog("setResourceViewToMapResourceData size=" .. tostring(#mapData.resourceViews))
end

local function fillRouteResult(x, y, left, top, width, height, retRoute)
    if nil == retRoute then
        return
    end

    local result = false
    if x >= left and x <= left + width and y >= top and y <= top + height then
        if nil == retRoute.x1 or nil == retRoute.y1 then
            retRoute.x1 = x
            retRoute.y1 = y
        else
            retRoute.x2 = x
            retRoute.y2 = y
        end
        result = true
    end

    printLog("fillRouteResult: " .. tostring(result) .. ", x="..tostring(x)..",y="..tostring(y)..
            ", left="..tostring(left)..", top="..tostring(top) ..
            ", width:" .. tostring(width) .. ", height:" .. tostring(height));
end

local function toFullRoute(origRoute, left, top, width, height)
    if nil == origRoute then
        return origRoute
    end

    if origRoute.x2 == origRoute.x1 then
        if origRoute.y2 == origRoute.y1 then
            return origRoute
        else
            --- 垂直直线
            local ret = {
                x1 = origRoute.x1,
                y1 = top,
                x2 = origRoute.x2,
                y2 = top + height
            }

            return ret
        end
    elseif origRoute.y2 == origRoute.y1 then
        --- 水平直线
        local ret = {
            x1 = left,
            y1 = origRoute.y1,
            x2 = left + width,
            y2 = origRoute.y2
        }
        return ret
    end

    local k = (origRoute.x2 - origRoute.x1) / (origRoute.y2 - origRoute.y1)
    if 0 == k then
        return origRoute
    end

    local ret = {
        x1 = nil,
        y1 = nil,
        x2 = nil,
        y2 = nil,
    }

    local xPoint1 = left
    local yPoint1 = (xPoint1 - origRoute.x2) / k + origRoute.y2
    fillRouteResult(xPoint1, yPoint1, left, top, width, height, ret)

    local xPoint2 = left + width
    local yPoint2 = (xPoint2 - origRoute.x2) / k + origRoute.y2
    fillRouteResult(xPoint2, yPoint2, left, top, width, height, ret)

    local yPoint3 = top
    local xPoint3 = k * (yPoint3 - origRoute.y2) + origRoute.x2
    fillRouteResult(xPoint3, yPoint3, left, top, width, height, ret)

    local yPoint4 = top + height
    local xPoint4 = k * (yPoint4 - origRoute.y2) + origRoute.x2
    fillRouteResult(xPoint4, yPoint4, left, top, width, height, ret)

    if nil == ret.x1 or nil == ret.y1 or nil == ret.x2 or nil == ret.y2 then
        return origRoute
    else
        return ret
    end
end

local function toSizePxString(size)
    return tostring(size) .. "px"
end

local function toSize(size, scale)
    if nil == size or nil == scale then
        return 0
    end

    return size * scale
end

local function toScaleSizePxString(size, scale)
    return tostring(toSize(size, scale)) .. "px"
end

local function createRelativeLayoutParam(layoutParam, topViewId)
    if nil == layoutParam  then
        printLog("createRelativeLayoutParam, args error!!!")
        return
    end

    local params = create("RelativeLayoutParam");
    local paramProperties = {
        layout_marginTop    = toScaleSizePxString(layoutParam.marginTop, gfScaleRelativeTo1080),
        layout_marginLeft   = toScaleSizePxString(layoutParam.marginLeft, gfScaleRelativeTo1080),
        layout_marginRight  = toScaleSizePxString(layoutParam.marginRight, gfScaleRelativeTo1080),
        layout_marginBottom = toScaleSizePxString(layoutParam.marginBottom, gfScaleRelativeTo1080),
        layout_width        = toScaleSizePxString(layoutParam.width, gfScaleRelativeTo1080),
        layout_height       = toScaleSizePxString(layoutParam.height, gfScaleRelativeTo1080),
        layout_below        = topViewId
    }
    params:setLayoutParam(paramProperties);
    return params
end

local function createRelativeLayout(floatView, mapLayoutRect, tag)
    if nil == floatView  then
        printLog("createRelativeLayout, floatView is nil, tag:".. tag)
        return
    end

    if nil ~= mapLayoutRect then
        local layoutView = floatView:addRelativeLayout( --- 这个函数内部会基于1080p做缩放
                mapLayoutRect.flag,
                mapLayoutRect.left,
                mapLayoutRect.top,
                mapLayoutRect.width,
                mapLayoutRect.height,
                ZOrder().zorder_bottom)

        printLog("createRelativeLayout, " .. tag .. " relativelayout succeed, flag:" .. tostring(mapLayoutRect.flag) ..
                ", left:" .. tostring(mapLayoutRect.left) .. ", top:" .. tostring(mapLayoutRect.top) ..
                ", w:" .. tostring(mapLayoutRect.width) .. ", h:" .. tostring(mapLayoutRect.height))
        return layoutView
    else
        printLog("createRelativeLayout failed, tag:".. tag)
    end
end

local function createImageView(relativeLayout, imageLayoutRect, imagePath, topViewId)
    if nil == relativeLayout or nil == imageLayoutRect or nil == imagePath then
        printLog("createImageView, args error")
        return
    end

    local imageParam = createRelativeLayoutParam(imageLayoutRect, topViewId)
    local imageView  = relativeLayout:addImageView(imagePath, imageParam, nil)
    if nil == imageView then
        printLog("createImageView, create imageview error")
        return
    end

    return imageView
end

local function createTextView(relativeLayout, textLayoutRect, textDataCfg, topViewId)
    if nil == relativeLayout or nil == textLayoutRect or nil == textDataCfg then
        printLog("createTextView, args error")
        return
    end

    local textParam = createRelativeLayoutParam(textLayoutRect, topViewId)
    local textView = relativeLayout:addTextView(
            textDataCfg.text, textDataCfg.textColor, toScaleSizePxString(textDataCfg.textSize, gfScaleRelativeTo1080), textParam, nil)
    if nil == textView then
        printLog("createTextView, create error")
        return
    end

    return textView
end

local function checkRouteValid(routeValue)
    if nil == routeValue or nil == gNewGameEngine then
        printLog("checkRouteValid data invalid");
        return false
    end

    local rect = gNewGameEngine:getConditionRect("cd_rect_build_map_resource")
    if nil == rect then
        printLog("checkRouteValid map rect invalid");
        return false
    end

    local width  = toSize(rect.width, gfScaleRelativeTo1080)
    local height = toSize(rect.height, gfScaleRelativeTo1080)

    local routeRelative = toFullRoute(routeValue, 0, 0, width, height)
    if nil == routeRelative or nil == routeRelative.y1 or nil == routeRelative.y2 then
        printLog("checkRouteValid toFullRoute invalid");
        return
    end

    local minY = toSize(CONST_VALUE.ROUTE_MIN_Y, gfScaleRelativeTo1080)
    local bRet = routeRelative.y1 > minY or routeRelative.y2 > minY
    if not bRet then
        printLog("checkRouteValid invalid, y1:" .. tostring(routeRelative.y1) .. ", y2:" .. tostring(routeRelative.y2));
    end

    return bRet
end

local function getResourceSettingViewRect(settingConfig)
    local settingRect = gNewGameEngine:getConditionRect("cd_rect_build_map_resource_setting")
    local tlen = #settingConfig
    if tlen < CONST_VALUE.MAX_RESOURCE_MAP_SETTING_VIEW then
        local diff = (CONST_VALUE.MAX_RESOURCE_MAP_SETTING_VIEW - tlen) * CONST_VALUE.RESOURCE_MAP_SETTING_HEIGHT_DIFF
        settingRect.height = settingRect.height - diff
        settingRect.top = settingRect.top + diff
    end
    printLog("settingRect, top" .. tostring(settingRect.top)
            .. ", left=" .. tostring(settingRect.left)
            .. ", width=" .. tostring(settingRect.width)
            .. ", height=" .. tostring(settingRect.height))
    return settingRect
end

local function getResourceSettingConfig()
    local settingConfig = {}
    local mapConfig = getMapConfigData()
    if mapConfig ~= nil and mapConfig.resourceAdvanced ~= nil and commonlib_isTableEmpty(mapConfig.resourceAdvanced) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_RESOURCE_ADVANCED,
            text = "高级物质",
            circle = { border_size = 2, border_color = 0xFF5C00, border_alpha = 0xFF, fill_color = 0xFF5C00, fill_alpha = 0x7F, radius = 16 }, }
        table.insert(settingConfig, #settingConfig + 1, value)
    end
    if mapConfig ~= nil and mapConfig.resourceIntermediate ~= nil and commonlib_isTableEmpty(mapConfig.resourceIntermediate) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_RESOURCE_INTERMEDIATE,
            text = "中级物质",
            circle = { border_size = 2, border_color = 0xFFD100, border_alpha = 0xFF, fill_color = 0xFBD100, fill_alpha = 0x66, radius = 16 }, }
        table.insert(settingConfig, #settingConfig + 1, value)
    end
    if mapConfig ~= nil and mapConfig.resourceGeneral ~= nil and commonlib_isTableEmpty(mapConfig.resourceGeneral) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_RESOURCE_GENERAL,
            text = "一般物质",
            circle = { border_size = 2, border_color = 0x11D217, border_alpha = 0xFF, fill_color = 0x12D219, fill_alpha = 0x66, radius = 16 }, }
        table.insert(settingConfig, #settingConfig + 1, value)
    end
    if mapConfig ~= nil and mapConfig.carFixed ~= nil and commonlib_isTableEmpty(mapConfig.carFixed) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_CAR_FIXED,
            text = "固定车辆",
            image = { path = "common://image/mapres/fixed_car.png" }, }
        table.insert(settingConfig, #settingConfig + 1, value)
    end
    if mapConfig ~= nil and mapConfig.carProbability ~= nil and commonlib_isTableEmpty(mapConfig.carProbability) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_CAR_PROBABILITY,
            text = "概率车辆",
            image = { path = "common://image/mapres/probability_car.png"}, }
        table.insert(settingConfig, #settingConfig + 1, value)
    end
    if mapConfig ~= nil then
        if gRoute ~= nil then
            local value = {
                type = CONST_VALUE.TYPE_AIR_LINE_ROUNT,
                text = "跳伞航线", }
            table.insert(settingConfig, #settingConfig + 1, value)
        end
    end
    return settingConfig
end

local function updateResourceViews()
    for key, value in pairs(mapResourceData) do
        local result = getMapResourceSettingSwitchState(key)
        if result then
            printLog("updateResourceViews size=" .. tostring(#value.resourceViews) .. ", key, =" .. tostring(key))
            for k, v in pairs(value.resourceViews) do
                if v.image ~= nil then
                    if v.image:isShowing() ~= true then
                        v.image:show()
                    end
                end
                if v.circle ~= nil then
                    if v.circle:isShowing() ~= true then
                        v.circle:show()
                    end
                end
                if v.line ~= nil then
                    if v.line:isShowing() ~= true then
                        v.line:show()
                    end
                end
            end
        else
            for k, v in pairs(value.resourceViews) do
                if v.image ~= nil then
                    if v.image:isShowing() then
                        v.image:hide()
                    end
                end
                if v.circle ~= nil then
                    if v.circle:isShowing() then
                        v.circle:hide()
                    end
                end
                if v.line ~= nil then
                    if v.line:isShowing() then
                        v.line:hide()
                    end
                end
            end
        end
    end
    if mapResourceView:isShowing() ~= true then
        mapResourceView:show()
    end
end

local function reportSwitch(type)
    if type == CONST_VALUE.TYPE_AIR_LINE_ROUNT then
        reportOp(4)
    elseif type == CONST_VALUE.TYPE_RESOURCE_ADVANCED then
        reportOp(5)
    elseif type == CONST_VALUE.TYPE_RESOURCE_INTERMEDIATE then
        reportOp(6)
    elseif type == CONST_VALUE.TYPE_RESOURCE_GENERAL then
        reportOp(7)
    elseif type == CONST_VALUE.TYPE_CAR_FIXED then
        reportOp(8)
    elseif type == CONST_VALUE.TYPE_CAR_PROBABILITY then
        reportOp(9)
    end
end

--- 单项开关变化的回调
local function onResourceSwitchChange(resKey, bEnable)
    setMapResourceSettingSwitchState(resKey, bEnable)
    updateResourceViews()
    reportSwitch(resKey)
end

local function createResourceMapSettingView()
    if mapSettingClickFloat ~= nil then
        return
    end

    printLog("create createResourceMapSettingView start")
    local settingConfig = getResourceSettingConfig()
    if commonlib_isTableEmpty(settingConfig) then
        printLog("createResourceMapSettingView, getResourceSettingConfig=nil")
        return
    end
    local rect = getResourceSettingViewRect(settingConfig)
    if commonlib_isTableEmpty(rect) then
        printLog("createResourceMapSettingView, getResourceSettingViewRect=nil")
        return
    end

    if mapSettingClickFloat == nil then
        mapSettingClickFloat = commonlib_getFloatViewMgrEx():create(
                rect.left,
                rect.top,
                rect.width,
                rect.height,
                rect.flag,
                true)
        local layoutView = mapSettingClickFloat:addRelativeLayout(Anchor().TOPLEFT, 0, 0, rect.width, rect.height, ZOrder().zorder_bottom)
        local titleRect = {
            width = 203,
            height = 44,
        }
        local titleView = createImageView(layoutView, titleRect, "common://image/mapres/setting_title.png", nil)
        local contentLayoutRect = rect
        local contentParam = createRelativeLayoutParam(contentLayoutRect, titleView:getId());
        if nil == contentParam then
            printLog("createResSettingView, createRelativeLayoutParam error")
            return
        end
        local contentRelativeLayout = layoutView:addRelativeLayout(contentParam)
        if nil ~= contentRelativeLayout then
            contentRelativeLayout:setDefaultBackground();
        end

        local belowId = nil
        local checkboxRect = { marginLeft = 24,
                               marginTop = 0,
                               marginRight = 0,
                               marginBottom = 0,
                               width = 220,
                               height = 42 + 26,
                               paddingTop = 13,
                               paddingBottom = 13, }
        local checkBoxView = nil

        local checkboxCircleRect = {
            marginLeft = 240, marginTop = 19, marginRight = 0, marginBottom = 0, width = 34, height = 34 ,
        }
        local checkboxCirclView = nil

        local checkboxImageRect = {
            marginLeft = 240, marginTop = 19, marginRight = 0, marginBottom = 0, width = 28, height = 36 ,
        }
        local checkboxImageView = nil
        local isFirstContentRelativeLayout = true
        for key, value in pairs(settingConfig) do
            if isFirstContentRelativeLayout then
                checkboxRect.marginTop = checkboxRect.marginTop + 24
                checkboxCircleRect.marginTop = checkboxCircleRect.marginTop + 24
                checkboxImageRect.marginTop = checkboxImageRect.marginTop + 24
                isFirstContentRelativeLayout = false
            else
                checkboxRect.marginTop = 0
                checkboxCircleRect.marginTop = 19
                checkboxImageRect.marginTop = 19
            end
            checkboxCirclView = nil
            checkboxImageView = nil

            printLog("settingConfig key=" .. tostring(key) .. ", value=" .. tostring(value))
            if value.text ~= nil then
                printLog("settingConfig text=" .. tostring(value.text))
                local checkboxParams = createRelativeLayoutParam(checkboxRect, belowId)
                local checkboxValue = getMapResourceSettingSwitchState(value.type)
                setMapResourceSettingSwitchState(value.type, checkboxValue)
                checkBoxView = contentRelativeLayout:addCheckBoxView(value.text, checkboxValue, checkboxParams, function(id, isChecked)
                    onResourceSwitchChange(value.type, isChecked)
                end, "customStyle2",
                        toScaleSizePxString(checkboxRect.padding,       gfScaleRelativeTo1080),
                        toScaleSizePxString(checkboxRect.paddingLeft,   gfScaleRelativeTo1080),
                        toScaleSizePxString(checkboxRect.paddingRight,  gfScaleRelativeTo1080),
                        toScaleSizePxString(checkboxRect.paddingTop,    gfScaleRelativeTo1080),
                        toScaleSizePxString(checkboxRect.paddingBottom, gfScaleRelativeTo1080))
                if value.circle ~= nil then
                    local circleR = toSize(value.circle.radius, gfScaleRelativeTo1080)
                    local circleBorderSize = toSize(value.circle.border_size, gfScaleRelativeTo1080)
                    local circleParams = createRelativeLayoutParam(checkboxCircleRect, belowId);
                    if nil ~= circleParams then
                        checkboxCirclView =  contentRelativeLayout:addCircleView(circleParams, circleR, circleBorderSize,
                                value.circle.border_color, value.circle.fill_color, value.circle.border_alpha, value.circle.fill_alpha)
                        printLog("settingConfig circle, "
                                .. ", circleR=" .. tostring(circleR)
                                .. ", circleBorderSize=" .. tostring(circleBorderSize)
                                .. ", border_color=" .. tostring(value.circle.border_color)
                                .. ", fill_color=" .. tostring(value.circle.fill_color)
                                .. ", border_alpha=" .. tostring(value.circle.border_alpha)
                                .. ", fill_alpha=" .. tostring(value.circle.fill_alpha))
                    end
                elseif value.image ~= nil then
                    checkboxImageView = createImageView(contentRelativeLayout, checkboxImageRect, value.image.path, belowId)
                    printLog("settingConfig image, path=" .. tostring(value.image.path))
                end
                if checkBoxView ~= nil then
                    belowId = checkBoxView:getId()
                    setSettingViewToMapResourceData(value.type, checkBoxView, checkboxImageView, checkboxCirclView)
                end
            end
        end
    end
    printLog("create createResourceMapSettingView end")
end

local function destroyResourceMapView()
    if mapResourceView ~= nil then
        commonlib_runOnUIThread(function()
            for key, value in pairs(mapResourceData) do
                for k, v in pairs(value.resourceViews) do
                    if v.image ~= nil then
                        v.image:destroy()
                        v.image = nil
                    end
                    if v.circle ~= nil then
                        v.circle:destroy()
                        v.circle = nil
                    end
                    if v.line ~= nil then
                        v.line:destroy()
                        v.circle = nil
                    end
                end
                value.resourceViews = {}
            end
            mapResourceView:destroy()
            mapResourceView = nil
        end)
    end
end

local function hideResourceMapView()
    if mapResourceView ~= nil then
        commonlib_runOnUIThread(function()
            if mapResourceView:isShowing() then
                mapResourceView:hide()
            end

            for key, value in pairs(mapResourceData) do
                for k, v in pairs(value.resourceViews) do
                    if v.image ~= nil then
                        if v.image:isShowing() then
                            v.image:hide()
                        end
                    end
                    if v.circle ~= nil then
                        if v.circle:isShowing() then
                            v.circle:hide()
                        end
                    end
                    if v.line ~= nil then
                        if v.line:isShowing() then
                            v.line:hide()
                        end
                    end
                end
            end
        end)
    end
end

local function showResourceMapView()
    if mapResourceView ~= nil then
        commonlib_runOnUIThread(function()
            updateResourceViews()
        end)
    end
end

local function hideResourceMapSettingView()
    if mapSettingClickFloat ~= nil then
        commonlib_runOnUIThread(function()
            if mapSettingClickFloat:isShowing() then
                mapSettingClickFloat:hide()
            end
        end)
        hideResourceMapView()
    end
end

local function destroyResourceMapSettingView()
    if mapSettingClickFloat ~= nil then
        commonlib_runOnUIThread(function()
            mapSettingClickFloat:destroy()
            mapSettingClickFloat = nil
        end)
    end
end

local function showResourceMapSettingView()
    if mapSettingClickFloat ~= nil then
        commonlib_runOnUIThread(function()
            if mapSettingClickFloat:isShowing() == false then
                mapSettingClickFloat:show()
            end
        end)
        showResourceMapView()
    end

end

local function getMapResourceViewConfig()
    local settingConfig = {}
    local mapConfig = getMapConfigData()
    if mapConfig ~= nil and mapConfig.resourceAdvanced ~= nil and commonlib_isTableEmpty(mapConfig.resourceAdvanced) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_RESOURCE_ADVANCED,
            text = "高级物质",
            circle = { border_size = 2, border_color = 0xFF5C00, border_alpha = 0xE5, fill_color = 0xFF5C00, fill_alpha = 0x59 },
            rect = mapConfig.resourceAdvanced }
        table.insert(settingConfig, #settingConfig + 1, value)
    end

    if mapConfig ~= nil and mapConfig.resourceIntermediate ~= nil and commonlib_isTableEmpty(mapConfig.resourceIntermediate) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_RESOURCE_INTERMEDIATE,
            text = "中级物质",
            circle = { border_size = 2, border_color = 0xFFD100, border_alpha = 0xE5, fill_color = 0xFBD100, fill_alpha = 0x59 },
            rect = mapConfig.resourceIntermediate }
        table.insert(settingConfig, #settingConfig + 1, value)
    end

    if mapConfig ~= nil and mapConfig.resourceGeneral ~= nil and commonlib_isTableEmpty(mapConfig.resourceGeneral) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_RESOURCE_GENERAL,
            text = "一般物质",
            circle = { border_size = 2, border_color = 0x11D217, border_alpha = 0xE5, fill_color = 0x12D219, fill_alpha = 0x59 },
            rect = mapConfig.resourceGeneral }
        table.insert(settingConfig, #settingConfig + 1, value)
    end

    if mapConfig ~= nil and mapConfig.carFixed ~= nil and commonlib_isTableEmpty(mapConfig.carFixed) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_CAR_FIXED,
            text = "固定车辆",
            image = { path = "common://image/mapres/fixed_car.png", width = 18, height = 23 },
            rect = mapConfig.carFixed }
        table.insert(settingConfig, #settingConfig + 1, value)
    end

    if mapConfig ~= nil and mapConfig.carProbability ~= nil and commonlib_isTableEmpty(mapConfig.carProbability) ~= true then
        local value = {
            type = CONST_VALUE.TYPE_CAR_PROBABILITY,
            text = "概率车辆",
            image = { path = "common://image/mapres/probability_car.png", width = 18, height = 23 },
            rect = mapConfig.carProbability }
        table.insert(settingConfig, #settingConfig + 1, value)
    end

    if mapConfig ~= nil then
        local routeValue
        if gRoute ~= nil then
            routeValue = gRoute
        end
        if routeValue ~= nil and checkRouteValid(routeValue) then
            printLog("setRoute:x1="..tostring(routeValue.x1)..",y1="..tostring(routeValue.y1)..
                    ",x2="..tostring(routeValue.x2)..",y2="..tostring(routeValue.y2));
            local value = {
                type = CONST_VALUE.TYPE_AIR_LINE_ROUNT,
                text = "跳伞航线",
                line = {
                    x1 = routeValue.x1,
                    y1 = routeValue.y1,
                    x2 = routeValue.x2,
                    y2 = routeValue.y2,
                },
                rect = {}, }
            table.insert(settingConfig, #settingConfig + 1, value)
        end
    end
    return settingConfig
end

local function createResourceMapView()
    if mapResourceView ~= nil then
        return
    end

    local rect = gNewGameEngine:getConditionRect("cd_rect_build_map_resource")
    if rect == nil then
        printLog("createResourceMapView rect is nil")
        return
    end
    local mapResourceLayout = createRelativeLayout(unClickFoatView, rect, "Map_RelativeLayout")
    local mapConfig = getMapResourceViewConfig()
    if mapConfig == nil then
        printLog("createResourceMapView getMapResourceViewConfig is nil")
        return
    end
    for key, value in pairs(mapConfig) do
        printLog("createResourceMapView key=" .. tostring(key) .. ", value=" .. tostring(value))
        if value.type == CONST_VALUE.TYPE_AIR_LINE_ROUNT and value.line ~= nil then
            local params = create("RelativeLayoutParam");
            local width  = toSize(rect.width, gfScaleRelativeTo1080)
            local height = toSize(rect.height, gfScaleRelativeTo1080)
            local paramProperties = {
                layout_marginTop  = toSizePxString(0),
                layout_marginLeft = toSizePxString(0),
                layout_width      = toSizePxString(width),
                layout_height     = toSizePxString(height),
            }
            params:setLayoutParam(paramProperties);
            local routeRelative = toFullRoute(value.line, 0, 0, width, height)
            printLog("toFullRoute:x1="..tostring(routeRelative.x1)..",y1="..tostring(routeRelative.y1)..
                    ",x2="..tostring(routeRelative.x2)..",y2="..tostring(routeRelative.y2) ..
                    ", width:" .. tostring(rect.width) .. ", height:" .. tostring(rect.height));

            local airLineRouteView = mapResourceLayout:addLineView(
                    routeRelative.x1, routeRelative.y1,
                    routeRelative.x2, routeRelative.y2,
                    "1.5dp", "#FFFFFFFF", true, params)
            if nil ~= airLineRouteView then
                printLog("addRouteView, addLineView succeed")
                setResourceViewToMapResourceData(value.type, nil, nil, airLineRouteView)
            else
                printLog("addRouteView, addLineView failed!!!")
            end
        end

        for k, v in pairs(value.rect) do
            printLog("createResourceMapView k=" .. tostring(k) .. ", v=" .. tostring(v))
            local mapImageView = nil
            local circleView = nil
            if value.image ~= nil then
                local imageRect = {
                    marginLeft = v.x -  value.image.width / 2,
                    marginTop = v.y - value.image.height,
                    marginRight = 0,
                    marginBottom = 0,
                    width = value.image.width,
                    height = value.image.height,
                }
                mapImageView = createImageView(mapResourceLayout, imageRect, value.image.path, nil)
                setResourceViewToMapResourceData(value.type, mapImageView, circleView, nil)
                printLog("settingConfig image, path=" .. tostring(value.image.path))
            end

            if value.circle ~= nil then
                local circleR = toSize(v.radius, gfScaleRelativeTo1080)
                local circleBorderSize = toSize(value.circle.border_size, gfScaleRelativeTo1080)
                local circleRect = {
                    marginLeft = v.x - v.radius,
                    marginTop = v.y - v.radius,
                    marginRight = 0,
                    marginBottom = 0,
                    width = v.radius * 2,
                    height = v.radius * 2 ,
                }
                local circleParams = createRelativeLayoutParam(circleRect, nil);
                if circleParams ~= nil then
                    circleView = mapResourceLayout:addCircleView(circleParams, circleR, circleBorderSize,
                            value.circle.border_color, value.circle.fill_color, value.circle.border_alpha, value.circle.fill_alpha)
                    printLog("createResourceMapView circle, "
                            .. ", circleR=" .. tostring(circleR)
                            .. ", circleBorderSize=" .. tostring(circleBorderSize)
                            .. ", border_color=" .. tostring(value.circle.border_color)
                            .. ", fill_color=" .. tostring(value.circle.fill_color)
                            .. ", border_alpha=" .. tostring(value.circle.border_alpha)
                            .. ", fill_alpha=" .. tostring(value.circle.fill_alpha)
                            .. ", marginLeft=" .. tostring(circleRect.marginLeft)
                            .. ", marginTop=" .. tostring(circleRect.marginTop)
                            .. ", marginRight=" .. tostring(circleRect.marginRight)
                            .. ", marginBottom=" .. tostring(circleRect.marginBottom)
                            .. ", width=" .. tostring(circleRect.width)
                            .. ", height=" .. tostring(circleRect.height))
                end
            end
            setResourceViewToMapResourceData(value.type, mapImageView, circleView, nil)
        end
    end
    mapResourceView = mapResourceLayout
    updateResourceViews()
    unClickFoatView:show()
end

local function updateMapButtonViewBackground()
    if nil ~= mapButtonView then
        if isMapButtonClicked then
            mapButtonView:setBackgroundImage("common://image/mapres/map_res_hide.png")
        else
            mapButtonView:setBackgroundImage("common://image/mapres/map_res_show.png")
        end
    end
end

local function onClickMapButtonView(isshow)
    isMapButtonClicked = isshow
    reportOp(3)
    commonlib_setSharedPrefBoolean(CONST_VALUE.KEY_IS_MAP_RESOURCE_BUTTON, isMapButtonClicked)
    commonlib_runOnUIThread(function()
        updateMapButtonViewBackground()
    end)
end

local function createResourceMapButtonView()
    if mapButtonClickFloat ~= nil then
        return
    end
    printLog("createResourceMapButtonView start")
    local rect = gNewGameEngine:getConditionRect("cd_rect_build_map_resource_button")
    if commonlib_isTableEmpty(rect) then
        printLog("createResourceMapButtonView, rect=nil")
        return
    end

    if mapButtonClickFloat == nil then
        mapButtonClickFloat = commonlib_getFloatViewMgrEx():create(
                rect.left,
                rect.top,
                rect.width,
                rect.height,
                rect.flag,
                true)
        local layoutView = mapButtonClickFloat:addRelativeLayout(Anchor().TOPLEFT, 0, 0, rect.width, rect.height, ZOrder().zorder_bottom)
        local buttomLayoutRect = {
            width = rect.width,
            height = rect.height,
        }
        local buttomLayoutParam = createRelativeLayoutParam(buttomLayoutRect, nil)
        mapButtonView = layoutView:addRelativeLayout(buttomLayoutParam, function(viewId)
            onClickMapButtonView(not isMapButtonClicked)
        end)
    end

    updateMapButtonViewBackground()
    printLog("createResourceMapButtonView end")
end

local function hideResourceMapButtonView()
    if mapButtonClickFloat ~= nil then
        commonlib_runOnUIThread(function()
            printLog("hideResourceMapButtonView")
            if mapButtonClickFloat:isShowing() then
                mapButtonClickFloat:hide()
            end
        end)
    end


end

local function showResourceMapButtonView()
    if mapButtonClickFloat ~= nil then
        commonlib_runOnUIThread(function()
            printLog("showResourceMapButtonView")
            updateMapButtonViewBackground()
            if mapButtonClickFloat:isShowing() == false then
                mapButtonClickFloat:show()
            end
        end)
    end
end

local function destroyResourceMapButtonView()
    if mapButtonClickFloat ~= nil then
        commonlib_runOnUIThread(function()
            mapButtonClickFloat:destroy()
            mapButtonClickFloat = nil
        end)
    end
end

local function createMapSettingTipsView()
    if mapSettingTipsView ~= nil then
        return
    end

    local rect = gNewGameEngine:getConditionRect("cd_rect_build_map_resource_setting")
    if rect == nil then
        printLog("createMapSettingTipsView rect=nil")
        return
    end
    local layoutView = createRelativeLayout(unClickFoatView, rect, "mapSettingLayout")
    if layoutView == nil then
        printLog("createMapSettingTipsView mapSettingLayout=nil")
        return
    end
    local titleRect = {
        width = 203,
        height = 44,
    }
    local titleView = createImageView(layoutView, titleRect, "common://image/mapres/setting_title.png", nil)
    local contentLayoutRect = rect
    local contentParam = createRelativeLayoutParam(contentLayoutRect, titleView:getId());
    if nil == contentParam then
        printLog("createResSettingView, createRelativeLayoutParam error")
        return
    end
    local contentRelativeLayout = layoutView:addRelativeLayout(contentParam)
    if nil ~= contentRelativeLayout then
        contentRelativeLayout:setDefaultBackground();
    end

    local iconRect = { marginLeft = 26, marginTop = 24, marginRight = 0, marginBottom = 0, width = 32, height = 35 }
    local iconImageView  = createImageView(contentRelativeLayout, iconRect, "common://image/mapres/alert.png", nil)

    local textRect = { marginLeft = 64, marginTop = 22, marginRight = 0, marginBottom = 0, width = 293 - 26, height = 35 }
    local textConfig = { text = "资源地图无法显示", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FF5353" }
    local iconTextView = createTextView(contentRelativeLayout, textRect, textConfig, nil)

    local secondAreaRect = { marginLeft = 24, marginTop = 14, marginRight = 24, marginBottom = 36 - 2, width = 293 - 24 * 2, height = 101 }
    local secondAreaParam = createRelativeLayoutParam(secondAreaRect, iconImageView:getId());
    if nil == secondAreaParam then
        printLog("createResSettingView, createRelativeLayoutParam error")
        return
    end
    local secondAreaLayout = contentRelativeLayout:addRelativeLayout(secondAreaParam)
    if nil ~= secondAreaLayout then
        secondAreaLayout:setBackgroundColor("#19FFFFFF");
    end

    local rectTxtFirst  = { marginLeft = 26 - 4, marginTop = 17 - 5, marginRight = 0, marginBottom = 0, width = 293 - 24 * 2 - (26 - 3), height = 30 }
    local txtFirstConfig = { text = "仅在最小尺寸显示", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" }
    local txtFirstView = createTextView(secondAreaLayout, rectTxtFirst, txtFirstConfig, nil)

    local rectTxtSecond = { marginLeft = 26 - 4, marginTop = 10 - 2, marginRight = 0, marginBottom = 0, width = 293 - 24 * 2 - (26 - 3), height = 30 }
    local txtSecondConfig = { text = "请缩放地图至最小", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" }
    local txtSecondView = createTextView(secondAreaLayout, rectTxtSecond, txtSecondConfig, txtFirstView:getId())


    local fixedCarRect = { marginLeft = 26, marginTop = 0, marginRight = 0, marginBottom = 0, width = 28, height = 35 }
    local fixedCarImageView  = createImageView(contentRelativeLayout, fixedCarRect, "common://image/mapres/fixed_car.png", secondAreaLayout:getId())

    local fixedCartextRect = { marginLeft = 64, marginTop = 0, marginRight = 0, marginBottom = 0, width = 293 - 26, height = 35 }
    local fixedCartextConfig = { text = "固定车辆在车库里", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" }
    local fixedCarTextView = createTextView(contentRelativeLayout, fixedCartextRect, fixedCartextConfig, secondAreaLayout:getId())

    local garageRect = { marginLeft = 28, marginTop = 13, marginRight = 0, marginBottom = 32 - 4, width = 238, height = 116 }
    local garageImageView  = createImageView(contentRelativeLayout, garageRect, "common://image/mapres/map_res_garage.png", fixedCarImageView:getId())


    local probabilityCarRect = { marginLeft = 26, marginTop = 0, marginRight = 0, marginBottom = 0, width = 28, height = 35 }
    local probabilityCarImageView  = createImageView(contentRelativeLayout, probabilityCarRect, "common://image/mapres/probability_car.png", garageImageView:getId())

    local probabilityCartextRect = { marginLeft = 64, marginTop = 0, marginRight = 0, marginBottom = 0, width = 293 - 26, height = 35 }
    local probabilityCartextConfig = { text = "概率车辆在马路边", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" }
    local probabilityCarTextView = createTextView(contentRelativeLayout, probabilityCartextRect, probabilityCartextConfig, garageImageView:getId())

    mapSettingTipsView = layoutView
    mapSettingTipsView:hide()
end

local function showMapSettingTipsView()
    if mapSettingTipsView ~= nil then
        commonlib_runOnUIThread(function()
            mapSettingTipsView:show()
        end)
    end
end

local function hideMapSettingTipsView()
    if mapSettingTipsView ~= nil then
        commonlib_runOnUIThread(function()
            mapSettingTipsView:hide()
        end)
    end
end

local function destroyMapSettingTipsView()
    if mapSettingTipsView ~= nil then
        commonlib_runOnUIThread(function()
            mapSettingTipsView:destroy()
            mapSettingTipsView = nil
        end)
    end
end

local function hideAllViews()
    hideResourceMapButtonView()
    hideResourceMapSettingView()
    hideMapSettingTipsView()
    printLog("hideAllViews")
end

local function destroyAllViews()
    printLog("destroyAllViews")
    hideAllViews()
    destroyResourceMapSettingView()
    destroyResourceMapView()
    destroyResourceMapButtonView()
    destroyMapSettingTipsView()
    resetData()
end

local function isOpenMap()
    local cover = commonlib_getGameParam(PUBGM_KEY_GAME_RUNNING_COVER_STATUS)
    if cover == nil or cover == PUBGM_GAME_COVER_NONE then
        return false
    end

    local openMap = gNewGameEngine:matchCondition("cd_build_open_map")
    return openMap
end

local function isNormalMap()
    local noExpand = gNewGameEngine:matchCondition("cd_build_map_expand")
    return noExpand
end

local function matchMapType()
    if mapType == -1 then
        local result = gNewGameEngine:matchConditionOnNumber("cd_build_cj_detect_map_type")
        printLog("matchMapType=" .. tostring(result))
        if result > 0 and result < 5 then
            mapType = result
        end
    end
end

local function getAirLineRoute()
    if gRoute ~= nil then
        return true
    end

    local routeValue = gNewGameEngine:matchConditionOnTable("cd_build_cj_detect_air_line")
    if routeValue ~= nil and checkRouteValid(routeValue) then
        gRoute = {
            x1 = routeValue.x1,
            y1 = routeValue.y1,
            x2 = routeValue.x2,
            y2 = routeValue.y2,
        }
        printLog("setRoute:x1="..tostring(routeValue.x1)..",y1="..tostring(routeValue.y1)..
                ",x2="..tostring(routeValue.x2)..",y2="..tostring(routeValue.y2));
        return true
    end
    printLog("getAirLineRoute=false")
    return false
end

local function canShowMapResource()
    if gbResMapSwitch == false then
        return false
    end

    if mapType == -1 then
        return false
    end
    return true
end

local function reportZoom(openMap, normalMap)
    local lastMapState = CONST_VALUE.CURRENT_MAP_NORMAL
    if openMap then
        if normalMap then
            lastMapState = CONST_VALUE.CURRENT_MAP_NORMAL
        else
            lastMapState = CONST_VALUE.CURRENT_MAP_EXTAND
        end
    else
        lastMapState = -1
    end

    if lastMapState == CONST_VALUE.CURRENT_MAP_NORMAL and currentMapState == CONST_VALUE.CURRENT_MAP_EXTAND then
        reportOp(2)
    elseif lastMapState == CONST_VALUE.CURRENT_MAP_EXTAND and currentMapState == CONST_VALUE.CURRENT_MAP_NORMAL then
        reportOp(1)
    elseif lastMapState == CONST_VALUE.CURRENT_MAP_NORMAL and currentMapState == -1 then
        reportOp(2)
    end
    currentMapState = lastMapState
end

local function onGameRunning()
    local openMap = isOpenMap()
    local normalMap = isNormalMap()
    if openMap and normalMap then
        matchMapType()
    end
    reportZoom(openMap, normalMap)

    printLog("openMap=" .. tostring(openMap)
            .. ", normalMap=" .. tostring(normalMap)
            .. ", mapType=" .. tostring(mapType))

    if canShowMapResource() and openMap and normalMap then
        ---先尝试获取航线，获取成功再显示其它的
        if airLineRouteCount < MAX_AIR_LINE_ROUTE then
            if getAirLineRoute() == false then
                airLineRouteCount = airLineRouteCount + 1
                return
            end
        end

        commonlib_runOnUIThread(function()
            createResourceMapSettingView()
        end)

        commonlib_runOnUIThread(function()
            createResourceMapView()
        end)

        commonlib_runOnUIThread(function()
            createResourceMapButtonView()
        end)

        commonlib_runOnUIThread(function()
            createMapSettingTipsView()
        end)

        if isMapButtonClicked then
            showResourceMapSettingView()
        else
            hideResourceMapSettingView()
        end
        showResourceMapButtonView()
        hideMapSettingTipsView()
    elseif canShowMapResource() and openMap and normalMap == false then
        hideResourceMapSettingView()
        hideResourceMapButtonView()
        showMapSettingTipsView()
    else
        hideAllViews()
    end
end

local function onEnterGame()
    printLog("onEnterGame")
    destroyAllViews()
end

local function onGameOver()
    printLog("onGameOver")
    destroyAllViews()
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks[PUBGM_KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[PUBGM_KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[PUBGM_KEY_GAME_OVER], onGameOver)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[PUBGM_KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[PUBGM_KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[PUBGM_KEY_GAME_OVER], onGameOver)
end

local function onCheckChangeListener(checkBoxId, isChecked)
    commonlib_setSharedPrefBoolean(CONST_VALUE.KEY_IS_MAP_RESOURCE_ENABLE, isChecked)
    gbResMapSwitch = isChecked
end

local function initSettingView()
    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    relativeLayoutParam:setLayoutParam(paramValues)

    gbResMapSwitch = commonlib_getSharedPrefBoolean(CONST_VALUE.KEY_IS_MAP_RESOURCE_ENABLE, true)
    gResMapSwitchView = commonlib_getSettingView():addTableView(CONST_VALUE.TAB_NAME):addCheckBoxView(CONST_VALUE.CHECKBOX_TEXT, gbResMapSwitch, relativeLayoutParam, onCheckChangeListener)
    if gbResMapSwitch then
        report_gamemaster_game_pubgm_state(3, 1)
    else
        report_gamemaster_game_pubgm_state(3, 2)
    end
end


local function initVariable()
    gfScaleRelativeTo1080 = commonlib_getScale()
    unClickFoatView = commonlib_getUnClickableFloatView()
    gNewGameEngine = CNewGameEngine:getInstance()
    resetMapResourceData()
end

local function init()
    printLog("map resources init")
    initVariable()
    initSettingView()
    registerGameEvents()
end

local function uninit()
    printLog("map resources uninit")
    unregisterGameEvents()
    destroyAllViews()
end

table.insert(common_life_circle_callbacks, { init, uninit, PUBGM_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.map_resources })
