---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by libin.
--- DateTime: 2018/8/15 14:16
---

local function printLog(msg)
    commonlib_print("arsenal", msg)
end

local CONST_VALUE = {
    TAB_NAME                   = "武器库",
    CHECKBOX_TEXT              = "开启武器详情",
    FIRST_ARSENAL_VIEW_OFFSET  = 42,
    SECOND_ARSENAL_VIEW_OFFSET = 458,
    THIRD_ARSENAL_VIEW_OFFSET = 0,
    KEY_IS_FIRST_OPEN = "key_arsenal_is_first_open",
    IS_FIRST_OPEN = -2,
    MAX_MATCH_COUNT = 20,
    SETTING_ARSENAL_DESC_TEXT = "在背包中一键查看武器性能，选择适合你的武器战斗吧～",
    SETTING_ARSENAL_TOAST_TEXT = "请返回游戏超人App首页，点击“新用户特权”卡片，即可解锁该技能~~",
    ARSENAL_SHARED_TITLE = "价值8.8元的「武器库」免费送",
    ARSENAL_SHARED_URL = "http://a.app.qq.com/o/simple.jsp?pkgname=com.cmcm.gamemaster&ckey=CK1400691030646",
    ARSENAL_SHARED_ICON = "https://dl.cm.ksmobile.com/static/res/fixed/eb/gm_logo_100px.png",
    ARSENAL_SHARED_DESC = "【吃鸡神器】资源地图、炫酷皮肤免费领！解锁快速辨别敌人方位新技能",
    ARSENAL_SHARED_SUCC_TEXT = "恭喜，您已免费获得「武器详情」特权，快去体验吧~",
    ARSENAL_SHARED_FAIL_TEXT = "分享失败",
    ARSENAL_UNLOCK_DESC = "(未解锁)"
}

local gfScaleRelativeTo1080
local gNewGameEngine

--- 设置上的开关
local settingTabelArsenalSwitch = true
local settingTabelArsenalView
local settingTableArsenalDescTextView
local settingTableArsenalTipImageView
local mUnlockTextView

local unClickFloat
local firstArsenalpropertyView
local secondArsenalpropertyView
local arsenalShareView
local maskShareView = nil

local clickFloat
local arsenalOpenButtonView
local isShowArsenalOpenButton = false

local isCreateArsenalpropertyView = false
local isCreateOpenButtonView = false

local MAX_UPLOAD_BITMAP_COUNT = 3
local uploadBitmapCount = 0
local isOpenButton = false
---分享
local gArsenalShareView = nil;
local gArsenalhareFloatView = nil;
local mBottomShareView

local ARSENAL_LOCKED = 1;
local ARSENAL_UNLOCKED = 2;

local function report_gamemaster_game_pubgm_equipment(action, weapon1, weapon2, unlocked)
    commonlib_report("gamemaster_game_pubgm_equipment",
            {
                ["action"] = action,
                ["weapon1"]  = weapon1,
                ["weapon2"]    = weapon2,
                ["unlocked"] = unlocked,
            });
    printLog("report_gamemaster_game_pubgm_equipment, action=" .. tostring(action)
            .. ", weapon1=" .. tostring(weapon1)
            .. ", weapon2=" .. tostring(weapon2)
            .. ", unlocked=" .. tostring(unlocked))
end

local function reportAssistShowSucceed()
    notifyAssistShowSucceed(ASSIST_SHOW_TYPE_ARSENAL)
    printLog("reportAssistShowSucceed=" .. tostring(ASSIST_SHOW_TYPE_ARSENAL))
end

local function isFirstOpen()
    local value = commonlib_getSharedPrefInt(CONST_VALUE.KEY_IS_FIRST_OPEN, CONST_VALUE.IS_FIRST_OPEN)
    if value == CONST_VALUE.IS_FIRST_OPEN then
        return true
    end
    return false
end

local function getArsenalData(index)
    if index == 36 then
        return nil
    end

    local rawData = GLOBAL_ARSENAL_CONFIG[index]
    if rawData == nil then
        printLog("getArsenalData rawData=nil")
        return nil
    end
    return rawData;
end

local function toSize(size, scale)
    if nil == size or nil == scale then
        return 0
    end

    return size * scale
end

local function toScaleSizePxString(size, scale)
    return tostring(toSize(size, scale)) .. "px"
end

local function createRelativeLayoutParam(layoutParam, topViewId)
    if nil == layoutParam  then
        printLog("createRelativeLayoutParam, args error!!!")
        return
    end

    local params = create("RelativeLayoutParam");
    local paramProperties = {
        layout_marginTop    = toScaleSizePxString(layoutParam.marginTop, gfScaleRelativeTo1080),
        layout_marginLeft   = toScaleSizePxString(layoutParam.marginLeft, gfScaleRelativeTo1080),
        layout_marginRight  = toScaleSizePxString(layoutParam.marginRight, gfScaleRelativeTo1080),
        layout_marginBottom = toScaleSizePxString(layoutParam.marginBottom, gfScaleRelativeTo1080),
        layout_width        = toScaleSizePxString(layoutParam.width, gfScaleRelativeTo1080),
        layout_height       = toScaleSizePxString(layoutParam.height, gfScaleRelativeTo1080),
        layout_below        = topViewId
    }
    params:setLayoutParam(paramProperties);
    return params
end

local function getArsenalRect()
    return gNewGameEngine:getConditionRect("cd_build_rect_arsenal_properties")
    --return { left = -874, top = 0, width= 492, height = 382, flag = Anchor().TOPRIGHT, }
end

local function getOpenButtonRect()
    return gNewGameEngine:getConditionRect("cd_build_rect_arsenal_botton")
    --return { left = -1005, top = 441, width = 103, height = 103, flag = Anchor().TOPRIGHT, }
end

local function resetVariable()
    isCreateArsenalpropertyView = false
    isCreateOpenButtonView = false
    isShowArsenalOpenButton = false
    isOpenButton = false
end

local function showToastView(text)
    local toastContainer = commonlib_getFloatViewMgrEx():create(0, 366, Anchor().TOPLEFT, false)
    local toastView = toastContainer:addToastView(text, 3500,
            Anchor().TOPLEFT, 200, 0, ZOrder().zorder_top,
            function()
                toastContainer:destroy();
            end)

    toastContainer:setGravity(Anchor().CENTER);
    toastContainer:show()
    toastView:start();
    printLog("show toast view, " .. text)
end

local function isArsenalShareAbTestSolutionA()
    local shareAbTest = commonlib_getCommonAbTestSolution("section_gameassitant_arsenal_share", true)
    printLog("arsenal share abtest =  " .. tostring(shareAbTest))
    return shareAbTest == 1 --方案A
end

local function isSharedArsenal()
    if commonlib_getUtilTool():isNewInstallUser() == false then
        printLog("isSharedArsenal: not isNewInstallUser")
        return true
    end

    local isShared = commonlib_getUtilTool():getCanSharedArasenal()
    printLog("isSharedArsenal: " .. tostring(isShared))
    return isShared
end

local function canShowArsenal()
    settingTabelArsenalSwitch = commonlib_getSharedPrefBoolean(SP_ARSENAL_SWITCH_KEY, true)
    if settingTabelArsenalSwitch ~= true then
        return false
    end
    local result = gNewGameEngine:matchCondition("cd_build_backage_items")
    return result
end

local function getGunsTypeRectsString(matchString)
    if matchString == "cd_build_gunstype1" then
        return "cd_build_rect_gun1_rect"
    end

    if matchString == "cd_build_gunstype2" then
        return "cd_build_rect_gun2_rect"
    end
end


local function uploadBitmap(matchString, index, prob)
    if prob > 0.5 then
        return
    end

    if uploadBitmapCount >= MAX_UPLOAD_BITMAP_COUNT then
        return
    end

    local str = getGunsTypeRectsString(matchString)
    local rects = gNewGameEngine:getConditionRect(str)
    if rects == nil then
        return
    end

    local filename = "arsenal_" .. tostring(index) .. "_" .. tostring(prob)
    commonlib_getUtilTool():uploadbitmap(rects, filename, SHOT_SCREEN_FOR_MAT_TYPE.pubgmhd_arsenal)
    uploadBitmapCount = uploadBitmapCount + 1

    printLog("ScreenshotDataForMat uploadBitmap: filename=" .. tostring(filename) .. ", " .. matchString)
end


local function getGunsType(matchString)
    local index = 0
    local prob = 0
    for i = 1, CONST_VALUE.MAX_MATCH_COUNT do
        local t = gNewGameEngine:matchConditionOnTable(matchString)
        if t == nil then
            printLog("matchConditionOnTable(" .. matchString .. ")=nil")
        else
            printLog(matchString .. ", t=" .. tostring(t) .. ", size=" .. tostring(#t))
            for key, value in pairs(t) do
                if value.prob and value.prob > prob then
                    prob = value.prob
                    if value.index then
                        index = value.index
                    end
                end
                local str = " "
                for k, v in pairs(value) do
                    str = str .. " [" .. tostring(k) .. "=" .. tostring(v) .. tostring("] ")
                end
                printLog(matchString .. "[" .. tostring(key) .. "]"  .. str)
            end
            if prob > 0.95 then
                return index
            else
                uploadBitmap(matchString, index, prob)
            end
        end
    end
    return index
end

local function getFirstGunsType()
    local index = getGunsType("cd_build_gunstype1")
    return index
end

local function getSecnodGunsType()
    local index = getGunsType("cd_build_gunstype2")
    return index
end

local function getFirstArsenalpropertyViewData()

    local index = getFirstGunsType()
    local data = getArsenalData(index)
    if data ~= nil then
        return data, index
    end
    return nil, 0
end

local function getSecondArsenalPropertyiViewData()
    local index = getSecnodGunsType()
    local data = getArsenalData(index)
    if data ~= nil then
        return data, index
    end
    return nil, 0
end

--- 分享
local function destroyArsenalShareView()
    commonlib_runOnUIThread(function()
        if gArsenalhareFloatView ~= nil then
            gArsenalhareFloatView:destroy()
            gArsenalhareFloatView = nil
        end
        if gArsenalShareView ~= nil then
            gArsenalShareView:setOnEventListener(nil)
            gArsenalShareView:destroy()
            gArsenalShareView = nil
        end
    end)
end

local function showArsenalShareView(from)
    commonlib_runOnUIThread(function()
        if gArsenalhareFloatView == nil then
            gArsenalhareFloatView = commonlib_getFloatViewMgrEx():create(0, 0, Anchor().TOPLEFT, true);
            gArsenalhareFloatView:setGravity(Anchor().CENTER);

            local shareParams = {}
            shareParams.ShareType = tostring(from);
            shareParams.ShareTitle = CONST_VALUE.ARSENAL_SHARED_TITLE;
            shareParams.GameId = commonlib_getGameId();
            shareParams.ShareDesc = CONST_VALUE.ARSENAL_SHARED_DESC
            shareParams.ShareUrl = CONST_VALUE.ARSENAL_SHARED_URL
            shareParams.ShareImageUrl = CONST_VALUE.ARSENAL_SHARED_ICON;
            printLog("show arsenal share: " .. tostring(shareParams.ShareDesc) ..
                    ", " .. tostring(shareParams.ShareUrl) .. ", " .. tostring(shareParams.ShareImageUrl))

            gArsenalShareView = gArsenalhareFloatView:addCommonShareView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top, shareParams);
            gArsenalShareView:setOnEventListener(function(type, action)
                printLog("arsenal share event: " .. type .. "." .. action .. ", from: " .. from)
                if type == tostring(from) then
                    destroyArsenalShareView();
                    if action == "common_share_succ" then
                        showToastView(CONST_VALUE.ARSENAL_SHARED_SUCC_TEXT)
                        commonlib_getUtilTool():setCanSharedArasenal(true);
                        commonlib_setSharedPrefBoolean(SP_ARSENAL_SWITCH_KEY, true)
                        settingTabelArsenalSwitch = true
                    else
                        showToastView(CONST_VALUE.ARSENAL_SHARED_FAIL_TEXT)
                    end
                end
            end)
        end
        if gArsenalShareView ~= nil then
            gArsenalhareFloatView:show()
        end
    end)
end

local function createArsenalView(firstData, firstIndex, secondData, secondIndex)
    printLog("createArsenalView")
    if firstArsenalpropertyView == nil and firstData ~= nil then
        local rect = getArsenalRect()
        firstArsenalpropertyView = unClickFloat:addPubgmhdArsenalViewForLua(
                rect.flag, rect.left, rect.top + CONST_VALUE.FIRST_ARSENAL_VIEW_OFFSET, rect.width, rect.height, ZOrder().zorder_bottom)
        isCreateArsenalpropertyView = true
    end
    if firstArsenalpropertyView ~= nil and firstData ~= nil then
        firstArsenalpropertyView:setArsenalData(firstData)
        if not firstArsenalpropertyView:isShowing() then
            firstArsenalpropertyView:show()
        end
    end

    if secondArsenalpropertyView == nil and secondData ~= nil then
        local rect = getArsenalRect()
        secondArsenalpropertyView = unClickFloat:addPubgmhdArsenalViewForLua(
                rect.flag, rect.left, rect.top + CONST_VALUE.SECOND_ARSENAL_VIEW_OFFSET, rect.width, rect.height, ZOrder().zorder_bottom)
        isCreateArsenalpropertyView = true
    end
    if secondArsenalpropertyView ~= nil and secondData ~= nil then
        secondArsenalpropertyView:setArsenalData(secondData)
        if not secondArsenalpropertyView:isShowing() then
            secondArsenalpropertyView:show()
        end
    end

    report_gamemaster_game_pubgm_equipment(2, firstIndex, secondIndex, ARSENAL_UNLOCKED)
end

local function createMaskView()
    local rect = getArsenalRect()
    printLog("rect=" .. rect.left)
    if maskShareView == nil then
        maskShareView = commonlib_getFloatViewMgrEx():create(
            rect.left,
            0,
            rect.width, -1,
            rect.flag,
            true);
    end

    if arsenalShareView == nil then
        local relativeLayoutParam = create("RelativeLayoutParam")
        local paramValues = {}
        paramValues.layout_width = "MATCH_PARENT"
        paramValues.layout_height = "MATCH_PARENT"
        relativeLayoutParam:setLayoutParam(paramValues)

        local shareParams = {}
        shareParams.ShareType = tostring(GAME_COMMON_SHARE_ARSENAL_BACKAGE);
        shareParams.ShareTitle = "分享免费解锁";
        shareParams.GameId = commonlib_getGameId();
        shareParams.ShareDesc = CONST_VALUE.ARSENAL_SHARED_DESC
        shareParams.ShareUrl = CONST_VALUE.ARSENAL_SHARED_URL
        shareParams.ShareImageUrl = CONST_VALUE.ARSENAL_SHARED_ICON;
        printLog("show arsenal share botton: " .. tostring(shareParams.ShareDesc) ..
                ", " .. tostring(shareParams.ShareUrl) .. ", " .. tostring(shareParams.ShareImageUrl))

        arsenalShareView = maskShareView:addCommonShareView(ZOrder().zorder_top, shareParams, relativeLayoutParam);
        arsenalShareView:setOnEventListener(function(type, action)
            if type == tostring(GAME_COMMON_SHARE_ARSENAL_BACKAGE) then
                if action == "common_share_succ" then
                    showToastView(CONST_VALUE.ARSENAL_SHARED_SUCC_TEXT)
                    commonlib_getUtilTool():setCanSharedArasenal(true);
                    commonlib_setSharedPrefBoolean(SP_ARSENAL_SWITCH_KEY, true)
                    maskShareView:destroy()
                    maskShareView = nil
                else
                    showToastView(CONST_VALUE.ARSENAL_SHARED_FAIL_TEXT)
                end
            end
        end)
    end

    if arsenalShareView ~= nil then
        printLog("createMaskView arsenalShareView show")
        maskShareView:show()
        arsenalShareView:show()
    end
    local firstData, firstIndex = getFirstArsenalpropertyViewData()
    local secondData, secondIndex = getSecondArsenalPropertyiViewData()
    createArsenalView(firstData, firstIndex, secondData, secondIndex)
end

local function hideArsenalView()
    printLog("hideArsenalView")
    if firstArsenalpropertyView ~= nil then
        firstArsenalpropertyView:hide()
    end

    if secondArsenalpropertyView ~= nil then
        secondArsenalpropertyView:hide()
    end

    if maskShareView ~= nil then
        maskShareView:hide()
    end
    isOpenButton = false
    report_gamemaster_game_pubgm_equipment(3, 0, 0, ARSENAL_UNLOCKED)
end

local function destroyArsenalView()
    printLog("destroyArsenalView")
    if firstArsenalpropertyView ~= nil then
        firstArsenalpropertyView:destroy()
        firstArsenalpropertyView = nil
    end

    if secondArsenalpropertyView ~= nil then
        secondArsenalpropertyView:destroy()
        secondArsenalpropertyView = nil
    end
    if maskShareView ~= nil then
        arsenalShareView = nil
        maskShareView:destroy()
        maskShareView = nil
    end

    isOpenButton = false
    isCreateArsenalpropertyView = false
end

local function updateArsenalOpenButtonViewBackground()
    if nil ~= arsenalOpenButtonView then
        if isShowArsenalOpenButton then
            arsenalOpenButtonView:setBackgroundImage("img/arsenal_open.png")
            commonlib_setSharedPrefInt(CONST_VALUE.KEY_IS_FIRST_OPEN, 1)
            isOpenButton = true
        else
            if isFirstOpen() then
                arsenalOpenButtonView:setBackgroundImage("img/arsenal_open_first.png")
            else
                arsenalOpenButtonView:setBackgroundImage("img/arsenal_normal.png")
            end
            destroyArsenalView()
        end
    end
end

local function onClickArsenalOpenButtonView(isshow)
    printLog("onClickArsenalOpenButtonView, isShowArsenalOpenButton="
            .. tostring(isShowArsenalOpenButton) .. ", isshow=" .. tostring(isshow))
    isShowArsenalOpenButton = isshow
    if isshow == true and isSharedArsenal() == false then
        -- 未分享
        report_gamemaster_game_pubgm_equipment(2, 0, 0, ARSENAL_LOCKED);
--        if isArsenalShareAbTestSolutionA() then
--            showToastView(CONST_VALUE.SETTING_ARSENAL_TOAST_TEXT)
--        else
--            showArsenalShareView(GAME_COMMON_SHARE_ARSENAL_BACKAGE)
--        end
        commonlib_runOnUIThread(function()
            updateArsenalOpenButtonViewBackground()
        end)
    else -- 已分享
        report_gamemaster_game_pubgm_equipment(2, 0, 0, ARSENAL_UNLOCKED);
        commonlib_runOnUIThread(function()
            updateArsenalOpenButtonViewBackground()
        end)
    end
end

local function createOpenButtonView()
    printLog("createOpenButtonView start")
    local rect = getOpenButtonRect()
    if clickFloat == nil then
        clickFloat = commonlib_getFloatViewMgrEx():create(
                rect.left,
                rect.top,
                rect.width,
                rect.height,
                rect.flag,
                true)
        local layoutView = clickFloat:addRelativeLayout(Anchor().TOPLEFT, 0, 0, rect.width, rect.height, ZOrder().zorder_bottom)
        local buttomLayoutRect = {
            width = rect.width,
            height = rect.height,
        }
        local buttomLayoutParam = createRelativeLayoutParam(buttomLayoutRect, nil)
        arsenalOpenButtonView = layoutView:addRelativeLayout(buttomLayoutParam, function(viewId)
            onClickArsenalOpenButtonView(not isShowArsenalOpenButton)
        end)
        isCreateOpenButtonView = true
        reportAssistShowSucceed()
        if isSharedArsenal() then
            report_gamemaster_game_pubgm_equipment(1, 0, 0, ARSENAL_UNLOCKED)
        else
            report_gamemaster_game_pubgm_equipment(1, 0, 0, ARSENAL_LOCKED)
        end
    end
    updateArsenalOpenButtonViewBackground()
    clickFloat:show()
    printLog("createOpenButtonView end")
end

local function destroyOpenButtonView()
    if clickFloat == nil then
        return
    end
    clickFloat:destroy()
    clickFloat = nil
    arsenalOpenButtonView = nil
    isCreateOpenButtonView = false
    isShowArsenalOpenButton = false
end

local function onCheckChangeListener(checkBoxId, isChecked)
    printLog("onCheckChangeListener, isChecked=" .. tostring(isChecked))
    if isSharedArsenal() == false then
        settingTabelArsenalView:setChecked(false)
        if isArsenalShareAbTestSolutionA() == true then --方案A显示Toast
            showToastView(CONST_VALUE.SETTING_ARSENAL_TOAST_TEXT)
        else --方案B显示分享界面
            showArsenalShareView(GAME_COMMON_SHARE_ARSENAL_SETTING)
        end
        return
    end
    commonlib_setSharedPrefBoolean(SP_ARSENAL_SWITCH_KEY, isChecked)
    settingTabelArsenalSwitch = isChecked
end

local function destroyViews()
    destroyArsenalView()
    destroyOpenButtonView()
end

local function initVariable()
    unClickFloat = commonlib_getUnClickableFloatView()
    gfScaleRelativeTo1080 = commonlib_getScale()
    gNewGameEngine = CNewGameEngine:getInstance()
    resetVariable()
    uploadBitmapCount = 0
end

local function getTextColor(enable)
    if enable == true then
        return "#FF00DEFF";
    else
        return "#FF979797";
    end
end

local function initSettingView()
    local tab = commonlib_getSettingView():addTableView(CONST_VALUE.TAB_NAME)
    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    relativeLayoutParam:setLayoutParam(paramValues)

    if isSharedArsenal() == false then
        settingTabelArsenalSwitch = false
        tab:updateTab(not commonlib_getSharedPrefBoolean(SP_ARSENAL_CLICKED, false))
    else
        settingTabelArsenalSwitch = commonlib_getSharedPrefBoolean(SP_ARSENAL_SWITCH_KEY, true)
    end

    printLog("settingTabelArsenalSwitch:" .. tostring(settingTabelArsenalSwitch))
    settingTabelArsenalView = tab:addCheckBoxView(
            CONST_VALUE.CHECKBOX_TEXT, settingTabelArsenalSwitch, relativeLayoutParam, onCheckChangeListener)
    if settingTabelArsenalSwitch then
        report_gamemaster_game_pubgm_state(8, 1)
    else
        report_gamemaster_game_pubgm_state(8, 2)
    end

-- 点击后,红点消失
    tab:setOnTabSelectedListener(function()
        commonlib_setSharedPrefBoolean(SP_ARSENAL_CLICKED, true)
        tab:updateTab(false)
    end);

    paramValues.layout_below = settingTabelArsenalView:getId()
    paramValues.layout_marginLeft = "40dp"
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_width = "226dp"
    paramValues.layout_height = "75dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    settingTableArsenalTipImageView = tab:addImageView("img/arsenal_tip_image.png", relativeLayoutParam, nil)

    paramValues.layout_below = settingTableArsenalTipImageView:getId()
    paramValues.layout_marginLeft = "40dp"
    paramValues.layout_marginTop = "7dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    relativeLayoutParam:setLayoutParam(paramValues)
    settingTableArsenalDescTextView = tab:addTextView(CONST_VALUE.SETTING_ARSENAL_DESC_TEXT,
            getTextColor(settingTabelArsenalSwitch),
            "12sp",
            relativeLayoutParam,
            nil);
-- 底部分享
    paramValues.layout_below = settingTableArsenalDescTextView:getId()
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_marginRight = "20dp"
    paramValues.layout_alignParentRight = "true"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    relativeLayoutParam:setLayoutParam(paramValues)

    local shareParams = {}
    shareParams.ShareType = tostring(GAME_COMMON_SHARE_ARSENAL_BOTTOM);
    if isSharedArsenal() == false then
        shareParams.ShareTitle = "分享免费解锁";
    else
        shareParams.ShareTitle = "推荐给朋友";
    end
    shareParams.GameId = commonlib_getGameId();
    shareParams.ShareDesc = CONST_VALUE.ARSENAL_SHARED_DESC
    shareParams.ShareUrl = CONST_VALUE.ARSENAL_SHARED_URL
    shareParams.ShareImageUrl = CONST_VALUE.ARSENAL_SHARED_ICON;

    mBottomShareView = tab:addCommonShareView(shareParams, relativeLayoutParam);
    mBottomShareView:setOnEventListener(function(type, action)
        if type == tostring(GAME_COMMON_SHARE_ARSENAL_BOTTOM) then
            if action == "common_share_succ" then
                showToastView(CONST_VALUE.ARSENAL_SHARED_SUCC_TEXT)
                commonlib_getUtilTool():setCanSharedArasenal(true);
                commonlib_setSharedPrefBoolean(SP_ARSENAL_SWITCH_KEY, true)
            else
                showToastView(CONST_VALUE.ARSENAL_SHARED_FAIL_TEXT)
            end
        end
    end)


--  未解锁
    if isSharedArsenal() == false then
        local textLayoutParam = create("RelativeLayoutParam")
        local textParam = {}
        textParam.layout_toRightOf = settingTabelArsenalView:getId()
        textParam.layout_marginLeft = "5dp"
        textParam.layout_marginTop = "22dp"
        textParam.layout_width = "WRAP_CONTENT"
        textParam.layout_height = "WRAP_CONTENT"
        textLayoutParam:setLayoutParam(textParam)
        mUnlockTextView = tab:addTextView(CONST_VALUE.ARSENAL_UNLOCK_DESC,
            "#FF7A00",
            "10sp",
            textLayoutParam,
            nil);
    end

end

local function onGameRunning()
    local canShow = canShowArsenal()
    printLog("canShow=" .. tostring(canShow))
    if canShow then
        if isCreateOpenButtonView == false then
            commonlib_runOnUIThread(function()
                    createOpenButtonView()
                end)
        end
        if isOpenButton then
            if isCreateArsenalpropertyView == false then
                local firstData, firstIndex = getFirstArsenalpropertyViewData()
                local secondData, secondIndex = getSecondArsenalPropertyiViewData()
                commonlib_runOnUIThread(function()
                    if isSharedArsenal() == false then
                        createMaskView()
                    else
                        createArsenalView(firstData, firstIndex, secondData, secondIndex)
                    end
                end)
            end
        end
    else
        if isCreateArsenalpropertyView == true then
            commonlib_runOnUIThread(function()
                destroyArsenalView()
            end)
        end
        if isCreateOpenButtonView == true then
            commonlib_runOnUIThread(function()
                destroyOpenButtonView()
            end)
        end
    end
end

local function onEnterGame()
    printLog("onEnterGame")
    resetVariable()
end

local function onGameOver()
    printLog("onGameOver")
    commonlib_runOnUIThread(function()
        destroyViews()
    end)
end

local function onSettingViewOpen()
    local isShared = isSharedArsenal()
    if isShared == false then
        settingTabelArsenalView:setChecked(false)
        if mUnlockTextView ~= nil then
            mUnlockTextView:show()
        end
    else
        settingTabelArsenalView:setChecked(settingTabelArsenalSwitch)
        settingTableArsenalDescTextView:setTextColor(getTextColor(settingTabelArsenalSwitch))
        if mUnlockTextView ~= nil then
            mUnlockTextView:hide()
        end
    end
    printLog("onSettingViewOpen isshared=" .. tostring(isShared))
end

local function onSettingViewClose()
    local isShared = isSharedArsenal()
    if isShared == false then
        settingTabelArsenalView:setChecked(false)
    else
        settingTabelArsenalView:setChecked(settingTabelArsenalSwitch)
        settingTableArsenalDescTextView:setTextColor(getTextColor(settingTabelArsenalSwitch))
    end
    printLog("onSettingViewClose isshared=" .. tostring(isShared))
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)

    commonlib_registerSettingViewOpenCallback(onSettingViewOpen)
    commonlib_registerSettingViewCloseCallback(onSettingViewClose)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)

    commonlib_unRegisterSettingViewOpenCallback(onSettingViewOpen)
    commonlib_unRegisterSettingViewCloseCallback(onSettingViewClose)
end

local function init()
    printLog("init start")
    initVariable()
    initSettingView()
    registerGameEvents()
    printLog("init end")
end

local function uninit()
    printLog("uninit start")
    unregisterGameEvents()
    destroyViews()
    printLog("uninit end")
    uploadBitmapCount = 0
end

table.insert(common_life_circle_callbacks, { init, uninit, PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.arsenal })
