--- 游戏状态脚本
--- 悬浮球
---date:2018-04-11
---modify by: hexujun@cmcm.com

PUBGMHD_APP_NAME = 5

PUBGMHD_GAMESTATE_UNKNOW = -2;--未知
PUBGMHD_GAMESTATE_IN_GAMEHOME = GAME_STATE_NOTSTART;--游戏大厅
PUBGMHD_GAMESTATE_RUNNING = GAME_STATE_RUNNING;--游戏进行中
PUBGMHD_GAMESTATE_OVER = GAME_STATE_FINISH;--结束游戏

KEY_GAME_RUNNING_SUBSTATE = "gameRunningSubState";
PUBGMHD_GAMESTATE_RUNNING_AIRPORT = 101; -- 机场
PUBGMHD_GAMESTATE_RUNNING_FLIGHT = 102;  -- 飞行
PUBGMHD_GAMESTATE_RUNNING_PARACHUTE = 103; -- 伞降
PUBGMHD_GAMESTATE_RUNNING_ONLAND = 104;  -- 陆地
PUBGMHD_GAMESTATE_RUNNING_SWIM = 105;  -- 水中
PUBGMHD_GAMESTATE_RUNNING_CAR_SHIP = 106;  -- 驾驶 汽车或轮船
PUBGMHD_GAMESTATE_RUNNING_SHOOT = 107;  -- 可射击

local gRecognizeAdapterManager;
local isCanTracePerformance;
local performanceTrace;
local gNewGameEngine;

local Tag = "common_state"
local function printLog(msg)
    commonlib_print(Tag, msg)
end

local COMMON_STATE = "common_state_lua"
local source
local pkgName;
local GAME_ID = "com.tencent.tmgp.pubgmhd"
local KEY_START_GAME_SRC = "src";

--- 装备圆圈
local tryRecognizeWeaponStateCount = 0;
local hasRecognizedWeaponState = false;
local hasRecognizedLeftWeaponState = false;
local hasRecognizedRightWeaponState = false;

KEY_WEAPON_ICON = "hasWeaponIcon"
WEAPON_NONE = 0
WEAPON_LEFT = 1
WEAPON_RIGHT = 2
WEAPON_BOTH = 3

--- 遮挡类型
GAME_COVER_NONE = 0;    -- 无遮挡
GAME_COVER_UNKNOWN = 1; -- 未知遮挡
GAME_COVER_BACKPACK_OPEN = 2; -- 背包打开
GAME_COVER_MAP_EXPAND = 3;    -- 地图展开
GAME_COVER_MODIFY_OPERATING_MODE = 4;    -- 修改设置面板的操作方式

--- 地图类型
KEY_NAME_MAP_TYPE = "pubgmhd_map_type"
PUBGMHD_KEY_MAP_IS_TRAIN = "pubgmhd_map_is_train"

KEY_GAME_RUNNING_COVER_STATUS = "RuningCoverStatus"
KEY_GAME_RUNNING_COVER_STATUS_CHANGED = "RunningCoverStatusChanged"

KEY_GAME_LOADING = "GameLoading"
KEY_IN_GAME_HOME = "InGameHome"
KEY_ENTER_GAME_HOME = "EnterGameHome"
KEY_ENTER_GAME = "EnterGame"--进入游戏
KEY_GAME_RUNNING = "GameRunning"--进入游戏
KEY_GAME_OVER = "GameOver"--游戏结束
KEY_IN_GAME_OVER_PAGE = "InGameOverPage"--在游戏结页面
KEY_GAME_STATUS_CHANGED = "GameStatusChanged"--游戏状态变更
KEY_GAME_ONCE_STATUS_UNKNOW = "gameOnceStatusUnknow"

KEY_ON_GAME_MODE_CONFIRMED = "OnGameModeConfirmed"

KEY_GAME_MODE = "GameMode"
GAME_MODEL_UNKNOW = -1
GAME_MODEL_SMOOTH = 0;
GAME_MODEL_GOOD_QUALITY = 1;

KEY_IS_SIGHT_MODE = "IsSightMode" --用于记录是否在望远镜模式，即准心模式

KEY_IS_SHOW_RED_DOT = "IsShowRedDot"

KEY_AIRPORT_END_SYS_TIME = "airportEndSysTime"

-- 用于回调到各个业务脚本的回调函数表
common_game_events_callbacks = {
    [KEY_GAME_LOADING] = {},
    [KEY_ENTER_GAME] = {},
    [KEY_ENTER_GAME_HOME] = {},
    [KEY_GAME_RUNNING] = {},
    [KEY_GAME_OVER] = {},
    [KEY_IN_GAME_HOME] = {},
    [KEY_GAME_STATUS_CHANGED]={},
    [KEY_IN_GAME_OVER_PAGE] = {},
    [KEY_ON_GAME_MODE_CONFIRMED] = {},
    [KEY_GAME_ONCE_STATUS_UNKNOW]={},
}

local INIT_INDEX = 1
local UNINIT_INDEX = 2

local MAX_UPLOAD_BITMAP_COUNT = 1
local uploadBitmapCount = 0
local enterHomeTime = 0
local isTopleft = false
local isExpand = nil

local function uploadBitmap()
    if uploadBitmapCount >= MAX_UPLOAD_BITMAP_COUNT then
        return
    end

    local currentTime = commonlib_getCurrentTime()
    if currentTime - enterHomeTime <= 0 or enterHomeTime == 0 then
        return
    end

    if currentTime - enterHomeTime < 2 * 60 * 1000 then
        return
    end

    uploadBitmapMat("cd_build_rect_blood", "pubgmhd_blood", SHOT_SCREEN_FOR_MAT_TYPE.pubgmhd_blood)
    uploadBitmapCount = uploadBitmapCount + 1
end

local function callLifeCircleInit()
    printLog("callLifeCircleInit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleInit common_life_circle_callbacks is nil or empty")
        return
    end
    commonlib_handleNestingTable(common_life_circle_callbacks, INIT_INDEX)
end

local function callLifeCircleUninit()
    printLog("callLifeCircleUninit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleUninit common_life_circle_callbacks is nil or empty")
        return
    end
    commonlib_handleNestingTable(common_life_circle_callbacks, UNINIT_INDEX)
end

local function isInHallHome()
    if gNewGameEngine:matchCondition("cd_build_game_home") then
        return true
    end
    return false
end

--- 是否修改操作方式
local function isModifyOperatingMode()
    local isModifyOperating = gNewGameEngine:matchCondition("cd_build_running_operating_mode");
    return isModifyOperating;
end


--- 地图类型检查
local function setMapType()
    local map = commonlib_getGameParam(KEY_NAME_MAP_TYPE);
    if not commonlib_isStringEmpty(map) then
        return map;
    end

    local mapType = gNewGameEngine:matchConditionOnNumber("cd_build_cj_detect_map_type");
    if mapType == 1 then
        map = KEY_NAME_MAP_ISLAND;
        commonlib_setGameParam(KEY_NAME_MAP_TYPE, KEY_NAME_MAP_ISLAND);
    elseif mapType == 2 then
        map = KEY_NAME_MAP_DESERT;
        commonlib_setGameParam(KEY_NAME_MAP_TYPE, KEY_NAME_MAP_DESERT);
    elseif mapType == 3 then
        map = KEY_NAME_MAP_RAINFOREST;
        commonlib_setGameParam(KEY_NAME_MAP_TYPE, KEY_NAME_MAP_RAINFOREST);
    elseif mapType == 4 then
        map = KEY_NAME_MAP_SNOW;
        commonlib_setGameParam(KEY_NAME_MAP_TYPE, KEY_NAME_MAP_SNOW);
    elseif mapType == 0 then
        commonlib_setGameParam(PUBGMHD_KEY_MAP_IS_TRAIN, true)
    end
    printLog("setMapType = " .. commonlib_toString(map));
    return map;
end

--- 地图是否展开
local function isMapExpand()
    if isExpand ~= nil then
        return isExpand
    end

    isExpand = gNewGameEngine:matchCondition("cd_build_map_close");
    if isExpand == true then
        setMapType();
    end
    return isExpand;
end

local function getRunningStateImpl()
    if isTopleft == false then
        isTopleft = gNewGameEngine:matchCondition("cd_build_topleft")
        if isTopleft == true then
            common_skin_clearSkinDataAndDestroySkin()
            common_skin_createSkinData()
            printLog("recreateSkinData")
        end
    end

    local result = gNewGameEngine:matchCondition("cd_build_game_running_setting_default_mode_1")
    if false == result then
        result = gNewGameEngine:matchCondition("cd_build_topleft")
    end

    if result == true then
        result = isModifyOperatingMode() == false
    end

    local isSpectatorMode = false;
    --如果是running，要判断是否是观战模式，如果是观战模式，就当成位置模式
    if result == true and
            gNewGameEngine:matchCondition(KEY_NAME_SPECTATOR_RECOG_INFO)then
        result = false;
        isSpectatorMode = true;
    end

    if result == true then
        if isMapExpand() then
            result = false;
        end
    end

    return {
        running = result,
        spectatorMode = isSpectatorMode,
    };
end

--通过判断gameruning来确定是否是高清模式，来确定地图的大小
local function isRunning()
    return getRunningStateImpl().running;
end

local function isGameOver()
    return gNewGameEngine:matchCondition(KEY_NAME_GAME_OVER_RECOG_INFO);
end

--- 是否可射击
local function canShoot()
    return gNewGameEngine:matchCondition(KEY_NAME_RIGHT_SQUAT_RECOG_INFO)
            or gNewGameEngine:matchCondition(KEY_NAME_RIGHT_SQUAT_SELECTED_RECOG_INFO);
end

local function getCurrentState(lastState)
    local currentState = PUBGMHD_GAMESTATE_UNKNOW;
    if lastState == nil or lastState == PUBGMHD_GAMESTATE_UNKNOW then
        if isInHallHome() then
            printLog("未知-->游戏大厅");
            currentState = PUBGMHD_GAMESTATE_IN_GAMEHOME;
        elseif isRunning() then
            printLog("未知-->游戏进行中");
            currentState = PUBGMHD_GAMESTATE_RUNNING;
        elseif isGameOver() then
            currentState = PUBGMHD_GAMESTATE_OVER;
            printLog("未知-->游戏结束");
        end
    elseif lastState == PUBGMHD_GAMESTATE_IN_GAMEHOME then
        if isRunning() then
            printLog("游戏未开始-->游戏运行");
            currentState = PUBGMHD_GAMESTATE_RUNNING;
        elseif isInHallHome() then
            printLog("游戏大厅-->游戏大厅");
            currentState = PUBGMHD_GAMESTATE_IN_GAMEHOME;
        end
    elseif lastState == PUBGMHD_GAMESTATE_RUNNING then
        local runninState = getRunningStateImpl();
        if runninState.running == true then
            printLog("游戏运行-->游戏运行");
            currentState = PUBGMHD_GAMESTATE_RUNNING;
        elseif runninState.spectatorMode == true then
            printLog("游戏运行-->游戏结束 by spectator mode");
            currentState = PUBGMHD_GAMESTATE_OVER;
        elseif isGameOver() then
            currentState = PUBGMHD_GAMESTATE_OVER;
            printLog("游戏运行-->游戏结束");
        elseif isInHallHome() then
            printLog("游戏运行-->游戏大厅");
            currentState = PUBGMHD_GAMESTATE_IN_GAMEHOME;
        end
    elseif lastState == PUBGMHD_GAMESTATE_OVER then
        if isGameOver() then
            currentState = PUBGMHD_GAMESTATE_OVER;
            printLog("游戏运行-->游戏结束");
        elseif isInHallHome() then
            printLog("游戏运行-->游戏大厅");
            currentState = PUBGMHD_GAMESTATE_IN_GAMEHOME;
        end
    end

    return currentState;
end

local function setCurrentGameState(currentState, lastState)
    if currentState ~= lastState and currentState ~= PUBGMHD_GAMESTATE_UNKNOW then
        commonlib_setGameParam(KEY_GAME_STATE, currentState);
        if lastState == GAME_STATE_NOTSTART and currentState == PUBGMHD_GAMESTATE_RUNNING then
            commonlib_notifyGameStateChange(GAME_STATE_NOTSTART, GAME_STATE_LOADING, null, null)
        end
        commonlib_notifyGameStateChange(lastState, currentState, null, null)
        printLog("GAME_STATE_CHANGE " .. tostring(lastState) .. " > " ..tostring(currentState));
    end
end

local function distpatchGameStateEvent(lastGameState, currentState)
    printLog("distpatchGameStateEvent:start, state " .. tostring(lastGameState) .. " > " .. tostring(currentState))

    if lastGameState == PUBGMHD_GAMESTATE_UNKNOW and currentState == PUBGMHD_GAMESTATE_UNKNOW then
        commonlib_handleTableWithoutParam(common_game_events_callbacks[KEY_GAME_LOADING])
    end

    if lastGameState ~= currentState then
        if (lastGameState == PUBGMHD_GAMESTATE_RUNNING and currentState == PUBGMHD_GAMESTATE_OVER) or
                (currentState ~= PUBGMHD_GAMESTATE_UNKNOW and lastGameState == PUBGMHD_GAMESTATE_RUNNING) then
            printLog("distpatchGameStateEvent:KEY_GAME_OVER")
            commonlib_handleTableWithoutParam(common_game_events_callbacks[KEY_GAME_OVER])
        end

        if currentState == PUBGMHD_GAMESTATE_RUNNING then
            printLog("distpatchGameStateEvent:KEY_ENTER_GAME")
            commonlib_handleTableWithoutParam(common_game_events_callbacks[KEY_ENTER_GAME])
        elseif currentState == PUBGMHD_GAMESTATE_IN_GAMEHOME then
            printLog("distpatchGameStateEvent:KEY_ENTER_GAME_HOME")
            commonlib_reportScriptMonitorAbnormal(PUBGMHD_APP_NAME, "enter game home");
            commonlib_handleTableWithoutParam(common_game_events_callbacks[KEY_ENTER_GAME_HOME])
        end
    end

    if currentState == PUBGMHD_GAMESTATE_RUNNING then
        printLog("distpatchGameStateEvent:KEY_GAME_RUNNING")
        commonlib_handleTableWithoutParam(common_game_events_callbacks[KEY_GAME_RUNNING])
    elseif currentState == PUBGMHD_GAMESTATE_IN_GAMEHOME then
        printLog("distpatchGameStateEvent:PUBGMHD_GAMESTATE_IN_GAMEHOME")
        commonlib_handleTableWithoutParam(common_game_events_callbacks[KEY_IN_GAME_HOME])
    elseif currentState == PUBGMHD_GAMESTATE_OVER or
            (lastGameState == PUBGMHD_GAMESTATE_OVER and currentState == PUBGMHD_GAMESTATE_UNKNOW) then
        printLog("distpatchGameStateEvent:KEY_IN_GAME_OVER_PAGE")
        commonlib_handleTableWithTwoParam(common_game_events_callbacks[KEY_IN_GAME_OVER_PAGE],
                lastGameState, currentState);
    end

    if lastGameState ~= currentState and currentState ~= PUBGMHD_GAMESTATE_UNKNOW then
        printLog("distpatchGameStateEvent:KEY_GAME_STATUS_CHANGED")
        commonlib_handleTableWithTwoParam(common_game_events_callbacks[KEY_GAME_STATUS_CHANGED],
            lastGameState, currentState);
    end

    if currentState == PUBGMHD_GAMESTATE_UNKNOW then
        local nowStatus = commonlib_getGameParam(KEY_GAME_STATE);
        commonlib_handleTableWithOneParam(common_game_events_callbacks[KEY_GAME_ONCE_STATUS_UNKNOW], nowStatus);
    end

    printLog("distpatchGameStateEvent:end")
end

local function resetStatus()
    commonlib_setGameParam(KEY_GAME_RUNNING_COVER_STATUS, GAME_COVER_NONE);
    commonlib_setGameParam(KEY_GAME_RUNNING_SUBSTATE, PUBGMHD_GAMESTATE_UNKNOW);
    commonlib_setGameParam(KEY_WEAPON_ICON, WEAPON_NONE);
    commonlib_setGameParam(KEY_NAME_MAP_TYPE, "");
    commonlib_setGameParam(KEY_IS_SIGHT_MODE, false);
    commonlib_setGameParam(PUBGMHD_KEY_MAP_IS_TRAIN, false)
    tryRecognizeWeaponStateCount = 0;
    hasRecognizedWeaponState = false;
    hasRecognizedLeftWeaponState = false;
    hasRecognizedRightWeaponState = false;
    isTopleft = false
end

local function initStatus()
    commonlib_setGameParam(KEY_GAME_STATE, PUBGMHD_GAMESTATE_UNKNOW);
    resetStatus();
end

local function initVarible()

    gNewGameEngine = CNewGameEngine:getInstance()
    gRecognizeAdapterManager = AdapterManagerClass:getRecognizeInstance();
    gRecognizeAdapterManager:init(global_getAdapterConfig());
    gRecognizeAdapterManager:printLog();
    report_gamemaster_game_pubgm_state(100, 1)
end

local function initPerformanceTrace()
    performanceTrace = PerformanceTrace();
    isCanTracePerformance = performanceTrace:canTracePerformance();
end

--gamemaster_source:441 gameid:string pkgname:string state:byte source:string uptime2:int
local ENTER_GAME = 1;
local EXIT_GAME = 2;
local function reportGameState(state)
    if source == nil then
        source = ""
    end
    if pkgName == nil then
        pkgName = ""
    end
end

local function onEnterGame()
    printLog("onEnterGame");
    enterHomeTime = commonlib_getCurrentTime()
    commonlib_initScriptMonitor(PUBGMHD_APP_NAME);

    if isCanTracePerformance then
        performanceTrace:onJustEnterGame();
    end

    resetAssistShowReportCache()
    notifyEnterGame()
    notifyAssistShowSucceed(ASSIST_SHOW_TYPE_ENTER_GAME)
    reportAssistShow(ASSIST_SHOW_TYPE_ENTER_GAME)

    pkgName = commonlib_getGamePackageName();
    reportGameState(ENTER_GAME)
    commonlib_setGameParam(PUBGMHD_KEY_MAP_IS_TRAIN, false)
end

local function onGameOver()
    printLog("onGameOver");
    resetStatus();
    if isCanTracePerformance then
        performanceTrace:onGameOver();
    end

    commonlib_uninitScriptMonitor(PUBGMHD_APP_NAME, "game over");

    notifyGameOver()
    reportAllAssistShow()

    reportGameState(EXIT_GAME)
    if gNewGameEngine ~= nil then
        gNewGameEngine:clearCache({CLEAR_FLAG_TIME_LIMIT_UNTIL_TRUE, CLEAR_FLAG_LIMIT_TIME_EXIT_INCORRECTLY});
    end
    gNewGameEngine:matchCondition("printSpendTime")
    gNewGameEngine:matchCondition("clearSpendTime")
end

local function parseGameStartParam()
    printLog("parseGameStartParam start")
    local gameStartParamTable = commonlib_getStartParams()
    if nil == gameStartParamTable then
        printLog("parseGameStartParam table=nil")
        return
    end

    source = gameStartParamTable[KEY_START_GAME_SRC]

    if nil == source then
        printLog("parseGameStartParam, decode json, data error")
        return
    end

end

local function registerResume()
    commonlib_registerResume(COMMON_STATE, function()
        printLog("onResume")
        parseGameStartParam()
    end)
end

local function unregisterResume()
    commonlib_unregisterResume(COMMON_STATE)
end

local function registerEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function unRegisterEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function init()
    printLog("LuaFlow: pubgmhd init")

    initVarible();
    initStatus();

    commonlib_lifeCircleSort()
    callLifeCircleInit()

    -- 关注设置面板的关闭事件，用于埋点上报
    commonlib_putSettingViewsEventListener()
    commonlib_registerSettingViewCloseCallback(pressAllGameSettingsReport)

    registerEvents();
    initPerformanceTrace();

    registerResume();

    gNewGameEngine:matchCondition("clearSpendTime")
    init_feedback()
end

local function uninit()
    printLog("LuaFlow: pubgmhd uninit")

    callLifeCircleUninit()

    -- 取消关注设置面板的关闭事件
    commonlib_unRegisterSettingViewCloseCallback(pressAllGameSettingsReport)
    unRegisterEvents();

    commonlib_uninitScriptMonitor(PUBGMHD_APP_NAME, "uninit")
    reportAllAssistShow()

    gNewGameEngine:matchCondition("clearSpendTime")
    unregisterResume()
end

--- 武器按钮识别
local function setCurrentWeaponState(state)
    local lastState = commonlib_getGameParam(KEY_WEAPON_ICON);
    if lastState ~= state then
        commonlib_setGameParam(KEY_WEAPON_ICON, state);
        printLog("WEAPON_STATE_CHANGE " .. tostring(lastState) .. " > " ..tostring(state));
    end
end

local function checkWeaponState()
    local maxRetryCount = 30;
    if hasRecognizedWeaponState == true or tryRecognizeWeaponStateCount > maxRetryCount then
        return hasRecognizedWeaponState;
    end

    tryRecognizeWeaponStateCount = tryRecognizeWeaponStateCount + 1;

    if hasRecognizedLeftWeaponState ~= true then
        gNewGameEngine:clearConditionCache(KEY_FIND_LEFT_WEAPON_CIRCLE_RECT);
        hasRecognizedLeftWeaponState = gNewGameEngine:matchCondition(KEY_FIND_LEFT_WEAPON_CIRCLE_RECT);
    end

    if hasRecognizedRightWeaponState ~= true then
        gNewGameEngine:clearConditionCache(KEY_FIND_RIGHT_WEAPON_CIRCLE_RECT);
        hasRecognizedRightWeaponState = gNewGameEngine:matchCondition(KEY_FIND_RIGHT_WEAPON_CIRCLE_RECT);
    end

    hasRecognizedWeaponState = hasRecognizedLeftWeaponState and hasRecognizedRightWeaponState;
    printLog("CHECK_WEAPON_STATE_CHANGE " .. tostring(hasRecognizedLeftWeaponState) .. ", " ..tostring(hasRecognizedRightWeaponState));
    return hasRecognizedWeaponState;
end

local function resetWeaponState()
    tryRecognizeWeaponStateCount = 0;
    hasRecognizedWeaponState = false;
    setCurrentWeaponState(WEAPON_NONE);
    hasRecognizedLeftWeaponState = false;
    hasRecognizedRightWeaponState = false;
end

--- 运行子状态识别
local function getRunningSubState(currentGameState)
    local currentSubState = PUBGMHD_GAMESTATE_UNKNOW;
    if currentGameState == PUBGMHD_GAMESTATE_RUNNING then
        if gNewGameEngine:matchCondition(KEY_NAME_BN_IS_IN_CARD_OR_SHIP_RECT_INFO) then
            currentSubState = PUBGMHD_GAMESTATE_RUNNING_CAR_SHIP;
        elseif canShoot()  then
            currentSubState = PUBGMHD_GAMESTATE_RUNNING_SHOOT;
        end
    end
    return currentSubState;
end

local function setCurrentRunningSubState(currentSubState, lastSubState)
    if currentSubState ~= lastSubState then
        printLog("RUNNING_SUBSTATE_CHANGE " .. tostring(lastSubState) .. " > " ..tostring(currentSubState));
        commonlib_setGameParam(KEY_GAME_RUNNING_SUBSTATE, currentSubState);
    end
end

--- 遮挡类型检查
local function getGameCoverType(currentGameState, lastGameState)
    local currentCoverType = GAME_COVER_NONE;
    if currentGameState == PUBGMHD_GAMESTATE_UNKNOW and lastGameState == PUBGMHD_GAMESTATE_RUNNING then
        if isMapExpand() then
            currentCoverType = GAME_COVER_MAP_EXPAND;
            --elseif isBackpackOpen() then
            --    currentCoverType = GAME_COVER_BACKPACK_OPEN;
        --elseif isModifyOperatingMode() then
            --currentCoverType = GAME_COVER_MODIFY_OPERATING_MODE;
        else
            currentCoverType = GAME_COVER_UNKNOWN;
        end
    end

    return currentCoverType;
end

local function setCurrentGameCoverType(currentCoverType, lastCoverType)
    if lastCoverType ~= currentCoverType then
        printLog("COVER_STATE_CHANGE " .. tostring(lastCoverType) .. " > " ..tostring(currentCoverType));
        commonlib_setGameParam(KEY_GAME_RUNNING_COVER_STATUS, currentCoverType);
    end
end

local function handleStateChange(currentRunningSubState, lastRunningSubState, currentCoverType, lastCoverType)
    if currentCoverType ~= lastCoverType then
        if currentCoverType ~= GAME_COVER_NONE then -- 有遮挡
            resetWeaponState();
        elseif checkWeaponState() == true then
            setCurrentWeaponState(WEAPON_BOTH);
        end
    elseif currentRunningSubState == PUBGMHD_GAMESTATE_UNKNOW then
        setCurrentWeaponState(WEAPON_NONE);
    elseif currentRunningSubState ~= lastRunningSubState then
        if currentRunningSubState ~= PUBGMHD_GAMESTATE_RUNNING_SHOOT then -- 不可射击状态
            setCurrentWeaponState(WEAPON_NONE);
        elseif checkWeaponState() == true then
            setCurrentWeaponState(WEAPON_BOTH);
        end
    end
end

local function work()
    printLog("work:start")

    gNewGameEngine:clearCache();
    isExpand = nil

    -- 游戏主状态
    local lastGameState = commonlib_getGameParam(KEY_GAME_STATE);
    local currentGameState = getCurrentState(lastGameState);
    setCurrentGameState(currentGameState, lastGameState);

    -- 遮挡类型
    local lastCoverType = commonlib_getGameParam(KEY_GAME_RUNNING_COVER_STATUS);
    local currentCoverType = getGameCoverType(currentGameState, lastGameState);
    setCurrentGameCoverType(currentCoverType, lastCoverType);

    -- 游戏子状态
    local lastRunningSubState = commonlib_getGameParam(KEY_GAME_RUNNING_SUBSTATE);
    local currentRunningSubState = getRunningSubState(currentGameState);
    setCurrentRunningSubState(currentRunningSubState, lastRunningSubState);

    handleStateChange(currentRunningSubState, lastRunningSubState, currentCoverType, lastCoverType);

    -- 遮挡状态视为游戏中
    if currentCoverType ~= GAME_COVER_NONE then
        currentGameState = PUBGMHD_GAMESTATE_RUNNING;
    end

    if currentGameState == PUBGMHD_GAMESTATE_RUNNING and currentCoverType == GAME_COVER_NONE then
        local hasSightMode = gNewGameEngine:matchCondition(KEY_NAME_BN_SIGHT_MODE_RECONG_INFO);
        commonlib_setGameParam(KEY_IS_SIGHT_MODE, hasSightMode);
	else
		commonlib_setGameParam(KEY_IS_SIGHT_MODE, false);
    end

    -- 游戏主状态分发
    distpatchGameStateEvent(lastGameState, currentGameState);

    uploadBitmap()
    printLog("work:end")
end

table.insert(core_scripts, { init, uninit, work })