--- 悬浮球
---date:2018-04-11
---author: hexujun@cmcm.com

local FLOAT_TAG = "float_window";
local floatBall;
local FLOAT_BALL_POSITION = { anchor = Anchor().TOPRIGHT, x = -449, y = 129}
local FLOAT_BALL_POSITION_AT_HOME = { anchor = Anchor().TOPRIGHT, x = -449, y = 129 }
local guideView
local settingView
local floatBallShowing = false;
local gbSettingViewOpen = false
local gbInGameHome = false;
local shareView
local floatTipContainer
local FLOAT_TIP_TEXT = "把超人分享给朋友吧~"
local FLOAT_TIP_SHOWING_TIME = 5 * 1000;
local gbHasShowInGameOverPage = false

local mLastEnterHomeSysTime;

local FLOAT_TIP_POS = {
    anchor = Anchor().TOPRIGHT,
    x = -449 - 478,
    y = 129 - 77
}

local function printLog(msg)
    commonlib_print(FLOAT_TAG, msg)
end

local function setSettingViewIcon()
    commonlib_setFloatBallIcon("common://image/icon_floatball_home.png")
    commonlib_setSettingViewIcon("common://image/icon_settingview.png")
    commonlib_setSettingViewIconSize(97.67, 65)
    commonlib_setSettingViewIconMargin(12, 0, 0, 0)
    commonlib_setSettingViewIconExtrudeHeight(21)
    commonlib_setFloatBallDragAndClick(true)
end

local function showFloatBall(show)
    printLog("showFloatBall " .. tostring(show))
    if floatBall == nil then
        printLog("showFloatBall return")
        return
    end

    commonlib_runOnUIThread(
        function()
            if floatBall == nil then
                printLog("showFloatBall return")
                return
            end

            if gbSettingViewOpen then
                printLog("showFloatBall return, setting view is opened")
                return
            end

            floatBallShowing = show;

            if show == true then
                printLog("showFloatBall show")
                floatBall:show()

                notifyAssistShowSucceed(ASSIST_SHOW_TYPE_FLOW_VIEW)
            else
                printLog("showFloatBall hide")
                floatBall:hide()
            end
        end);
end

--某个功能未开启
local function someFunctionNoOpen()
    --皮肤
    local skin = getSkinSwitchState()
    if skin == false then
        return true
    end
    --吃鸡雷达
    local radar = getSoundRadarSwitchState()
    if radar == false then
        return true
    end
    --警觉提醒
    local remind = getRemindSwitchState()
    if remind == false then
        return true
    end
    --瞄准器
    local gunSight = getGunSightSwitchState()
    if gunSight == false then
        return true
    end
    --资源地图
    local resMap = getResMapSwitchState()
    if resMap == false then
        return true
    end
    --收圈提醒
    local shrinkCircle = getShrinkCircleSwitchState()
    if shrinkCircle == false then
        return true
    end
    --跑圈提醒
    local runCircle = getRunCircleSwitchState()
    if runCircle == false then
        return true
    end
    return false
end

local PUBGMHD_FUNC_GUIDE_SECTION = "pubgmhd_func_guide_section"
local RED_DOT_FIRST_SHOW_DELAY_DAY = "reddot_first_show_delay_day"
local RED_DOT_FIRST_SHOW_DEFAULT = 1
local RED_DOT_AGAIN_SHOW_DELAY_DAY = "reddot_again_show_delay_day"
local RED_DOT_AGAIN_SHOW_DEFAULT = -1

local SP_RED_DOT_FIRST_SHOW_TIME = "sp_reddot_first_show_time"
local ONE_DAY_MILLIS = 24 * 60 * 60 * 1000

local function canShowRedDot()

    local someFuncNoOpen = someFunctionNoOpen()
    if someFuncNoOpen == false then
        return false
    end
    local currentTime = commonlib_getCurrentTime()
    local duration = 0
    local lastShowTime = commonlib_getSharedPrefLong(SP_RED_DOT_FIRST_SHOW_TIME, 0)
    if lastShowTime == 0 then
        duration = (currentTime - commonlib_getFirstInstallTime()) / ONE_DAY_MILLIS
        local firstShowDelayDay = commonlib_getCloudConfigIntValue(PUBGMHD_FUNC_GUIDE_SECTION,
                RED_DOT_FIRST_SHOW_DELAY_DAY, RED_DOT_FIRST_SHOW_DEFAULT)
        if commonlib_isLogWriteAble() then
            printLog("duration=" .. tostring(duration) .. " firstShowDelayDay=" .. tostring(firstShowDelayDay))
        end
        if duration >= firstShowDelayDay then
            return true
        end
    else
        local againShowDelayDay = commonlib_getCloudConfigIntValue(PUBGMHD_FUNC_GUIDE_SECTION,
                RED_DOT_AGAIN_SHOW_DELAY_DAY, RED_DOT_AGAIN_SHOW_DEFAULT)
        if againShowDelayDay ~= RED_DOT_AGAIN_SHOW_DEFAULT then
            duration = (currentTime - lastShowTime) / ONE_DAY_MILLIS
            if commonlib_isLogWriteAble() then
                printLog("duration=" .. tostring(duration) .. " againShowDelayDay=" .. tostring(againShowDelayDay))
            end
            if duration >= againShowDelayDay then
                return true
            end
        end
    end
    return false
end

local showRedDot = false

local function canShowGuidView()
    local gameState = commonlib_getGameParam(KEY_GAME_STATE);
    printLog("canShowGuidView, gameState=" .. tostring(gameState));
    if gbInGameHome == true then
        return false; -- 游戏大厅显示设置界面
    end
--    return gameState == PUBGMHD_GAMESTATE_UNKNOW or gameState == GAME_STATE_NOTSTART;
    return false;
end

local function destroyGuideView()
    if guideView ~= nil then
        guideView:destroy()
        guideView = nil
        printLog("destroyGuideView")
    end
end

local function destroyGuideViewOnUiThread()
    commonlib_runOnUIThread(function()
        destroyGuideView() end)
end

local function createGuideView()
    if guideView == nil then
        printLog("createGuideView")
        guideView = commonlib_getFloatViewMgrEx():createPubgmhdAssistGuideView();
        guideView:setOnEventListener(
                function ()
                    printLog("guideView open")
                end,
                function()
                    printLog("guideView hide")
                    if canShowGuidView() == true then
                        floatBall:show();
                        floatBallShowing = true;
                        notifyAssistShowSucceed(ASSIST_SHOW_TYPE_FLOW_VIEW)
                    end
                    destroyGuideViewOnUiThread()
                end);
        guideView:show();
    end
end

local function creteGuideViewOnUiThread()
    commonlib_runOnUIThread(function()
        createGuideView()
    end)
end

local function canShowGameOverShareView()
    local isViewShouldOpen = commonlib_getUtilTool():isGameOverShareFuncOpen()
    printLog("canShowGameOverShareView"..tostring(isViewShouldOpen))
    if isViewShouldOpen and gbHasShowInGameOverPage then
        return true
    else
        return false
    end
end

local function destroyGameOverSharView()
    if shareView ~= nil then
        shareView:destroy()
        shareView = nil
        printLog("destroyGameOverShareView")
    end
end

local function destroyGuideViewOnUiThread()
    commonlib_runOnUIThread(function()
        destroyGameOverSharView() end)
end

local function createShareView()
    if shareView == nil then
        printLog("createShareView")
        shareView = commonlib_getFloatViewMgrEx():createPubgmhdAssistGameOverShareView();
        shareView:setOnEventListener(
        function ()
            printLog("gameover shareView open")
        end,
        function ()
            printLog("gameover shareView hide")
            if canShowGameOverShareView() == true then
                floatBall:show();
                floatBallShowing = true;
                notifyAssistShowSucceed(ASSIST_SHOW_TYPE_FLOW_VIEW)
            end
            destroyGuideViewOnUiThread()
        end
        )
        shareView:show();
    end
end

local function createShareViewOnUiThread()
    commonlib_runOnUIThread(function()
        createShareView()
    end)
end

local function moveFloatBall()
    commonlib_runOnUIThread(function()
        if floatBall == nil then
            return
        end
        showRedDot = canShowRedDot()--展示红点
        if showRedDot == true then
            commonlib_setFloatBallIcon("common://image/icon_floatball_red.png")
            commonlib_setGameParam(KEY_IS_SHOW_RED_DOT, true)
        else
            commonlib_setFloatBallIcon("common://image/icon_floatball.png")
            commonlib_setGameParam(KEY_IS_SHOW_RED_DOT, false)
        end
        floatBall:moveCenterTo(FLOAT_BALL_POSITION.anchor, FLOAT_BALL_POSITION.x, FLOAT_BALL_POSITION.y)
    end);
end

-- 皮肤上新通知红点
local mIsShowNotice = false
local function newSkinNotice()
    local newSkin = commonlib_getGlobalSharedPrefString(SP_NEW_SKIN_KEY, "")
    local haveClick = commonlib_getSharedPrefBoolean(SP_SKIN_RED_DOT_CLICKED, false)
    printLog("newSkinNotice newSkin=" .. tostring(newSkin) .. " haveClick=" ..tostring(haveClick))
    mIsShowNotice = commonlib_isStringEmpty(newSkin) == false  and haveClick == false
    return mIsShowNotice
end

local function moveFloatBallOnEnterHome()
    commonlib_runOnUIThread(function()
        if floatBall == nil then
            return
        end
        if (newSkinNotice()) then
            commonlib_setFloatBallIcon("common://image/icon_floatball_red_home.png")
        else
            commonlib_setFloatBallIcon("common://image/icon_floatball_home.png")
        end
        floatBall:moveCenterTo(FLOAT_BALL_POSITION_AT_HOME.anchor, FLOAT_BALL_POSITION_AT_HOME.x, FLOAT_BALL_POSITION_AT_HOME.y)
    end);
end

local function onEnterGame()
    printLog("onEnterGame")
    gbInGameHome = false;
    gbSettingViewOpen = false
    moveFloatBall();
    showFloatBall(true);
end

local function onGameRunning()

    if gbSettingViewOpen then
        return
    end
    gbInGameHome = false;

    local cover = commonlib_getGameParam(KEY_GAME_RUNNING_COVER_STATUS);
    if cover == GAME_COVER_NONE  and floatBallShowing == false then
        showFloatBall(true);  -- 展示
    elseif cover ~= GAME_COVER_NONE  and floatBallShowing == true then
        showFloatBall(false); -- 隐藏
    end
end

local function onGameOver()
    printLog("onGameOver")
    gbInGameHome = false;
    showFloatBall(false);
    floatBallShowing = false;
    commonlib_setGameParam(KEY_IS_SHOW_RED_DOT, false)
end

local function destroyFloatTipContainer()
    if floatTipContainer ~= nil then
        floatTipContainer:destroy()
        floatTipContainer = nil;
    end
end

local function createFloatTipContainer()
    if floatTipContainer == nil then
        floatTipContainer = commonlib_getUnClickableFloatView():addSGameFloatViewControl(ZOrder().zorder_bottom)
    end
end

local function showFloatTip(text, position)
    commonlib_runOnUIThread(function()
        createFloatTipContainer()
        floatTipContainer:addFloatTipRemindView(text, FLOAT_TIP_SHOWING_TIME, position.anchor, position.x,
            position.y, false, ZOrder().zorder_top, nil);
    end)
end

local function hideFloatTipContainer()
    commonlib_runOnUIThread(function()
        if floatTipContainer ~= nil then
            floatTipContainer:hide()
            printLog("floatTipContainer hide");
        end
    end)
end

local function reportPubgmResultData(op, rank)
    commonlib_report("gamemaster_game_pubgm_result",
        {
            ["op"] = op,
            ["rank"]  = rank,
        })
end

local function onInGameOverPage()
    if not gbHasShowInGameOverPage  then
        printLog("onInGameOverPage")
--        showFloatBall(false)
        moveFloatBall()
        showFloatBall(true)
        local isShareFuncOpen = commonlib_getUtilTool():isGameOverShareFuncOpen()
        if isShareFuncOpen then
            showFloatTip(FLOAT_TIP_TEXT, FLOAT_TIP_POS)
            reportPubgmResultData(1, 0)
        end
        gbHasShowInGameOverPage = true
    end
end

local function showFloatBallBeforeGameStart()
    local lCurrentTime = commonlib_getCurrentTime()
    if nil == mLastEnterHomeSysTime or lCurrentTime - mLastEnterHomeSysTime > 1000 then
        if nil == guideView and nil ~= floatBall and  floatBallShowing == false then
            printLog("showFloatBallBeforeGameStart" )
            showFloatBall(true);
            moveFloatBallOnEnterHome();
        end
    end
    mLastEnterHomeSysTime = lCurrentTime
end

local function onGameLoading()
    printLog("onGameLoading")
    gbHasShowInGameOverPage = false
    gbInGameHome = false;
    showFloatBallBeforeGameStart();
end

local function onEnterGameHome()
    printLog("onEnterGameHome")
    gbInGameHome = true;
    gbHasShowInGameOverPage = false
    if guideView == nil then
        showFloatBall(true);
        moveFloatBallOnEnterHome();
    end
    mLastEnterHomeSysTime = commonlib_getCurrentTime()
end

local function onStayGameHome()
    printLog("onStayGameHome")
    gbHasInGameOverPage = false
    gbInGameHome = true;
    showFloatBallBeforeGameStart()
end

local function initVariable()
    floatBall = commonlib_getFloatBall();
    settingView = commonlib_getSettingView();

    ---floatBall:setTargetPackage("com.tencet.tmgp.pubgmhd")

    floatBall:setOnClickListener(function()
        printLog("悬浮球被点击");
        if canShowGuidView() == true then
            printLog("显示 guideView");
            creteGuideViewOnUiThread()
        elseif canShowGameOverShareView() == true then
            printLog("show gameover shareView")
            hideFloatTipContainer()
            createShareViewOnUiThread()
        else
            printLog("显示 settingView");
            settingView:show();
            commonlib_setGameParam(KEY_IS_SHOW_RED_DOT, showRedDot)
            if showRedDot then
                showRedDot = false
                commonlib_setSharedPrefLong(SP_RED_DOT_FIRST_SHOW_TIME, commonlib_getCurrentTime())
                commonlib_setFloatBallIcon("common://image/icon_floatball.png")
            end
            if mIsShowNotice then
                mIsShowNotice = false
                commonlib_setFloatBallIcon("common://image/icon_floatball_home.png")
            end
        end
        floatBall:hide();
        floatBallShowing = false;
    end);

    floatBall:setOnMoveListener(function()
        printLog("悬浮球移动")
        if canShowGameOverShareView() then
            hideFloatTipContainer()
        end
    end)
end

local function unInitVariable()
    floatBall = nil
    destroyGuideView()
    destroyFloatTipContainer()
end

local function onSettingViewOpen()
    gbSettingViewOpen = true
    printLog("onSettingViewOpen")
end
local function onSettingViewClose()
    gbSettingViewOpen = false
    printLog("onSettingViewClose")
    if not showRedDot then
        commonlib_setGameParam(KEY_IS_SHOW_RED_DOT, false)
    end
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_LOADING], onGameLoading)
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME_HOME], onEnterGameHome)
    commonlib_registerCallback(common_game_events_callbacks[KEY_IN_GAME_HOME], onStayGameHome)
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
    commonlib_registerCallback(common_game_events_callbacks[KEY_IN_GAME_OVER_PAGE], onInGameOverPage)

    commonlib_registerSettingViewOpenCallback(onSettingViewOpen)
    commonlib_registerSettingViewCloseCallback(onSettingViewClose)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_LOADING], onGameLoading)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME_HOME], onEnterGameHome)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_IN_GAME_HOME], onStayGameHome)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)

    commonlib_unRegisterSettingViewOpenCallback(onSettingViewOpen)
    commonlib_unRegisterSettingViewCloseCallback(onSettingViewClose)
end

local function init()
    printLog("init begin")
    registerGameEvents()
    initVariable()

    -- 开始设置悬浮球的外观
    setSettingViewIcon()
end

local function uninit()
    printLog("uninit")
    unInitVariable()
    unregisterGameEvents()
end

table.insert(common_life_circle_callbacks, { init, uninit, PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.float_window  })

