

--- 地图类型
KEY_NAME_MAP_ISLAND = "key_map_island"; --- 海岛地图
KEY_NAME_MAP_DESERT = "key_map_desert"; --- 沙漠地图
KEY_NAME_MAP_RAINFOREST = "key_name_rainforest" ---热带雨林
KEY_NAME_MAP_SNOW = "key_name_snow" ---12月新雪地地图

--- 物资类型
KEY_NAME_RESOURCE_ADVANCED     = "key_resource_advanced";     --- 高级物资
KEY_NAME_RESOURCE_INTERMEDIATE = "key_resource_intermediate"; --- 中级物资
KEY_NAME_RESOURCE_GENERAL      = "key_resource_general";      --- 一般物资
KEY_NAME_RESOURCE_ADVANCED_GUN = "key_resource_advanced_gun"; --- 高级枪械

--- 载具类型
KEY_NAME_CAR_FIXED             = "key_car_fixed";           --- 固定载具
KEY_NAME_CAR_PROBABILITY       = "key_car_probability";     --- 概率载具

KEY_NAME_ROUTE                 = "key_route";               --- 航线

KEY_NAME_MAP_HEIGHT            = "key_map_height"           --- 标注数据的地图高度，用于算缩放比例

--- 信号枪
KEY_NAME_SIGNAL_GUN            = "key_signal_gun"           --- 信号枪

--- 游乐场
KEY_NAME_PLAYGROUND            = "key_playground"           --- 游乐场

--- 圣诞树
CHRISTMAS_TREE = "christmas_tree"
KEY_NAME_BIG_CHRISTMAS_TREE    = "key_big_christmas_tree"
KEY_NAME_SMALL_CHRISTMAS_TREE    = "small_christmas_tree"

local MODEL = {
    ["mix 2;"] = {
    }
};

local RESOLUTION = {
    ["1280_720;"] = {
    }
};

local DEFAULT = {
    [KEY_NAME_MAP_ISLAND] = { --- 海岛地图
                              [KEY_NAME_MAP_HEIGHT] = 1080, -- 标注数据的地图高度，用于标注数据缩放

                              [KEY_NAME_RESOURCE_ADVANCED] = { --- 高级物资
                                                               { x = 	154	,	y=	167	,	radius=	30	},   --Z城
                                                               { x = 	504	,	y=	166	,	radius=	30	},   --S城
                                                               { x = 	242	,	y=	296	,	radius=	39	},   --G港上小镇
                                                               { x = 	723	,	y=	318	,	radius=	38	},   --Y城
                                                               { x = 	209	,	y=	377	,	radius=	27	},   --G港小镇
                                                               { x = 	272	,	y=	365	,	radius=	26	},   --G港
                                                               { x = 	537	,	y=	384	,	radius=	30	},   --R城
                                                               { x = 	584	,	y=	440	,	radius=	16	},   --学校
                                                               { x = 	484	,	y=	538	,	radius=	30	},   --P城
                                                               { x = 	962	,	y=	575	,	radius=	30	},   --核电站
                                                               { x = 	792	,	y=	635	,	radius=	30	},   --M城
                                                               { x = 	225	,	y=	818	,	radius=	32	},   --P港
                                                               { x = 	814	,	y=	805	,	radius=	32	},   --军事基地
                                                               { x = 	832	,	y=	498	,	radius=	15	},    --监狱
                                                               { x = 	761	,	y=	518	,	radius=	15	},    --防空洞
                                                               { x = 	593	,	y=	846	,	radius=	40	},    --N港

                                                               { x = 	1065,   y=	30, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE},    --大圣诞树-出生岛
                                                               { x = 	762	,	y=	166, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE	},    --大圣诞树-山顶废墟
                                                               { x = 	663	,	y=	474, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE	},    --大圣诞树-G镇上
                                                               { x = 	295	,	y=	509, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE	}     --大圣诞树-学校路口


                              },

                              [KEY_NAME_RESOURCE_INTERMEDIATE] = { --- 中级物资
                                                                   { x = 	591	,	y=	393	,	radius=	17	},    --医院
                                                                   { x = 	202	,	y=	424	,	radius=	15	},    --废墟
                                                                   { x = 	404	,	y=	424	,	radius=	23	},    --学校
                                                                   { x = 	464	,	y=	418	,	radius=	17	},
                                                                   { x = 	824	,	y=	402	,	radius=	15	},
                                                                   { x = 	557	,	y=	431	,	radius=	15	},    --学校坐标
                                                                   { x = 	591	,	y=	450	,	radius=	20	},    --宿舍楼
                                                                   { x = 	289	,	y=	518	,	radius=	17	},
                                                                   { x = 	840	,	y=	559	,	radius=	24	},
                                                                   { x = 	108	,	y=	655	,	radius=	26	},    --左下角海岸小镇
                                                                   { x = 	235	,	y=	695	,	radius=	26	},
                                                                   { x = 	379	,	y=	749	,	radius=	26	},
                                                                   { x = 	937	,	y=	440	,	radius=	30	},  --L城

                                                                   { x = 	315,   y=	328, christmas_tree = KEY_NAME_SMALL_CHRISTMAS_TREE},    --小圣诞树-G港旁
                                                                   { x = 	599	,	y=	525, christmas_tree = KEY_NAME_SMALL_CHRISTMAS_TREE},    --小圣诞树-农场山顶
                                                                   { x = 	734	,	y=	686, christmas_tree = KEY_NAME_SMALL_CHRISTMAS_TREE}    --小圣诞树-右边大桥

                              },

                              [KEY_NAME_RESOURCE_GENERAL] = { --- 一般物资
                                                              { x = 	755	,	y=	168	,	radius=	13	},
                                                              { x = 	486	,	y=	222	,	radius=	8	},
                                                              { x = 	518	,	y=	226	,	radius=	13	},
                                                              { x = 	656	,	y=	365	,	radius=	15	},
                                                              { x = 	742	,	y=	473	,	radius=	15	},
                                                              { x = 	208	,	y=	548	,	radius=	13	},
                                                              { x = 	534	,	y=	536	,	radius=	13	},
                                                              { x = 	326	,	y=	566	,	radius=	13	},
                                                              { x = 	550	,	y=	635	,	radius=	13	},
                                                              { x = 	105	,	y=	648	,	radius=	19	},
                                                              { x = 	281	,	y=	692	,	radius=	10	},
                                                              { x = 	506	,	y=	758	,	radius=	13	},
                                                              { x = 	734	,	y=	833	,	radius=	13	}
                              },
        --
                              [KEY_NAME_CAR_FIXED] = { --- 固定载具
                                                       { x = 	313	,	y=	399	},
                                                       { x = 	325	,	y=	371	},
                                                       { x = 	694	,	y=	323	},
                                                       { x = 	325	,	y=	371	},
                                                       { x = 	842	,	y=	362	},
                                                       { x = 	478	,	y=	392	},
                                                       { x = 	538	,	y=	401	},
                                                       { x = 	590	,	y=	396	},
                                                       { x = 	620	,	y=	419	},
                                                       { x = 	226	,	y=	462	},
                                                       { x = 	938	,	y=	434	},
                                                       { x = 	478	,	y=	546	},
                                                       { x = 	792	,	y=	635	},
                                                       { x = 	767	,	y=	795	},
                                                       { x = 	800	,	y=	802	}
                              },

                              [KEY_NAME_CAR_PROBABILITY] = { --- 概率载具
                                                             { x = 	133	,	y=	188	},
                                                             { x = 	119	,	y=	212	},
                                                             { x = 	184	,	y=	284	},
                                                             { x = 	330	,	y=	188	},
                                                             { x = 	431	,	y=	198	},
                                                             { x = 	414	,	y=	329	},
                                                             { x = 	467	,	y=	328	},
                                                             { x = 	518	,	y=	152	},
                                                             { x = 	506	,	y=	188	},
                                                             { x = 	524	,	y=	227	},
                                                             { x = 	592	,	y=	239	},
                                                             { x = 	630	,	y=	113	},
                                                             { x = 	697	,	y=	60	},
                                                             { x = 	831	,	y=	69	},
                                                             { x = 	847	,	y=	254	},
                                                             { x = 	275	,	y=	398	},
                                                             { x = 	187	,	y=	440	},
                                                             { x = 	143	,	y=	471	},
                                                             { x = 	268	,	y=	490	},
                                                             { x = 	129	,	y=	554	},
                                                             { x = 	243	,	y=	539	},
                                                             { x = 	287	,	y=	596	},
                                                             { x = 	290	,	y=	701	},
                                                             { x = 	308	,	y=	734	},
                                                             { x = 	181	,	y=	772	},
                                                             { x = 	233	,	y=	826	},
                                                             { x = 	374	,	y=	727	},
                                                             { x = 	501	,	y=	522	},
                                                             { x = 	476	,	y=	610	},
                                                             { x = 	450	,	y=	690	},
                                                             { x = 	450	,	y=	734	},
                                                             { x = 	569	,	y=	440	},
                                                             { x = 	655	,	y=	380	},
                                                             { x = 	662	,	y=	466	},
                                                             { x = 	659	,	y=	498	},
                                                             { x = 	647	,	y=	592	},
                                                             { x = 	670	,	y=	644	},
                                                             { x = 	728	,	y=	610	},
                                                             { x = 	752	,	y=	581	},
                                                             { x = 	770	,	y=	634	},
                                                             { x = 	736	,	y=	687	},
                                                             { x = 	767	,	y=	537	},
                                                             { x = 	770	,	y=	634	},
                                                             { x = 	835	,	y=	473	},
                                                             { x = 	892	,	y=	471	},
                                                             { x = 	889	,	y=	569	},
                                                             { x = 	877	,	y=	614	},
                                                             { x = 	932	,	y=	615	},
                                                             { x = 	946	,	y=	425	},
                                                             { x = 	479	,	y=	777	},
                                                             { x = 	519	,	y=	768	},
                                                             { x = 	635	,	y=	768	},
                                                             { x = 	731	,	y=	788	},
                                                             { x = 	795	,	y=	810	},
                                                             { x = 	573	,	y=	935	},
                                                             { x = 	550	,	y=	875	},
                                                             { x = 	548	,	y=	842	},
                                                             { x = 	577	,	y=	821	},
                                                             { x = 	617	,	y=	825	},
                                                             { x = 	650	,	y=	848	},
                                                             { x = 	685	,	y=	822	},
                                                             { x = 	608	,	y=	878	}
                              },
    },

    [KEY_NAME_MAP_DESERT] = { --- 沙漠地图
                              [KEY_NAME_MAP_HEIGHT] = 1080, -- 标注数据的地图高度，用于标注数据缩放

                              [KEY_NAME_RESOURCE_ADVANCED] = { --- 高级物资
                                                               { x = 	925	,	y=	51	,	radius=	80	},
                                                               { x = 	225	,	y=	373	,	radius=	60	},
                                                               { x = 	499	,	y=	386	,	radius=	49	},
                                                               { x = 	576	,	y=	374	,	radius=	23	},
                                                               { x = 	179	,	y=	374	,	radius=	60	},
                                                               { x = 	494	,	y=	572	,	radius=	28	},
                                                               { x = 	631	,	y=	727	,	radius=	94	},
                                                               { x = 	113	,	y=	965	,	radius=	35	}
                              },

                              [KEY_NAME_RESOURCE_INTERMEDIATE] = { --- 中级物资
                                                                   { x = 	336	,	y=	178	,	radius=	50	},
                                                                   { x = 	731	,	y=	77	,	radius=	60	},
                                                                   { x = 	878	,	y=	168	,	radius=	44	},
                                                                   { x = 	731	,	y=	193	,	radius=	38	},
                                                                   { x = 	857	,	y=	346	,	radius=	61	},
                                                                   { x = 	258	,	y=	531	,	radius=	55	},
                                                                   { x = 	853	,	y=	584	,	radius=	62	},
                                                                   { x = 	368	,	y=	696	,	radius=	62	},
                                                                   { x = 	179	,	y=	798	,	radius=	59	},
                                                                   { x = 	821	,	y=	829	,	radius=	51	}
                              },

                              [KEY_NAME_RESOURCE_ADVANCED_GUN] = { --- 高级枪械
                                                                   { x = 	248	,	y=	390	}, --伊波成
                                                                   { x = 	505	,	y=	568	}, --皮卡多
                                                                   { x = 	582	,	y=	378	}, --别墅
                                                                   { x = 	844	,	y=	363	}, --橙花
                                                                   { x = 	126	,	y=	979	}, --监狱
                              },

                              [KEY_NAME_CAR_PROBABILITY] = { --- 概率载具
                                                             { x = 	178	,	y=	194	},
                                                             { x = 	301	,	y=	194	},
                                                             { x = 	362	,	y=	157	},
                                                             { x = 	400	,	y=	157	},
                                                             { x = 	311	,	y=	194	},
                                                             { x = 	156	,	y=	250	},
                                                             { x = 	167	,	y=	307	},
                                                             { x = 	151	,	y=	401	},
                                                             { x = 	184	,	y=	373	},
                                                             { x = 	250	,	y=	349	},
                                                             { x = 	262	,	y=	388	},
                                                             { x = 	213	,	y=	449	},
                                                             { x = 	422	,	y=	424	},
                                                             { x = 	486	,	y=	183	},
                                                             { x = 	486	,	y=	332	},
                                                             { x = 	492	,	y=	401	},
                                                             { x = 	521	,	y=	162	},
                                                             { x = 	522	,	y=	196	},
                                                             { x = 	533	,	y=	401	},
                                                             { x = 	546	,	y=	270	},
                                                             { x = 	606	,	y=	117	},
                                                             { x = 	594	,	y=	307	},
                                                             { x = 	624	,	y=	419	},
                                                             { x = 	665	,	y=	361	},
                                                             { x = 	665	,	y=	332	},
                                                             { x = 	697	,	y=	60	},
                                                             { x = 	724	,	y=	60	},
                                                             { x = 	746	,	y=	388	},
                                                             { x = 	788	,	y=	349	},
                                                             { x = 	827	,	y=	117	},
                                                             { x = 	857	,	y=	80	},
                                                             { x = 	941	,	y=	62	},
                                                             { x = 	884	,	y=	126	},
                                                             { x = 	866	,	y=	194	},
                                                             { x = 	827	,	y=	355	},
                                                             { x = 	866	,	y=	361	},
                                                             { x = 	833	,	y=	320	},
                                                             { x = 	650	,	y=	449	},
                                                             { x = 	158	,	y=	489	},
                                                             { x = 	301	,	y=	489	},
                                                             { x = 	549	,	y=	509	},
                                                             { x = 	266	,	y=	559	},
                                                             { x = 	290	,	y=	541	},
                                                             { x = 	483	,	y=	566	},
                                                             { x = 	455	,	y=	606	},
                                                             { x = 	132	,	y=	647	},
                                                             { x = 	132	,	y=	679	},
                                                             { x = 	197	,	y=	688	},
                                                             { x = 	307	,	y=	679	},
                                                             { x = 	342	,	y=	688	},
                                                             { x = 	364	,	y=	697	},


                                                             { x = 	229	,	y=	801	},
                                                             { x = 	250	,	y=	861	},
                                                             { x = 	375	,	y=	878	},
                                                             { x = 	323	,	y=	920	},

                                                             { x = 	630	,	y=	535	},
                                                             { x = 	661	,	y=	489	},
                                                             { x = 	782	,	y=	541	},
                                                             { x = 	900	,	y=	541	},
                                                             { x = 	842	,	y=	606	},
                                                             { x = 	893	,	y=	625	},
                                                             { x = 	589	,	y=	713	},
                                                             { x = 	589	,	y=	798	},
                                                             { x = 	609	,	y=	801	},
                                                             { x = 	798	,	y=	844	},
                                                             { x = 	567	,	y=	946	},
                                                             { x = 	692	,	y=	902	}

                              },
    },

    [KEY_NAME_MAP_RAINFOREST] = { --- 热带雨林
                                  [KEY_NAME_MAP_HEIGHT] = 1080, --- 标注数据的地图高度，用于标注数据缩放

                                  [KEY_NAME_RESOURCE_ADVANCED] = { --- 高级物资
                                                                   { x =  340 , y= 311 , radius= 49 },   --河静
                                                                   { x =  675 , y= 373 , radius= 45 },   --天堂度假村
                                                                   { x =  527 , y= 530 , radius= 56 },   --训练基地
                                                                   { x =  925 , y= 611 , radius= 39 },   --拉卡维
                                                                   { x =  925 , y= 777 , radius= 38 },   --坎邦
                                                                   { x =  329 , y= 695 , radius= 34 },   --祭坛
                                                                   { x =  388 , y= 961 , radius= 30 },   --萨米
                                                                   { x =  858 , y= 216 , radius= 38 }   --椰树林
                                  },

                                  [KEY_NAME_RESOURCE_INTERMEDIATE] = { --- 中级物资
                                                                       { x =  587 , y= 273 , radius= 41 },   --塔莫克
                                                                       { x =  210 , y= 447 , radius= 45 },   --1号营地
                                                                       { x =  925 , y= 422 , radius= 45 },   --2号营地
                                                                       { x =  794 , y= 542 , radius= 38 },   --容树林
                                                                       { x =  504 , y= 728 , radius= 45 },   --派南
                                                                       { x =  719 , y= 682 , radius= 57 }   --采石场
                                  },

                                  [KEY_NAME_RESOURCE_GENERAL] = { --- 一般物资
                                                                  { x =  625 , y= 199 , radius= 49 },    --克豪镇
                                                                  { x =  235 , y= 777 , radius= 39 },    --塔姆邦
                                                                  { x =  295 , y= 876 , radius= 37 },    --纳坎
                                                                  { x =  635 , y= 923 , radius= 49 },    --3号营地
                                                                  { x =  719 , y= 821 , radius= 24 },    --洞穴
                                                                  { x =  881 , y= 929 , radius= 38 }    --码头
                                  },

                                  [KEY_NAME_CAR_PROBABILITY] = { --- 概率载具
                                                                 { x = 	251	,	y=	431	},
                                                                 { x = 	231	,	y=	519	},
                                                                 { x = 	187	,	y=	567	},
                                                                 { x = 	249	,	y=	559	},
                                                                 { x = 	409	,	y=	388	},
                                                                 { x = 	414	,	y=	434	},
                                                                 { x = 	536	,	y=	336	},
                                                                 { x = 	550	,	y=	329	},
                                                                 { x = 	645	,	y=	265	},
                                                                 { x = 	688	,	y=	169	},
                                                                 { x = 	731	,	y=	245	},
                                                                 { x = 	809	,	y=	306	},
                                                                 { x = 	927	,	y=	337	},
                                                                 { x = 	936	,	y=	458	},
                                                                 { x = 	638	,	y=	487	},
                                                                 { x = 	748	,	y=	527	},
                                                                 { x = 	872	,	y=	631	},
                                                                 { x = 	366	,	y=	766	},
                                                                 { x = 	837	,	y=	702	},
                                                                 { x = 	841	,	y=	834	},
                                                                 { x = 	614	,	y=	938	},
                                                                 { x = 	541	,	y=	974	},
                                                                 { x = 	868	,	y=	913	},
                                                                 { x = 	904	,	y=	794	},
                                                                 { x = 	339	,	y=	892	},
                                                                 { x = 	771	,	y=	614	},
                                                                 { x = 	323	,	y=	739	},
                                                                 { x = 	625	,	y=	783	},
                                                                 { x = 	773	,	y=	691	},
                                                                 { x = 	475	,	y=	806	},
                                                                 { x = 	426	,	y=	686	},
                                                                 { x = 	348	,	y=	331	}
                                  },
    },

    [KEY_NAME_MAP_SNOW] = { --- 12月新雪地地图
                            [KEY_NAME_MAP_HEIGHT] = 1080, --- 标注数据的地图高度，用于标注数据缩放

                            [KEY_NAME_RESOURCE_ADVANCED] = { --- 高级物资
                                                             { x =  	866 	 , y= 	208 	, radius=	31 	},---	亚力克港
                                                             { x =  	504 	 , y= 	204 	, radius=	24 	},---	扎鲁镇
                                                             { x =  	189 	 , y= 	439 	, radius=	26 	},---	钟塔港
                                                             { x =  	698 	 , y= 	279 	, radius=	31 	},---	航天基地
                                                             { x =  	303 	 , y= 	312 	, radius=	19 	},---	双港镇
                                                             { x =  	447 	 , y= 	421 	, radius=	28 	},---	冰湖镇
                                                             { x =  	887 	 , y= 	387 	, radius=	23 	},---	哈达农场
                                                             { x =  	709 	 , y= 	482 	, radius=	34 	},---	双桥镇
                                                             { x =  	794 	 , y= 	578 	, radius=	24 	},---	水泥厂
                                                             { x =  	539 	 , y= 	638 	, radius=	14 	},---	爱情小镇
                                                             { x =  	289 	 , y= 	666 	, radius=	14 	},---	布格沃镇
                                                             { x =  	669 	 , y= 	780 	, radius=	40 	},---	凛冬城
                                                             { x =  	802 	 , y= 	798 	, radius=	34 	},---	中央公园
                                                             { x =  	584 	 , y= 	907 	, radius=	24 	},---	酿酒厂
                                                             { x =  	384 	 , y= 	879 	, radius=	26 	}, ---	渔村

                                                             { x = 	586,   y=	430, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE },    --大圣诞树-滑雪场
                                                             { x = 	644	,	y=	646, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE 	},    --大圣诞树-城堡
                                                             { x = 	822	,	y=	814, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE 	},    --大圣诞树-中央公园
                                                             { x = 	215	,	y=	554, christmas_tree = KEY_NAME_BIG_CHRISTMAS_TREE 	}     --大圣诞树-恩希港上


                            },

                            [KEY_NAME_RESOURCE_INTERMEDIATE] = { --- 中级物资
                                                                 { x =  	916 	 , y= 	434 	, radius=	19 	},---	哈达农场右下
                                                                 { x =  	643 	 , y= 	643 	, radius=	14 	},---	城堡
                                                                 { x =  	233 	 , y= 	652 	, radius=	24 	},---	希恩港
                                                                 { x =  	420 	 , y= 	179 	, radius=	19 	},---	军港
                                                                 { x =  	921 	 , y= 	531 	, radius=	16 	},---	水泥厂右侧海岸上
                                                                 { x =  	593 	 , y= 	913 	, radius=	16 	},---	水泥厂右侧海岸下
                                                                 { x =  	493 	 , y= 	542 	, radius=	13 	},---	豪宅
                                                                 { x =  	397 	 , y= 	680 	, radius=	20 	},---	恐龙乐园
                                                                 { x =  	764 	 , y= 	745 	, radius=	13 	},---	中央公园左上
                                                                 { x =  	827 	 , y= 	696 	, radius=	16 	},---	中央公园正上
                                                                 { x =  	872 	 , y= 	744 	, radius=	16 	},---	中央公园右上
                                                                 { x =  	592 	 , y= 	765 	, radius=	16 	},---	凛冬城左侧
                                                                 { x =  	506 	 , y= 	758 	, radius=	16 	},---	庄园
                                                                 { x =  	335 	 , y= 	884 	, radius=	19 	},---	渔村左侧
                                                                 { x =  	440 	 , y= 	872 	, radius=	18 	},---	渔村右侧
                                                                 { x =  	539 	 , y= 	883 	, radius=	19 	},---	酿酒厂左侧
                                                                 { x =  	649 	 , y= 	941 	, radius=	14 	},---	酿酒厂右下海边
                                                                 { x =  	309 	 , y= 	607 	, radius=	13 	},---	布格沃镇上
                                                                 { x =  	459 	 , y= 	338 	, radius=	14 	},---	煤矿左侧
                                                                 { x =  	828 	 , y= 	412 	, radius=	13 	},---	农场左1
                                                                 { x =  	770 	 , y= 	4170 	, radius=	13 	},---	农场左2
                                                                 { x =  	340 	 , y= 	446 	, radius=	13 	},---	冰湖镇左侧
                                                                 { x =  	405 	 , y= 	267 	, radius=	12 	},---	军港下方
                                                                 { x =  	207 	 , y= 	557 	, radius=	12 	},---	希恩港上方
                                                                 { x =  	282 	 , y= 	786 	, radius=	13 	} ---	希恩港下方
                            },
    }
};

function global_getMapAdapterConfig()
    return {
        MODEL      = MODEL,
        RESOLUTION = RESOLUTION,
        DEFAULT    = DEFAULT,
    }
end