
local function printLog(msg)
    commonlib_print("map_resource", msg)
end

local CONST_VALUE = {
    MAP_RES_SETTING_VIEW_TYPE_CHECKBOX = 1,
    MAP_RES_SETTING_VIEW_TYPE_TOAST    = 2,
    TAB_NAME                   = "资源地图",
    CHECKBOX_TEXT              = "开启资源地图",
    KEY_IS_MAP_RESOURCE_ENABLE = SP_RES_MAP_SWITCH_KEY,
    KEY_ISLAND_SETTING_SWITCH_PREF      = "island_",
    KEY_DESERT_SETTING_SWITCH_PREF      = "desert_",
    KEY_RAINFOREST_SETTING_SWITCH_PREF  = "rainforest_",
    KEY_SNOW_SETTING_SWITCH_PREF        = "snow_",
    KEY_IS_ADVANCED_RESOURCE_ENABLE     = "key_is_advanced_resource_enable",
    KEY_IS_INTERMEDIATE_RESOURCE_ENABLE = "key_is_intermediate_resource_enable",
    KEY_IS_GENERAL_RESOURCE_ENABLE      = "key_is_general_resource_enable",
    KEY_IS_FIXED_CAR_ENABLE             = "key_is_fixed_car_enable",
    KEY_IS_PROBABILITY_CAR_ENABLE       = "key_is_probability_car_enable",
    KEY_IS_ROUTE_ENABLE                 = "key_is_route_enable",
    KEY_IS_HIDE_ALL_MAP_RES             = "key_is_hide_all_map_res",
    KEY_IS_SIGNAL_GUN_ENABLE            = "key_is_signal_gun_enable",
    KEY_IS_ADVANCED_GUN_RESOURCE_ENABLE = "key_is_advanced_gun_resource_enable",
    KEY_IS_PLAYGROUND_ENABLE            = "key_is_playground_enable",
    KEY_NAME_MAP_RES_SETTING_TITLE_LAYOUT                   = "key_map_res_setting_title_layout",  --- 地图资源设置的title
    KEY_NAME_MAP_RES_SETTING_HIDEBUTTON_LAYOUT              = "key_map_res_setting_hidebutton_layout",
    KEY_NAME_MAP_RES_HIDEBUTTON_LAYOUT                      = "key_map_res_hidebutton_layout",
    KEY_NAME_MAP_RES_SETTING_CONTENT_LAYOUT                 = "key_map_res_setting_content_layout", --- 地图资源设置内容
    KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_LAYOUT            = "key_map_res_setting_content_item_layout",
    KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CHECKBOX_LAYOUT   = "key_map_res_setting_content_item_checkbox_layout",
    KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CIRCLEVIEW_LAYOUT = "key_map_res_setting_content_item_circleview_layout",
    KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CAREVIEW_LAYOUT   = "key_map_res_setting_content_item_carview_layout",

    KEY_NAME_MAP_RES_SETTING_TOAST_ALERT_ITEM_LAYOUT        = "key_map_res_setting_toast_alert_item_layout",
    KEY_NAME_MAP_RES_SETTING_TOAST_CAR_ITEM_LAYOUT          = "key_map_res_setting_toast_car_item_layout",
    KEY_NAME_MAP_RES_SETTING_TOAST_ICON_LAYOUT              = "key_map_res_setting_toast_icon_layout",
    KEY_NAME_MAP_RES_SETTING_TOAST_TITLE_LAYOUT             = "key_map_res_setting_toast_title_layout",

    KEY_NAME_MAP_RES_SETTING_TOAST_DESC_LAYOUT              = "key_map_res_setting_toast_desc_layout",
    KEY_NAME_MAP_RES_SETTING_TOAST_GARAGE_IMAGE_LAYOUT      = "key_map_res_setting_toast_garage_image_layout",

    KEY_NAME_MAP_RES_ISLAND_HIDEBUTTON_LAYOUT               = "key_map_res_island_hidebutton_layout",
    KEY_NAME_MAP_RES_DESERT_HIDEBUTTON_LAYOUT               = "key_map_res_desert_hidebutton_layout",
    KEY_NAME_MAP_RES_RAINFOREST_HIDEBUTTON_LAYOUT           = "key_map_res_rainforest_hidebutton_layout",
    KEY_NAME_MAP_RES_SNOW_HIDEBUTTON_LAYOUT                 = "key_map_res_snow_hidebutton_layout",

    KEY_NAME_SETTING_TITLE                                  = "key_setting_title",        --- 地图设置页title
    KEY_NAME_GARAGE_IMAGE                                   = "key_garage_image",

    ROUTE_MIN_Y = 112, --- 皮肤高度

    -- 地图资源有6类，沙漠地图资源只有4类，提取设置项高度差为全局量
    MAP_RES_SIGNAL_GUN_HEIGHT_DIFF = (42 + 26),
    MAP_RES_DESERT_SETTING_HEIGHT_DIFF = (42 + 26),
    MAP_RES_RAINFOREST_SETTING_HEIGHT_DIFF = (42 + 26),
    MAP_RES_PLAYGROUND_HEIGHT_DIFF = (42 + 26),
    MAP_RES_SNOW_SETTING_HEIGHT_DIFF = (42 + 26),
    TEXT_DEFAULT_SIZE_PX = 24 + 1.5,

    TOAST_ITEM_MAP_RESOURCE    = 1,
    TOAST_ITEM_FIXED_CAR       = 2,
    TOAST_ITEM_PROBABILITY_CAR = 3,

    TOAST_DESC_FIRST  = 1,
    TOAST_DESC_SECOND = 2,

    --memaster_pubgm_resourcesmap:272 action:byte state:byte map:byte game_map:byte
    ACTION_MAP_EXPANED_ENLARGED           = 1,
    ACTION_MAP_EXPANED_NORMAL             = 2,
    ACTION_HIDE_BUTTON                    = 3,
    ACTION_SETTING_ROUTE                  = 4,
    ACTION_SETTING_RESOURCE_ADVANCED      = 5,
    ACTION_SETTING_RESOURCE_INTERMEDIATE  = 6,
    ACTION_SETTING_RESOURCE_GENERAL       = 7,
    ACTION_SETTING_CAR_FIXED              = 8,
    ACTION_SETTING_CAR_PROBABILITY        = 9,

    STATE_OPEN  = 1,
    STATE_CLOSE = 2,

    MAP_STATUS_NOT_EXPANED      = 0, ---地图没有展开
    MAP_STATUS_EXPANED_NORMAL   = 1, --- 地图正常展开
    MAP_STATUS_EXPANED_ENLARGED = 2, --- 地图正常展开并且放大的

    MAP_RESOURCE_HIDE = 1,
    MAP_RESOURCE_SHOW = 2,
    DELAY_INIT_MAP_RES = 2 * 1000
}

local MAP_RESOURCE_SETTING_VIEW = { ---地图资源设置，基于1080p下的坐标
                                    rect       = nil, --- need init on initVariable function
                                    rectDesert = nil, --- need init on initVariable function
                                    rectRainforest = nil, --- need init on initVariable function
                                    rectSnow = nil,

                                    [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TITLE_LAYOUT] = {
                                        rect = { width = 203, height = 44 }
                                    },

                                    [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_HIDEBUTTON_LAYOUT] = {
                                        rect = { marginLeft = 194, marginTop = 1, width = 97, height = 42 },
                                        rectText = { marginLeft = 30, marginTop = 3, width = 67, height = 30 }
                                    },

                                    [CONST_VALUE.KEY_NAME_MAP_RES_ISLAND_HIDEBUTTON_LAYOUT] = {
                                        rect = { flag = Anchor().BOTTOMRIGHT, left = -802, top = -92, width = 206, height = 71 },
                                    },
                                    [CONST_VALUE.KEY_NAME_MAP_RES_DESERT_HIDEBUTTON_LAYOUT] = {
                                        rect = { flag = Anchor().BOTTOMRIGHT, left = -233, top = -186, width = 206, height = 71 },
                                    },
                                    [CONST_VALUE.KEY_NAME_MAP_RES_RAINFOREST_HIDEBUTTON_LAYOUT] = {
                                        rect = { flag = Anchor().BOTTOMRIGHT, left = -802, top = -92, width = 206, height = 71 },
                                    },
                                    [CONST_VALUE.KEY_NAME_MAP_RES_SNOW_HIDEBUTTON_LAYOUT] = {
                                        rect = { flag = Anchor().BOTTOMRIGHT, left = -802, top = -92, width = 206, height = 71 },
                                    },
                                    [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_LAYOUT] = {
                                        rect = { width = 293, height = 464 },
                                        rectDesert = { width = 293, height = 464 - CONST_VALUE.MAP_RES_DESERT_SETTING_HEIGHT_DIFF },
                                        rectRainforest = { width = 293, height = 464 - CONST_VALUE.MAP_RES_RAINFOREST_SETTING_HEIGHT_DIFF },
                                        rectSnow = { width = 293, height = 464 - CONST_VALUE.MAP_RES_SNOW_SETTING_HEIGHT_DIFF },

                                        [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_LAYOUT] = {

                                            rectFirst = { marginLeft = 24, marginTop = 41 - 13, marginRight = 16, marginBottom = 0, width = 253, height = 42 + 26 },
                                            rect      = { marginLeft = 24, marginTop = 26 - 26, marginRight = 16, marginBottom = 0, width = 253, height = 42 + 26 },

                                            [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CHECKBOX_LAYOUT] = {
                                                rect = { marginLeft = 0, marginTop = 0, marginRight = 0, marginBottom = 0, width = 220, height = 42 + 26, paddingTop = 13, paddingBottom = 13 },
                                            },

                                            [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CIRCLEVIEW_LAYOUT] = {
                                                rect = { marginLeft = 220, marginTop = 6 + 13, marginRight = 0, marginBottom = 0, width = 34, height = 34 },
                                            },

                                            [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CAREVIEW_LAYOUT] = {
                                                rect = { marginLeft = 221, marginTop = 6 + 13, marginRight = 0, marginBottom = 0, width = 28, height = 36 },
                                            },
                                        },

                                        [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_ALERT_ITEM_LAYOUT] = {
                                            rect = { marginLeft = 26, marginTop = 24 - 2, marginRight = 0, marginBottom = 0, width = 293 - 26, height = 35 },

                                            [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_ICON_LAYOUT] = {
                                                rect = { marginLeft = 0, marginTop = 0, marginRight = 0, marginBottom = 0, width = 32, height = 35 },
                                            },

                                            [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_TITLE_LAYOUT] = {
                                                rect = { marginLeft = 32 + 17 - 7, marginTop = 0, marginRight = 0, marginBottom = 0, width = 293 - 26 - (32 + 17 - 7), height = 30 },
                                            }
                                        },

                                        [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_CAR_ITEM_LAYOUT] = {
                                            rect = { marginLeft = 26, marginTop = 0, marginRight = 0, marginBottom = 0, width = 293 - 26, height = 35 },

                                            [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_ICON_LAYOUT] = {
                                                rect = { marginLeft = 0, marginTop = 0, marginRight = 0, marginBottom = 0, width = 28, height = 35 },
                                            },

                                            [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_TITLE_LAYOUT] = {
                                                rect = { marginLeft = 32 + 17 - 7, marginTop = 0, marginRight = 0, marginBottom = 0, width = 293 - 26 - (32 + 17 - 7), height = 30 },
                                            }
                                        },

                                        [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_DESC_LAYOUT] = {
                                            background    = { color = "#19FFFFFF" },
                                            rect          = { marginLeft = 24, marginTop = 14, marginRight = 24, marginBottom = 36 - 2, width = 293 - 24 * 2, height = 101 },
                                            rectTxtFirst  = { marginLeft = 26 - 4, marginTop = 17 - 5, marginRight = 0, marginBottom = 0, width = 293 - 24 * 2 - (26 - 3), height = 30 },
                                            rectTxtSecond = { marginLeft = 26 - 4, marginTop = 10 - 2, marginRight = 0, marginBottom = 0, width = 293 - 24 * 2 - (26 - 3), height = 30 },
                                        },

                                        [CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_GARAGE_IMAGE_LAYOUT] = {
                                            rect = { marginLeft = 28, marginTop = 13, marginRight = 0, marginBottom = 32 - 4, width = 238, height = 116 },
                                        }
                                    },
}

local MAP_RESOURCE_CIRCLE = { --- 基于1080下的参数
                              [KEY_NAME_RESOURCE_ADVANCED]     = { border_size = 2, border_color = 0xFF5C00, border_alpha = 0xE5, fill_color = 0xFF5C00, fill_alpha = 0x59 },
                              [KEY_NAME_RESOURCE_INTERMEDIATE] = { border_size = 2, border_color = 0xFFD100, border_alpha = 0xE5, fill_color = 0xFBD100, fill_alpha = 0x59 },
                              [KEY_NAME_RESOURCE_GENERAL]      = { border_size = 2, border_color = 0x11D217, border_alpha = 0xE5, fill_color = 0x12D219, fill_alpha = 0x59 },
                              [KEY_NAME_PLAYGROUND]            = { border_size = 2, border_color = 0xFF5C00, border_alpha = 0xE5, fill_color = 0xFF5C00, fill_alpha = 0x59 },
}
local IMAGE_PARAM = { --- 基于1080下的参数
                      [KEY_NAME_CAR_FIXED]       = { path = "img/mapres/fixed_car.png", width = 18, height = 23 },
                      [KEY_NAME_CAR_PROBABILITY] = { path = "img/mapres/probability_car.png", width = 18, height = 23 },
                      [CONST_VALUE.KEY_NAME_SETTING_TITLE]   = { path = "img/mapres/setting_title.png" },
                      [CONST_VALUE.KEY_NAME_GARAGE_IMAGE]    = { path = "img/mapres/map_res_garage.png" },
                      [KEY_NAME_SIGNAL_GUN]    = { path = "img/mapres/signal_sun.png", width = 32, height = 40 },
                      [KEY_NAME_RESOURCE_ADVANCED_GUN] = { path = "img/mapres/advanced_gun.png", width = 32, height = 40 },
                      [KEY_NAME_PLAYGROUND]    = { path = "img/mapres/playground.png" , width = 46, height = 46 },

                      [CONST_VALUE.MAP_RESOURCE_HIDE]        = { path = "img/mapres/map_res_hide.png" },
                      [CONST_VALUE.MAP_RESOURCE_SHOW]        = { path = "img/mapres/map_res_show.png" },

                      [KEY_NAME_BIG_CHRISTMAS_TREE] = { path = "img/mapres/big_christmas_tree.png", width = 68, height = 68 },
                      [KEY_NAME_SMALL_CHRISTMAS_TREE] = { path = "img/mapres/small_christmas_tree.png", width = 52, height = 52 },

}

local SETTING_RESOURCE_CIRCLE = { --- 基于1080下的参数
                                  [KEY_NAME_RESOURCE_ADVANCED]     = { border_size = 2, border_color = 0xFF5C00, border_alpha = 0xFF, fill_color = 0xFF5C00, fill_alpha = 0x7F, radius = 16 },
                                  [KEY_NAME_RESOURCE_INTERMEDIATE] = { border_size = 2, border_color = 0xFFD100, border_alpha = 0xFF, fill_color = 0xFBD100, fill_alpha = 0x66, radius = 16 },
                                  [KEY_NAME_RESOURCE_GENERAL]      = { border_size = 2, border_color = 0x11D217, border_alpha = 0xFF, fill_color = 0x12D219, fill_alpha = 0x66, radius = 16 }
}

local SETTING_ITEM_LIST_ISLAND = {
    { type = KEY_NAME_RESOURCE_ADVANCED,     text = "高级物资" },
    { type = KEY_NAME_RESOURCE_INTERMEDIATE, text = "中级物资" },
    { type = KEY_NAME_RESOURCE_GENERAL,      text = "一般物资" },
    { type = KEY_NAME_CAR_FIXED,             text = "固定车辆" },
    { type = KEY_NAME_CAR_PROBABILITY,       text = "概率车辆" },
    { type = KEY_NAME_ROUTE,                 text = "跳伞航线" }
}

local SETTING_ITEM_LIST_DESERT = {
    { type = KEY_NAME_RESOURCE_ADVANCED_GUN, text = "高级枪械" },
    { type = KEY_NAME_RESOURCE_ADVANCED,     text = "高级物资" },
    { type = KEY_NAME_RESOURCE_INTERMEDIATE, text = "中级物资" },
    { type = KEY_NAME_CAR_PROBABILITY,       text = "概率车辆" },
    { type = KEY_NAME_ROUTE,                 text = "跳伞航线" }
}

local SETTING_ITEM_LIST_RAINFOREST = {
    { type = KEY_NAME_RESOURCE_ADVANCED,     text = "高级物资" },
    { type = KEY_NAME_RESOURCE_INTERMEDIATE, text = "中级物资" },
    { type = KEY_NAME_RESOURCE_GENERAL,      text = "一般物资" },
    { type = KEY_NAME_CAR_PROBABILITY,       text = "概率车辆" },
    { type = KEY_NAME_ROUTE,                 text = "跳伞航线" }
}

local SETTING_ITEM_LIST_SNOW = {
    { type = KEY_NAME_RESOURCE_ADVANCED,     text = "高级物资" },
    { type = KEY_NAME_RESOURCE_INTERMEDIATE, text = "中级物资" },
}

local SETTING_HIDE_BUTTON = { --- TEXTSIZE:"8sp"->"24px"
                              [CONST_VALUE.MAP_RESOURCE_HIDE] = { text = "隐藏", textSize = 24, textColor = "#161719", path = "img/mapres/map_res_hidebutton_background.png" },
                              [CONST_VALUE.MAP_RESOURCE_SHOW] = { text = "显示", textSize = 24, textColor = "#161719", path = "img/mapres/map_res_showbutton_background.png" }
}


local SETTING_TOAST_ITEM = { --- TEXTSIZE:"9.67sp"->"24px"
                             [CONST_VALUE.TOAST_ITEM_MAP_RESOURCE]     = { text = "资源地图无法显示", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FF5353", path = "img/mapres/alert.png" },
                             [CONST_VALUE.TOAST_ITEM_FIXED_CAR]        = { text = "固定车辆在车库里", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF", path = "img/mapres/fixed_car.png" },
                             [CONST_VALUE.TOAST_ITEM_PROBABILITY_CAR]  = { text = "概率车辆在马路边", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF", path = "img/mapres/probability_car.png" }
}

local SETTING_TOAST_DESC = {
    [CONST_VALUE.TOAST_DESC_FIRST]  = { text = "仅在最小尺寸显示", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" },
    [CONST_VALUE.TOAST_DESC_SECOND] = { text = "请缩放地图至最小", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" }
}

local gHideButtonClickFloatView
local gHideButtonRelativeLayout
local gHideButtonView

local gFloatView
local gMapResRelativeLayout

local gSettingClickFloatView
local gMapResSettingRelativeLayout
local gMapResSettingCheckBoxLayout
local gMapResSettingToastLayout

local gMapResAdapterManager


local gMapResSettingViewType
local gbMapResSettingViewShow            = false

local gMapKey; --- 地图类型, KEY_NAME_MAP_ISLAND或KEY_NAME_MAP_DESERT

--- 地图状态：
local gMapStatus;

local gbHideResMap --- 是否隐藏资源地图
local gbResMapSwitch --- 设置上的资源地图开关
local gResMapSwitchView;

local gfMapResScale
local gfScaleRelativeTo1080
local gRoute;
local glGameStartTime

local gbInitReport = false
local gNewGameEngine

local signalGunTabel = {}

local isGetSignalGunTabel

local playgroundTabel = {}
local isGetPlaygroundTabel
local playgroundSwitch = false

local isDelayInitSetting = false
local delayInitSettingTime = 0

local gMapResourceTipImageView
local gMapResourseDescTextView
local MAP_RESOURCE_DESC_TEXT = "使你可以在地图中显示各种物资标记，并记录跳伞航线\n*物资刷新存在概率性，资源地图结合了高概率的信息供参考"

local mapSettingTipsView

local function isHideButtonInMap() --- TODO，return true表示hidebutton显示于地图上
    return true
end

local function getPlaygroundTabel()
    if playgroundSwitch == false then
        return false
    end

    local glAirportEndSysTime = commonlib_getGameParam(KEY_AIRPORT_END_SYS_TIME)
    if glAirportEndSysTime and glAirportEndSysTime > 0 then
        local difftime = commonlib_getCurrentTime() - glAirportEndSysTime
        if difftime  > 1000 then
            printLog("getPlaygroundTabel, difftime=" .. tostring(difftime))
            if isGetPlaygroundTabel ~= nil then
                return isGetPlaygroundTabel
            end
        end
    else
        if isGetPlaygroundTabel ~= nil then
            return isGetPlaygroundTabel
        end
    end

    printLog("playground, isGetPlaygroundTabel=" .. tostring(isGetPlaygroundTabel))
    if isGetPlaygroundTabel == true then
        return isGetPlaygroundTabel
    end

    if gMapKey ~= KEY_NAME_MAP_ISLAND then
        isGetPlaygroundTabel = false
        return isGetPlaygroundTabel
    end
    ---[[
    local resultTable = gNewGameEngine:matchConditionOnTable("cd_build_playgroundv2")
    if resultTable == nil then
        printLog("playground, cd_build_playgroundv2 result=" .. tostring(resultTable))
        isGetPlaygroundTabel = false
        return isGetPlaygroundTabel
    end
    printLog("playground, result table=" .. tostring(#resultTable))
    local rect = {}
    local maxValue = 0
    for key, data in pairs(resultTable) do
        if nil ~= data then
            if data["result"] and data["result"] > maxValue then
                maxValue = data["result"]
                rect.top = data["top"]
                rect.left = data["left"]
                rect.width = data["width"]
                rect.height = data["height"]
                rect.flag = data["flag"]
                printLog("playground, rect.left=" .. tostring( rect.left)
                        .. ", rect.top=" .. tostring(rect.top)
                        .. ", rect.width=" .. tostring(rect.width)
                        .. ", rect.height=" .. tostring(rect.height)
                        .. ", maxValue=" .. tostring(maxValue))
            end
        end
    end

    if maxValue == 0 then
        printLog("playground, maxValue=" .. tostring(maxValue))
        isGetPlaygroundTabel = false
        return isGetPlaygroundTabel
    end
    --]]

    --local rect = {left = 272 + 180, top = 365, radius = 67}
    local rectExpandedMap = gNewGameEngine:getConditionRect(KEY_NAME_MR_EXPANDED_MAP_RECT)
    printLog("playground, rectExpandedMap.left=" .. tostring(rectExpandedMap.left)
            .. ", rectExpandedMap.top=" .. tostring(rectExpandedMap.top)
            .. ", rectExpandedMap.width=" .. tostring(rectExpandedMap.width)
            .. ", rectExpandedMap.height=" .. tostring(rectExpandedMap.height))

    isGetPlaygroundTabel = true
    table.insert(playgroundTabel, { x = rect.left - rectExpandedMap.left + rect.width / 2,
                                    y = rect.top + rect.height / 2,
                                    radius = 48})
    printLog("playground, playgroundTabel size=" .. tostring(#playgroundTabel)
            .. ", x=".. tostring(rect.left) .. ", y=" .. tostring(rect.top))
    return isGetPlaygroundTabel
end

local function getSignalGunMapTypeString()
    if gMapKey == nil then
        return ""
    end
    return gMapKey
end

local function getSignalGunTable()
    if isGetSignalGunTabel ~= nil then
        return isGetSignalGunTabel
    end

    if not commonlib_isTableEmpty(signalGunTabel) then
        return true
    end
    local mapString = getSignalGunMapTypeString()
    local sgTabel = commonlib_getUtilTool():getPubgmhdSignalGunTable(mapString)
    if sgTabel == nil then
        printLog("signalGun, commonlib_getUtilTool():getPubgmhdSignalGunTable() is nil")
        isGetSignalGunTabel = false
        return false
    end
    signalGunTabel = sgTabel
    printLog("signalGun, signalGunTabel size=" .. tostring(#signalGunTabel)
            .. ", mapString=" .. mapString .. ", mapKKey=" .. gMapKey)

    if commonlib_isTableEmpty(signalGunTabel) then
        isGetSignalGunTabel = false
        return false
    end
    isGetSignalGunTabel = true
    return true
end

local function settingITemSignalGun(settingItemList)
    printLog("signalGun, settingITemSignalGun, mapKKey=" .. gMapKey)
    if not getSignalGunTable() then
        return
    end
    table.insert(settingItemList, 1, { type = KEY_NAME_SIGNAL_GUN, text = "概率信号枪" })
    printLog("signalGun, settingITemSignalGun")
end

local function contentLayoutRectSignalGun(contentLayoutRect)
    printLog("signalGun, contentLayoutRectSignalGun, mapKKey=" .. gMapKey)
    if not getSignalGunTable() then
        return
    end
    contentLayoutRect.height = contentLayoutRect.height + CONST_VALUE.MAP_RES_SIGNAL_GUN_HEIGHT_DIFF
    printLog("signalGun, contentLayoutRect, width=" .. tostring(contentLayoutRect.width)
            .. ", height=" .. tostring(contentLayoutRect.height))
end

local function mapLayoutRectSignalGun(mapLayoutRect)
    printLog("signalGun, mapLayoutRectSignalGun, mapKKey=" .. gMapKey)
    if not getSignalGunTable() then
        return
    end
    mapLayoutRect.height = mapLayoutRect.height + CONST_VALUE.MAP_RES_SIGNAL_GUN_HEIGHT_DIFF
    mapLayoutRect.top = mapLayoutRect.height - CONST_VALUE.MAP_RES_SIGNAL_GUN_HEIGHT_DIFF

    printLog("signalGun, mapLayoutRect, width=" .. tostring(mapLayoutRect.width)
            .. ", height=" .. tostring(mapLayoutRect.height) .. ", top=" .. tostring(mapLayoutRect.top))
end

local function toSize(size, scale)
    if nil == size or nil == scale then
        return 0
    end

    return size * scale
end

local function toSizePxString(size)
    return tostring(size) .. "px"
end

local function toScaleSizePxString(size, scale)
    return tostring(toSize(size, scale)) .. "px"
end

------------------------------
-- report start --------------
------------------------------
local function getMapStateForReport()
    if gbHideResMap then
        return CONST_VALUE.STATE_CLOSE
    else
        return CONST_VALUE.STATE_OPEN
    end
end

local function reportOp(action, state)
    local mapType = 1 --- 海岛地图
    if gMapKey == KEY_NAME_MAP_DESERT then
        mapType = 2 --- 沙漠地图
    elseif gMapKey == KEY_NAME_MAP_RAINFOREST then
        mapType = 3 --- 热带雨林
    elseif gMapKey == KEY_NAME_MAP_SNOW  then
        mapType = 4 --- 雪地地图
    end

    commonlib_report("gamemaster_pubgm_resourcesmap",
        {
            ["action"] = action,
            ["state"]  = state,
            ["map"]    = mapType,
            ["game_map"] = mapType,
            ["game_id"] = tostring(commonlib_getGameId()),
        });

    printLog("report, action:" .. tostring(action) .. ", state:" .. tostring(state) .. ", map or game_map:" .. tostring(mapType))
end

local function reportSettingOp(resKey, bEnable)

    local action
    if KEY_NAME_RESOURCE_ADVANCED == resKey then
        action = CONST_VALUE.ACTION_SETTING_RESOURCE_ADVANCED
    elseif KEY_NAME_RESOURCE_INTERMEDIATE == resKey then
        action = CONST_VALUE.ACTION_SETTING_RESOURCE_INTERMEDIATE
    elseif KEY_NAME_RESOURCE_GENERAL == resKey then
        action = CONST_VALUE.ACTION_SETTING_RESOURCE_GENERAL
    elseif KEY_NAME_CAR_FIXED == resKey then
        action = CONST_VALUE.ACTION_SETTING_CAR_FIXED
    elseif KEY_NAME_CAR_PROBABILITY == resKey then
        action = CONST_VALUE.ACTION_SETTING_CAR_PROBABILITY
    elseif KEY_NAME_ROUTE == resKey then
        action = CONST_VALUE.ACTION_SETTING_ROUTE
    end

    if nil ~= action then

        local state = CONST_VALUE.STATE_CLOSE
        if bEnable then
            state = CONST_VALUE.STATE_OPEN
        end

        reportOp(action, state)
    end
end

------------------------------
-- report end ----------------
------------------------------

------------------------------
-- cache start ---------------
------------------------------
MapResourceData = {
    mnDataType,            -- 数据类型
    mbSwitch,              -- 当前开关状态
    mbAlreadyShown,        -- 当前显示状态
    mViewTable,            -- view列表
    mViewCheckBox,         -- checkboxView
}

function MapResourceData:create(dataType, defaultSwitch)
    local cache = {}

    cache.mstrDataType   = dataType
    cache.mbSwitch       = defaultSwitch
    cache.mbAlreadyShown = false
    cache.mViewTable     = {}
    cache.mViewCheckBox  = nil

    setmetatable(cache, self)
    self.__index = self
    return cache
end

function MapResourceData:getDataType()
    return self.mstrDataType
end

function MapResourceData:updateSwitch(bSwitch)
    self.mbSwitch = bSwitch
end
function MapResourceData:isSwitchOpen()
    return self.mbSwitch
end

function MapResourceData:updateShowStatus(bShow)
    self.mbAlreadyShown = bShow
end
function MapResourceData:isShow()
    return self.mbAlreadyShown
end

function MapResourceData:getViewTable()
    return self.mViewTable
end

function MapResourceData:setCheckBoxView(checkBoxView)
    self.mViewCheckBox = checkBoxView
end
function MapResourceData:getCheckBoxView()
    return self.mViewCheckBox
end

function MapResourceData:reset()
    self.mViewTable     = {}
    self.mbAlreadyShown = false
    self.mViewCheckBox  = nil
end

local RESOURCE_DEFAULT_SWITCH = {
    [KEY_NAME_SIGNAL_GUN]            = { default = true,  save_key = CONST_VALUE.KEY_IS_SIGNAL_GUN_ENABLE },                  -- 信号枪
    [KEY_NAME_RESOURCE_ADVANCED_GUN] = { default = true,  save_key = CONST_VALUE.KEY_IS_ADVANCED_GUN_RESOURCE_ENABLE },       -- 高级枪械
    [KEY_NAME_RESOURCE_ADVANCED]     = { default = true,  save_key = CONST_VALUE.KEY_IS_ADVANCED_RESOURCE_ENABLE },           -- 高级物资
    [KEY_NAME_RESOURCE_INTERMEDIATE] = { default = true,  save_key = CONST_VALUE.KEY_IS_INTERMEDIATE_RESOURCE_ENABLE },       -- 中级物资
    [KEY_NAME_RESOURCE_GENERAL]      = { default = false, save_key = CONST_VALUE.KEY_IS_GENERAL_RESOURCE_ENABLE },            -- 一般物资
    [KEY_NAME_CAR_FIXED]             = { default = true,  save_key = CONST_VALUE.KEY_IS_FIXED_CAR_ENABLE },                   -- 固定载具
    [KEY_NAME_CAR_PROBABILITY]       = { default = false, save_key = CONST_VALUE.KEY_IS_PROBABILITY_CAR_ENABLE },             -- 概率载具
    [KEY_NAME_ROUTE]                 = { default = false, save_key = CONST_VALUE.KEY_IS_ROUTE_ENABLE },                        -- 航线
}

local gMapResData = {
    [KEY_NAME_SIGNAL_GUN]            = MapResourceData:create(KEY_NAME_SIGNAL_GUN, RESOURCE_DEFAULT_SWITCH[KEY_NAME_SIGNAL_GUN].default),                         -- 信号枪
    [KEY_NAME_RESOURCE_ADVANCED_GUN] = MapResourceData:create(KEY_NAME_RESOURCE_ADVANCED_GUN, RESOURCE_DEFAULT_SWITCH[KEY_NAME_RESOURCE_ADVANCED_GUN].default),   -- 高级枪械
    [KEY_NAME_RESOURCE_ADVANCED]     = MapResourceData:create(KEY_NAME_RESOURCE_ADVANCED, RESOURCE_DEFAULT_SWITCH[KEY_NAME_RESOURCE_ADVANCED].default),           -- 高级物资
    [KEY_NAME_RESOURCE_INTERMEDIATE] = MapResourceData:create(KEY_NAME_RESOURCE_INTERMEDIATE, RESOURCE_DEFAULT_SWITCH[KEY_NAME_RESOURCE_INTERMEDIATE].default),   -- 中级物资
    [KEY_NAME_RESOURCE_GENERAL]      = MapResourceData:create(KEY_NAME_RESOURCE_GENERAL, RESOURCE_DEFAULT_SWITCH[KEY_NAME_RESOURCE_GENERAL].default),             -- 一般物资
    [KEY_NAME_CAR_FIXED]             = MapResourceData:create(KEY_NAME_CAR_FIXED, RESOURCE_DEFAULT_SWITCH[KEY_NAME_CAR_FIXED].default),                           -- 固定载具
    [KEY_NAME_CAR_PROBABILITY]       = MapResourceData:create(KEY_NAME_CAR_PROBABILITY, RESOURCE_DEFAULT_SWITCH[KEY_NAME_CAR_PROBABILITY].default),               -- 概率载具
    [KEY_NAME_ROUTE]                 = MapResourceData:create(KEY_NAME_ROUTE, RESOURCE_DEFAULT_SWITCH[KEY_NAME_ROUTE].default),                                  -- 航线
}

------------------------------
-- cache end -----------------
------------------------------

local function isResourceType(dataType)
    return KEY_NAME_RESOURCE_ADVANCED == dataType or
            KEY_NAME_RESOURCE_INTERMEDIATE == dataType or
            KEY_NAME_RESOURCE_GENERAL == dataType
end

local function isCarType(dataType)
    return KEY_NAME_CAR_FIXED == dataType or KEY_NAME_CAR_PROBABILITY == dataType
end

local function isSignalGunType(dataType)
    return KEY_NAME_SIGNAL_GUN == dataType
end

local function isAdvancedGunType(dataType)
    return KEY_NAME_RESOURCE_ADVANCED_GUN == dataType
end

local function getSettingItemList()
    if KEY_NAME_MAP_ISLAND == gMapKey then
        return SETTING_ITEM_LIST_ISLAND
    elseif KEY_NAME_MAP_DESERT == gMapKey then
        return SETTING_ITEM_LIST_DESERT
    elseif KEY_NAME_MAP_RAINFOREST == gMapKey then
        return SETTING_ITEM_LIST_RAINFOREST
    elseif KEY_NAME_MAP_SNOW == gMapKey then
        return SETTING_ITEM_LIST_SNOW
    end
end

local function getHideButtonRectInMap()
    if KEY_NAME_MAP_ISLAND == gMapKey then
        return MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_ISLAND_HIDEBUTTON_LAYOUT].rect
    elseif KEY_NAME_MAP_DESERT == gMapKey then
        return MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_DESERT_HIDEBUTTON_LAYOUT].rect
    elseif KEY_NAME_MAP_RAINFOREST == gMapKey then
        return MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_RAINFOREST_HIDEBUTTON_LAYOUT].rect;
    elseif KEY_NAME_MAP_SNOW == gMapKey then
        return MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_SNOW_HIDEBUTTON_LAYOUT].rect;
    end
end
local function isDesertMap()
    return KEY_NAME_MAP_DESERT == gMapKey
end

local function getRectCfg(itemCfg)
    if nil ~= itemCfg then
        if KEY_NAME_MAP_ISLAND == gMapKey then
            return itemCfg.rect
        elseif KEY_NAME_MAP_DESERT == gMapKey then
            return itemCfg.rectDesert
        elseif KEY_NAME_MAP_RAINFOREST == gMapKey then
            return itemCfg.rectRainforest
        elseif KEY_NAME_MAP_SNOW == gMapKey then
            return itemCfg.rectSnow
        end
    end
end

local function resetItemList(dataType)
    local settingItemList = getSettingItemList()
    if nil == settingItemList then
        printLog("resetSignalGunTable, setting_item_list is nil")
        return
    end

    local removeIndex = {}

    for i = 1, #settingItemList do
        if settingItemList[i].type == dataType then
            table.insert(removeIndex, i)
        end
    end

    if commonlib_isTableEmpty(removeIndex) then
        return
    end

    for i = 1, #removeIndex do
        table.remove(settingItemList, removeIndex[i])
        local contentLayoutCfg = MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_LAYOUT]
        local contentLayoutRect = getRectCfg(contentLayoutCfg)
        if contentLayoutRect then
            contentLayoutRect.height = contentLayoutRect.height - CONST_VALUE.MAP_RES_SIGNAL_GUN_HEIGHT_DIFF
            printLog("resetItemList, contentLayoutRect, width=" .. tostring(contentLayoutRect.width)
                    .. ", height=" .. tostring(contentLayoutRect.height))
        end

        local mapLayoutRect = getRectCfg(MAP_RESOURCE_SETTING_VIEW)
        if mapLayoutRect then
            mapLayoutRect.height = mapLayoutRect.height - CONST_VALUE.MAP_RES_SIGNAL_GUN_HEIGHT_DIFF
            mapLayoutRect.top = mapLayoutRect.height + CONST_VALUE.MAP_RES_SIGNAL_GUN_HEIGHT_DIFF
            printLog("resetItemList, mapLayoutRect, width=" .. tostring(mapLayoutRect.width)
                    .. ", height=" .. tostring(mapLayoutRect.height) .. ", top=" .. tostring(mapLayoutRect.top))
        end
    end
end

local function getSettingSaveKey(saveKey)
    if nil ~= saveKey then
        if KEY_NAME_MAP_ISLAND == gMapKey then
            return CONST_VALUE.KEY_ISLAND_SETTING_SWITCH_PREF .. saveKey
        elseif KEY_NAME_MAP_DESERT == gMapKey then
            return CONST_VALUE.KEY_DESERT_SETTING_SWITCH_PREF .. saveKey
        elseif KEY_NAME_MAP_RAINFOREST == gMapKey then
            return CONST_VALUE.KEY_RAINFOREST_SETTING_SWITCH_PREF .. saveKey
        elseif KEY_NAME_MAP_SNOW == gMapKey then
            return CONST_VALUE.KEY_SNOW_SETTING_SWITCH_PREF .. saveKey
        end
    end
end

local function initSetting()
    for key, data in pairs(gMapResData) do
        if nil ~= data then
            local saveKey = getSettingSaveKey(RESOURCE_DEFAULT_SWITCH[key].save_key)
            if nil ~= saveKey then
                local bEnable = commonlib_getSharedPrefBoolean(saveKey, RESOURCE_DEFAULT_SWITCH[key].default)
                data:updateSwitch(bEnable)

                printLog("initSetting, saveKey:" .. saveKey .. ", key:" .. tostring(key) .. ", enable:" .. tostring(bEnable))
            end
        end
    end

    local saveKey = getSettingSaveKey(CONST_VALUE.KEY_IS_HIDE_ALL_MAP_RES)
    if nil ~= saveKey then
        gbHideResMap = commonlib_getSharedPrefBoolean(saveKey, false)
        printLog("initSetting, saveKey" .. saveKey .. ", HideResMap:" .. tostring(gbHideResMap))
    end
end

local function updateSettingCheckBoxStatus(bEnable)
    for key, mapResData in pairs(gMapResData) do
        if nil ~= mapResData then
            local checkBoxView = mapResData:getCheckBoxView()
            if nil ~= checkBoxView then
                checkBoxView:setEnabled(bEnable)
            end
        end
    end
end

------------------------------
-- route view start ----------
------------------------------
---无返回值
local function updateViewStatus(view, bShow)
    if nil ~= view and bShow ~= view:isShowing() then
        if bShow then
            view:show()
        else
            view:hide()
        end
    end
end

local function fillRouteResult(x, y, left, top, width, height, retRoute)
    if nil == retRoute then
        return
    end

    local result = false
    if x >= left and x <= left + width and y >= top and y <= top + height then
        if nil == retRoute.x1 or nil == retRoute.y1 then
            retRoute.x1 = x
            retRoute.y1 = y
        else
            retRoute.x2 = x
            retRoute.y2 = y
        end
        result = true
    end

    printLog("fillRouteResult: " .. tostring(result) .. ", x="..tostring(x)..",y="..tostring(y)..
            ", left="..tostring(left)..", top="..tostring(top) ..
            ", width:" .. tostring(width) .. ", height:" .. tostring(height));
end

local function toFullRoute(origRoute, left, top, width, height)
    if nil == origRoute then
        return origRoute
    end

    if origRoute.x2 == origRoute.x1 then
        if origRoute.y2 == origRoute.y1 then
            return origRoute
        else
            --- 垂直直线
            local ret = {
                x1 = origRoute.x1,
                y1 = top,
                x2 = origRoute.x2,
                y2 = top + height
            }

            return ret
        end
    elseif origRoute.y2 == origRoute.y1 then
        --- 水平直线
        local ret = {
            x1 = left,
            y1 = origRoute.y1,
            x2 = left + width,
            y2 = origRoute.y2
        }
        return ret
    end

    local k = (origRoute.x2 - origRoute.x1) / (origRoute.y2 - origRoute.y1)
    if 0 == k then
        return origRoute
    end

    local ret = {
        x1 = nil,
        y1 = nil,
        x2 = nil,
        y2 = nil,
    }

    local xPoint1 = left
    local yPoint1 = (xPoint1 - origRoute.x2) / k + origRoute.y2
    fillRouteResult(xPoint1, yPoint1, left, top, width, height, ret)

    local xPoint2 = left + width
    local yPoint2 = (xPoint2 - origRoute.x2) / k + origRoute.y2
    fillRouteResult(xPoint2, yPoint2, left, top, width, height, ret)

    local yPoint3 = top
    local xPoint3 = k * (yPoint3 - origRoute.y2) + origRoute.x2
    fillRouteResult(xPoint3, yPoint3, left, top, width, height, ret)

    local yPoint4 = top + height
    local xPoint4 = k * (yPoint4 - origRoute.y2) + origRoute.x2
    fillRouteResult(xPoint4, yPoint4, left, top, width, height, ret)

    if nil == ret.x1 or nil == ret.y1 or nil == ret.x2 or nil == ret.y2 then
        return origRoute
    else
        return ret
    end
end

local function addRouteView(viewTable, bShow)
    local route = gRoute
    if nil == viewTable or nil == route or nil == gMapResRelativeLayout or nil == gMapResAdapterManager then
        printLog("addRouteView, args error!!!")
        return
    end

    local rect = gNewGameEngine:getConditionRect(KEY_NAME_MR_EXPANDED_MAP_RECT)
    local params = create("RelativeLayoutParam");

    local width  = toSize(rect.width, gfScaleRelativeTo1080)
    local height = toSize(rect.height, gfScaleRelativeTo1080)
    local paramProperties = {
        layout_marginTop  = toSizePxString(0),
        layout_marginLeft = toSizePxString(0),
        layout_width      = toSizePxString(width),
        layout_height     = toSizePxString(height),
    }
    params:setLayoutParam(paramProperties);

    local routeRelative = toFullRoute(route, 0, 0, width, height)

    printLog("toFullRoute:x1="..tostring(routeRelative.x1)..",y1="..tostring(routeRelative.y1)..
            ",x2="..tostring(routeRelative.x2)..",y2="..tostring(routeRelative.y2) ..
            ", width:" .. tostring(rect.width) .. ", height:" .. tostring(rect.height));

    local lineView = gMapResRelativeLayout:addLineView(
        routeRelative.x1, routeRelative.y1,
        routeRelative.x2, routeRelative.y2,
        "1.5dp", "#FFFFFFFF", true, params)
    if nil ~= lineView then
        updateViewStatus(lineView, bShow)
        viewTable[#viewTable + 1] = lineView
        printLog("addRouteView, addLineView succeed")
    else
        printLog("addRouteView, addLineView failed!!!")
    end
end

local function initRouteView(mapResData)
    printLog("initRouteView")

    if nil == gRoute or nil == mapResData then -- 参数出错
        printLog("initRouteView, args error!!!")
        return
    end

    local viewTable     = mapResData:getViewTable()
    local bSwitchOpen   = mapResData:isSwitchOpen()
    if nil == viewTable then -- 出错
        printLog("initRouteView, error viewTable")
        return
    end

    if #viewTable > 0 then -- 已添加过
        printLog("initRouteView, viewTable size > 0")
        return
    end

    addRouteView(viewTable, bSwitchOpen)
    mapResData:updateShowStatus(bSwitchOpen)
    printLog("initRouteView, updateShowStatus:" .. tostring(bSwitchOpen))
end

local function updateRouteStatus(mapResData)
    if nil == mapResData then
        return
    end

    initRouteView(mapResData)

    local viewTable     = mapResData:getViewTable()
    local bSwitchOpen   = mapResData:isSwitchOpen()
    local bAlreadyShown = mapResData:isShow()

    if bSwitchOpen == bAlreadyShown then
        printLog("updateRouteStatus, status is not changed, switch:" .. tostring(bSwitchOpen))
        return
    end

    if nil == viewTable or #viewTable <= 0 then
        printLog("updateRouteStatus, viewTable is empty, switch:" .. tostring(bSwitchOpen))
        return
    end

    for key, view in pairs(viewTable) do
        updateViewStatus(view, bSwitchOpen)
    end
    mapResData:updateShowStatus(bSwitchOpen)

    printLog("updateRouteStatus succeed, switch:" .. tostring(bSwitchOpen))
end
------------------------------
-- route view start ----------
------------------------------


------------------------------
-- res view start ------------
------------------------------
-- return view

local function addRouteViewImageDataType(rect, dataType)
    local x = toSize(rect.x, gfMapResScale)
    local y = toSize(rect.y, gfMapResScale)
    local signalGunParam = IMAGE_PARAM[dataType]
    local height = toSize(signalGunParam.height, gfMapResScale)
    local width  = toSize(signalGunParam.width, gfMapResScale)

    local params = create("RelativeLayoutParam");
    local paramProperties = {
        layout_marginTop  = toSizePxString(y - height),
        layout_marginLeft = toSizePxString(x - width / 2),
        layout_width      = toSizePxString(width),
        layout_height     = toSizePxString(height),
    }
    params:setLayoutParam(paramProperties);

    printLog("addRouteViewImageDataType, dataType:" .. tostring(dataType) ..
            ", x:" .. tostring(x) .. ", y:" .. tostring(y) ..
            ", h:" .. tostring(height) .. ", w:" .. tostring(width) .. ", scale:" .. tostring(gfMapResScale))

    return gMapResRelativeLayout:addImageView(signalGunParam.path, params, nil);
end

local function addRoutViewResourceType(rect, dataType)
    local x = toSize(rect.x, gfMapResScale)
    local y = toSize(rect.y, gfMapResScale)
    local r = toSize(rect.radius, gfMapResScale)
    local viewParam = MAP_RESOURCE_CIRCLE[dataType]
    local borderSize = toSize(viewParam.border_size, gfMapResScale)

    local params = create("RelativeLayoutParam");
    local paramProperties = {
        layout_marginTop  = toSizePxString(y - r),
        layout_marginLeft = toSizePxString(x - r),
        layout_width      = toSizePxString(r * 2),
        layout_height     = toSizePxString(r * 2),
    }
    params:setLayoutParam(paramProperties);

    printLog("addRoutViewResourceType, dataType:" .. tostring(dataType) ..
            ", x:" .. tostring(x) .. ", y:" .. tostring(y) .. ", r:" .. tostring(r) ..
            ", border_size:" .. tostring(borderSize) ..
            ", border_color:" .. tostring(viewParam.border_color) ..
            ", fill_color:" .. tostring(viewParam.fill_color) ..
            ", scale:" .. tostring(gfMapResScale))

    return gMapResRelativeLayout:addCircleView(params, r, borderSize,
            viewParam.border_color, viewParam.fill_color, viewParam.border_alpha, viewParam.fill_alpha)
end

local function addRouteViewTextBelowImageViewDataType(rect, dataType)
    local x = toSize(rect.x - 40, gfMapResScale)
    local y = toSize(rect.y, gfMapResScale)

    local params = create("RelativeLayoutParam");
    local paramProperties = {
        layout_marginTop  = toSizePxString(y),
        layout_marginLeft = toSizePxString(x),
        layout_width      = "WRAP_CONTENT",
        layout_height     = "WRAP_CONTENT",
    }
    params:setLayoutParam(paramProperties);

    printLog("addRouteViewTextBelowImageViewDataType, dataType:" .. tostring(dataType) ..
            ", x:" .. tostring(x) .. ", y:" .. tostring(y) .. ", scale:" .. tostring(gfMapResScale))

    return gMapResRelativeLayout:addTextView( "游乐场",
            "#FFFFFFFF",
            "9sp",
            params,
            nil);
end

local function addResourceView(rect, dataType)
    if nil == rect or nil == gMapResRelativeLayout then
        printLog("addResourceView, args error!!!")
        return nil
    end

    local views = {}
    local view
    if isResourceType(dataType) then
        if rect.christmas_tree == nil then
            view = addRoutViewResourceType(rect, dataType)
            table.insert(views, view)
        else
            --[[ 取消ChristmasTree
            local isShowTree = commonlib_getUtilTool():isShowChristmasTree()
            if isShowTree == true then
                local view2 = addRouteViewImageDataType(rect, rect.christmas_tree)
                table.insert(views, view2)
            end
            --]]
        end
    elseif isCarType(dataType) then
        view = addRouteViewImageDataType(rect, dataType)
        table.insert(views, view)
    elseif isAdvancedGunType(dataType) then
        view = addRouteViewImageDataType(rect, dataType)
        table.insert(views, view)
    elseif isSignalGunType(dataType) then
        view = addRouteViewImageDataType(rect, dataType)
        table.insert(views, view)
    elseif dataType == KEY_NAME_PLAYGROUND then
        printLog("addResourceView, KEY_NAME_PLAYGROUND, #rect=" .. tostring(#rect))
        for  i = 1, #rect do
            view = addRoutViewResourceType(rect[i], dataType)
            table.insert(views, view)
            view = addRouteViewImageDataType(rect[i], dataType)
            table.insert(views, view)
            view = addRouteViewTextBelowImageViewDataType(rect[i], dataType)
            table.insert(views, view)
        end
    end
    return views
end

local function addResourceViewsRetTable(views, bShow, viewRetTable, key, dataType)
    if not commonlib_isTableEmpty(views) then
        for i = 1, #views do
            local view = views[i]
            if nil ~= view then
                updateViewStatus(view, bShow)
                viewRetTable[#viewRetTable + 1] = view
                printLog("addResourceView, key:" .. tostring(key) .. ", dataType:" .. tostring(dataType) ..
                        ", show:" .. tostring(bShow) .. ", updateViewStatus succeed")
            end
        end
    end
end

--- 无返回值
local function addResourceViews(rectTable, viewRetTable, dataType, bShow)
    if nil == rectTable or nil == viewRetTable then
        printLog("addResourceViews, args error!!!, dataType=" .. tostring(dataType))
        return
    end

    local views
    if dataType == KEY_NAME_RESOURCE_ADVANCED then
        if commonlib_isTableEmpty(playgroundTabel) then
            getPlaygroundTabel()
        end
        if not commonlib_isTableEmpty(playgroundTabel) then
            printLog("addResourceViews, KEY_NAME_PLAYGROUND, playgroundTabel size=" .. tostring(#playgroundTabel))
            views = addResourceView(playgroundTabel, KEY_NAME_PLAYGROUND)
            addResourceViewsRetTable(views, bShow, viewRetTable, "playground", KEY_NAME_PLAYGROUND)
        end
    end

    for key, rect in pairs(rectTable) do
        views = addResourceView(rect, dataType)
        addResourceViewsRetTable(views, bShow, viewRetTable, key, dataType)
    end
end

-- 无返回值
local function updateViewStatusByTable(viewTable, bShow)
    if nil ~= viewTable then
        for key, view in pairs(viewTable) do
            updateViewStatus(view, bShow)
        end
    end
end

--- 此函数使用到gMapResData
local function addResourceViewsIfViewTableEmpty(mapCfgItem, resKey)
    if nil == mapCfgItem or nil == resKey then
        printLog("addResourceViewsIfViewTableEmpty, args error!!!")
        return
    end

    local mapResData = gMapResData[resKey]
    if nil == mapResData then
        printLog("addResourceViewsIfViewTableEmpty, map res data is nil, key:" .. tostring(resKey))
        return
    end

    local viewTable = mapResData:getViewTable()
    if nil == viewTable or #viewTable > 0 then
        printLog("addResourceViewsIfViewTableEmpty, already added view, key:" .. tostring(resKey))
        return
    end

    local bSwitchOpen = mapResData:isSwitchOpen()
    local rectTable;
    local dataType = mapResData:getDataType()
    if  isSignalGunType(dataType) then
        if not commonlib_isTableEmpty(signalGunTabel) then
            rectTable = signalGunTabel
        end
    else
        rectTable = mapCfgItem[resKey]
    end

    addResourceViews(rectTable, viewTable, dataType, bSwitchOpen)

    mapResData:updateShowStatus(bSwitchOpen)

    printLog("addResourceViewsIfViewTableEmpty, key:" .. tostring(resKey) .. ", updateShow:" .. tostring(bSwitchOpen))
end

local function getMapConfigData()
    if nil == gMapResRelativeLayout or nil == gMapResAdapterManager or nil == gMapKey then
        printLog("getMapConfigData, args error!!!")
        return
    end

    local mapCfgItem = gMapResAdapterManager:getItem(gMapKey)
    if nil ~= mapCfgItem then
        local origHeigth = mapCfgItem[KEY_NAME_MAP_HEIGHT]
        if nil ~= origHeigth and origHeigth > 0 then
            local realScreenSize = commonlib_getScreenRealSize()
            if nil ~= realScreenSize and nil ~= realScreenSize.h then
                gfMapResScale = realScreenSize.h / origHeigth
            end
        end
    end

    if nil == gfMapResScale or gfMapResScale <= 0 then
        printLog("scale calc error!!!")
        return nil
    end

    return mapCfgItem
end

local function resetSignalGunTable()
    if isGetSignalGunTabel == nil then
        return
    end
    isGetSignalGunTabel = nil

    if commonlib_isTableEmpty(signalGunTabel) then
        return
    end

    resetItemList(KEY_NAME_SIGNAL_GUN)
    signalGunTabel = {}
end


local function resetPlaygroundTabel()
    if nil == isGetPlaygroundTabel then
        return
    end
    isGetPlaygroundTabel = nil
    if commonlib_isTableEmpty(playgroundTabel) then
        return
    end
    playgroundTabel = {}
end

--- 重置缓存记录
local function resetMapResData()
    if nil == gMapResData then
        return
    end

    for key, data in pairs(gMapResData) do
        if nil ~= data then
            data:reset()
        end
    end
end

local function initAllResourceViews()
    local mapCfgItem = getMapConfigData()
    if nil == mapCfgItem then
        return
    end

    printLog("initAllResourceViews")
    addResourceViewsIfViewTableEmpty(mapCfgItem, KEY_NAME_RESOURCE_ADVANCED_GUN)
    addResourceViewsIfViewTableEmpty(mapCfgItem, KEY_NAME_RESOURCE_ADVANCED)
    addResourceViewsIfViewTableEmpty(mapCfgItem, KEY_NAME_RESOURCE_INTERMEDIATE)
    addResourceViewsIfViewTableEmpty(mapCfgItem, KEY_NAME_RESOURCE_GENERAL)
    addResourceViewsIfViewTableEmpty(mapCfgItem, KEY_NAME_CAR_FIXED)
    addResourceViewsIfViewTableEmpty(mapCfgItem, KEY_NAME_CAR_PROBABILITY)
    addResourceViewsIfViewTableEmpty(mapCfgItem, KEY_NAME_SIGNAL_GUN)
end

local function updateResourceGroupStatus(mapResData)
    if nil == mapResData then
        printLog("updateResourceGroupStatus, args error!!!")
        return
    end

    local mapCfgItem = getMapConfigData()
    if nil == mapCfgItem then
        return
    end

    local viewTable     = mapResData:getViewTable()
    local dataType      = mapResData:getDataType()
    local bSwitchOpen   = mapResData:isSwitchOpen()
    local bAlreadyShown = mapResData:isShow()

    if nil == viewTable then
        printLog("updateResourceGroupStatus, viewTable is nil, key:" .. tostring(dataType))
        return
    end

    if bSwitchOpen == bAlreadyShown then -- 开关状态一致
        printLog("updateResourceGroupStatus, status is not changed, switch:" .. tostring(bSwitchOpen) .. ", key:" .. tostring(dataType))
        return
    end

    local bAddViews = false
    if bSwitchOpen and #viewTable <= 0 then
        local rectTable;
        if isSignalGunType(dataType) then
            if not commonlib_isTableEmpty(signalGunTabel) then
                rectTable = signalGunTabel
            end
        else
            rectTable = mapCfgItem[resKey]
        end
        addResourceViews(rectTable, viewTable, dataType, bSwitchOpen)
        bAddViews = true
    end

    if not bAddViews and #viewTable > 0 then
        updateViewStatusByTable(viewTable, bSwitchOpen)
        mapResData:updateShowStatus(bSwitchOpen)
    end
end
------------------------------
-- res view end --------------
------------------------------

------------------------------
--- map view public start ----
------------------------------

local function createRelativeLayoutParam(layoutParam, topViewId)
    if nil == layoutParam  then
        printLog("createRelativeLayoutParam, args error!!!")
        return
    end

    local params = create("RelativeLayoutParam");
    local paramProperties = {
        layout_marginTop    = toScaleSizePxString(layoutParam.marginTop, gfScaleRelativeTo1080),
        layout_marginLeft   = toScaleSizePxString(layoutParam.marginLeft, gfScaleRelativeTo1080),
        layout_marginRight  = toScaleSizePxString(layoutParam.marginRight, gfScaleRelativeTo1080),
        layout_marginBottom = toScaleSizePxString(layoutParam.marginBottom, gfScaleRelativeTo1080),
        layout_width        = toScaleSizePxString(layoutParam.width, gfScaleRelativeTo1080),
        layout_height       = toScaleSizePxString(layoutParam.height, gfScaleRelativeTo1080),
        layout_below        = topViewId
    }
    params:setLayoutParam(paramProperties);
    return params
end

local function createTextView(relativeLayout, textLayoutRect, textDataCfg, topViewId)
    if nil == relativeLayout or nil == textLayoutRect or nil == textDataCfg then
        printLog("createTextView, args error")
        return
    end

    local textParam = createRelativeLayoutParam(textLayoutRect, topViewId)
    local textView = relativeLayout:addTextView(
        textDataCfg.text, textDataCfg.textColor, toScaleSizePxString(textDataCfg.textSize, gfScaleRelativeTo1080), textParam, nil)
    if nil == textView then
        printLog("createTextView, create error")
        return
    end

    return textView
end

local function createImageView(relativeLayout, imageLayoutRect, imagePath, topViewId)
    if nil == relativeLayout or nil == imageLayoutRect or nil == imagePath then
        printLog("createImageView, args error")
        return
    end

    local imageParam = createRelativeLayoutParam(imageLayoutRect, topViewId)
    local imageView  = relativeLayout:addImageView(imagePath, imageParam, nil)
    if nil == imageView then
        printLog("createImageView, create imageview error")
        return
    end

    return imageView
end

local function createRelativeLayout(floatView, mapLayoutRect, tag)
    if nil == floatView  then
        printLog("createRelativeLayout, floatView is nil, tag:".. tag)
        return
    end

    if nil ~= mapLayoutRect then
        local layoutView = floatView:addRelativeLayout( --- 这个函数内部会基于1080p做缩放
            mapLayoutRect.flag,
            mapLayoutRect.left,
            mapLayoutRect.top,
            mapLayoutRect.width,
            mapLayoutRect.height,
            ZOrder().zorder_bottom)

        printLog("createRelativeLayout, " .. tag .. " relativelayout succeed, flag:" .. tostring(mapLayoutRect.flag) ..
                ", left:" .. tostring(mapLayoutRect.left) .. ", top:" .. tostring(mapLayoutRect.top) ..
                ", w:" .. tostring(mapLayoutRect.width) .. ", h:" .. tostring(mapLayoutRect.height))
        return layoutView
    else
        printLog("createRelativeLayout failed, tag:".. tag)
    end
end

local function showView(view, tag)
    if nil == view then
        return false
    end
    view:show()
    printLog("showView:" .. tag)
    return true
end

local function hideView(view, tag)
    if nil == view then
        return
    end
    view:hide()
    printLog("hideView:" .. tag)
end

local function destroyView(view, tag)
    if nil ~= view then
        view:destroy()
        view = nil
    end
    printLog("destroyView:" .. tag)
end
------------------------------
--- map view public end ------
------------------------------

------------------------------
--- map setting start --------
------------------------------
--- 单项开关变化的回调
local function onResourceSwitchChange(resKey, bEnable)
    printLog("onResourceSwitchChange:resKey="..tostring(resKey)..",bEnable="..tostring(bEnable))
    local mapResData = gMapResData[resKey]
    if nil == mapResData then
        printLog("onResourceSwitchChange, map res data is nil, resKey="..tostring(resKey)..",bEnable="..tostring(bEnable))
        return
    end

    if mapResData:isSwitchOpen() == bEnable then
        printLog("onResourceSwitchChange, status is not changed, resKey="..tostring(resKey)..",bEnable="..tostring(bEnable))
        return
    end
    mapResData:updateSwitch(bEnable)

    printLog("onResourceSwitchChange, really_switch:"..tostring(mapResData:isSwitchOpen())..",bEnable="..tostring(bEnable) .. ", cache:" .. tostring(mapResData))

    local saveKey = getSettingSaveKey(RESOURCE_DEFAULT_SWITCH[resKey].save_key)
    if nil ~= saveKey then
        commonlib_setSharedPrefBoolean(saveKey, bEnable)
    else
        printLog("onResourceSwitchChange, getSettingSaveKey error, resKey="..tostring(resKey)..",bEnable="..tostring(bEnable))
    end

    reportSettingOp(resKey, bEnable)

    commonlib_runOnUIThread(function()
        if KEY_NAME_ROUTE == mapResData:getDataType() then
            updateRouteStatus(mapResData)
        else
            updateResourceGroupStatus(mapResData)
        end
    end)
end

local function createResSettingItemView(itemRelativeLayout, itemLayoutCfg, data)
    if nil == itemRelativeLayout or nil == itemLayoutCfg or nil == data then
        printLog("createResSettingItemView, args error!!!")
        return false
    end

    local checkBoxCfg = itemLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CHECKBOX_LAYOUT]
    if nil == checkBoxCfg then
        printLog("createResSettingItemView, checkBoxCfg is nil")
        return false
    end

    local params = createRelativeLayoutParam(checkBoxCfg.rect, nil)
    if nil == params then
        return false
    end

    local mapResData = gMapResData[data.type]
    if nil == mapResData then
        printLog("createResSettingItemView, mapResData is nil, dataType:" .. tostring(data.type))
        return false
    end

    local checkBoxView = itemRelativeLayout:addCheckBoxView(data.text, mapResData:isSwitchOpen(), params, function(id, isChecked)
        onResourceSwitchChange(data.type, isChecked)
    end, "customStyle2",
        toScaleSizePxString(checkBoxCfg.rect.padding,       gfScaleRelativeTo1080),
        toScaleSizePxString(checkBoxCfg.rect.paddingLeft,   gfScaleRelativeTo1080),
        toScaleSizePxString(checkBoxCfg.rect.paddingRight,  gfScaleRelativeTo1080),
        toScaleSizePxString(checkBoxCfg.rect.paddingTop,    gfScaleRelativeTo1080),
        toScaleSizePxString(checkBoxCfg.rect.paddingBottom, gfScaleRelativeTo1080))
    if nil == checkBoxView then
        printLog("createResSettingItemView, addCheckBoxView failed, text:" .. tostring(data.text))
        return false
    end
    mapResData:setCheckBoxView(checkBoxView)

    if isCarType(data.type) then

        createImageView(itemRelativeLayout, itemLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CAREVIEW_LAYOUT].rect,
                IMAGE_PARAM[data.type].path, nil)

    elseif isResourceType(data.type) then
        local rect = itemLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CIRCLEVIEW_LAYOUT].rect
        local viewParam = SETTING_RESOURCE_CIRCLE[data.type]
        local borderSize = toSize(viewParam.border_size, gfScaleRelativeTo1080)
        local r = toSize(viewParam.radius, gfScaleRelativeTo1080)
        local params = createRelativeLayoutParam(rect, nil);
        if nil ~= params then
            itemRelativeLayout:addCircleView(params, r, borderSize,
                    viewParam.border_color, viewParam.fill_color, viewParam.border_alpha, viewParam.fill_alpha)
        end
    elseif isSignalGunType(data.type) then
        createImageView(itemRelativeLayout, itemLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CAREVIEW_LAYOUT].rect,
                IMAGE_PARAM[data.type].path, nil)
    elseif isAdvancedGunType(data.type) then
        createImageView(itemRelativeLayout, itemLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_CAREVIEW_LAYOUT].rect,
                IMAGE_PARAM[data.type].path, nil)
    end

    return true
end

local function createResSettingContentItemView(contentRelativeLayout, contentLayoutCfg, data, topViewId, firstView)
    if nil == contentRelativeLayout or nil == contentLayoutCfg or nil == data then
        printLog("createResSettingContentItemView, args error!!!")
        return
    end

    local itemLayoutCfg = contentLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_ITEM_LAYOUT]

    local rect = itemLayoutCfg.rect
    if firstView then
        rect = itemLayoutCfg.rectFirst
    end

    local itemRelativeLayoutParam = createRelativeLayoutParam(rect, topViewId);
    local itemRelativeLayout = contentRelativeLayout:addRelativeLayout(itemRelativeLayoutParam)
    if createResSettingItemView(itemRelativeLayout, itemLayoutCfg, data) then
        return itemRelativeLayout
    end
end

local function createResSettingContentView(contentRelativeLayout, contentLayoutCfg)

    local settingItemList = getSettingItemList()
    if nil == settingItemList then
        printLog("createResSettingContentView, setting_item_list is nil")
        return
    end

    settingITemSignalGun(settingItemList)
    local topViewId
    local itemView
    for key, data in pairs(settingItemList) do
        itemView = createResSettingContentItemView(
            contentRelativeLayout, contentLayoutCfg, data, topViewId, nil == topViewId);
        if nil ~= itemView then
            topViewId = itemView:getId()
        end
    end
end

local function createResSettingToastItemView(contentRelativeLayout, itemLayoutRect, itemLayoutCfg, itemDataCfg, topViewId)
    if nil == contentRelativeLayout or nil == itemLayoutRect or nil == itemLayoutCfg or nil == itemDataCfg then
        printLog("createResSettingToastItemView, args error")
        return
    end

    local itemLayoutParam = createRelativeLayoutParam(itemLayoutRect, topViewId)
    local itemLayout = contentRelativeLayout:addRelativeLayout(itemLayoutParam)
    if nil == itemLayout then
        printLog("createResSettingToastItemView, addRelativeLayout error")
        return
    end

    local imageView = createImageView(
        itemLayout, itemLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_ICON_LAYOUT].rect, itemDataCfg.path, nil)
    if nil == imageView then
        return
    end

    local textView = createTextView(
        itemLayout, itemLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_TITLE_LAYOUT].rect, itemDataCfg, nil)
    if nil == textView then
        return
    end

    return itemLayout
end

local function createResSettingToastDescView(contentRelativeLayout, descLayoutCfg, topViewId)

    if nil == contentRelativeLayout or nil == descLayoutCfg then
        printLog("createResSettingToastDescView, args error")
        return
    end

    local descLayoutParam = createRelativeLayoutParam(descLayoutCfg.rect, topViewId)
    local descLayout = contentRelativeLayout:addRelativeLayout(descLayoutParam)
    if nil == descLayout then
        printLog("createResSettingToastDescView, addRelativeLayout error")
        return
    end
    descLayout:setBackgroundColor(descLayoutCfg.background.color)

    local firstTextView = createTextView(descLayout, descLayoutCfg.rectTxtFirst,
        SETTING_TOAST_DESC[CONST_VALUE.TOAST_DESC_FIRST], nil)
    if nil == firstTextView then
        printLog("createResSettingToastDescView, create firstTextView error")
        return
    end

    local secondTextView = createTextView(descLayout, descLayoutCfg.rectTxtSecond,
        SETTING_TOAST_DESC[CONST_VALUE.TOAST_DESC_SECOND], firstTextView:getId())
    if nil == secondTextView then
        printLog("createResSettingToastDescView, create secondTextView error")
        return
    end

    return descLayout
end

local function createResSettingToastView(contentRelativeLayout, contentLayoutCfg)
    if nil == contentRelativeLayout or nil == contentLayoutCfg then
        printLog("createResSettingToastView, args error")
        return
    end

    local itemAlertLayoutCfg = contentLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_ALERT_ITEM_LAYOUT]
    local itemCarLayoutCfg = contentLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_CAR_ITEM_LAYOUT]
    local descLayoutCfg = contentLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_DESC_LAYOUT]
    if nil == itemAlertLayoutCfg or nil == descLayoutCfg or nil == itemCarLayoutCfg then
        printLog("createResSettingToastView, itemLayoutCfg or descLayoutCfg or itemCarLayoutCfg is nil")
        return
    end

    local firstItemView = createResSettingToastItemView(contentRelativeLayout, itemAlertLayoutCfg.rect,
        itemAlertLayoutCfg, SETTING_TOAST_ITEM[CONST_VALUE.TOAST_ITEM_MAP_RESOURCE], nil)
    if nil == firstItemView then
        printLog("createResSettingToastView, create firstItemView error")
        return
    end

    local descView = createResSettingToastDescView(contentRelativeLayout, descLayoutCfg, firstItemView:getId())
    if nil == descView then
        return
    end

    if KEY_NAME_MAP_ISLAND == gMapKey then
        local secondItemView = createResSettingToastItemView(contentRelativeLayout, itemCarLayoutCfg.rect,
            itemCarLayoutCfg, SETTING_TOAST_ITEM[CONST_VALUE.TOAST_ITEM_FIXED_CAR], descView:getId())
        if nil == secondItemView then
            printLog("createResSettingToastView, create secondItemView error")
            return
        end

        local garageImageView = createImageView(contentRelativeLayout,
            contentLayoutCfg[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TOAST_GARAGE_IMAGE_LAYOUT].rect,
            IMAGE_PARAM[CONST_VALUE.KEY_NAME_GARAGE_IMAGE].path, secondItemView:getId())
        if nil == garageImageView then
            printLog("createResSettingToastView, create garageImageView error")
            return
        end

        local thirdItemView = createResSettingToastItemView(contentRelativeLayout, itemCarLayoutCfg.rect,
            itemCarLayoutCfg, SETTING_TOAST_ITEM[CONST_VALUE.TOAST_ITEM_PROBABILITY_CAR], garageImageView:getId())
        if nil == secondItemView then
            printLog("createResSettingToastView, create thirdItemView error")
            return
        end
    end

end

local function getButtonImageCfgInMap()
    local hideButtonImageCfg = IMAGE_PARAM[CONST_VALUE.MAP_RESOURCE_SHOW]
    if not gbHideResMap then
        hideButtonImageCfg = IMAGE_PARAM[CONST_VALUE.MAP_RESOURCE_HIDE]
    end
    return hideButtonImageCfg
end

local function getButtonCfg()
    local hideButtonCfg = SETTING_HIDE_BUTTON[CONST_VALUE.MAP_RESOURCE_SHOW]
    if not gbHideResMap then
        hideButtonCfg = SETTING_HIDE_BUTTON[CONST_VALUE.MAP_RESOURCE_HIDE]
    end
    return hideButtonCfg
end

local function updateHideButtonInSettingView()
    if nil == gHideButtonRelativeLayout or nil == gHideButtonView then
        return
    end

    local hideButtonCfg = getButtonCfg()
    gHideButtonView:setText(hideButtonCfg.text)
    gHideButtonRelativeLayout:setBackgroundImage(hideButtonCfg.path)
end

local function updateHideButtonInMap()
    if nil ~= gHideButtonView then
        local imageCfg = getButtonImageCfgInMap()
        gHideButtonView:setBackgroundImage(imageCfg.path)
    end
end

local onHideResourceMapSwitchChange
local function createHideButtonViewInMap(fatherRelativeLayout, hideButtonLayoutRect, hideButtonViewRect)
    if nil == hideButtonLayoutRect or nil == fatherRelativeLayout or nil == hideButtonViewRect then
        printLog("createHideButtonView, args error")
    end

    local hideButtonLayoutParam = createRelativeLayoutParam(hideButtonLayoutRect, nil)
    gHideButtonRelativeLayout = fatherRelativeLayout:addRelativeLayout(hideButtonLayoutParam, function(viewId)
        onHideResourceMapSwitchChange(not gbHideResMap)
        printLog("(map) hide button click, bHideResMap:" .. tostring(gbHideResMap))
        updateHideButtonInMap()
    end)
    if nil ~= gHideButtonRelativeLayout then
        local hideButtonViewParam = createRelativeLayoutParam(hideButtonViewRect, nil)
        gHideButtonView = fatherRelativeLayout:addRelativeLayout(hideButtonViewParam, nil)
        updateHideButtonInMap()
    end
end
local function createHideButtonViewInSettingView(fatherRelativeLayout, hideButtonLayoutRect, buttonTextRect)
    if nil == hideButtonLayoutRect or nil == buttonTextRect or nil == fatherRelativeLayout then
        printLog("createHideButtonView, args error")
    end

    local hideButtonLayoutParam = createRelativeLayoutParam(hideButtonLayoutRect, nil)
    gHideButtonRelativeLayout = fatherRelativeLayout:addRelativeLayout(hideButtonLayoutParam, function(viewId)
        onHideResourceMapSwitchChange(not gbHideResMap)
        printLog("hide button click, bHideResMap:" .. tostring(gbHideResMap))
        updateHideButtonInSettingView()
    end)
    if nil ~= gHideButtonRelativeLayout then
        gHideButtonView = createTextView(gHideButtonRelativeLayout, buttonTextRect, getButtonCfg(), nil)
        updateHideButtonInSettingView()
    end
end

local function createHideButtonView()

    if isHideButtonInMap() then

        local mapLayoutRect = getHideButtonRectInMap()
        local rectMap
        if nil ~= gNewGameEngine then
            rectMap = gNewGameEngine:getConditionRect(KEY_NAME_MR_EXPANDED_MAP_RECT)
        end

        if nil == rectMap or nil == mapLayoutRect then
            printLog("createHideButtonView, rectMap or rectButton is nil")
            return
        end

        local lDiffLeft = (0 - rectMap.left) - rectMap.width  --- TODO，此处依赖于地图的位置，地图的配置必须是TOPRIGHT

        local lDiffClickHeight = 36 + 3
        local lDiffTop         = 18
        if isDesertMap() then
            lDiffClickHeight   = 18
            lDiffTop           = 18
        end

        gHideButtonClickFloatView = commonlib_getFloatViewMgrEx():create( --- 这个函数内部会基于1080p做缩放
            mapLayoutRect.left - lDiffLeft,
            mapLayoutRect.top - lDiffTop,
            mapLayoutRect.width,
            mapLayoutRect.height + lDiffClickHeight,
            mapLayoutRect.flag,
            true)

        local hideButtonFatherLayoutRect = {
            left   = 0,
            top    = 0,
            width  = mapLayoutRect.width,
            height = mapLayoutRect.height + lDiffClickHeight,
            flag   = Anchor().TOPLEFT,
        }
        local hideButtonFatherLayout = createRelativeLayout(
            gHideButtonClickFloatView, hideButtonFatherLayoutRect, "Map_Button_RelativeLayout")

        local hideButtonLayoutRect = {
            width  = mapLayoutRect.width,
            height = mapLayoutRect.height + lDiffClickHeight,
        }
        local hideButtonViewRect = {
            marginTop = lDiffTop,
            width     = mapLayoutRect.width,
            height    = mapLayoutRect.height,
        }
        createHideButtonViewInMap(hideButtonFatherLayout, hideButtonLayoutRect, hideButtonViewRect)

    else

        if nil == gMapResSettingRelativeLayout then
            printLog("createHideButtonView, setting layout is nil")
            return
        end

        createHideButtonViewInSettingView(
            gMapResSettingRelativeLayout,
            MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_HIDEBUTTON_LAYOUT].rect,
            MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_HIDEBUTTON_LAYOUT].rectText)

    end
end

local function showButtonView()
    showView(gHideButtonClickFloatView, "resource button")
end

local function hideButtonView()
    hideView(gHideButtonClickFloatView, "resource button")
end

local function destroyButtonView()
    destroyView(gHideButtonClickFloatView, "resource button")
    gHideButtonClickFloatView = nil
end

local function createResSettingView()
    if nil ~= gMapResSettingRelativeLayout then
        return
    end

    local mapLayoutRect = getRectCfg(MAP_RESOURCE_SETTING_VIEW)
    if nil == mapLayoutRect then
        printLog("createResSettingView,  setting view rect is nil")
        return
    end
    mapLayoutRectSignalGun(mapLayoutRect)
    gSettingClickFloatView = commonlib_getFloatViewMgrEx():create(
        mapLayoutRect.left,
        mapLayoutRect.top,
        mapLayoutRect.width,
        mapLayoutRect.height,
        mapLayoutRect.flag,
        true)

    local rectNew = {
        left   = 0,
        top    = 0,
        width  = mapLayoutRect.width,
        height = mapLayoutRect.height,
        flag   = Anchor().TOPLEFT,
    };
    gMapResSettingRelativeLayout = createRelativeLayout(
        gSettingClickFloatView, rectNew, "MapSetting_RelativeLayout")
    if nil == gMapResSettingRelativeLayout then
        return
    end

    local titleImageView = createImageView(gMapResSettingRelativeLayout, MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_TITLE_LAYOUT].rect,
        IMAGE_PARAM[CONST_VALUE.KEY_NAME_SETTING_TITLE].path, nil)
    if nil == titleImageView then
        printLog("createResSettingView, title view,  createImageView error")
        return
    end

    createHideButtonView()

    local topViewId = titleImageView:getId()
    local contentLayoutCfg = MAP_RESOURCE_SETTING_VIEW[CONST_VALUE.KEY_NAME_MAP_RES_SETTING_CONTENT_LAYOUT]
    local contentLayoutRect = getRectCfg(contentLayoutCfg)
    contentLayoutRectSignalGun(contentLayoutRect)

    local contentParam = createRelativeLayoutParam(contentLayoutRect, topViewId);
    if nil == contentParam then
        printLog("createResSettingView, createRelativeLayoutParam error")
        return
    end

    local contentRelativeLayout = gMapResSettingRelativeLayout:addRelativeLayout(contentParam)
    if nil ~= contentRelativeLayout then
        contentRelativeLayout:setDefaultBackground();
        createResSettingContentView(contentRelativeLayout, contentLayoutCfg)

        gMapResSettingCheckBoxLayout = contentRelativeLayout
    end

    if isHideButtonInMap() then
        local toastRelativeLayout = gMapResSettingRelativeLayout:addRelativeLayout(contentParam)
        if nil ~= toastRelativeLayout then
            toastRelativeLayout:setDefaultBackground();
            createResSettingToastView(toastRelativeLayout, contentLayoutCfg)

            gMapResSettingToastLayout = toastRelativeLayout
        end
    end

    updateSettingCheckBoxStatus(not gbHideResMap)
end

local function showResSettingView(viewType)
    if CONST_VALUE.MAP_RES_SETTING_VIEW_TYPE_TOAST ~= viewType and CONST_VALUE.MAP_RES_SETTING_VIEW_TYPE_CHECKBOX ~= viewType then
        printLog("showResSettingView, viewType error")
        return
    end

    if viewType ~= gMapResSettingViewType then

        if viewType == CONST_VALUE.MAP_RES_SETTING_VIEW_TYPE_TOAST then
            printLog("showResSettingView, change setting view, checkbox -> toast")
            hideView(gMapResSettingCheckBoxLayout, "resource setting checkbox")
            showView(gMapResSettingToastLayout, "resource setting toast")
        else
            printLog("showResSettingView, change setting view, toast -> checkbox")
            hideView(gMapResSettingToastLayout, "resource setting toast")
            showView(gMapResSettingCheckBoxLayout, "resource setting checkbox")
        end

        gMapResSettingViewType = viewType
    end

    if not gbMapResSettingViewShow then
        gbMapResSettingViewShow = showView(gSettingClickFloatView, "resource setting")
    end
end

local function hideResSettingView()
    if gbMapResSettingViewShow then
        hideView(gSettingClickFloatView, "resource setting")
        gbMapResSettingViewShow = false
    end
end

local function destroyResSettingView()
    destroyView(gSettingClickFloatView, "resource setting")
    gSettingClickFloatView       = nil
    gMapResSettingRelativeLayout = nil

    gHideButtonRelativeLayout    = nil
    gHideButtonView              = nil

    gMapResSettingCheckBoxLayout = nil
    gMapResSettingToastLayout    = nil
    gMapResSettingViewType       = nil

    gbMapResSettingViewShow      = false
end
------------------------------
--- map setting end ----------
------------------------------

------------------------------
--- map view start -----------
------------------------------
local function createMapView()
    if nil ~= gMapResRelativeLayout then
        return
    end

    if nil == gMapKey then
        printLog("createMapView, maptype is nil")
        return
    end

    local rect = gNewGameEngine:getConditionRect(KEY_NAME_MR_EXPANDED_MAP_RECT)
    gMapResRelativeLayout = createRelativeLayout(gFloatView, rect, "Map_RelativeLayout")
    if nil ~= gMapResRelativeLayout then
        initAllResourceViews()
        updateRouteStatus(gMapResData[KEY_NAME_ROUTE])

    -- TODO, test code
--        gMapResRelativeLayout:setBackgroundColor("#7F87CEFA")

        printLog("createMapView succeed")
    else
        printLog("createMapView failed")
    end
end

local function showMapView()
    showView(gMapResRelativeLayout, "map resource")
end

local function hideMapView()
    hideView(gMapResRelativeLayout, "map resource")
end

local function destroyMapView()
    resetMapResData()
    resetSignalGunTable()
    resetPlaygroundTabel()
    destroyView(gMapResRelativeLayout, "map resource")
    gMapResRelativeLayout = nil
end

local function updateMapView()
    printLog("updateMapView, res_map_switch:" .. tostring(gbResMapSwitch) .. ", map_expand:" .. tostring(gMapStatus))

    if gbResMapSwitch then
        if gMapStatus == CONST_VALUE.MAP_STATUS_EXPANED_NORMAL then
            if gbHideResMap then
                hideMapView()
            else
                showMapView()
            end

            if gbHideResMap and isHideButtonInMap() then
                hideResSettingView()
            else
                showResSettingView(CONST_VALUE.MAP_RES_SETTING_VIEW_TYPE_CHECKBOX)
            end

            showButtonView()

            notifyAssistShowSucceed(ASSIST_SHOW_TYPE_MAP_RES)
            local routeData = gMapResData[KEY_NAME_ROUTE]
            if nil ~= routeData and routeData:isSwitchOpen() and routeData:isShow() then
                notifyAssistShowSucceed(ASSIST_SHOW_TYPE_MAP_ROUTE)
            else
                notifyAssistShowError(ASSIST_SHOW_TYPE_MAP_ROUTE, nil ~= routeData and routeData:isSwitchOpen())
            end
        else
            hideMapView()
            hideButtonView()

            if gMapStatus == CONST_VALUE.MAP_STATUS_EXPANED_ENLARGED and not gbHideResMap and isHideButtonInMap() then
                --- 展现地图
                showResSettingView(CONST_VALUE.MAP_RES_SETTING_VIEW_TYPE_TOAST)
            else
                hideResSettingView()
            end

        end
    else
        notifyAssistShowError(ASSIST_SHOW_TYPE_MAP_RES, gbResMapSwitch)
        notifyAssistShowError(ASSIST_SHOW_TYPE_MAP_ROUTE, gbResMapSwitch)
    end
end


local function initResourceSettingView()
    local settingViewRectCfg = {
        rect = gNewGameEngine:getConditionRect(KEY_NAME_MR_SETTING_VIEW_RECT);

    }
    if settingViewRectCfg.rect == nil then
        printLog("initVariable failed settingViewRectCfg.rect == nil")
        return
    end

    if settingViewRectCfg.rect ~= nil then
        printLog("rect.top:" .. tostring(settingViewRectCfg.rect.top) .. "| rect.left:" ..tostring( settingViewRectCfg.rect.left) .. "|  rect.width:" .. tostring( settingViewRectCfg.rect.width) .. "| rect.height:" .. tostring(settingViewRectCfg.rect.height) .. "| rect.flag:" .. tostring(settingViewRectCfg.rect.flag))
    end
    MAP_RESOURCE_SETTING_VIEW.rect       = settingViewRectCfg.rect;
    MAP_RESOURCE_SETTING_VIEW.rectDesert = commonlib_deepCopy(settingViewRectCfg.rect);
    MAP_RESOURCE_SETTING_VIEW.rectDesert.top = MAP_RESOURCE_SETTING_VIEW.rectDesert.top + CONST_VALUE.MAP_RES_DESERT_SETTING_HEIGHT_DIFF;
    MAP_RESOURCE_SETTING_VIEW.rectDesert.height = MAP_RESOURCE_SETTING_VIEW.rectDesert.height - CONST_VALUE.MAP_RES_DESERT_SETTING_HEIGHT_DIFF;

    MAP_RESOURCE_SETTING_VIEW.rectRainforest = commonlib_deepCopy(settingViewRectCfg.rect);
    MAP_RESOURCE_SETTING_VIEW.rectRainforest.top = MAP_RESOURCE_SETTING_VIEW.rectRainforest.top + CONST_VALUE.MAP_RES_RAINFOREST_SETTING_HEIGHT_DIFF;
    MAP_RESOURCE_SETTING_VIEW.rectRainforest.height = MAP_RESOURCE_SETTING_VIEW.rectRainforest.height - CONST_VALUE.MAP_RES_RAINFOREST_SETTING_HEIGHT_DIFF;

    MAP_RESOURCE_SETTING_VIEW.rectSnow = commonlib_deepCopy(settingViewRectCfg.rect);
    MAP_RESOURCE_SETTING_VIEW.rectSnow.top = MAP_RESOURCE_SETTING_VIEW.rectSnow.top + CONST_VALUE.MAP_RES_SNOW_SETTING_HEIGHT_DIFF;
    MAP_RESOURCE_SETTING_VIEW.rectSnow.height = MAP_RESOURCE_SETTING_VIEW.rectSnow.height - CONST_VALUE.MAP_RES_SNOW_SETTING_HEIGHT_DIFF;

    printLog("island left=" .. tostring(MAP_RESOURCE_SETTING_VIEW.rect.left) ..", top="..tostring(MAP_RESOURCE_SETTING_VIEW.rect.top)..", width="..tostring(MAP_RESOURCE_SETTING_VIEW.rect.width) ..", height="..tostring(MAP_RESOURCE_SETTING_VIEW.rect.height))
    printLog("desert left=" .. tostring(MAP_RESOURCE_SETTING_VIEW.rectDesert.left) ..", top="..tostring(MAP_RESOURCE_SETTING_VIEW.rectDesert.top)..", width="..tostring(MAP_RESOURCE_SETTING_VIEW.rectDesert.width) ..", height="..tostring(MAP_RESOURCE_SETTING_VIEW.rectDesert.height))
end
------------------------------
--- map view end -------------
------------------------------

local function checkRouteValid(routeValue)

    if nil == routeValue or nil == gNewGameEngine then
        printLog("checkRouteValid data invalid");
        return false
    end

    local rect = gNewGameEngine:getConditionRect(KEY_NAME_MR_EXPANDED_MAP_RECT)
    if nil == rect then
        printLog("checkRouteValid map rect invalid");
        return false
    end


    local width  = toSize(rect.width, gfScaleRelativeTo1080)
    local height = toSize(rect.height, gfScaleRelativeTo1080)

    local routeRelative = toFullRoute(routeValue, 0, 0, width, height)
    if nil == routeRelative or nil == routeRelative.y1 or nil == routeRelative.y2 then
        printLog("checkRouteValid toFullRoute invalid");
        return
    end

    local minY = toSize(CONST_VALUE.ROUTE_MIN_Y, gfScaleRelativeTo1080)
    local bRet = routeRelative.y1 > minY or routeRelative.y2 > minY
    if not bRet then
        printLog("checkRouteValid invalid, y1:" .. tostring(routeRelative.y1) .. ", y2:" .. tostring(routeRelative.y2));
    end

    return bRet
end

local function setRoute()
    if nil ~= gRoute then
        return
    end

    if nil == glGameStartTime then
        glGameStartTime = commonlib_getCurrentTime()
    end

    if commonlib_getCurrentTime() - glGameStartTime > 150000 then
        printLog("setRoute timeout");
        return
    end

    local routeValue = gNewGameEngine:matchConditionOnTable("cd_build_cj_detect_air_line");
    if routeValue ~= nil and checkRouteValid(routeValue) then
        gRoute = {
            x1 = routeValue.x1,
            y1 = routeValue.y1,
            x2 = routeValue.x2,
            y2 = routeValue.y2,
        }
        printLog("setRoute:x1="..tostring(routeValue.x1)..",y1="..tostring(routeValue.y1)..
        ",x2="..tostring(routeValue.x2)..",y2="..tostring(routeValue.y2));

        commonlib_runOnUIThread(function()
            if gbResMapSwitch then
                updateRouteStatus(gMapResData[KEY_NAME_ROUTE])
            end
        end)
    else
        printLog("setRoute:failed");
    end
end

local function createMapSettingTipsView()
    if mapSettingTipsView ~= nil then
        return
    end
    printLog("createMapSettingTipsView start")
    local rect = gNewGameEngine:getConditionRect("cd_build_rect_map_setting_rect")
    if rect == nil then
        printLog("createMapSettingTipsView rect=nil")
        return
    end
    local layoutView = createRelativeLayout(gFloatView, rect, "mapSettingLayout")
    if layoutView == nil then
        printLog("createMapSettingTipsView mapSettingLayout=nil")
        return
    end
    local titleRect = {
        width = 203,
        height = 44,
    }
    local titleView = createImageView(layoutView, titleRect, "common://image/mapres/setting_title.png", nil)
    local contentLayoutRect = rect
    local contentParam = createRelativeLayoutParam(contentLayoutRect, titleView:getId());
    if nil == contentParam then
        printLog("createResSettingView, createRelativeLayoutParam error")
        return
    end
    local contentRelativeLayout = layoutView:addRelativeLayout(contentParam)
    if nil ~= contentRelativeLayout then
        contentRelativeLayout:setDefaultBackground();
    end

    local iconRect = { marginLeft = 26, marginTop = 24, marginRight = 0, marginBottom = 0, width = 32, height = 35 }
    local iconImageView  = createImageView(contentRelativeLayout, iconRect, "common://image/mapres/alert.png", nil)

    local textRect = { marginLeft = 64, marginTop = 22, marginRight = 0, marginBottom = 0, width = 293 - 26, height = 35 }
    local textConfig = { text = "资源地图无法显示", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FF5353" }
    local iconTextView = createTextView(contentRelativeLayout, textRect, textConfig, nil)

    local secondAreaRect = { marginLeft = 24, marginTop = 14, marginRight = 24, marginBottom = 36 - 2, width = 293 - 24 * 2, height = 101 }
    local secondAreaParam = createRelativeLayoutParam(secondAreaRect, iconImageView:getId());
    if nil == secondAreaParam then
        printLog("createResSettingView, createRelativeLayoutParam error")
        return
    end
    local secondAreaLayout = contentRelativeLayout:addRelativeLayout(secondAreaParam)
    if nil ~= secondAreaLayout then
        secondAreaLayout:setBackgroundColor("#19FFFFFF");
    end

    local rectTxtFirst  = { marginLeft = 26 - 4, marginTop = 17 - 5, marginRight = 0, marginBottom = 0, width = 293 - 24 * 2 - (26 - 3), height = 30 }
    local txtFirstConfig = { text = "仅在海岛、沙漠、雨林", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" }
    local txtFirstView = createTextView(secondAreaLayout, rectTxtFirst, txtFirstConfig, nil)

    local rectTxtSecond = { marginLeft = 26 - 4, marginTop = 10 - 2, marginRight = 0, marginBottom = 0, width = 293 - 24 * 2 - (26 - 3), height = 30 }
    local txtSecondConfig = { text = "地图显示", textSize = CONST_VALUE.TEXT_DEFAULT_SIZE_PX, textColor = "#FFFFFF" }
    local txtSecondView = createTextView(secondAreaLayout, rectTxtSecond, txtSecondConfig, txtFirstView:getId())

    mapSettingTipsView = layoutView
    mapSettingTipsView:show()
    printLog("createMapSettingTipsView end")
end

local function destroyMapSettingTipsView()
    if mapSettingTipsView ~= nil then
        commonlib_runOnUIThread(function()
            printLog("destroyMapSettingTipsView")
            mapSettingTipsView:destroy()
            mapSettingTipsView = nil
        end)
    end
end

local function destroyAllView()
    destroyButtonView()
    destroyMapView()
    destroyResSettingView()
end

local function refreshMapResView(bDestoryViewIfSwitchClose)
    commonlib_runOnUIThread(function()
        if gbResMapSwitch then
            createMapView()
            createResSettingView()
        elseif bDestoryViewIfSwitchClose then
            destroyAllView()
        end

        updateMapView()
    end)
end

------------------------------
--- callback start -----------
------------------------------
-- 要在地图展现或缩小时回调
local function onNotifyMapExpandStatusForRes(status)
    printLog(">>>>status:" .. tostring(status))
    if status == CONST_VALUE.MAP_STATUS_EXPANED_ENLARGED or status == CONST_VALUE.MAP_STATUS_EXPANED_NORMAL then
        initResourceSettingView();
    end
    if status == CONST_VALUE.MAP_STATUS_EXPANED_NORMAL then
        if gMapKey == nil then
            gMapKey = commonlib_getGameParam(KEY_NAME_MAP_TYPE);
            if playgroundSwitch == true then
                if nil ~= gMapKey then
                    if gMapKey == KEY_NAME_MAP_ISLAND then
                        isDelayInitSetting = true
                        delayInitSettingTime = commonlib_getCurrentTime()
                        getPlaygroundTabel()
                    else
                        getSignalGunTable()
                        initSetting()
                        isDelayInitSetting = false
                    end
                end
            else
                getSignalGunTable()
                initSetting()
                isDelayInitSetting = false
            end
        end
        if isDelayInitSetting then
            if (commonlib_getCurrentTime() - delayInitSettingTime > CONST_VALUE.DELAY_INIT_MAP_RES) or getPlaygroundTabel() then
                getSignalGunTable()
                initSetting()
                isDelayInitSetting = false
            end
        end
    end

    if isDelayInitSetting then
        return
    end

    if status == gMapStatus then
        return
    end

    gMapStatus = status;

    refreshMapResView(false)

    if gMapStatus == CONST_VALUE.MAP_STATUS_EXPANED_NORMAL then
        reportOp(CONST_VALUE.ACTION_MAP_EXPANED_NORMAL, getMapStateForReport())
    elseif gMapStatus == CONST_VALUE.MAP_STATUS_EXPANED_ENLARGED then
        reportOp(CONST_VALUE.ACTION_MAP_EXPANED_ENLARGED, getMapStateForReport())
    end

end

local function onNotifyMapExpandStatusForRoute(status)
    if status == CONST_VALUE.MAP_STATUS_EXPANED_NORMAL then
        setRoute()
    end
end

local function onNotifyMapExpandStatus(status)
    local isTrain = commonlib_getGameParam(PUBGMHD_KEY_MAP_IS_TRAIN)
    if isTrain ~= nil and isTrain == true then
        if status == CONST_VALUE.MAP_STATUS_EXPANED_NORMAL
                or  status == CONST_VALUE.MAP_STATUS_EXPANED_ENLARGED then
            if mapSettingTipsView == nil then
                commonlib_runOnUIThread(function()
                    createMapSettingTipsView()
                end)
            end
        else
            destroyMapSettingTipsView()
        end
    end

    onNotifyMapExpandStatusForRes(status)
    onNotifyMapExpandStatusForRoute(status)
end

local function initReport()
    if gbInitReport then
        return
    end
    gbInitReport = true

    if not gbResMapSwitch then
        notifyAssistShowError(ASSIST_SHOW_TYPE_MAP_RES, gbResMapSwitch)
        notifyAssistShowError(ASSIST_SHOW_TYPE_MAP_ROUTE, gbResMapSwitch)
    else
        local routeData = gMapResData[KEY_NAME_ROUTE]
        if nil ~= routeData and not routeData:isSwitchOpen() then
            notifyAssistShowError(ASSIST_SHOW_TYPE_MAP_ROUTE, false)
        end
    end
end

local function onGameRunning()

    initReport()

    local cover = commonlib_getGameParam(KEY_GAME_RUNNING_COVER_STATUS);
    --printLog("onGameRunning, bCovered:" .. tostring(cover));
    if cover == GAME_COVER_MAP_EXPAND then
        local isEnlarged = gNewGameEngine:matchCondition(KEY_NAME_MR_EXPANDED_MAP_ENLARGED) == false;
        if isEnlarged then
            onNotifyMapExpandStatus(CONST_VALUE.MAP_STATUS_EXPANED_ENLARGED);
        else
            onNotifyMapExpandStatus(CONST_VALUE.MAP_STATUS_EXPANED_NORMAL);
        end
    else
        onNotifyMapExpandStatus(CONST_VALUE.MAP_STATUS_NOT_EXPANED);
    end
end

local function onMapSwitchChange(bEnable)

    printLog("onMapSwitchChange, bEnable:" .. tostring(bEnable) .. ", map_switch:" .. tostring(gbResMapSwitch))
    if bEnable == gbResMapSwitch then
        return
    end
    gbResMapSwitch = bEnable

    if bEnable then
        notifyAssistSwitchToOpen(ASSIST_SHOW_TYPE_MAP_RES)

        local routeData = gMapResData[KEY_NAME_ROUTE]
        if nil ~= routeData and routeData:isSwitchOpen() then
            notifyAssistSwitchToOpen(ASSIST_SHOW_TYPE_MAP_ROUTE)
        end
    end

    refreshMapResView(true)
end

local function onEnterGame()
    printLog("onEnterGame, switch:" .. tostring(gbResMapSwitch))
    gMapStatus = CONST_VALUE.MAP_STATUS_NOT_EXPANED;
    gbMapResSettingViewShow = false;
    gMapKey = nil;
    gRoute = nil;
    glGameStartTime = commonlib_getCurrentTime()
    gbInitReport = false

    isDelayInitSetting = false
    delayInitSettingTime = 0

    resetSignalGunTable()
    resetPlaygroundTabel()
    destroyMapSettingTipsView()
end

local function onGameOver()
    printLog("onGameOver")
    commonlib_runOnUIThread(function()
        destroyAllView()
    end)

    gRoute = nil
    glGameStartTime = nil
    gbInitReport = false
    resetSignalGunTable()
    resetPlaygroundTabel()
    destroyMapSettingTipsView()
end

onHideResourceMapSwitchChange = function (bHideResMap)
    printLog("onHideResourceMapSwitchChange, bHideResMap:" .. tostring(bHideResMap) .. ", hide_map_switch:" .. tostring(gbHideResMap))
    if bHideResMap == gbHideResMap then
        return
    end
    gbHideResMap = bHideResMap

    reportOp(CONST_VALUE.ACTION_HIDE_BUTTON, getMapStateForReport())

    local saveKey = getSettingSaveKey(CONST_VALUE.KEY_IS_HIDE_ALL_MAP_RES)
    if nil ~= saveKey then
        commonlib_setSharedPrefBoolean(saveKey, gbHideResMap)
        printLog("onHideResourceMapSwitchChange, save setting, hide:" .. tostring(gbHideResMap))
    end

    commonlib_runOnUIThread(function()
        updateSettingCheckBoxStatus(not gbHideResMap)
        updateMapView()
    end)
end
------------------------------
--- callback end -------------
------------------------------

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function onCheckChangeListener(checkBoxId, isChecked)
    commonlib_setSharedPrefBoolean(CONST_VALUE.KEY_IS_MAP_RESOURCE_ENABLE, isChecked)
    onMapSwitchChange(isChecked)
    onOpenMapResourceSettingsChange(isChecked)
end

local function getTextColor(enable)
    if enable == true then
        return "#FF00DEFF";
    else
        return "#FF979797";
    end
end

local function initSettingView()
    local tab = commonlib_getSettingView():addTableView(CONST_VALUE.TAB_NAME)

    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    relativeLayoutParam:setLayoutParam(paramValues)

    gbResMapSwitch = getResMapSwitchState()
    gResMapSwitchView = tab:addCheckBoxView(CONST_VALUE.CHECKBOX_TEXT, gbResMapSwitch, relativeLayoutParam, onCheckChangeListener)
    if gbResMapSwitch then
        report_gamemaster_game_pubgm_state(3, 1)
    else
        report_gamemaster_game_pubgm_state(4, 2)
    end

    paramValues.layout_below = gResMapSwitchView:getId()
    paramValues.layout_marginLeft = "52dp"
    paramValues.layout_marginTop = "12dp"
    paramValues.layout_width = "128dp"
    paramValues.layout_height = "68dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    gMapResourceTipImageView = tab:addImageView("img/map_resource_tip_image.png", relativeLayoutParam, nil)

    paramValues.layout_below = gMapResourceTipImageView:getId()
    paramValues.layout_marginLeft = "52dp"
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    relativeLayoutParam:setLayoutParam(paramValues)
    gMapResourseDescTextView = tab:addTextView(MAP_RESOURCE_DESC_TEXT,
            getTextColor(gbResMapSwitch),
            "12sp",
            relativeLayoutParam,
            nil);
end

local function initVariable()
    gMapStatus = CONST_VALUE.MAP_STATUS_NOT_EXPANED;
    gFloatView = commonlib_getUnClickableFloatView()
    gfScaleRelativeTo1080 = commonlib_getScale()

    gNewGameEngine = CNewGameEngine:getInstance()

    gMapResAdapterManager = AdapterManagerClass:getMapResourceInstance()
    gMapResAdapterManager:init(global_getMapAdapterConfig())
    gMapResAdapterManager:printLog()
    printLog("initVariable end")
end

local function uninitVariable()
    gFloatView = nil
    gMapResAdapterManager = nil

    if gResMapSwitchView ~= nil then
        gResMapSwitchView:destroy();
        gResMapSwitchView = nil;
    end

    printLog("uninitVariable end")
end

local function init()
    printLog("map resources init")
    registerGameEvents()
    initVariable()
    initSettingView()
    initSetting()
end

local function uninit()
    printLog("map resources uninit")
    unregisterGameEvents()

    destroyAllView()

    uninitVariable()

    gRoute = nil
    destroyMapSettingTipsView()
end

table.insert(common_life_circle_callbacks, { init, uninit, PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.map_resources })