--- 跑圈提示
--- date:2018-05-31
--- author: zhengyousheng@cmcm.com

local TAG = "pubgmhd_cicle"

local FROM_AIRPORT     = "pubgmhd_airport_wait"
local FROM_MAP_BOTTOM  = "pubgmhd_map_time"
local CLASSIC_MODE_NUM = 4

local MAP_BOTTOM_NUM_RECOGNIZE_CORRECT_MIN_CNT = 2
local MAP_BOTTOM_NUM_RECOGNIZE_TOTAL_MAX_CNT   = 4
local AIRPORT_TIMER_RECOGNIZE_CORRECT_MIN_CNT  = 2

local TAB_NAME                     = "跑圈助手";

local SHRINK_CIRCLE_CHECKBOX_TEXT = "开启收圈倒计时"
local SHRINK_CIRCLE_DESC_TEXT = "当毒圈开始收圈时，会显示完全收圈所需的时间。"
local KEY_SHRINK_CIRCLE_ENABLE = SP_SHRINK_CIRCLE_SWITCH_KEY

local RUN_CIRCLE_CHECKBOX_TEXT = "开启跑圈提醒"
local RUN_CIRCLE_DESC_TEXT = "当你离安全圈较远时，会根据你的距离给出跑圈提醒。"
local KEY_RUN_CIRCLE_ENABLE = SP_RUN_CIRCLE_SWITCH_KEY

local gNewGameEngine;

local SHRINK_CIRCLE_START_TIME_REDUCED_TIME = 1000
local CFG_ADAPTER = {

    ISLAND_AND_DESERT = {
        SHRINK_CIRCLE_TIME_TABLE = { --- 以机场倒计时时间为0作为基准，时间单位是ms (沙漠、海岛地图)
            { start = (7 * 60  + 0)  * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 5 * 60 * 1000,        index_text="一" },
            { start = (15 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = (2 * 60 + 20) * 1000, index_text="二" },
            { start = (20 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = (1 * 60 + 30) * 1000, index_text="三" },
            { start = (23 * 60 + 40) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 1 * 60 * 1000,        index_text="四" },
            { start = (26 * 60 + 40) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 40 * 1000,            index_text="五" },
            { start = (28 * 60 + 50) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 30 * 1000,            index_text="六" },
            { start = (30 * 60 + 50) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 30 * 1000,            index_text="七" },
            { start = (32 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 30 * 1000,            index_text="八" },
            { start = (32 * 60 + 50) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = (3 * 60 + 15) * 1000, index_text="九" },
        },

        SAFETY_CIRCLE_TIP_TIME_TABLE = { --- 跑圈提醒
            {pos = 25,  ahead = {275 * 1000,155 * 1000,145 * 1000, 75 * 1000, 65 * 1000}}, -- A
            {pos = 50,  ahead = {245 * 1000,125 * 1000, 75 * 1000, 55 * 1000, 55 * 1000}}, -- B
            {pos = 75,  ahead = {185 * 1000, 95 * 1000, 65 * 1000, 45 * 1000, 35 * 1000}}, -- C
            {pos = 100, ahead = { 85 * 1000, 55 * 1000, 45 * 1000, 35 * 1000}}, -- D
        },

        DAMAGA_NOTICE_TABLE = { --- 毒圈提醒,开始时间，
                                {startTime = (7 * 60  + 0)  * 1000 , endTime = (12 * 60  + 0)  * 1000,  damagaRate = 0.4,  cartridgeBagLocation = 0.05 },
                                {startTime = (12 * 60  + 0)  * 1000 , endTime = (17 * 60  + 40)  * 1000,  damagaRate = 0.6,  cartridgeBagLocation = 0.08 },
                                {startTime = (17 * 60  + 40)  * 1000 , endTime = (22 * 60  + 30)  * 1000,  damagaRate = 0.8,  cartridgeBagLocation = 0.1 },
                                {startTime = (22 * 60  + 30)  * 1000 , endTime = (25 * 60  + 30)  * 1000,  damagaRate = 1,  cartridgeBagLocation = 0.12 },
                                {startTime = (25 * 60  + 30)  * 1000 , endTime = (28 * 60  + 10)  * 1000,  damagaRate = 3,  cartridgeBagLocation = 0.3 },
                                {startTime = (28 * 60  + 10)  * 1000 , endTime = (30 * 60  + 10)  * 1000,  damagaRate = 5,  cartridgeBagLocation = 0.45 },
                                {startTime = (30 * 60  + 10)  * 1000 , endTime = (32 * 60  + 10)  * 1000,  damagaRate = 7,  cartridgeBagLocation = 0.55 },
                                {startTime = (32 * 60  + 10)  * 1000 , endTime = (33 * 60  + 40)  * 1000,  damagaRate = 9,  cartridgeBagLocation = 0.7 },
        },
    },

    RAINFOREST = {
        SHRINK_CIRCLE_TIME_TABLE = { --- 以机场倒计时时间为0作为基准，时间单位是ms (热带雨林地图)
            { start = (3 * 60  + 30) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 4 * 60 * 1000,        index_text="一" },
            { start = (9 * 60  + 30) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 2 * 60 * 1000,        index_text="二" },
            { start = (13 * 60 + 0)  * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 2 * 60 * 1000,        index_text="三" },
            { start = (16 * 60 + 0)  * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 2 * 60 * 1000,        index_text="四" },
            { start = (18 * 60 + 45) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 1 * 60 * 1000,        index_text="五" },
            { start = (20 * 60 + 30) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 1 * 60 * 1000,        index_text="六" },
            { start = (22 * 60 + 15) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 40 * 1000,            index_text="七" },
            { start = (23 * 60 + 35) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 40 * 1000,            index_text="八" },
        },

        SAFETY_CIRCLE_TIP_TIME_TABLE = { --- 跑圈提醒
            {pos = 25,  ahead = {165 * 1000, 185 * 1000, 135 * 1000, 85 * 1000, 55 * 1000}}, -- A
            {pos = 50,  ahead = {145 * 1000, 155 * 1000, 115 * 1000, 65 * 1000, 45 * 1000}}, -- B
            {pos = 75,  ahead = { 95 * 1000, 125 * 1000,  75 * 1000, 55 * 1000, 35 * 1000}}, -- C
            {pos = 100, ahead = { 65 * 1000,  95 * 1000,  55 * 1000, 35 * 1000}}, -- D
        },
        DAMAGA_NOTICE_TABLE = { --- 毒圈提醒
                                {startTime = (3 * 60  + 30)  * 1000 , endTime = (7 * 60  + 30)  * 1000,  damagaRate = 0.4,  cartridgeBagLocation = 0.05 },
                                {startTime = (7 * 60  + 30)  * 1000 , endTime = (11 * 60  + 30)  * 1000,  damagaRate = 0.6,  cartridgeBagLocation = 0.08 },
                                {startTime = (11 * 60  + 30)  * 1000 , endTime = (15 * 60  + 00)  * 1000,  damagaRate = 0.8,  cartridgeBagLocation = 0.1 },
                                {startTime = (15 * 60  + 00)  * 1000 , endTime = (18 * 60  + 00)  * 1000,  damagaRate = 1,  cartridgeBagLocation = 0.12 },
                                {startTime = (18 * 60  + 00)  * 1000 , endTime = (19 * 60  + 45)  * 1000,  damagaRate = 3,  cartridgeBagLocation = 0.3 },
                                {startTime = (19 * 60  + 45)  * 1000 , endTime = (21 * 60  + 30)  * 1000,  damagaRate = 5,  cartridgeBagLocation = 0.45 },
                                {startTime = (21 * 60  + 30)  * 1000 , endTime = (22 * 60  + 55)  * 1000,  damagaRate = 7,  cartridgeBagLocation = 0.55 },
                                {startTime = (22 * 60  + 55)  * 1000 , endTime = (25 * 60  + 00)  * 1000,  damagaRate = 9,  cartridgeBagLocation = 0.7 },
        },
    },


--- TEST
--    ISLAND_AND_DESERT__TEST = {
--        SHRINK_CIRCLE_TIME_TABLE = { --- 以机场倒计时时间为0作为基准，时间单位是ms (沙漠、海岛地图)
--            { start = (2 * 60  + 0)  * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 1 * 60 * 1000,        index_text="一" },
--            { start = (3 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = (40) * 1000,          index_text="二" },
--            { start = (4 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = (30) * 1000,          index_text="三" },
--            { start = (5 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 50 * 1000,            index_text="四" },
--            { start = (6 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 40 * 1000,            index_text="五" },
--            { start = (7 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 20 * 1000,            index_text="六" },
--            { start = (7 * 60 + 50) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 10 * 1000,            index_text="七" },
--            { start = (8 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 30 * 1000,            index_text="八" },
--            { start = (9 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = (1 * 60 + 15) * 1000, index_text="九" },
--        },
--
--        SAFETY_CIRCLE_TIP_TIME_TABLE = { --- 跑圈提醒
--            {pos = 25,  ahead = {275 * 1000,155 * 1000,145 * 1000, 75 * 1000, 65 * 1000}}, -- A
--            {pos = 50,  ahead = {245 * 1000,125 * 1000, 75 * 1000, 55 * 1000, 55 * 1000}}, -- B
--            {pos = 75,  ahead = {185 * 1000, 95 * 1000, 65 * 1000, 45 * 1000, 35 * 1000}}, -- C
--            {pos = 100, ahead = { 85 * 1000, 55 * 1000, 45 * 1000, 35 * 1000}}, -- D
--        },
--    },
--
--    RAINFOREST__TEST = {
--        SHRINK_CIRCLE_TIME_TABLE = { --- 以机场倒计时时间为0作为基准，时间单位是ms (热带雨林地图)
--            { start = (2 * 60  + 0)  * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,  timer = 1 * 60 * 1000,        index_text="一" },
--            { start = (3 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = (40) * 1000,          index_text="二" },
--            { start = (4 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = (30) * 1000,          index_text="三" },
--            { start = (5 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 50 * 1000,            index_text="四" },
--            { start = (6 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 40 * 1000,            index_text="五" },
--            { start = (7 * 60 + 10) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 20 * 1000,            index_text="六" },
--            { start = (7 * 60 + 50) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 10 * 1000,            index_text="七" },
--            { start = (8 * 60 + 20) * 1000 - SHRINK_CIRCLE_START_TIME_REDUCED_TIME,   timer = 30 * 1000,            index_text="八" },
--        },
--
--        SAFETY_CIRCLE_TIP_TIME_TABLE = { --- 跑圈提醒
--            {pos = 25,  ahead = {155 * 1000, 185 * 1000, 115 * 1000, 85 * 1000, 55 * 1000}}, -- A
--            {pos = 50,  ahead = {125 * 1000, 155 * 1000,  85 * 1000, 65 * 1000, 45 * 1000}}, -- B
--            {pos = 75,  ahead = { 95 * 1000, 125 * 1000,  65 * 1000, 55 * 1000, 35 * 1000}}, -- C
--            {pos = 100, ahead =  {65 * 1000,  95 * 1000,  55 * 1000, 35 * 1000}}, -- D
--        },
--    },
}
local FINALLY_CIRCLE_INDEX = 9

local AIRPORT_TIMER_RECOGNIZE_MAX_TIME      = 60 * 1000     --- 机场倒计时时间，以进入游戏的时间为基准，最多识别60s，时间单位是ms
local MAP_BOTTOM_TIMER_RECOGNIZE_DELAY_TIME = 2 * 60 * 1000 --- 地图底下的倒计时延后识别时间，以机场倒计时时间为0作为基准，最多识别2 * 60s，时间单位是ms
local MAP_BOTTOM_TIMER_RECOGNIZE_MAX_TIME   = 60 * 1000     --- 地图底下的倒计时最大的识别时间，以开始识别的时间为基准，最多识别60s，时间单位是ms

local AIRPORT_TIMER_NIN_VALUE = 0
local AIRPORT_TIMER_MAX_VALUE = 60

local MAP_BOTTOM_LEFT_TIMER_MIN_VALUE = 0
local MAP_BOTTOM_LEFT_TIMER_MAX_VALUE = 5

local TIP_SAFTEY_CIRCLE_EXPIRED_TIME = 3000 --- 提醒文字显示时间（到时自动消失）

--- 当前收圈索引、进机场时间、机场倒计时时间、距离收圈时间、已收圈时间
local gbAirportRecognizeTimeout   = false
local gbMapBottomRecognizeTimeout = false
local gbShowingCircleView         = false --- 此标识是用于记录当前要一直展现或不展现circleView
local gbHideCircleView            = false --- 此标识是表示是否临时隐藏circleView，比如遮挡状态下，gbShowingCircleView为true，gbHideCircleView也会true

local glEnterGameTime          = -1    --- 进入游戏时间, 单位是ms
local glAirportSysTime         = -1    --- 识别到机场倒计时的时间, 单位是ms
local glAirportTimerTime       = -1    --- 机场到计时时间, 单位是ms
local glAirportEndSysTime      = -1    --- 机场结束的时间, 单位是ms
local glMapBottomTimerTime     = -1    --- 地图底部的定时器时间, 单位是minute

local gnCurrentShrinkCircle    = -1    --- 当前收圈的索引
local glDistanceCircleTime     = -1    --- 距离收圈的时间, 单位是ms
local glAlreadyCircleTime      = -1    --- 已经收圈的时间, 单位是ms
local glCurCircleTotalTime     = -1    --- 当前圈的总时长，包括等待时间+收圈时间，单位是ms
local glCurCircleStartTime     = -1    --- 当前圈的开始时间，单位是ms

local gMapType           --- 地图类型
local gbRecognizeMapType --- 是否识别了地图类型

local gbLogTimeNotArrived   = false
local gTableAirportTimers   = {}

local gnMapBottomTimerTotalCnt     = 0
local gnMapBottomTimerCorrectCnt   = 0

local gShrinkCircleSwitch
local gShrinkCircleCheckBox
local gShrinkCircleDescTextView


local gRunCircleSwitch
local gRunCircleCheckBox
local gRunCircleDescTextView

local floatWindow
local gRecognizeAdapterManager
local shrinkCircleView

local safetyCircleTipView;
local safetyCircleTipViewShowed = {}
local lastDetectSafetyAreaTime = 0;
local maxSafetyCircleTipCount;

local SHRINK_CIRCLE_TIP_TEXT_FORMAT = "第<font color='#ff5353'>%s个</font>圈开始收圈，收圈时间<font color='#ff5353'>%s</font>"
local FINALLY_SHRINK_CIRCLE_TIP_TEXT_FORMAT = "<font color='#ff5353'>最终圈</font>将在<font color='#ff5353'>%s</font>后收圈"

local RUN_CIRCLE_TIPS_TEXT = "当前距离<font color='#ff5353'>安全圈较远</font>，建议现在<font color='#ff5353'>开始跑圈</font>"

local REPORT_TABLE_RUNLAPS = "gamemaster_pubgm_runlaps"
local REPORT_TYPE_SHRINK_START  = 1
local REPORT_TYPE_SHRINK_CIRCLE = 2
local REPORT_TYPE_RUN_CIRCLE    = 3
local REPORT_TYPE_DAMAGA_NOTICE = 4

local START_AFTER_10 = 10--开始后10%
local END_PREV_10 = 90--结束前10%
local VALID_INTERVAL = 1000--有效时间区间 1s

local MAX_VALID_INTERVAL = 10 * 1000;--最大有效时间
local MIN_VALID_INTERVAL = -1000;--最小有效时间

------------------ 伤害提醒变量申明---------------------
local DAMAGA_NOTICE_TIP_TEXT_FORMAT = "进入第<font color='#ff5353'>%s个</font>毒圈范围，每秒伤害<font color='#ff5353'>%s</font>"
local DAMAGA_NOTICE_REFRESH_TIME_MS = 1000; --读圈伤害刷新时间
local DAMAGA_NOTICE_CHECKBOX_TEXT = "开启毒圈伤害"
local DAMAGA_NOTICE_DESC_TEXT = "当你进入毒圈后，计算毒圈存活时间，并提供药物指示"
local KEY_DAMAGA_NOTICE_ENABLE = SP_DAMAGA_NOTICE_SWITCH_KEY
local gDamagaNoticeSwitch = true
local gDamagaNoticeCheckBox
local gDamagaNoticeDescTextView
local gDamagaNoticeTipImageView

local damagaData = {
    bloodPercentage = 0,
    whichRunLaps = 0,
    survivalTime = 0,
    lastRefreshTime = 0,
    damagaRate = 0,
    cartridgeBagLocation = 0,
    hasBeenShownTipText = false
}

local gbShowBloodFlagView = false
local bloodFlagView
local gbShowDamagaNoticeView = false
local damagaNoticeView
-------------------伤害提醒结束------------------------

local gNewGameEngine = CNewGameEngine:getInstance()

local DEBUG = commonlib_isLogWriteAble();

local function printLog(msg)
    commonlib_print(TAG, msg)
end

local function getMapType()
    if commonlib_isStringEmpty(gMapType) then
        gMapType = commonlib_getGameParam(KEY_NAME_MAP_TYPE);
        if not commonlib_isStringEmpty(gMapType) then
            printLog("getMapType return " .. gMapType)
        end
    end
    return gMapType
end

local function getCfgAdapter() --- 明确判断到热带草原地图，则拿热带草原地图的适配器，否则走原来的逻辑
    if KEY_NAME_MAP_RAINFOREST == getMapType() then
        return CFG_ADAPTER.RAINFOREST
    else
        return CFG_ADAPTER.ISLAND_AND_DESERT
    end
end

local function getShrinkCircleTimeTable()
    local cfgAdpater = getCfgAdapter()
    if nil ~= cfgAdpater then
        return cfgAdpater.SHRINK_CIRCLE_TIME_TABLE
    end
end

local function getSafetyCircleTipTimeTable()
    local cfgAdpater = getCfgAdapter()
    if nil ~= cfgAdpater then
        return cfgAdpater.SAFETY_CIRCLE_TIP_TIME_TABLE
    end
end

--- gamemaster_pubgm_runlaps:348 action:byte laps:byte game_map:byte
local function report(type, shrinkCircleIdx)

    local mapType = 0;
    local map = getMapType();
    if map == KEY_NAME_MAP_ISLAND then
        mapType = 1;
    elseif map == KEY_NAME_MAP_DESERT then
        mapType = 2;
    elseif map == KEY_NAME_MAP_RAINFOREST then
        mapType = 3;
    end

    commonlib_report(REPORT_TABLE_RUNLAPS,
        {
            ["action"] = type,
            ["laps"]   = shrinkCircleIdx,
            ["game_map"] = mapType,
        });

    printLog("report, action:" .. tostring(type) .. ", idx:" .. tostring(shrinkCircleIdx) .. ", mapType:" .. tostring(mapType))
end

local function getShrinkCircleViewRect()

    if nil == gRecognizeAdapterManager then
        printLog("getShrinkCircleViewRect, recognize adapter manager is nil")
        return
    end

    local mapRectInfoRect = gNewGameEngine:getConditionRect(KEY_CIRCLE_TIMER_VIEW_RECT);
    if nil == mapRectInfoRect then
        printLog("getShrinkCircleViewRect, rect is nil")
        return
    end

    return mapRectInfoRect
end

local function formatTipText(index, circleTime)
    if nil == circleTime or nil == circleTime.timer then
        printLog("formatTipText, circleTime data error")
        return
    end

    local lTimeSecond = circleTime.timer / 1000
    local lMinite, _ = math.modf(lTimeSecond / 60)
    local lSecond = math.mod(lTimeSecond, 60)

    local timeText = ""
    if lMinite > 0 then
        if lSecond > 0 then
            timeText = string.format("%d分", lMinite)
        else
            timeText = string.format("%d分钟", lMinite)
        end
    end
    if lSecond > 0 then
        timeText = timeText .. string.format("%d秒", lSecond)
    end

    if commonlib_isStringEmpty(timeText) then
        printLog("formatTipText error, timeText is nil, timer:" .. tostring(circleTime.timer))
        return
    end

    if index == FINALLY_CIRCLE_INDEX then
        return string.format(FINALLY_SHRINK_CIRCLE_TIP_TEXT_FORMAT, timeText)
    end

    return string.format(SHRINK_CIRCLE_TIP_TEXT_FORMAT, circleTime.index_text, timeText)
end

local function showExistTimerViewInUiThread()
    if nil == shrinkCircleView then
        return
    end

    if not gbHideCircleView then
        return
    end
    gbHideCircleView = false;
    printLog("showExistTimerViewInUiThread, hided, need restore show")

    commonlib_runOnUIThread(function()
        if nil ~= shrinkCircleView then
            shrinkCircleView:show()
        end
    end)
end

local function hideExistTimerViewInUiThread()
    if nil == shrinkCircleView then
        return
    end

    if gbHideCircleView then
        return
    end
    gbHideCircleView = true;
    printLog("hideExistTimerViewInUiThread, need hide")

    commonlib_runOnUIThread(function()
        if nil ~= shrinkCircleView then
            shrinkCircleView:hide()
        end
    end)
end

local function destoryTimerView()
    if nil ~= shrinkCircleView then
        shrinkCircleView:stopShow()
        shrinkCircleView:destroy()
        shrinkCircleView = nil
    end
end

local function destoryTimerViewInUiThread()
    commonlib_runOnUIThread(destoryTimerView)
end

local function showTimerViewInUiThread(index, circleTime)

    if nil == index or index <= 0 or nil == circleTime then
        printLog("showTimerView error, index:" .. tostring(index))
        return
    end

    commonlib_runOnUIThread(function()
        if nil == shrinkCircleView then
            shrinkCircleView = floatWindow:addPubgmhdShrinkCircleViewForLua(
                Anchor().TOPLEFT, 0, 0, ZOrder().zorder_bottom)
        end

        if nil == shrinkCircleView then
            printLog("showTimerView error, circle view is nil, index:" .. tostring(index))
            return
        end


        local tipText = formatTipText(index, circleTime);
        if commonlib_isStringEmpty(tipText) then
            printLog("showTimerView, tipText is empty, index:" .. tostring(index))
            return
        end

        local timerViewRect = getShrinkCircleViewRect()
        if nil == timerViewRect then
            return
        end

        shrinkCircleView:setTimeViewPoint(timerViewRect.flag, timerViewRect.left, timerViewRect.top)
        shrinkCircleView:startShow(tipText, circleTime.timer,
            function()
                destoryTimerViewInUiThread()
            end)
        printLog("showTimerView, startShow:" .. tipText .. ", timer:" .. tostring(circleTime.timer))

        report(REPORT_TYPE_SHRINK_CIRCLE, index)
    end)
end

local function checkCurrentCircle(shrinkCicleTimeTable)
    if gnCurrentShrinkCircle < #shrinkCicleTimeTable then
        local lAirportEndToCurrentTime = commonlib_getCurrentTime() - glAirportEndSysTime
        for index, time in pairs(shrinkCicleTimeTable) do
            if index >= gnCurrentShrinkCircle and nil ~= time then
                if lAirportEndToCurrentTime < (time.start + time.timer) then
                    return index
                end
            end
        end
    end
    return gnCurrentShrinkCircle
end

local function updateCurrentCircle()

    local shrinkCicleTimeTable = getShrinkCircleTimeTable();
    if nil == shrinkCicleTimeTable then
        printLog("updateCurrentCircle error, shrinkCicleTimeTable is nil")
        return
    end

    local nCurrentIdx = checkCurrentCircle(shrinkCicleTimeTable)
    if -1 == nCurrentIdx then
        printLog("updateCurrentCircle error, idx:-1")
        return
    end

    local bSwitchCircle = (nCurrentIdx > gnCurrentShrinkCircle);
    gnCurrentShrinkCircle = nCurrentIdx

    local circleTime = shrinkCicleTimeTable[gnCurrentShrinkCircle]
    if nil == circleTime then
        printLog("circleTime error, idx:" .. tostring(gnCurrentShrinkCircle))
        return
    end

    local lAirportEndToCurrent = commonlib_getCurrentTime() - glAirportEndSysTime
    local lStartTime = circleTime.start
    if lAirportEndToCurrent <= lStartTime then
        glDistanceCircleTime = lStartTime - lAirportEndToCurrent
        glAlreadyCircleTime  = 0
    else
        glDistanceCircleTime = 0
        glAlreadyCircleTime  = lAirportEndToCurrent - lStartTime
    end

    if bSwitchCircle then
        gbShowingCircleView = false

        --- 检查上一个收到圈的view是否结束，还没结束则隐藏view
        destoryTimerViewInUiThread()

        local lLastCircleTime = shrinkCicleTimeTable[gnCurrentShrinkCircle - 1]
        if nil == lLastCircleTime then
            glCurCircleTotalTime = circleTime.start + circleTime.timer
            glCurCircleStartTime = glAirportEndSysTime
        else
            glCurCircleTotalTime = circleTime.start + circleTime.timer - lLastCircleTime.start - lLastCircleTime.timer
            glCurCircleStartTime = glAirportEndSysTime + lLastCircleTime.start + lLastCircleTime.timer
        end

        printLog("switch circle, idx:" .. tostring(gnCurrentShrinkCircle)
                .. ", distance_t:" .. tostring(glDistanceCircleTime)
                .. ", already_t:"  .. tostring(glAlreadyCircleTime)
                .. ", total_t:" .. tostring(glCurCircleTotalTime)
                .. ", start_t:" .. tostring(glCurCircleStartTime)
                .. ", timer:" .. tostring(circleTime.timer)
                .. ", start_to_current:" .. tostring(commonlib_getCurrentTime() - glCurCircleStartTime))
    end

    if not gbShowingCircleView and glDistanceCircleTime == 0 and glAlreadyCircleTime < circleTime.timer then
        gbShowingCircleView = true

        --- 校准时间
        local circleTimeArgs
        if glAlreadyCircleTime >= 5000 then
            circleTimeArgs = {
                start = circleTime.start + glAlreadyCircleTime,
                timer = circleTime.timer - glAlreadyCircleTime,
                index_text = circleTime.index_text,
            }

            printLog("start circle, index:" .. tostring(gnCurrentShrinkCircle)
                    .. ", origTimer:" .. tostring(circleTime.timer)
                    .. ", adjustTimer:" .. tostring(circleTimeArgs.timer))
        else
            circleTimeArgs = circleTime
        end

        --- 启动倒计时
        showTimerViewInUiThread(gnCurrentShrinkCircle, circleTimeArgs)

        printLog("start circle, index:" .. tostring(gnCurrentShrinkCircle))

        return true
    end
end

local function getRectData(key)
    local rect = gNewGameEngine:getConditionRect(key)
    if rect == nil then
        return nil
    end

    return {
        rect = rect,
        threshold = 80,
    }
end

local function recognizeAirportTimer()
    --local rectData = getRectData(KEY_AIRPORT_TIMER_NUM_RECT)
    local result = gNewGameEngine:matchConditionOnString("cd_build_recognize_airport_time_number");
    printLog("KEY_AIRPORT_TIMER_NUM_RECT" .. tostring(result))
    if nil == result then
        return nil
    end
    return tonumber(result)
end

local function recognizeMapBottomMinuteTime()
    --local rectData = getRectData(KEY_MAP_BOTTOM_LEFT_NUM_RECT)
    local result = gNewGameEngine:matchConditionOnString("cd_build_recognize_map_left_time_number");
    printLog("cd_build_recognize_map_left_time_number" .. tostring(result))

    if nil == result then
        return nil
    end
    return tonumber(result)
end

local function checkAirportTimers(recognizedTimer)
    local matchCnt = 0
    for _, lastRecognizedTimer in pairs(gTableAirportTimers) do
        local systimeDiff = recognizedTimer.airport_systime - lastRecognizedTimer.airport_systime
        local timerDiff   = lastRecognizedTimer.airport_timert - recognizedTimer.airport_timert

        if timerDiff >= systimeDiff - 2500 and timerDiff <= systimeDiff + 2500 then
            matchCnt = matchCnt + 1
        end

        if matchCnt >= AIRPORT_TIMER_RECOGNIZE_CORRECT_MIN_CNT then
            return true
        end
    end
end

local function onRecognizeAirportTimerTime()
    if glEnterGameTime < 0 then
        printLog("onRecognizeAirportTimerTime, enter_game_time error")
        return
    end

    if glAirportSysTime > 0 and glAirportTimerTime >= 0 then
        return true
    end

    if gbAirportRecognizeTimeout then
        if DEBUG then
            printLog("onRecognizeAirportTimerTime, timeout")
        end
        return
    end
    gbAirportRecognizeTimeout = commonlib_getCurrentTime() - glEnterGameTime > AIRPORT_TIMER_RECOGNIZE_MAX_TIME
    if gbAirportRecognizeTimeout then
        printLog("onRecognizeAirportTimerTime, timeout")
        return
    end

    local nAirportTimeS = recognizeAirportTimer()
    if nil ~= nAirportTimeS and nAirportTimeS > AIRPORT_TIMER_NIN_VALUE and nAirportTimeS <= AIRPORT_TIMER_MAX_VALUE then

        local tmpTable = {
            airport_systime = commonlib_getCurrentTime(),
            airport_timert  = nAirportTimeS * 1000
        }
        gTableAirportTimers[#gTableAirportTimers + 1] = tmpTable

        printLog("onRecognizeAirportTimerTime, cnt:" .. tostring(#gTableAirportTimers) .. ", timer_t:" .. tostring(tmpTable.airport_timert)
                .. ", systime:" .. tostring(tmpTable.airport_systime))

        if checkAirportTimers(tmpTable) then
            glAirportSysTime    = tmpTable.airport_systime
            glAirportTimerTime  = tmpTable.airport_timert
            glAirportEndSysTime = glAirportSysTime + glAirportTimerTime
            commonlib_setGameParam(KEY_AIRPORT_END_SYS_TIME, glAirportEndSysTime)
            printLog("onRecognizeAirportTimerTime, succeed, timer_t:" .. tostring(glAirportTimerTime)
                    .. ", systime:" .. tostring(glAirportSysTime) .. ", to_end_systime:" .. tostring(glAirportEndSysTime))

            return true
        end

    elseif nil ~= nAirportTimeS then
        printLog("onRecognizeAirportTimerTime, recognize error, timer:" .. tostring(nAirportTimeS))
    else
        printLog("onRecognizeAirportTimerTime, recognize return nil")
    end
end

local function onRecognizeMapButtomTimerTime()

    if glAirportEndSysTime < 0 then
        printLog("onRecognizeMapButtomTimerTime, airporttimer not recognize")
        return
    end

    if glMapBottomTimerTime == CLASSIC_MODE_NUM then
        return true
    end

    if glMapBottomTimerTime > 0 then
        if DEBUG then
            printLog("glMapBottomTimerTime > 0")
        end
        return
    end

    local lAirportTimerZeroToCurrent = commonlib_getCurrentTime() - glAirportEndSysTime
    if DEBUG then
        printLog("lAirportTimerZeroToCurrent=" .. tostring(lAirportTimerZeroToCurrent) .. " glAirportEndSysTime=" .. tostring(glAirportEndSysTime))
    end
    if lAirportTimerZeroToCurrent < MAP_BOTTOM_TIMER_RECOGNIZE_DELAY_TIME then
        if not gbLogTimeNotArrived then
            printLog("onRecognizeMapButtomTimerTime, time not arrived")
            gbLogTimeNotArrived = true
        end
        return
    end

    if gbMapBottomRecognizeTimeout then
        if DEBUG then
            printLog("onRecognizeMapButtomTimerTime, time out")
        end
        return
    end
    gbMapBottomRecognizeTimeout = lAirportTimerZeroToCurrent - MAP_BOTTOM_TIMER_RECOGNIZE_DELAY_TIME > MAP_BOTTOM_TIMER_RECOGNIZE_MAX_TIME
    if gbMapBottomRecognizeTimeout then
        printLog("onRecognizeMapButtomTimerTime, time out")
        return
    end

    local nMapBottomTimeMinute = recognizeMapBottomMinuteTime()
    if nil ~= nMapBottomTimeMinute and nMapBottomTimeMinute > MAP_BOTTOM_LEFT_TIMER_MIN_VALUE and nMapBottomTimeMinute <= MAP_BOTTOM_LEFT_TIMER_MAX_VALUE then

        gnMapBottomTimerTotalCnt = gnMapBottomTimerTotalCnt + 1
        if nMapBottomTimeMinute == CLASSIC_MODE_NUM then
            gnMapBottomTimerCorrectCnt = gnMapBottomTimerCorrectCnt + 1
        end

        printLog("onRecognizeMapButtomTimerTime, timer:" .. tostring(nMapBottomTimeMinute))

        if gnMapBottomTimerCorrectCnt >= MAP_BOTTOM_NUM_RECOGNIZE_CORRECT_MIN_CNT or gnMapBottomTimerTotalCnt >= MAP_BOTTOM_NUM_RECOGNIZE_TOTAL_MAX_CNT then
            glMapBottomTimerTime = nMapBottomTimeMinute
        end

        if glMapBottomTimerTime == CLASSIC_MODE_NUM then
            printLog("onRecognizeMapButtomTimerTime, succeed")

            report(REPORT_TYPE_SHRINK_START, 0)

            return true
        end

    elseif nil ~= nMapBottomTimeMinute then
        printLog("onRecognizeMapButtomTimerTime, recognize error, timer:" .. tostring(nMapBottomTimeMinute))
    else
        printLog("onRecognizeMapButtomTimerTime, recognize return nil")
    end
end

local function checkMapType()
    if true ~= gbRecognizeMapType then
        if KEY_NAME_MAP_RAINFOREST == getMapType() then
            gbRecognizeMapType = true
        else
            gbRecognizeMapType = onRecognizeMapButtomTimerTime()
        end
    end
    return gbRecognizeMapType
end


local function resetDamagaData()
    damagaData.bloodPercentage = 0
    damagaData.whichRunLaps = 0
    damagaData.survivalTime = 0
    damagaData.lastRefreshTime = 0
end

local function reset()
    gbAirportRecognizeTimeout   = false
    gbMapBottomRecognizeTimeout = false
    gbShowingCircleView         = false
    gbHideCircleView            = false

    glEnterGameTime       = -1    --- 进入游戏时间
    glAirportSysTime      = -1    --- 识别到机场倒计时的时间
    glAirportTimerTime    = -1    --- 机场到计时时间
    glAirportEndSysTime   = -1    --- 机场结束的时间
    gnCurrentShrinkCircle = -1    --- 当前收圈的索引
    glDistanceCircleTime  = -1    --- 距离收圈的时间
    glAlreadyCircleTime   = -1    --- 已经收圈的时间
    glCurCircleTotalTime  = -1    --- 当前圈的总时长，包括等待时间+收圈时间，单位是ms
    glCurCircleStartTime  = -1    --- 当前圈的开始时间，单位是ms

    glMapBottomTimerTime  = -1    --- 地图底部的定时器时间

    gbLogTimeNotArrived   = false
    gTableAirportTimers   = {}

    gnMapBottomTimerTotalCnt   = 0
    gnMapBottomTimerCorrectCnt = 0

    safetyCircleTipViewShowed = {}

    gMapType           = nil
    gbRecognizeMapType = nil

    resetDamagaData()
    gbShowDamagaNoticeView = false
    gbShowBloodFlagView = false
    commonlib_setGameParam(KEY_AIRPORT_END_SYS_TIME, glAirportEndSysTime)
end

local function showSafetyCircleTip()

    local safetyCircleTipTimeTable = getSafetyCircleTipTimeTable()
    if nil == safetyCircleTipTimeTable then
        printLog("showSafetyCircleTip safetyCircleTipTimeTable is nil")
        return
    end

    if maxSafetyCircleTipCount == nil and #safetyCircleTipTimeTable > 0 then
        maxSafetyCircleTipCount = #(safetyCircleTipTimeTable[1].ahead);
        printLog("showSafetyCircleTip maxSafetyCircleTipCount=" .. tostring(maxSafetyCircleTipCount))
    end

    if gnCurrentShrinkCircle <= 0 or gnCurrentShrinkCircle > maxSafetyCircleTipCount then
        if DEBUG then
            printLog("showSafetyCircleTip gnCurrentShrinkCircle=" .. tostring(gnCurrentShrinkCircle))
        end
        return;
    end

    if safetyCircleTipViewShowed[gnCurrentShrinkCircle] == true then -- 此圈已提醒过
        if DEBUG then
            printLog("showSafetyCircleTip 第" .. tostring(gnCurrentShrinkCircle) .. "圈已提醒过")
        end
        return;
    end

    local ahead = safetyCircleTipTimeTable[1].ahead[gnCurrentShrinkCircle];
    if ahead == nil then
        return;
    end
    local start = glCurCircleStartTime + glCurCircleTotalTime - ahead - 15000; -- 识别优化
    local nowTime = commonlib_getCurrentTime();
    if nowTime < start or nowTime - lastDetectSafetyAreaTime < VALID_INTERVAL then
        return;
    end

    local pos = gNewGameEngine:matchConditionOnNumber(KEY_NAME_BN_PLAYER_SAFETY_POS);
    if pos == nil then
        printLog("showSafetyCircleTip pos=nil")
        return;
    end

    if DEBUG then
        printLog("showSafetyCircleTip pos=" .. tostring(pos))
    end
    lastDetectSafetyAreaTime = nowTime;
    if pos < START_AFTER_10 or pos > END_PREV_10 then
        return;
    end

    for idx = 1, #safetyCircleTipTimeTable do
        if pos <= safetyCircleTipTimeTable[idx].pos then
            ahead = safetyCircleTipTimeTable[idx].ahead[gnCurrentShrinkCircle];
            if ahead == nil then
                safetyCircleTipViewShowed[gnCurrentShrinkCircle] = true;
                return
            end
            local tipTime = glCurCircleStartTime + glCurCircleTotalTime - ahead;
            local diffTime = nowTime - tipTime
            if DEBUG then
                printLog("showSafetyCircleTip tipTime=".. tostring(tipTime)
                        .." nowTime=".. tostring(nowTime)
                        .. " ahead=" .. tostring(ahead)
                        .. " wait=" .. tostring(-diffTime))
            end
            if (diffTime < MAX_VALID_INTERVAL and diffTime > MIN_VALID_INTERVAL) then
                commonlib_runOnUIThread(function()
                    if nil == safetyCircleTipView then
                        safetyCircleTipView = floatWindow:addToastTipView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top)
                    end
                    safetyCircleTipView:show(RUN_CIRCLE_TIPS_TEXT, TIP_SAFTEY_CIRCLE_EXPIRED_TIME, true, 62)
                end)
                if DEBUG then
                    printLog("跑圈提示成功 圈数=" .. tostring(gnCurrentShrinkCircle))
                end
                report(REPORT_TYPE_RUN_CIRCLE, gnCurrentShrinkCircle)
                safetyCircleTipViewShowed[gnCurrentShrinkCircle] = true;
            end
            return;
        end
    end
end

local function handleSafetyTip(show)
    if show == true then
        showSafetyCircleTip();
    elseif safetyCircleTipView ~= nil then
        commonlib_runOnUIThread(function()
            if nil ~= safetyCircleTipView and safetyCircleTipView:isShowing() == true then
                safetyCircleTipView:hide()
            end
        end)
    end
end

local function damagaDataToString(dmData)
    if not dmData then
        return "nil"
    end

    return  "bloodPercentage=" .. tostring(dmData.bloodPercentage)
            .. ", whichRunLaps=" .. tostring(dmData.whichRunLaps)
            .. ", survivalTime=" .. tostring(dmData.survivalTime)
            .. ", lastRefreshTime=" .. tostring(dmData.lastRefreshTime)
            .. ", damagaRate=" .. tostring(dmData.damagaRate)
            .. ", cartridgeBagLocation=" .. tostring(dmData.cartridgeBagLocation)
end

--是否处于伤害中
local function isInDanger()
    local result = gNewGameEngine:matchCondition("cd_build_cj_detect_red_person")
    printLog("DamagaNotcieWork, isInDanger=" .. tostring(result))
    return result
end

--是
local function isRefreshdamagaNotice()
    if damagaData.lastRefreshTime <= 0 then
        damagaData.lastRefreshTime = commonlib_getCurrentTime()
        return true
    end

    local diffTime = commonlib_getCurrentTime() - damagaData.lastRefreshTime
    if diffTime < 0 then
        damagaData.lastRefreshTime = commonlib_getCurrentTime()
        return true
    end

    if diffTime > DAMAGA_NOTICE_REFRESH_TIME_MS then
        damagaData.lastRefreshTime = commonlib_getCurrentTime()
        return true
    end
    return false
end

local function getDamagaNoticeTable()
    local cfgAdpater = getCfgAdapter()
    if nil ~= cfgAdpater then
        return cfgAdpater.DAMAGA_NOTICE_TABLE
    end
end

local function damagaNoticeGetDamagaData(damagaNoticeTable)
    --local lAirportEndToCurrentTime = commonlib_getCurrentTime() - glEnterGameTime + 7 * 60 * 1000
    local lAirportEndToCurrentTime = commonlib_getCurrentTime() - glAirportEndSysTime
    for index, damagaNoticeInfo in pairs(damagaNoticeTable) do
        if lAirportEndToCurrentTime >= damagaNoticeInfo.startTime and lAirportEndToCurrentTime <= damagaNoticeInfo.endTime then
            damagaData.whichRunLaps = index
            damagaData.damagaRate = damagaNoticeInfo.damagaRate
            damagaData.cartridgeBagLocation = damagaNoticeInfo.cartridgeBagLocation
            if damagaData.damagaRate <= 0 then
                printLog("DamagaNotcieWork, damagaData.damagaRate=" .. tostring(damagaData.damagaRate))
                return false
            end
            return true
        end
    end
    printLog("DamagaNotcieWork, result=false")
    return false
end

--血条百分比
local function getBloodPercentage()
    local result = gNewGameEngine:matchConditionOnResult("cd_build_detect_blood_value")
    if type(result) ~= "number" then
        printLog("DamagaNotcieWork, matchConditionOnResult not number, result=" .. tostring(result))
        return nil
    end
    printLog("DamagaNotcieWork, getBloodPercentage=" .. tostring(result))
    return result
end

--计算存活时间，得出当前第几圈和计数器时间
local function calculateSurvivalTime(bloodPercentage)
    damagaData.bloodPercentage = bloodPercentage
    damagaData.survivalTime = bloodPercentage / damagaData.damagaRate
end

local function destoryDamagaNoticeTimerView()
    if nil ~= damagaNoticeView then
        damagaNoticeView:stopShow()
        damagaNoticeView:destroy()
        damagaNoticeView = nil
    end
    gbShowDamagaNoticeView = false
    printLog("DamagaNotcieWork, destoryDamagaNoticeTimerView")
end

local function destoryDamagaNoticeTimerViewnUiThread()
    commonlib_runOnUIThread(destoryDamagaNoticeTimerView)
end

local function formatDamagaNoticeTipText(runLaps, damagaRate)
    return string.format(DAMAGA_NOTICE_TIP_TEXT_FORMAT, tostring(runLaps), tostring(damagaRate))
end

local function isSameRunLaps(lastDamagaData, newDamagaData)
    if lastDamagaData == nil or newDamagaData == nil then
        return false
    end

    local result = lastDamagaData.whichRunLaps == newDamagaData.whichRunLaps
    return result
end

local function showDamagaNoticeTimerView(isshow, lastDamagaData, newDamagaData)
    if not isshow then
        if not gbShowDamagaNoticeView then
            return
        end
        if nil ~= damagaNoticeView then
            destoryDamagaNoticeTimerViewnUiThread()
        end
    else
        commonlib_runOnUIThread(function()
            local diffSurvivalTime = newDamagaData.survivalTime - lastDamagaData.survivalTime
            if math.abs(diffSurvivalTime) >= 6 then
                if nil ~= damagaNoticeView then
                    destoryDamagaNoticeTimerView()
                end
            end
            printLog("DamagaNotcieWork, showDamagaNoticeTimerView gbShowDamagaNoticeView="
                    .. tostring(gbShowDamagaNoticeView) .. ", diffSurvivalTime=" .. tostring(diffSurvivalTime))
            if gbShowDamagaNoticeView then
                return
            end

            if nil == damagaNoticeView then
                damagaNoticeView = floatWindow:addPubgmhdDamagaNoticeViewForLua(
                        Anchor().TOPLEFT, 0, 0, ZOrder().zorder_bottom)
            end

            if nil == damagaNoticeView then
                printLog("DamagaNotcieWork, showTimerView error, circle view is nil, index:" .. tostring(index))
                return
            end

            local tipText
            if newDamagaData.hasBeenShownTipText then
                tipText = ""
            else
                --tipText = "进入第<font color='#ff5353'>" .. tostring(newDamagaData.whichRunLaps)
                --        .. "个</font>毒圈范围，每秒伤害<font color='#ff5353'>"
                --        .. tostring(newDamagaData.damagaRate) .. "</font>"
                tipText = formatDamagaNoticeTipText(newDamagaData.whichRunLaps, newDamagaData.damagaRate)
                newDamagaData.hasBeenShownTipText = true
            end

            printLog("DamagaNotcieWork, tip text=" .. tostring(tipText))

            local timerViewRect = getShrinkCircleViewRect()
            if nil == timerViewRect then
                printLog("DamagaNotcieWork, timerViewRect=nil")
                return
            end
            damagaNoticeView:setTimeViewPoint(timerViewRect.flag, timerViewRect.left + 135, timerViewRect.top)
            damagaNoticeView:startShow(tipText, newDamagaData.survivalTime * 1000,
                    function()
                        destoryDamagaNoticeTimerViewnUiThread()
                    end)
            damagaNoticeView:show()
            printLog("DamagaNotcieWork, showTimerView, startShow:" .. tipText .. ", timer:" .. tostring(newDamagaData.survivalTime))
            gbShowDamagaNoticeView = true
        end)
    end
end

local function destorybloodFlagView()
    if nil ~= bloodFlagView then
        bloodFlagView:destroy()
        bloodFlagView = nil
    end
    gbShowBloodFlagView = false
    printLog("destorybloodFlagView")
end

local function showBloodFlagView(isshow, lastDamagaData, newDamagaData)
    if isshow then
        commonlib_runOnUIThread(function ()
            if gbShowBloodFlagView then
                if isSameRunLaps(lastDamagaData, newDamagaData) then
                    printLog("DamagaNotcieWork, same runlaps")
                    return
                else
                    destorybloodFlagView()
                    printLog("DamagaNotcieWork, not same runlaps, destorybloodFlagView")
                end
            end
            local bloodRect = gNewGameEngine:getConditionRect("cd_rect_build_detect_blood_value")
            if bloodRect == nil then
                printLog("DamagaNotcieWork, blood rect nil")
                return
            end
            local width = bloodRect.width
            local left = bloodRect.left
            local pos_x = width * newDamagaData.cartridgeBagLocation + left
            local pos_y = -60
            if nil == bloodFlagView then
                bloodFlagView = floatWindow:addImageView("img/damaga_notice_blood.png", Anchor().BOTTOM, pos_x, pos_y, 32, 28, true, ZOrder().zorder_top)
            end
            bloodFlagView:show()

            gbShowBloodFlagView = true
            report(REPORT_TYPE_DAMAGA_NOTICE, newDamagaData.whichRunLaps)
            printLog("DamagaNotcieWork, show bloodFlagView, pos_x=" .. tostring(pos_x))
            end)
    else
        if not gbShowBloodFlagView then
            return
        end
        gbShowBloodFlagView = false

        if bloodFlagView ~= nil then
            commonlib_runOnUIThread(destorybloodFlagView)
        end
        printLog("DamagaNotcieWork, hide bloodFlagView")
    end
end

local function resetBeenShownTipText(lastDamagaData, newDamagaData)
    if not isSameRunLaps(lastDamagaData, newDamagaData) then
        newDamagaData.hasBeenShownTipText = false
    end
end

--显示界面，
local function showDamagaNotice(isShow, lastDamagaData, newDamagaData)
    printLog("DamagaNotcieWork,showDamagaNotice=" .. tostring(isShow)
            .. ", last damaga data: "
            .. damagaDataToString(lastDamagaData)
            .. ", new damaga data: "
            .. damagaDataToString(newDamagaData))

    showBloodFlagView(isShow, lastDamagaData, newDamagaData)
    showDamagaNoticeTimerView(isShow, lastDamagaData, newDamagaData)
end

local function DamagaNotcieWork()
    if not gDamagaNoticeSwitch then
        showDamagaNotice(false, nil, nil)
        return
    end

    ---[[
    if glAirportEndSysTime < 0 then
        printLog("DamagaNotcieWork, onRecognizeMapButtomTimerTime, airporttimer not recognize")
        showDamagaNotice(false, nil, nil)
        return
    end
    --]]

    local lastDamagaData = commonlib_deepCopy(damagaData);
    if not isRefreshdamagaNotice() then
        return
    end

    local damagaNoticeTable = getDamagaNoticeTable()
    if not damagaNoticeGetDamagaData(damagaNoticeTable) then
        showDamagaNotice(false, nil, nil)
        printLog("DamagaNotcieWork, damagaNoticeGetDamagaData failed")
        return
    end

    resetBeenShownTipText(lastDamagaData, damagaData)
    
    ---[[
    if not isInDanger() then
        printLog("DamagaNotcieWork, not in danger")
        showDamagaNotice(false, nil, nil)
        return
    end
    --]]

    local bloodPercentage = getBloodPercentage()
    if nil ~= bloodPercentage and (bloodPercentage > 100 or bloodPercentage < 0) then
        showDamagaNotice(false, nil, nil)
        printLog("DamagaNotcieWork, error, blood percentage=" .. tostring(bloodPercentage))
        return
    end

    calculateSurvivalTime(bloodPercentage)
    if damagaData.survivalTime < 5 then
        printLog("DamagaNotcieWork, litter survivalTime =" .. tostring(damagaData.survivalTime))
        return
    end

    showDamagaNotice(true, lastDamagaData, damagaData)
end

local function hideDamagaNotice()
    if gbShowBloodFlagView then
        if nil ~= bloodFlagView then
            commonlib_runOnUIThread( function ()
                bloodFlagView:hide()
            end)
        end
        gbShowBloodFlagView = false
    end

    if gbShowDamagaNoticeView then
        if nil ~= damagaNoticeView then
            commonlib_runOnUIThread( function ()
                damagaNoticeView:hide()
            end)
        end
        gbShowDamagaNoticeView = false
    end
end

local function onEnterGame()
    reset()
    glEnterGameTime = commonlib_getCurrentTime()
    printLog("onEnterGame")
end

local function isChecked()
    if gShrinkCircleSwitch == true or gRunCircleSwitch == true or gDamagaNoticeSwitch == true then
        return true
    end
    return false
end

local function onGameRunning()
    if true == isChecked() and true == onRecognizeAirportTimerTime() and true == checkMapType() then
        local cover = commonlib_getGameParam(KEY_GAME_RUNNING_COVER_STATUS);
        if GAME_COVER_NONE == cover then
            if gShrinkCircleSwitch then
                local ret = updateCurrentCircle()
                if nil == ret or not ret then
                    showExistTimerViewInUiThread()
                end
            end

            if gRunCircleSwitch then
                handleSafetyTip(true)
            end

            DamagaNotcieWork()
        else
            hideExistTimerViewInUiThread()
            handleSafetyTip(false)
            hideDamagaNotice()
        end
    else
        if DEBUG then
            printLog("不满足条件，不识别")
        end
    end
end

local function onGameOver()
    reset()
    destoryTimerViewInUiThread()
    commonlib_runOnUIThread(destorybloodFlagView)
    commonlib_runOnUIThread(destoryDamagaNoticeTimerView)
    printLog("onGameOver")
end

local function registerEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function unRegisterEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function initVariable()
    floatWindow = commonlib_getUnClickableFloatView();
    gRecognizeAdapterManager = AdapterManagerClass:getRecognizeInstance();
    gNewGameEngine = CNewGameEngine:getInstance()
end

local function uninitVariable()
    floatWindow = nil
    gRecognizeAdapterManager = nil
end

local function getTextColor(enable)
    if enable == true then
        return "#FF00DEFF";
    else
        return "#FF979797";
    end
end

local function updateItemDescTextColor(textView, isChecked)
    if textView ~= nil then
        textView:setTextColor(getTextColor(isChecked))
    end
end

local function updateTotalCheckBoxState()
    if gRunCircleSwitch == false and gShrinkCircleSwitch == false and gDamagaNoticeSwitch == false then
    end
end

local function onRunCircleCheckChangeListener(checkBoxId, isChecked)
    commonlib_setSharedPrefBoolean(KEY_RUN_CIRCLE_ENABLE, isChecked)
    gRunCircleSwitch = isChecked
    updateTotalCheckBoxState()
    updateItemDescTextColor(gRunCircleDescTextView, isChecked)
end

local function onShrinkCircleCheckChangeListener(checkBoxId, isChecked)
    commonlib_setSharedPrefBoolean(KEY_SHRINK_CIRCLE_ENABLE, isChecked)
    gShrinkCircleSwitch = isChecked
    updateTotalCheckBoxState()
    updateItemDescTextColor(gShrinkCircleDescTextView, isChecked)
    if isChecked == false then
        destoryTimerView()
    end
end

local function onDamagaNoticeCheckChangeListen(checkBoxId, isChecked)
    commonlib_setSharedPrefBoolean(KEY_DAMAGA_NOTICE_ENABLE, isChecked)
    gDamagaNoticeSwitch = isChecked
    updateTotalCheckBoxState()
    updateItemDescTextColor(gDamagaNoticeDescTextView, isChecked)
end

local function initSettingView()
    local settingView = commonlib_getSettingView()
    local tab = settingView:addTableView(TAB_NAME)

    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginRight = "40dp"
    paramValues.layout_marginLeft = "40dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    gShrinkCircleSwitch = getShrinkCircleSwitchState()
    gShrinkCircleCheckBox = tab:addCheckBoxView(SHRINK_CIRCLE_CHECKBOX_TEXT, gShrinkCircleSwitch, relativeLayoutParam, onShrinkCircleCheckChangeListener)
    if gShrinkCircleSwitch then
        report_gamemaster_game_pubgm_state(5, 1)
    else
        report_gamemaster_game_pubgm_state(5, 2)
    end

    paramValues.layout_below = gShrinkCircleCheckBox:getId()
    paramValues.layout_marginLeft = "65dp"
    paramValues.layout_marginTop = "12dp"
    paramValues.layout_width = "95dp"
    paramValues.layout_height = "42dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    local shrinkImg = tab:addImageView("img/setting_shrink_circle.png", relativeLayoutParam, nil)

    paramValues.layout_below = shrinkImg:getId()
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    relativeLayoutParam:setLayoutParam(paramValues)
    gShrinkCircleDescTextView = tab:addTextView(SHRINK_CIRCLE_DESC_TEXT,
            getTextColor(gShrinkCircleSwitch),
            "12sp",
            relativeLayoutParam,
            nil);

    paramValues.layout_below = gShrinkCircleDescTextView:getId()
    paramValues.layout_marginLeft = "40dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    gRunCircleSwitch = getRunCircleSwitchState()
    gRunCircleCheckBox = tab:addCheckBoxView(RUN_CIRCLE_CHECKBOX_TEXT, gRunCircleSwitch, relativeLayoutParam, onRunCircleCheckChangeListener)
    if gRunCircleSwitch then
        report_gamemaster_game_pubgm_state(4, 1)
    else
        report_gamemaster_game_pubgm_state(4, 2)
    end
    paramValues.layout_below = gRunCircleCheckBox:getId()
    paramValues.layout_marginLeft = "65dp"
    paramValues.layout_marginTop = "12dp"
    paramValues.layout_width = "193dp"
    paramValues.layout_height = "30dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    local runImg = tab:addImageView("img/setting_run_circle.png", relativeLayoutParam, nil)

    paramValues.layout_below = runImg:getId()
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    relativeLayoutParam:setLayoutParam(paramValues)
    gRunCircleDescTextView = tab:addTextView(RUN_CIRCLE_DESC_TEXT,
            getTextColor(gRunCircleSwitch),
            "12sp",
            relativeLayoutParam,
            nil);

    paramValues.layout_below = gRunCircleDescTextView:getId()
    paramValues.layout_marginLeft = "40dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    gDamagaNoticeSwitch = getDamagaNoticeSwitchState()
    gDamagaNoticeCheckBox = tab:addCheckBoxView(DAMAGA_NOTICE_CHECKBOX_TEXT, gDamagaNoticeSwitch, relativeLayoutParam, onDamagaNoticeCheckChangeListen)
    if gDamagaNoticeSwitch then
        report_gamemaster_game_pubgm_state(6, 1)
    else
        report_gamemaster_game_pubgm_state(6, 2)
    end

    paramValues.layout_below = gDamagaNoticeCheckBox:getId()
    paramValues.layout_marginLeft = "65dp"
    paramValues.layout_marginTop = "12dp"
    paramValues.layout_width = "193dp"
    paramValues.layout_height = "30dp"
    relativeLayoutParam:setLayoutParam(paramValues)
    gDamagaNoticeTipImageView = tab:addImageView("img/damaga_notice_tip_image.png", relativeLayoutParam, nil)

    paramValues.layout_below = gDamagaNoticeTipImageView:getId()
    paramValues.layout_marginLeft = "65dp"
    paramValues.layout_marginTop = "10dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    relativeLayoutParam:setLayoutParam(paramValues)
    gDamagaNoticeDescTextView = tab:addTextView(DAMAGA_NOTICE_DESC_TEXT,
            getTextColor(gDamagaNoticeSwitch),
            "12sp",
            relativeLayoutParam,
            nil);
end

local function uninitSettingView()
    if gShrinkCircleCheckBox ~= nil then
        gShrinkCircleCheckBox:destroy()
        gShrinkCircleCheckBox = nil
    end
    if gRunCircleCheckBox ~= nil then
        gRunCircleCheckBox:destroy()
        gRunCircleCheckBox = nil
    end

end

local function init()
    printLog("init")
    initVariable()
    reset()
    registerEvents()
    initSettingView()
end

local function uninit()
    unRegisterEvents()
    destoryTimerView()
    uninitSettingView()
    reset()
    uninitVariable()
    printLog("uninit")
end

--table.insert(common_life_circle_callbacks, { init, uninit, PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.run_circle });