--- pubgmhd_skin

local TAG = "pubgmhd_skin"
local gbInited = false;
local gNewGameEngine = nil;
local hasRecognizeArm = false;
local report_table_isrepored = false;

local function printLog(msg)
    commonlib_print(TAG, msg)
end

--- gamemaster_pubgm_skinshow:314 isshow:byte reason:byte
local function report_gamemaster_pubgm_skinshow(isshow, reason)
    commonlib_report(TABLE_NAME,
        {
            ["isshow"] = isshow,
            ["reason"]   = reason
        });

    printLog("report: " .. ", isshow: " .. tostring(isshow) .. ", reason: " .. tostring(reason))
end

--- gamemaster_game_skinchoose:275 package:string skinname:string
local function reportSkinChoose()
    local skinId = common_skin_getCurrentSkinId()
    if commonlib_isTextEmpty(skinId) == false then
        commonlib_reportSkinChoose(GAME_PUBGMHD_PKG_NAME, skinId);
    end
end


local function onSkinCheckboxSelected(isChecked)
    printLog("onSkinCheckboxSelected isChecked=" .. tostring(isChecked))
    if isChecked then
        notifyAssistSwitchToOpen(ASSIST_SHOW_TYPE_GUN_SKIN)
        notifyAssistSwitchToOpen(ASSIST_SHOW_TYPE_BOTTOM_GUN_SKIN)
        notifyAssistSwitchToOpen(ASSIST_SHOW_TYPE_BOTTOM_DRUG_SKIN)
        notifyAssistSwitchToOpen(ASSIST_SHOW_TYPE_STATIC_SKIN)
    end
end

local function isCovered()
    local cover = commonlib_getGameParam(KEY_GAME_RUNNING_COVER_STATUS);
    if cover ~= GAME_COVER_NONE then
        return true;
    end
    return false;
end

local function dealControlSkinCondtions()
    local cd_build_group_skin_arm = "cd_build_group_skin_arm"
    if hasRecognizeArm == false then
        gNewGameEngine:clearConditionCache(cd_build_group_skin_arm);
        hasRecognizeArm = gNewGameEngine:matchCondition(cd_build_group_skin_arm)
    end
end

local function skin_work()
    common_skin_work();
end

local function onEnterGame()
    printLog("onEnterGame")
    reportSkinChoose()
    hasRecognizeArm = false;
    report_table_isrepored = false;
    common_skin_createSkinData()
end

local function onGameRunning()
    local isCbSwitchSelected = common_skin_isSwitchOpen();

--    if not report_table_isrepored then
--        report_table_isrepored = true
--        if not isCbSwitchSelected then
--            report_gamemaster_pubgm_skinshow(2, 1)
--        else
--            report_gamemaster_pubgm_skinshow(1, 0)
--        end
--    end

    if isCbSwitchSelected == true and
            isCovered() == false then
        dealControlSkinCondtions();
    end
    skin_work();
end

local function onGameOver()
    printLog("onGameOver")
    skin_work();
    hasRecognizeArm = false;
    common_skin_clearSkinDataAndDestroySkin()
end

local function registerEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function unRegisterEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME], onEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_unRegisterSettingViewCloseCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
end

local function initVariable()
    gNewGameEngine = CNewGameEngine:getInstance()
end


local function init()
    printLog("skin script init")

    initVariable();
    registerEvents()
    common_skin_init();
    common_skin_setSkinSwitchCheckStatusCallback(onSkinCheckboxSelected)
    gbInited = true
end

local function uninit()
    printLog("skin script uninit")

    gbInited = false
    unRegisterEvents();
    common_skin_uninit();
end

table.insert(common_life_circle_callbacks, { init, uninit , PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.skin})