---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by xujinping.
--- DateTime: 2018/5/10 15:30
---

local gRecognizeAdapterManager;
local INVALID_KILL_NUM = -1;


local KILL_NUM_CONFIRM_COUNT = 3;
local confirmedKillNumber = 0;
local confirmedKillNumberCount = 0;

local ONCE_MAX_VALID_KILL_NUM = 3;---一次最大杀人数
local MIN_VALID_KILL_COUNT = 5;---最小有效杀人数

local VALID_CONTINUE_KILL_INTERVAL_TIME = 10 * 1000;---有效的连杀间隔时间
local  KILL_PREV_TIME = 5 * 1000;---杀人前5s
local KILL_AFTER_TIME = 2 * 1000;---杀人后2s

local firstContinueKillTime = 0;---第一次连杀的时间
local continueKillNum = 0; ---连杀人个数

local lastScreenRecorderTime = 0;---上次录屏时间

local lastKillNum = 0;---上次杀人数目
local lastKillTime = 0;---上次杀人时间

local screenRecorder;

local combineOutPath;

local FILE_NAME_SEPARATOR = "-"


local isInDetailPage = false;
local isInDetailPageCovered = false;

local KEY_IS_STIMULATE_MOMENT_TIPS_SHOW = "key_is_stimulate_moment_tips_show"
local ACTION_CLICK = "action_click";
local ACTION_CLOSE = "action_close";

local cbSwitch
local isCbSwitchChecked
local gloryTextView
local gloryTextView2
local gNewGameEngine

local VIDEO_TYPE = 11;

local TAG = "stimulate"
local function printLog(msg)
    commonlib_print(TAG, msg)
end
local DEBUG = commonlib_isLogWriteAble()

local STIMULATE_CLOUD_SWITCH_SECTION = "stimulate_cloud_switch_section";
local STIMULATE_CLOUD_SWITCH_KEY = "stimulate_cloud_switch_key_new";

local OP_SHOW = 1
local OP_CLICK = 2
local REPORT_TABLE_NAME = "gamemaster_pubgmhd_click"
local function report(op)
    commonlib_report(REPORT_TABLE_NAME,
            {
                ["op"] = op,
            });
end

---获取云控总开关
local function getCloudSwitch()
    local globalCloudSwitch = commonlib_getCloudConfigBoolValue(STIMULATE_CLOUD_SWITCH_SECTION,
            STIMULATE_CLOUD_SWITCH_KEY, false);
    if globalCloudSwitch == nil then
        globalCloudSwitch = false;
    end
    return globalCloudSwitch;
end

---初始化录屏
local function initScreenRecord()
    if screenRecorder == nil then
        screenRecorder = ScreenRecorder()
    end
    screenRecorder:init()
end

---开始录屏
local function startScreenRecord()
    if screenRecorder ~= nil then
        screenRecorder:start()
    end
end

---释放录屏资源
local function releaseScreenRecord()
    if screenRecorder ~= nil then
        screenRecorder:uninit()
    end
end

local function videoFileExists(outPath)
    return screenRecorder ~= nil and screenRecorder:videoFileIsExists(outPath)
end

---展示视频弹窗
local function canShowButton(outPath, killCount)
    if not isCbSwitchChecked then
        printLog("switch is close")
        return false;
    end

    if killCount < MIN_VALID_KILL_COUNT then
        printLog("杀人数:" .. tostring(killCount))
        return false;
    end


    if not videoFileExists(outPath) then
        printLog("no file path:" .. tostring(outPath))
        return false;
    end

    return true;

end

local gloryMomentFloatView
local gloryMomentView

local function dismissGloryMomentOnUIThread()
    commonlib_runOnUIThread(function ()
        printLog("dismissGloryMomentOnUIThread")
        if gloryMomentFloatView ~= nil then
            gloryMomentFloatView:destroy()
            gloryMomentFloatView = nil
        end
        if gloryMomentView ~= nil then
            gloryMomentView:destroy()
            gloryMomentView = nil
        end
    end)
end

local function isFullScreen()
    local solution = commonlib_getCommonAbTestSolution("section_glory_moment_fullscreen", true)
    printLog("solution : " .. tostring(solution))
    return solution ~= nil and  tostring(solution) == "1";
end

local function addGloryMomentView()
    if DEBUG then
        printLog("addGloryMomentView")
    end

    if isFullScreen() then
        gloryMomentFloatView = commonlib_getFloatViewMgrEx():create(
                0, 0,
                COMMON_LAYOUTPARAM.MATCH_PARENT, COMMON_LAYOUTPARAM.MATCH_PARENT,
                Anchor().TOPLEFT,
                true);
        gloryMomentFloatView:setGravity(Anchor().TOP);
    else
        local realScreenSize = commonlib_getScreenRealSize();
        local width = math.max(realScreenSize.w, realScreenSize.h)
        local height = math.min(realScreenSize.w, realScreenSize.h)
        printLog(tostring(realScreenSize.w).."_"..tostring(realScreenSize.h))
        printLog(tostring(width * 0.8).."_"..tostring(height*0.8))
        gloryMomentFloatView = commonlib_getFloatViewMgrEx():create(
                0, 0,
                width * 0.8 / commonlib_getScale(), height * 0.8 / commonlib_getScale(),
                Anchor().TOPLEFT,
                true);
        gloryMomentFloatView:setGravity(Anchor().CENTER);
    end
    gloryMomentView = gloryMomentFloatView:addGloryMomentView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top, 2, combineOutPath, VIDEO_TYPE, lastKillNum);
    gloryMomentView:setOnEventListener(function (action)
        printLog("on event ："  .. action)
        if action == "action_click_close" then
            dismissGloryMomentOnUIThread()
        end
    end)
    gloryMomentFloatView:show()
    gloryMomentFloatView:addStatusChangedListener(function(action)
        printLog("on status changed : " .. tostring(action))
        if gloryMomentView ~= nil then
            if action == "hide" then
                gloryMomentView:onPause()
            elseif action == "show" then
                gloryMomentView:onResume()
            end
        end
    end)
end

local stimulateContentView
local stimulateTipsView

local function removePlayButton()
    printLog("removeButton")
    commonlib_runOnUIThread(function()
        if stimulateContentView ~= nil then
            stimulateContentView:destroy()
            stimulateContentView = nil;
        end

        if stimulateTipsView ~= nil then
            stimulateTipsView:destroy()
            stimulateTipsView = nil
        end
    end)
end

local function addStimulateMomentView()
    if stimulateContentView ~= nil then
        printLog("stimulateContentView ~= nil")
        return
    end

    if gloryMomentFloatView ~= nil then
        printLog("gloryMomentFloatView ~= nil")
        return
    end
    local STIMULATE_RECT = gNewGameEngine:getConditionRect(KEY_STIMULATE_VIEW_RECT)
    local STIMULATE_TIPS_RECT = gNewGameEngine:getConditionRect(KEY_STIMULATE_TIPS_VIEW_RECT)
    if STIMULATE_RECT == nil or STIMULATE_TIPS_RECT == nil then
        printLog("STIMULATE_RECT == nil or STIMULATE_TIPS_RECT == nil")
        return
    end

    stimulateContentView = commonlib_getFloatViewMgrEx():create(
            STIMULATE_RECT.left, STIMULATE_RECT.top,
            STIMULATE_RECT.width, STIMULATE_RECT.height,
            STIMULATE_RECT.flag,
            true);
    local stimulateView = stimulateContentView:addStimulateMomentView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top);
    stimulateView:setOnEventListener(function (action)
        printLog("on event ："  .. action)
        if action == ACTION_CLICK then
            --removePlayButton()
            addGloryMomentView()
            report(OP_CLICK)
        end
    end)
    stimulateView:setStimulateInfo(combineOutPath, VIDEO_TYPE, lastKillNum)
    stimulateContentView:show();
    report(OP_SHOW)

    local hasShow = commonlib_getSharedPrefBoolean(KEY_IS_STIMULATE_MOMENT_TIPS_SHOW, false)

    if not hasShow then
        stimulateTipsView = commonlib_getUnClickableFloatView():addStimulateMomentTipsView(STIMULATE_TIPS_RECT.flag, STIMULATE_TIPS_RECT.left, STIMULATE_TIPS_RECT.top, ZOrder().zorder_top)
        stimulateTipsView:show()
        commonlib_setSharedPrefBoolean(KEY_IS_STIMULATE_MOMENT_TIPS_SHOW, true)
        if commonlib_isLogWriteAble() then
            printLog("show tips view")
        end
    end
    if commonlib_isLogWriteAble() then
        printLog("add play btn success")
    end
end

local function addPlayButton()
    if commonlib_isLogWriteAble() then
        printLog("addButton")
    end
    local canShowBtn = canShowButton(combineOutPath, lastKillNum);
    if not canShowBtn then
        return
    end
    commonlib_runOnUIThread(function()
        addStimulateMomentView()
    end)
end

local function buildSaveVideoPath(startTime, endTime, onceKillNum, totalKillNum)
    local path
    local fileName = totalKillNum .. FILE_NAME_SEPARATOR
            .. onceKillNum .. FILE_NAME_SEPARATOR .. (endTime - startTime)
    if screenRecorder ~= nil then
        local dir = screenRecorder:getContinuousKillTempDir()
        path = dir .. "/" .. fileName
    end
    return path
end

---保存一次杀人视频
local function saveOnceKillVideo(onceKillNum, totalKillNum)
    if screenRecorder ~= nil then
        local startTime = firstContinueKillTime - KILL_PREV_TIME
        local endTime = lastKillTime + KILL_AFTER_TIME
        local savePath = buildSaveVideoPath(startTime, endTime, onceKillNum, totalKillNum);
        screenRecorder:signalSaveOnceKillVideo(startTime, endTime, savePath)

        if commonlib_isLogWriteAble() then
            printLog("save video:" .. " startTime:" .. tostring(startTime)
                    .. " endTime:" .. tostring(endTime)
                    .. " savePath:" .. tostring(savePath))
        end
    end
end

---获取杀人个数，获取失败时返回-1
local function getKillNum()
    local killNumStr = gNewGameEngine:matchConditionOnString("cd_build_recognize_kill_number");
    if commonlib_isTextEmpty(killNumStr) then
        return INVALID_KILL_NUM
    end

    local killNum = tonumber(killNumStr)
    if killNum < 0 then
        return INVALID_KILL_NUM
    end

    return killNum
end

---设置录屏需要的时长
local function setScreenRecorderTime(continueKillNum)
    local curScreenRecorderTime = (continueKillNum + 1) * VALID_CONTINUE_KILL_INTERVAL_TIME
    if lastScreenRecorderTime ~= curScreenRecorderTime then
        if screenRecorder ~= nil then
            screenRecorder:setNeedRecorderMillis(curScreenRecorderTime)
        end
        lastScreenRecorderTime = curScreenRecorderTime
    end
end

---处理杀人逻辑
local function handleKill(isValidKillNum, currentTime, diffKillTime, diffKillNum)
    if isValidKillNum then
        if continueKillNum > 0 and lastKillNum > 0 and diffKillTime > VALID_CONTINUE_KILL_INTERVAL_TIME then
            saveOnceKillVideo(continueKillNum, lastKillNum)
            continueKillNum = 0
        end

        if diffKillNum > 0 then
            if continueKillNum == 0 then
                firstContinueKillTime = currentTime
            end
            continueKillNum = continueKillNum + diffKillNum
            if commonlib_isLogWriteAble() then
                printLog("continueKillNum:" .. tostring(continueKillNum))
            end
        end
    end

    setScreenRecorderTime(continueKillNum)
end

---重置数据
local function resetData()
    confirmedKillNumber = 0;
    confirmedKillNumberCount = 0;

    firstContinueKillTime = 0;
    lastScreenRecorderTime = 0;
    continueKillNum = 0;

    lastKillTime = 0;
    lastKillNum = 0;

    combineOutPath = nil

    isInDetailPage = false;
end

local function deleteCacheFile()
    if screenRecorder ~= nil then
        screenRecorder:deleteHonourCacheVideo()
        screenRecorder:deleteKillAssistDeathTempDir()
    end
end

local function onGameStart()
    printLog("onGameStart: isCbSwitchChecked:" .. tostring(isCbSwitchChecked))
    resetData()
    if isCbSwitchChecked then
        initScreenRecord()
        startScreenRecord()
    end
    deleteCacheFile()
end

local function onGameRunning()
    if not isCbSwitchChecked then
        return
    end

    local cover = commonlib_getGameParam(KEY_GAME_RUNNING_COVER_STATUS);
    if cover ~= GAME_COVER_NONE and cover ~= GAME_COVER_MAP_EXPAND then
        if DEBUG then
            printLog("全屏覆盖，不识别")
        end
        return;
    end

    local curKillNum = getKillNum()
    if (confirmedKillNumber ~= curKillNum) then
        confirmedKillNumber = curKillNum
        confirmedKillNumberCount = 1
    else
        confirmedKillNumberCount = confirmedKillNumberCount + 1
    end

    if DEBUG then
        printLog("curKillNum=>" .. tostring(curKillNum) .. " lastKillNum=>" .. tostring(lastKillNum))
    end

    local diffKillNum = curKillNum - lastKillNum
    local currentTime = commonlib_getCurrentTime()
    local diffKillTime = currentTime - lastKillTime
    local isValidKillNum = curKillNum ~= INVALID_KILL_NUM
            and confirmedKillNumberCount >= KILL_NUM_CONFIRM_COUNT
            and diffKillNum <= ONCE_MAX_VALID_KILL_NUM

    ----修正lastKillNum ：正常情况是 currentKillNum >= lastKillNum
    if isValidKillNum and diffKillNum < 0 then
        if DEBUG then
            printLog("识别错误: curKillNum=>" .. tostring(curKillNum) .. " lastKillNum=>" .. tostring(lastKillNum))
        end
        lastKillNum = curKillNum
        continueKillNum = 0
        diffKillNum = 0
    end

    if isValidKillNum and diffKillNum > 0 then
        lastKillTime = currentTime
        lastKillNum = curKillNum
        if commonlib_isLogWriteAble() then
            printLog("有新的杀人，diffKillNum=>" .. tostring(diffKillNum) .. " lastKillTime=>" .. tostring(lastKillTime) .. " diffKillTime" .. tostring(diffKillTime))
        end
    end

    handleKill(isValidKillNum, currentTime, diffKillTime, diffKillNum)

end

local function getSavePath(type, killCount)
    local path
    local fileName = type .. FILE_NAME_SEPARATOR
            .. 999 .. FILE_NAME_SEPARATOR
            .. killCount .. FILE_NAME_SEPARATOR
            .. commonlib_getCurrentTime() .. ".mp4"
    if screenRecorder ~= nil then
        local dir = screenRecorder:getHonourVideoTempDir()
        path = dir .. "/" .. fileName
    end
    if commonlib_isLogWriteAble() then
        printLog("save path:" .. tostring(path))
    end
    return path
end

---拼接视频成功回调
local function combineVideoSuccessCallback()
    printLog("拼视频成功")
    if commonlib_isLogWriteAble() then
        printLog("isInDetailPage:" .. tostring(isInDetailPage) .. "isInDetailPageCovered:" .. tostring(isInDetailPageCovered))
    end
    if isInDetailPage == true and isInDetailPageCovered == false then
        addPlayButton()
    end
end

---拼接视频
local function combineVideo()
    if commonlib_isLogWriteAble() then
        printLog("screenRecorder:" .. tostring(screenRecorder) .. "lastKillNum:" .. tostring(lastKillNum))
    end
    if screenRecorder ~= nil and lastKillNum >= MIN_VALID_KILL_COUNT then
        local dir = screenRecorder:getContinuousKillTempDir()
        combineOutPath = getSavePath(VIDEO_TYPE, lastKillNum)
        screenRecorder:combineStimulateVideo(dir, combineOutPath, combineVideoSuccessCallback)
    end
end

---游戏结束时，尝试保存游戏结束还没来得及保存的一杀视频
local function saveOnceKillVideoOnGameOver()
    local diffTime = commonlib_getCurrentTime() - lastKillTime
    if diffTime <= VALID_CONTINUE_KILL_INTERVAL_TIME and continueKillNum > 0 and lastKillNum >= MIN_VALID_KILL_COUNT then
        saveOnceKillVideo(continueKillNum, lastKillNum)
    end
    if commonlib_isLogWriteAble() then
        printLog("diffTime:" .. tostring(diffTime) .. " continueKillNum:" .. tostring(continueKillNum)
                .. " lastKillTime:" .. tostring(lastKillTime)
                .. " lastKillNum:" .. tostring(lastKillNum))
    end
end

local function onGameOver()
    printLog("onGameOver")
    saveOnceKillVideoOnGameOver()
    combineVideo()
    releaseScreenRecord()
    commonlib_reportGameData(2, 1, lastKillNum)
end


local function onInGameOverPage(lastGameState, currentState)
    if commonlib_isLogWriteAble() then
        printLog("lastGameState:" .. tostring(lastGameState) .. " currentState:" .. tostring(currentState))
    end

    if currentState == PUBGMHD_GAMESTATE_UNKNOW then
        isInDetailPageCovered = true;
    else
        isInDetailPageCovered = false;
    end

    if not isInDetailPage then
        if isInDetailPageCovered == false then
            isInDetailPage = gNewGameEngine:matchCondition(KEY_SM_IN_GAMEOVER_DETAIL_PAGE_RECT);
        end
        printLog("isInDetailPage="..commonlib_toString(isInDetailPage))
        if isInDetailPage then
            addPlayButton()
        end
    else
        if isInDetailPageCovered == true then
            removePlayButton()
        else
            addPlayButton()
        end
    end
end

local function onGameStateChanged(lastGameState, currentGameState)
    printLog("onGameStateChanged:currentGameState=" ..
            commonlib_toString(currentGameState)..
            ",isInDetailPage="..commonlib_toString(isInDetailPage))
    if (currentGameState ~= PUBGMHD_GAMESTATE_OVER and isInDetailPage == true) then
        isInDetailPage = false;
        removePlayButton()
    end
end


local function getTextColor(enable)
    if enable == true then
        return "#FF00DEFF";
    else
        return "#FF979797";
    end
end

local function setTextViewColorBySwitch(textView, switchOpen)
    if textView == nil or switchOpen == nil then
        return;
    end
    textView:setTextColor(getTextColor(switchOpen));
end

local function onCheckChangeListener(checkboxId, isChecked)
    if DEBUG then
        printLog("onCheckChangeListener" .. tostring(isChecked))
    end
    isCbSwitchChecked = isChecked
    setTextViewColorBySwitch(gloryTextView, isCbSwitchChecked);
    setTextViewColorBySwitch(gloryTextView2, isCbSwitchChecked);

    commonlib_setSharedPrefBoolean(SP_IS_STIMULATE_MOMENT_ENABLE, isCbSwitchChecked)
    onStimulateMomentSettingsChange(isChecked)
    if isChecked then
        initScreenRecord()
        startScreenRecord()
    end
end

local function initSettingView()
    local TAB_NAME = "刺激时刻"
    local settingView = commonlib_getSettingView()
    local tableView = settingView:addTableView(TAB_NAME)

    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    relativeLayoutParam:setLayoutParam(paramValues)

    --local isEnable = commonlib_isGameVideoRecorderABTestEnable(true);
    isCbSwitchChecked = getStimulateMomentState()
    cbSwitch = tableView:addCheckBoxView(TAB_NAME, isCbSwitchChecked, relativeLayoutParam, onCheckChangeListener)

    local relativeLayoutParamText1 = create("RelativeLayoutParam");
    relativeLayoutParamText1:setLayoutParam({
        layout_marginTop = "20dp",
        layout_marginLeft = "40dp",
        layout_marginRight = "40dp",
        layout_below = cbSwitch:getId(),
    });

    gloryTextView = tableView:addTextView("开启后将自动记录你在对战中击败对手、最终决胜等精彩瞬间，并剪辑成视频。录制的视频会保存在游戏超人-我-精彩时刻内部",
            getTextColor(isCbSwitchChecked),
            "12sp",
            relativeLayoutParamText1,
            nil);

    local relativeLayoutParamText2 = create("RelativeLayoutParam");
    relativeLayoutParamText2:setLayoutParam({
        layout_marginTop = "20dp",
        layout_marginLeft = "40dp",
        layout_marginRight = "40dp",
        layout_below = gloryTextView:getId(),
    });
    gloryTextView2 = tableView:addTextView("杀人数>=5人时会自动录制刺激时刻",
            getTextColor(isCbSwitchChecked),
            "12sp",
            relativeLayoutParamText2,
            nil);
end

local function registerEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_STATUS_CHANGED], onGameStateChanged)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
    commonlib_registerCallback(common_game_events_callbacks[KEY_ENTER_GAME], onGameStart)
    commonlib_registerCallback(common_game_events_callbacks[KEY_IN_GAME_OVER_PAGE], onInGameOverPage)
end

local function unRegisterEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_STATUS_CHANGED], onGameStateChanged)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_OVER], onGameOver)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_ENTER_GAME], onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_IN_GAME_OVER_PAGE], onInGameOverPage)
end

local function initData()
    gRecognizeAdapterManager = AdapterManagerClass:getRecognizeInstance();
    gNewGameEngine = CNewGameEngine:getInstance()
end

local function init()
    printLog("init")
    local cloudSwitch = getCloudSwitch()
    ---测试代码
    --cloudSwitch = true
    if not cloudSwitch then
        printLog("云控总开关未开")
        return
    end
    initData()
    initSettingView()
    registerEvents()
end

local function uninit()
    printLog("uninit")
    unRegisterEvents()
end

--table.insert(common_life_circle_callbacks, { init, uninit, PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.stimulate_moment });