---
-- Created by IntelliJ IDEA.
-- User: hexujun
-- Date: 2018/7/25
-- Time: 11:23
-- To change this template use File | Settings | File Templates.
--
local gNewGameEngine;

local TEAMUP_TAG              = "teamup_lua"

local CONFIG_GAME_ID_PUBGMHD = "com.tencent.tmgp.pubgmhd";

local SP_KEY_GAME_START             = "assist_start_params";
local KEY_START_PARAM_JSON          = "json";
local KEY_START_GAME_SRC            = "src";
local SRC_TEAMUP_GUIDE_START_GAME   = "src_teamup_guide";
local SRC_TEAMUP_SUCCEED_START_GAME = "src_teamup_suc";
local KEY_START_GAME_TIME           = "time";
local KEY_START_GAME_ID             = "gameId";

local PARAM_VALID_TIME        = 5 * 60 * 1000

local TIP_LOCALION_FRAME_IMG  = "img/teamup_tip_frame.9.png"
local RIGHT_SQUARE_WH         = { w = 78,  h = 96, path = "img/teamup_tip_link.png" }
local RIGHT_LINK_WH           = { w = 5 ,  h = 14, path = "" }
local RIGHT_ARROWUP_TEXT_WH   = { w = 510, h = 74, path = "img/teamup_invite_friend.png" }
local RIGHT_ARROWDOWN_TEXT_WH = { w = 532, h = 78, path = "img/teamup_face.png" }
local QRCODE_VIEW_LAYOUT_WH   = { w = 942, h = 376 }


local TEST_ENABLE = false

local gSrc
local gTime
local gGameId
local gGameStartParam
local gbParseParamSucceed

local gbShowQRCodeTip
local gbShowArrowupTip
local gbShowArrowdownTip

local gViewQRCodeTip
local gViewArrowupTip
local gViewArrowdownTip

local gUnClickFloatView
local gfScaleRelativeTo1080

local gHomeModeRecognizeCondition;

local showQRCodeTime = 0
local isReportCodeQcr = false
local DELAY_REPORT_QR_CODE = 1000

local function printLog(msg)
    commonlib_print(TEAMUP_TAG, msg)
end

--gamemaster_code_ocr:410 code:byte uptime2:int
local function reportGamemasterCodeOcr(code)
    if isReportCodeQcr then
        return
    end

    commonlib_report("gamemaster_code_ocr",
            {
                ["code"] = code,
            });
    isReportCodeQcr = true
    printLog("report gamemaster_code_ocr, code:" .. tostring(code))
end

local function resetReport()
    showQRCodeTime = 0
    isReportCodeQcr = false
end

--gamemaster_teamup_invite:424 page:byte op:byte uptime2:int
local PAGE_IN_HOME = 1;
local PAGE_INVITE_FRIEND = 2;
local PAGE_TEAM_UP = 3;
local PAGE_QRCODE_SHOW = 4;
local PAGE_ENTER_GAME__TEAMUP_GUIDE    = 5;
local PAGE_ENTER_GAME__TEAMUP_SUCCEED  = 6;
local PAGE_ENTER_GAME__NORMAL          = 7;
local PAGE_GAME_RUNNING_TEAMUP_GUIDE   = 8;
local PAGE_GAME_RUNNING_TEAMUP_SUCCEED = 9;
local PAGE_GAME_RUNNING_NORMAL         = 10;
local PAGE_ENTER_TOTAL         = 11;
local PAGE_IN_HOME_TOTAL         = 12;

local reportInHomeTotal = false;
local reportInHome = false;
local reportInQRCode = false;
local reportInGameRunning = false;
local function reportTipsShow(page)

end

local function resetReportTipsShow()
    reportInQRCode = false
    reportInHome = false
    reportInGameRunning = false
    reportInHomeTotal = false;

end

local function updateLocalData(src, gameId, time, succeed)
    gbParseParamSucceed = succeed
    gSrc  = src
    gTime = time
    gGameId = gameId
end

local function resetShow()
    gbShowQRCodeTip    = nil
    gbShowArrowupTip   = nil
    gbShowArrowdownTip = nil
end

local function parseGameStartParam()

    if true == TEST_ENABLE then
        printLog("parseGameStartParam test")
        resetShow()
        updateLocalData(SRC_TEAMUP_GUIDE_START_GAME, CONFIG_GAME_ID_PUBGMHD, commonlib_getCurrentTime(), true)
        return
    end

    local gameStartParamTable = commonlib_getStartParams()
    if nil == gameStartParamTable then
        updateLocalData(nil, nil, nil, false); -- 无数据，需要清空本地内存记录
        printLog("commonlib_getStartParams error")
        return
    end

    local gameStartParam = gameStartParamTable[KEY_START_PARAM_JSON]
    if true == commonlib_isTextEmpty(gameStartParam) then
        updateLocalData(nil, nil, nil, false); -- 无数据，需要清空本地内存记录
        printLog("parseGameStartParam error")
        return
    end

    if nil ~= gGameStartParam and gGameStartParam == gameStartParam then
        printLog("parseGameStartParam, param is not changed")
        return
    end

    printLog("parseGameStartParam, reset data, new_data:" .. gameStartParam)
    updateLocalData(nil, nil, nil, false);
    resetShow()

    if nil == gameStartParamTable[KEY_START_GAME_SRC]
            or nil == gameStartParamTable[KEY_START_GAME_TIME]
            or nil == gameStartParamTable[KEY_START_GAME_ID] then
        printLog("parseGameStartParam, decode json, data error")
        return
    end

    updateLocalData(
        gameStartParamTable[KEY_START_GAME_SRC],
        gameStartParamTable[KEY_START_GAME_ID],
        gameStartParamTable[KEY_START_GAME_TIME],
        true);
    gGameStartParam = gameStartParam

    printLog("parseGameStartParam succeed, src:" .. gSrc .. ", time:" .. tostring(gTime) .. ", gameId:" .. gGameId)
end

local function checkParam(src, gameId, time)
    if true ~= gbParseParamSucceed then
        return GAME_START_SRC_UNKNOWN
    end

    if commonlib_isTextEmpty(gameId) or commonlib_isTextEmpty(src) or nil == time then
        return GAME_START_SRC_UNKNOWN
    end

    local myGameId = commonlib_getGameId()
    if gameId ~= myGameId or (src ~= SRC_TEAMUP_GUIDE_START_GAME and src ~= SRC_TEAMUP_SUCCEED_START_GAME) then
        return GAME_START_SRC_UNKNOWN
    end

    local diff = commonlib_getCurrentTime() - tonumber(time);
    local bRet = (diff >= 0 and diff <= PARAM_VALID_TIME)
    if true == bRet then
        if src == SRC_TEAMUP_GUIDE_START_GAME then
            return GAME_START_SRC_TEAMUP_GUIDE
        elseif src == SRC_TEAMUP_SUCCEED_START_GAME then
            return GAME_START_SRC_TEAMUP_SUCCEED
        end
    end

    return GAME_START_SRC_UNKNOWN
end

local function registerResume()
    commonlib_registerResume(TEAMUP_TAG, function()
        printLog("onResume")
        resetReportTipsShow()
        parseGameStartParam()
        --上传所有启动游戏的次数
        reportTipsShow(PAGE_ENTER_TOTAL)


        local nSrc   = checkParam(gSrc, gGameId, gTime)
        commonlib_updateCurrentGameStartSrc(gGameId, nSrc)
        if GAME_START_SRC_TEAMUP_GUIDE == nSrc then
            --从邀请组队进入游戏
            reportTipsShow(PAGE_ENTER_GAME__TEAMUP_GUIDE)
        elseif GAME_START_SRC_TEAMUP_SUCCEED == nSrc then
            --点击链接进入游戏
            reportTipsShow(PAGE_ENTER_GAME__TEAMUP_SUCCEED)
        else
            --其他入口进入游戏
            reportTipsShow(PAGE_ENTER_GAME__NORMAL)
        end
    end)
end

local function unregisterResume()
    commonlib_unregisterResume(TEAMUP_TAG)
end



local function destroyAll()
    commonlib_destroyView(gViewArrowupTip)
    gViewArrowupTip = nil

    commonlib_destroyView(gViewArrowdownTip)
    gViewArrowdownTip = nil

    commonlib_destroyView(gViewQRCodeTip)
    gViewQRCodeTip = nil
end

local function destroyArrowdownTipOnUiThread()
    if nil == gViewArrowdownTip then
        return
    end

    commonlib_runOnUIThread(function()
        printLog("destroyArrowdownTipOnUiThread")
        commonlib_destroyView(gViewArrowdownTip)
        gViewArrowdownTip = nil
    end)
end

local function destroyArrowupTipOnUiThread()
    if nil == gViewArrowupTip then
        return
    end

    commonlib_runOnUIThread(function()
        printLog("destroyArrowupTipOnUiThread")
        commonlib_destroyView(gViewArrowupTip)
        gViewArrowupTip = nil
    end)
end

local function destroyArrowTipOnUiThread()
    if nil == gViewArrowupTip and nil == gViewArrowdownTip then
        return
    end

    commonlib_runOnUIThread(function()
        printLog("destroyArrowTipOnUiThread")
        commonlib_destroyView(gViewArrowupTip)
        gViewArrowupTip = nil

        commonlib_destroyView(gViewArrowdownTip)
        gViewArrowdownTip = nil
    end)
end

local function destroyAllOnUiThread()

    if nil == gViewArrowupTip and nil == gViewArrowdownTip and nil == gViewQRCodeTip then
        return
    end

    commonlib_runOnUIThread(function()
        printLog("destroyAllOnUiThread")
        destroyAll()
    end)
end

local function getLinkLayoutRect(frameRect)
    local linkRect = {
        flag   = frameRect.flag,
        left   = frameRect.left + frameRect.width - RIGHT_LINK_WH.w,
        top    = frameRect.top - (RIGHT_SQUARE_WH.h + RIGHT_LINK_WH.h / 2),
        width  = RIGHT_SQUARE_WH.w,
        height = RIGHT_SQUARE_WH.h }
    return linkRect
end

local function getTextLayoutRect(linkRect, textWH)
    local textRect = {
        flag   = linkRect.flag,
        left   = linkRect.left,
        top    = linkRect.top - RIGHT_SQUARE_WH.h - textWH.h,
        width  = textWH.w,
        height = textWH.h }
    return textRect
end

local function createTipView(frameRect, textWH)
    if nil == frameRect or nil == textWH or nil == gUnClickFloatView then
        printLog("createTipView, param error")
        return;
    end

    printLog("createTipView!!!!!")

    local layoutView = gUnClickFloatView:addSGameFloatViewControl(ZOrder().zorder_bottom)
    if nil == layoutView then
        printLog("createTipView, addSGameFloatViewControl error")
        return
    end

    ---String src, int anchor, int x, int y, int width, int height, int zOrder

    local imageView  = layoutView:addZoomImageView(TIP_LOCALION_FRAME_IMG,
        frameRect.flag,
        frameRect.left,
        frameRect.top,
        frameRect.width,
        frameRect.height,
        ZOrder().zorder_bottom, true)
    if nil == imageView then
        printLog("createImageView, create imageview error")
        commonlib_destroyView(layoutView)
        return
    end

    local imageRect = getLinkLayoutRect(frameRect)
    imageView  = layoutView:addZoomImageView(RIGHT_SQUARE_WH.path,
        imageRect.flag,
        imageRect.left,
        imageRect.top,
        imageRect.width,
        imageRect.height,
        ZOrder().zorder_bottom, false)
    if nil == imageView then
        printLog("createImageView, create imageview2 error")
        commonlib_destroyView(layoutView)
        return
    end

    local imageRect = getTextLayoutRect(imageRect, textWH)
    imageView  = layoutView:addImageView(textWH.path,
        imageRect.flag,
        imageRect.left,
        imageRect.top,
        imageRect.width,
        imageRect.height,
        ZOrder().zorder_bottom)
    if nil == imageView then
        printLog("createImageView, create imageview3 error")
        commonlib_destroyView(layoutView)
        return
    end

--    layoutView:setBackgroundColor("#7F87CEFA") --- TODO
    layoutView:show();

    printLog("createTipView succeed")
    return layoutView
end

local function createQRCodeTipView(qrCode, gameId)
    ---自定义view
    local realScreenSize = commonlib_getScreenRealSize()
    if nil == realScreenSize or nil == gfScaleRelativeTo1080 or gfScaleRelativeTo1080 <= 0 then
        printLog("createQRCodeTipView getScreenRealSize error")
        return
    end

    local screenW = realScreenSize.w
    local screehH = realScreenSize.h
    if realScreenSize.w < realScreenSize.h then
        screenW = realScreenSize.h
        screehH = realScreenSize.w
    end

    local layoutRect = {
        flag   = Anchor().TOPLEFT ,
        left   = ((screenW / gfScaleRelativeTo1080) - QRCODE_VIEW_LAYOUT_WH.w) / 2,
        top    = ((screehH / gfScaleRelativeTo1080) - QRCODE_VIEW_LAYOUT_WH.h) / 2,
        width  = QRCODE_VIEW_LAYOUT_WH.w,
        height = QRCODE_VIEW_LAYOUT_WH.h }

    local layoutView = commonlib_getFloatViewMgrEx():create(
        layoutRect.left,
        layoutRect.top,
        layoutRect.width,
        layoutRect.height,
        layoutRect.flag,
        true)
    if nil == layoutView then
        printLog("createQRCodeTipView create layout error")
        return
    end

    local qrcodeView = layoutView:addTeamupQRCodeTipView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top)
    if nil == qrcodeView then
        commonlib_destroyView(layoutView)
        printLog("createQRCodeTipView addTeamupQRCodeTipView error")
        return
    end

    qrcodeView:setQRCodeUrl(qrCode)
    qrcodeView:setGameId(gameId)
    qrcodeView:setCallback(function(clickType)
        printLog("close qrcode dialog, clickType:" .. tostring(clickType))
        destroyAllOnUiThread()
    end)

    layoutView:show();

    printLog("createQRCodeTipView addTeamupQRCodeTipView succeed")

    return layoutView
end

local function showArrowupTipView()
    resetReport()
    commonlib_runOnUIThread(function()
        if nil ~= gViewArrowupTip then
            gViewArrowupTip:show()
            printLog("showArrowupTipView, show")
            return
        end

        local frameRect = gNewGameEngine:getConditionRect(KEY_HOME_ARROW_UP_RECT);
        if frameRect == nil then
            printLog("showArrowupTipView, KEY_HOME_ARROW_UP_RECT can not found");
        end

        gViewArrowupTip = createTipView(frameRect, RIGHT_ARROWUP_TEXT_WH)

        printLog("showArrowupTipView, create return " .. tostring(nil ~= gViewArrowupTip));
    end)
end

local function showArrowdownTipView()
    resetReport()
    commonlib_runOnUIThread(function()
        if nil ~= gViewArrowdownTip then
            gViewArrowdownTip:show()
            printLog("showArrowdownTipView, show")
            return
        end

        local leftRect = gNewGameEngine:getConditionRect(KEY_HOME_ARROW_DOWN_RECT)
        if leftRect == nil then
            printLog("showArrowupTipView, KEY_HOME_ARROW_DOWN_RECT can not found");
        end

        gViewArrowdownTip = createTipView(leftRect, RIGHT_ARROWDOWN_TEXT_WH)

        printLog("showArrowdownTipView, create return " .. tostring(nil ~= gViewArrowdownTip))
    end)
end

local function showQRCodeTipView(qrCode, gameId)
    commonlib_runOnUIThread(function()
        printLog("showQRCodeTipView, create")
        gViewQRCodeTip = createQRCodeTipView(qrCode, gameId)
    end)
end

local function onGameOnceStatusUnknow(nowStatus)
    printLog("onGameOnceStatusUnknow")
    if nowStatus ~= PUBGMHD_GAMESTATE_IN_GAMEHOME then
        printLog("onGameOnceStatusUnknow, status error")
        return;
    end
    --上报所有进入游戏大厅大次数
    if reportInHomeTotal == false then
        reportInHomeTotal = true
        reportTipsShow(PAGE_IN_HOME_TOTAL)
    end

    destroyArrowTipOnUiThread()

    if gbShowQRCodeTip == true then
        printLog("onGameOnceStatusUnknow, showQRCode")
        return;
    end

    local time   = gTime
    local gameId = gGameId
    local src    = gSrc
    if GAME_START_SRC_TEAMUP_GUIDE ~= checkParam(src, gameId, time) then
        printLog("onGameOnceStatusUnknow, checkParam error")
        return
    end

    ---此处也需要上报in home，此处也是在游戏大厅
    if reportInHome == false then
        reportInHome = true
        reportTipsShow(PAGE_IN_HOME)
    end

    ---识别二维码是否打开
    local bRet = gNewGameEngine:matchCondition(KEY_HOME_QR_CODE_OPEN);
    if true ~= bRet then
        printLog("onGameOnceStatusUnknow, qrcode is not open")
        return
    end

    if reportInQRCode == false then
        reportInQRCode = true
        reportTipsShow(PAGE_QRCODE_SHOW)
    end

    ---识别二维码
    local qrCode  = gNewGameEngine:matchConditionOnString(KEY_HOME_QR_CODE);
    if commonlib_isTextEmpty(qrCode) then
        printLog("onGameOnceStatusUnknow, get qrcode error")
        if showQRCodeTime <= 0 or showQRCodeTime > commonlib_getCurrentTime() then
            showQRCodeTime = commonlib_getCurrentTime()
        end
        if commonlib_getCurrentTime() - showQRCodeTime > DELAY_REPORT_QR_CODE then
            local uploadFilename = "pubgmhd_qr_code"
            uploadBitmapMat("cd_build_rect_home_qr_code_rect", uploadFilename , SHOT_SCREEN_FOR_MAT_TYPE.pubgmhd_teamup_qr_code)
            reportGamemasterCodeOcr(2)
        end
        return
    end
    isReportCodeQcr = false
    reportGamemasterCodeOcr(1)

    printLog("onGameOnceStatusUnknow, get qrcode succeed, qrcode:" .. qrCode)
    gbShowQRCodeTip = true
    showQRCodeTipView(qrCode, gameId)

    commonlib_setGlobalSharedPrefString(SP_KEY_GAME_START, "");
end

local function checkHomeHeachingIcon()
    local result = false

    if gHomeModeRecognizeCondition == nil then
        gNewGameEngine:clearConditionCache("cd_build_group_home_default_mode")
        result = gNewGameEngine:matchCondition("cd_build_group_home_default_mode")
        if result then
            gHomeModeRecognizeCondition = "cd_build_home_teaching_icon_default_mode";
        else
            result = gNewGameEngine:clearConditionCache("cd_build_group_home_smooth_mode")
            result = gNewGameEngine:matchCondition("cd_build_group_home_smooth_mode")
            if result then
                gHomeModeRecognizeCondition = "cd_build_home_teaching_icon_smooth_mode";
            end
        end
    else
        result = gNewGameEngine:matchCondition(gHomeModeRecognizeCondition)
    end

    printLog("checkHomeHeachingIcon, result=" .. tostring(result) .. ", conditon=" .. tostring(gHomeModeRecognizeCondition))
    return result
end

local function onGameInHome()

    printLog("onGameInHome")

    --上报所有进入游戏大厅大次数
    if reportInHomeTotal == false then
        reportInHomeTotal = true
        reportTipsShow(PAGE_IN_HOME_TOTAL)
    end

    if gbShowQRCodeTip == true then
        printLog("onGameInHome, showQRCode")
        return;
    end

    local time   = gTime
    local gameId = gGameId
    local src    = gSrc
    if GAME_START_SRC_TEAMUP_GUIDE ~= checkParam(src, gameId, time) then
        printLog("onGameInHome, checkParam error")
        return
    end
    if reportInHome == false then
        reportInHome = true
        reportTipsShow(PAGE_IN_HOME)
    end

    --- 邀请好友窗口是否收起
    local bRet = checkHomeHeachingIcon();
    printLog("onGameInHome, recognize arrowup " .. tostring(bRet))
    if true == bRet then

        --- 识别到Arrowup的处理
        destroyArrowdownTipOnUiThread()
        if true ~= gbShowArrowupTip and true ~= gbShowArrowdownTip then
            gbShowArrowupTip = true
            showArrowupTipView()
            reportTipsShow(PAGE_INVITE_FRIEND)
        end

        return;
    end

    --- 识别不到Arrowup的处理
    destroyArrowupTipOnUiThread()

    --- 邀请好友窗口是否打开
    local bRet = gNewGameEngine:matchCondition(KEY_HOME_INVITATION_ICON);
    printLog("onGameInHome, recognize arrowdown " .. tostring(bRet))
    if true == bRet then

        --- 识别到Arrowdown的处理
        if true ~= gbShowArrowdownTip then
            gbShowArrowdownTip = true
            showArrowdownTipView()
            reportTipsShow(PAGE_TEAM_UP)
        end

        return;
    end

    --- 识别不到Arrowdown的处理
    destroyArrowdownTipOnUiThread()
end

local function reportOnGameRunning()
    if reportInGameRunning == false then
        reportInGameRunning = true

        local nSrc = checkParam(gSrc, gGameId, gTime)
        if GAME_START_SRC_TEAMUP_GUIDE == nSrc then
            reportTipsShow(PAGE_GAME_RUNNING_TEAMUP_GUIDE)
        elseif GAME_START_SRC_TEAMUP_SUCCEED == nSrc then
            reportTipsShow(PAGE_GAME_RUNNING_TEAMUP_SUCCEED)
        else
            reportTipsShow(PAGE_GAME_RUNNING_NORMAL)
        end
    end
end

local function onGameRunning()
    destroyAllOnUiThread()
    reportOnGameRunning()
end

local function onGameStatusChanged(statusOld, statusNow)
    printLog("onGameStatusChanged")
    if statusNow ~= PUBGMHD_GAMESTATE_IN_GAMEHOME then
        ---进入其他游戏状态：隐藏引导view
        printLog("onGameStatusChanged, destroyAllOnUiThread")
        destroyAllOnUiThread()
    end
end

local function registerEvents()
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_STATUS_CHANGED], onGameStatusChanged)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_ONCE_STATUS_UNKNOW], onGameOnceStatusUnknow)
    commonlib_registerCallback(common_game_events_callbacks[KEY_IN_GAME_HOME], onGameInHome)
    commonlib_registerCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
end

local function unRegisterEvents()
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_STATUS_CHANGED], onGameStatusChanged)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_ONCE_STATUS_UNKNOW], onGameOnceStatusUnknow)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_IN_GAME_HOME], onGameInHome)
    commonlib_unregisterCallback(common_game_events_callbacks[KEY_GAME_RUNNING], onGameRunning)
end

local function initVariable()
    gUnClickFloatView = commonlib_getUnClickableFloatView()
    gfScaleRelativeTo1080 = commonlib_getScale()
    gNewGameEngine = CNewGameEngine:getInstance();
    gHomeModeRecognizeCondition = nil;
    resetReport()
end

local function uninitVariable()
    gUnClickFloatView = nil
end

local function init()

    initVariable();
    registerEvents();
    registerResume();
end

local function uninit()
    unRegisterEvents()
    unregisterResume()
    destroyAll()
    uninitVariable()
end

--table.insert(common_life_circle_callbacks, { init, uninit, PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.teamup });

