--- 战斗技巧脚本
local A = { ["flag"] = Anchor().CENTER, ["left"] = -681, ["top"] = -212, ["width"] = 250, ["height"] = 30 };
local B = { ["flag"] = Anchor().CENTER, ["left"] = -404, ["top"] = -212, ["width"] = 250, ["height"] = 30 };
local C = { ["flag"] = Anchor().CENTER, ["left"] = -126, ["top"] = -212, ["width"] = 250, ["height"] = 30 };
local D = { ["flag"] = Anchor().CENTER, ["left"] = 152, ["top"] = -212, ["width"] = 250, ["height"] = 30 };
local E = { ["flag"] = Anchor().CENTER, ["left"] = 433, ["top"] = -212, ["width"] = 250, ["height"] = 30 };

local F = { ["flag"] = Anchor().CENTER, ["left"] = -681, ["top"] = 381, ["width"] = 250, ["height"] = 30 };
local G = { ["flag"] = Anchor().CENTER, ["left"] = -404, ["top"] = 381, ["width"] = 250, ["height"] = 30 };
local H = { ["flag"] = Anchor().CENTER, ["left"] = -126, ["top"] = 381, ["width"] = 250, ["height"] = 30 };
local I = { ["flag"] = Anchor().CENTER, ["left"] = 152, ["top"] = 381, ["width"] = 250, ["height"] = 30 };
local J = { ["flag"] = Anchor().CENTER, ["left"] = 433, ["top"] = 381, ["width"] = 250, ["height"] = 30 };

KEY_HERO_ID_LIST_STRING = "heroIdListStringKey"

local DETECT_HERO_ROLE_RECT_INFO = { A, B, C, D, E, F, G, H, I, J };

local FLOAT_WINDOW_POS_WHEN_LOADING = {
    anchor = Anchor().TOPRIGHT,
    x = -162,
    y = 235
}

local BATTLE_SKILL_VIEW_POS_WHEN_LOADING = {
    anchor = Anchor().TOPLEFT,
    x = 0,
    y = 0
}

--- 英雄类型
local HERO_TYPE_ENEMY = 1;
local HERO_TYPE_SELF = 2;

-- 一局游戏中是否已经做过英雄角色的检测
local hasDoDetectHeroRole = false;
local cbBattleSkill = nil;
local isCbBattleSkillChecked = true;

local battleSkillContainer = nil
local battleSkillView = nil;
local battleSkillView1 = nil;
local floatBall = nil;
local settingView = nil;
guideView = nil;

--- 战斗技巧界面
local hasSetHeroInfo = false;
local enemyHeroIdList = nil;
local currentHeroId = nil;

local gameAssistant;
local isServerHeroRecognize;

local funcCloudSwitch
local FUNC_CLOUD_SWITCH_KEY = "sgame_battle_skill_cloud_switch_key"

local showBattleSkillTime = 0

------- 打印Log --------
local LOG = "battle_skill";
local function printLog(msg)
    commonlib_print(LOG, msg);
end

local function moveFloatWindowTo(position)
    commonlib_runOnUIThread(function()
        floatBall:moveCenterTo(position.anchor, position.x, position.y);
    end)
end

local function destroyBattleSkillView()
    if battleSkillContainer ~= nil then
        battleSkillContainer:destroy()
        battleSkillContainer = nil
    end
    battleSkillView = nil
    printLog("destroyBattleSkillView")
end

------- 界面 View 相关
local function setBattleSkillViewListener()
    battleSkillView:setOnCloseBtnClickListener(function()
        printLog("battleSkillView 关闭按钮被点击");

        commonlib_runOnUIThread(function()
            commonlib_setFloatBallIcon("img/icon_floatball.png");
            commonlib_setFloatBallDragAndClick(false);
        end)

        battleSkillContainer:hide()

        local currentState = commonlib_getGameParam(KEY_GAME_STATE);
        if currentState == GAME_STATE_LOADING then
            moveFloatWindowTo(FLOAT_WINDOW_POS_WHEN_LOADING);
        end

        if currentState == GAME_STATE_LOADING or currentState == GAME_STATE_RUNNING then
            floatBall:show();
        end
    end);
end

local function createBattleSkillView()
    if battleSkillContainer == nil then
        battleSkillContainer = commonlib_getFloatViewMgrEx():create(
                0,
                0,
                COMMON_LAYOUTPARAM.WRAP_CONTENT,
                COMMON_LAYOUTPARAM.WRAP_CONTENT,
                Anchor().TOPLEFT,
                true)

        battleSkillView = battleSkillContainer:addBattleSkillView(BATTLE_SKILL_VIEW_POS_WHEN_LOADING.anchor,
                BATTLE_SKILL_VIEW_POS_WHEN_LOADING.x, BATTLE_SKILL_VIEW_POS_WHEN_LOADING.y, ZOrder().zorder_top);
        battleSkillContainer:setGravity(Anchor().CENTER);
        setBattleSkillViewListener();
    end
    printLog("createBattleSkillView")
end

local function setFloatBallListener()
    floatBall:setOnClickListener(function()
        printLog("悬浮球被点击：isCbBattleSkillChecked ： " .. tostring(isCbBattleSkillChecked));

        if isCbBattleSkillChecked and hasSetHeroInfo and commonlib_getGameParam(KEY_GAME_STATE) == GAME_STATE_LOADING then
            printLog("显示 battleSkillView");
            battleSkillContainer:show()
        elseif commonlib_getGameParam(KEY_GAME_STATE) == GAME_STATE_RUNNING then
            printLog("显示 settingView");
            settingView:show();
        else
            printLog("显示 guideView");
            guideView:show();
        end
        floatBall:hide();
    end);
end

--local function setSettingViewListener()
--    settingView:putOnEventListener(function()
--    end, function()
--        printLog("设置界面被隐藏");
--        if isCbBattleSkillChecked and hasSetHeroInfo then
--            battleSkillContainer:show()
--        else
--            floatBall:show();
--        end
--    end);
--end

local function getViews()
    settingView = SettingView();
    floatBall = TopSmallView();
    guideView = commonlib_getFloatViewMgrEx():createSGameAssistGuideView();

    settingView:hide();
    floatBall:hide();
    guideView:hide();

    printLog("floatBall : " .. tostring(floatBall));
    printLog("settingView : " .. tostring(settingView));
    printLog("guideView : " .. tostring(guideView));
end

local function setViewListener()
    setFloatBallListener();
--    setSettingViewListener();
end

---  判断英雄个数是否有效
local function isHeroInfoValid(currentHeroId, heroIdTable)
    if currentHeroId == nil then
        printLog("未获取到当前英雄的用户角色");
        return false;
    end

    if heroIdTable == nil then
        printLog("未获取到敌方英雄的用户角色");
        return false;
    end

    if #heroIdTable == 0 then
        printLog("敌方英雄的个数为0个");
        return false;
    end

    return true;
end

local DEFAULT_BATTLE_SKILL_TEXT = "超人小编正在努力研究中，点击其他敌方英雄看看吧！";
local HERO_AVATOR_IMG_PATH_PREFIX = "img/hero_avator/";
local HERO_AVATOR_IMG_PATH_SUFFIX = ".png";

--现在的逻辑和以前可能稍稍不同,优先用对手的那个table
local function getBattleSkillText(id1, id2)
    x = HERO_COUNTER_INFO_TABLE[id1]
    if x == nil then
        return nil
    end
    text = x[id2]
    if text ~= nil then
        return text
    else
        text = OTHER_VS_ME_DEFAULT[id2]
        if text ~= nil then
            return text
        end
        text = I_VS_OTHER_DEFAULT[id1]
        if text ~= nil then
            return text
        end
    end
    return nil
end

local function getBattleSkillInfoMap(currentHeroId, heroIdTable)
    local skillInfoMap = {};

    print("HERO_COUNTER_INFO_TABLE 是否为空：" .. tostring(HERO_COUNTER_INFO_TABLE == nil));
    for index, heroId in pairs(heroIdTable) do
        local heroAvatorImgPath = HERO_AVATOR_IMG_PATH_PREFIX .. tostring(heroId) .. HERO_AVATOR_IMG_PATH_SUFFIX;
        --local heroBattleSkillTextKey = tostring(currentHeroId) .. " , " .. tostring(heroId);
        --local heroBattleSkillText = HERO_COUNTER_INFO_TABLE[heroBattleSkillTextKey];
        local heroBattleSkillText = getBattleSkillText(currentHeroId, heroId);

        if heroBattleSkillText == nil or string.len(heroBattleSkillText) == 0 then
            printLog("文本库中没有对应文本，选择默认文本");
            heroBattleSkillText = DEFAULT_BATTLE_SKILL_TEXT;
        end

        local skillInfo = {};
        skillInfo["heroAvatorImgPath"] = heroAvatorImgPath;
        skillInfo["heroBattleSkillText"] = heroBattleSkillText;

        skillInfoMap[#skillInfoMap + 1] = skillInfo;
    end

    return skillInfoMap;
end

local function setBattleSkillViewHeroInfo(currentHeroId, heroIdTable)
    if not isHeroInfoValid(currentHeroId, heroIdTable) then
        printLog("英雄信息无效，不应该作展示");
        return;
    end

    commonlib_runOnUIThread(function()
        printLog("开始设置 BattleSkillView 控件的敌方英雄信息");

        local battleSkillInfoMap = getBattleSkillInfoMap(currentHeroId, heroIdTable);

        battleSkillView:setBattleSkillInfo(battleSkillInfoMap);
        battleSkillView1:setBattleSkillInfo(battleSkillInfoMap);
--        battleSkillView1:show();

        hasSetHeroInfo = true;
        printLog("设置敌方英雄信息成功");

        if commonlib_getGameParam(KEY_GAME_STATE) == GAME_STATE_LOADING then
            showBattleSkillTime = commonlib_getCurrentTime()
            floatBall:hide();
            commonlib_setFloatBallDragAndClick(false);
            battleSkillContainer:show()
            commonlib_setSharedPrefBoolean(FLOAT_BALL_IS_SHOW_ALWAYS_KEY, false);
        end
    end);
end

local function initViews()

    getViews();

    setViewListener();

end

local KEY_IS_CHECKBOX_SELECTED = "isCheckboxSelected";
------- 设置版面UI -------
local function onBattleSkillCheckboxSelected(checkboxId, isChecked)
    isCbBattleSkillChecked = isChecked

    if isCbBattleSkillChecked and hasSetHeroInfo and commonlib_getGameParam(KEY_GAME_STATE) == GAME_STATE_RUNNING then
        battleSkillView1:show();
    else
        battleSkillView1:hide();
    end

    commonlib_setSharedPrefBoolean(KEY_IS_CHECKBOX_SELECTED, isCbBattleSkillChecked)

    onBattleSkillSettingsChange(isCbBattleSkillChecked)
end

local BATTLE_SKILL_TAB_PAGE_NAME = "战斗宝典";
local BATTLE_SKILL_CHECKBOX_TEXT = "开启对战技巧";
local function initBattleSkillUI()
    printLog("battle skill initConfigUI");

    local param;
    local paramProperty;

    param = create("RelativeLayoutParam");
    paramProperty = {
        layout_marginTop = "20dp",
        layout_marginLeft = "25dp"
    };
    param:setLayoutParam(paramProperty);

    local isEnable = commonlib_getSgameFuncAbcTestEnable(FUNC_CLOUD_SWITCH_KEY, true)

    isCbBattleSkillChecked = commonlib_getSharedPrefBoolean(KEY_IS_CHECKBOX_SELECTED, isEnable)

    local tabPage = settingView:addTableView(BATTLE_SKILL_TAB_PAGE_NAME)
    cbBattleSkill = tabPage:addCheckBoxView(BATTLE_SKILL_CHECKBOX_TEXT, isCbBattleSkillChecked, param, onBattleSkillCheckboxSelected)

    paramProperty = {
        layout_marginTop = "10dp",
        layout_marginLeft = "30dp",
        layout_below = cbBattleSkill:getId()
    };
    param:setLayoutParam(paramProperty);

    printLog("开始设置设置界面的战斗技巧页面");
    battleSkillView1 = tabPage:addBattleSkillView1(param);
    battleSkillView1:hide()
end

------ 检测英雄角色相关 ------
local function shouldDoDetect()
    if not isCbBattleSkillChecked then
        printLog("总Checkbox未选中，不做英雄角色识别");
        return false;
    end

    if hasDoDetectHeroRole then
        printLog("已经做过英雄角色的识别，不在进行第二次识别");
        return false;
    end

    if enemyHeroIdList ~= nil then
        printLog("已经识别到英雄角色，不再做识别");
        return false;
    end

    printLog("应该做英雄角色的识别");

    return true;
end

local function printHeroInfoTable(heroInfoTable)
    printLog("heroInfoTable is null: " .. tostring(heroInfoTable == nil));
    printLog("heroInfoTable size:" .. tostring(#heroInfoTable));

    for index, heroInfo in pairs(heroInfoTable) do
        printLog("print hero index : " .. tostring(index));

        printLog("hero type : " .. tostring(heroInfo["type"]));
        printLog("hero id : " .. tostring(heroInfo["id"]));

        if HERO_ID_TABLE ~= nil then
            printLog("hero name : " .. tostring(HERO_ID_TABLE[tostring(heroInfo["id"])]));
        else
            printLog("HERO_ID_TABLE is nil")
        end
    end
end

local function saveHeroInfo(currentHeroId, mateHeroIdList, enemyHeroIdList)
    if currentHeroId == nil or currentHeroId == "" or mateHeroIdList == nil or enemyHeroIdList == nil then
        printLog("saveHeroInfo param is invalid!")
        commonlib_setGameParam(KEY_HERO_ID_LIST_STRING, "")
        return
    end
    for i = #mateHeroIdList + 1, 4 do
        mateHeroIdList[i] = tostring(-1)
    end
    local mateHeroIdListString = table.concat(mateHeroIdList, ",")
    for i = #enemyHeroIdList + 1, 5 do
        enemyHeroIdList[i] = tostring(-1)
    end
    local enemyHeroIdListString = table.concat(enemyHeroIdList, ",")
    local heroIdListString = tostring(currentHeroId) .. "," .. mateHeroIdListString .. "," .. enemyHeroIdListString
    commonlib_setGameParam(KEY_HERO_ID_LIST_STRING, heroIdListString)
end

local function parseHeroInfo(heroInfoTable)
    printLog("开始解析英雄数据");
    currentHeroId = nil;
    enemyHeroIdList = {};

    local mateHeroIdList = {}

    for index, heroInfo in pairs(heroInfoTable) do
        local heroType = heroInfo["type"];
        local heroId = heroInfo["id"];

        if heroId >= 0 then
            if heroType == HERO_TYPE_SELF then
                currentHeroId = heroId;
            elseif heroType == HERO_TYPE_ENEMY and not commonlib_isTableContainsValue(enemyHeroIdList, heroId) then
                enemyHeroIdList[#enemyHeroIdList + 1] = heroId;
            else
                mateHeroIdList[#mateHeroIdList + 1] = heroId
            end
        end
    end

    if currentHeroId == nil or enemyHeroIdList == nil or #enemyHeroIdList == 0 then
        printLog("未获取到己方英雄信息或敌方英雄个数为0个");
        currentHeroId = nil;
        enemyHeroIdList = nil;
    else
        commonlib_setGameParam(KEY_CURRENT_HERO_ID, currentHeroId);
        saveHeroInfo(currentHeroId, mateHeroIdList, commonlib_deepCopy(enemyHeroIdList))
    end
end

local function handleDectHeroRole(heroInfoTable)
    printLog("处理英雄识别结果");
    printLog("识别到的个数: " .. tostring(#heroInfoTable));
    printLog("结果是否为空：" .. tostring(heroInfoTable == nil));

    if heroInfoTable == nil then
        printLog("接口返回的值为nil");
        return;
    else
        printLog("接口返回的值不为nil");
    end

    printHeroInfoTable(heroInfoTable);
    parseHeroInfo(heroInfoTable);
    setBattleSkillViewHeroInfo(currentHeroId, enemyHeroIdList);
end

local function onDetectHeroRoleCallback(heroInfoTable)
    printLog("英雄识别接口回调");
    handleDectHeroRole(heroInfoTable);
end

local function detectHeroRoleFromServer()
    if shouldDoDetect() then
        hasDoDetectHeroRole = true;
        printLog("开始进行英雄角色识别（服务端）");

        --- 采用回调方式
        --commonlib_detectHeroRole(DETECT_HERO_ROLE_RECT_INFO, onDetectHeroRoleCallback)

        --- 不采用回调方式
        local beginTime = commonlib_getCurrentTime();
        commonlib_detectHeroRole(DETECT_HERO_ROLE_RECT_INFO);
        local endTime = commonlib_getCurrentTime();
        printLog("检测英雄角色（服务端）的执行时间：" .. tostring(endTime - beginTime));

    end
    if commonlib_getResult() ~= nil then
        local heroInfoTable = commonlib_getResult();
        handleDectHeroRole(heroInfoTable);
        commonlib_resetResult();
    end
end

local function detectHeroRoleFromLocal()
    if shouldDoDetect() then
        hasDoDetectHeroRole = true;
        printLog("开始进行英雄角色识别（本地）");

        --- 采用回调方式
        --commonlib_detectHeroRole(DETECT_HERO_ROLE_RECT_INFO, onDetectHeroRoleCallback)

        --- 不采用回调方式
        local beginTime = commonlib_getCurrentTime();
        local heroInfoTable = commonlib_detectLocalHeroRole(DETECT_HERO_ROLE_RECT_INFO);
        local endTime = commonlib_getCurrentTime();
        printLog("检测英雄角色(本地)的执行时间：" .. tostring(endTime - beginTime));

        handleDectHeroRole(heroInfoTable);
    end
end

-------- 游戏状态回调 ------
local function onGameLoading()
    printLog("onGameLoading .....")

    if isCbBattleSkillChecked then
        createBattleSkillView()
        --- 加入云控，控制是否开启服务端英雄识别
        printLog("isServer onGameLoading " .. tostring(isServerHeroRecognize))
        if isServerHeroRecognize then
            -- 服务端英雄识别角色逻辑
            printLog("server hero recognize")
            detectHeroRoleFromServer()
        else
            -- 本地英雄识别角色逻辑
            printLog("local hero recognize")
            detectHeroRoleFromLocal()
        end
    end

    commonlib_runOnUIThread(function()
        if not battleSkillContainer:isShowing() and not floatBall:isShowing() and hasSetHeroInfo then
            printLog("battleSkillView is not showing and flostBall is not showing and heroInfoTable is not nil")
            floatBall:show()
        end
    end);
end

local function donotShowViews()
    if showBattleSkillTime == 0 then
        return
    end

    commonlib_runOnUIThread(function()
        destroyBattleSkillView()

        if hasSetHeroInfo then
            battleSkillView1:show();
        else
            battleSkillView1:hide();
        end
    end);
    showBattleSkillTime = 0
end

local function onJustEnterGame()
    if commonlib_isFlameMountainMap() then
        printLog("onJustEnterGame unsupport FlameMountainMap")
        return;
    end
    printLog("onJustEnterGame ...... ");
    donotShowViews()
end

local function onGameOver()
    if commonlib_isFlameMountainMap() then
        printLog("onGameOver unsupport FlameMountainMap")
        return;
    end
    printLog("onGameOver......");


    commonlib_runOnUIThread(function()
        settingView:hide();
        guideView:hide();
        floatBall:hide();
        battleSkillView1:hide();
    end);
    currentHeroId = nil;
    enemyHeroIdList = nil;
    hasDoDetectHeroRole = false;
    hasSetHeroInfo = false;
end

local function onGameWork()
    if showBattleSkillTime == 0 then
        return
    end
    local currentTime = commonlib_getCurrentTime()
    if currentTime - showBattleSkillTime > 50 *1000 then
        donotShowViews()
    end
end

local function registerGameEvents()
    printLog("注册游戏事件");

    commonlib_registerCallback(common_game_events_callbacks.common_game_loading, onGameLoading);

    commonlib_registerCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame);

    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver);

    commonlib_registerCallback(common_game_events_callbacks.common_game_work, onGameWork);
end

local function unregisterGameEvents()

    commonlib_unregisterCallback(common_game_events_callbacks.common_game_loading, onGameLoading);

    commonlib_unregisterCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame);

    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver);

    commonlib_unregisterCallback(common_game_events_callbacks.common_game_work, onGameWork);
end

local function getFuncCloudSwitch()
    if funcCloudSwitch ~= nil then
        return funcCloudSwitch
    end
    funcCloudSwitch = commonlib_getSgameFuncCloudSwitch(FUNC_CLOUD_SWITCH_KEY, true)
    return funcCloudSwitch
end

local function init()
    printLog("battle_skill init");

    local cloudSwitch = getFuncCloudSwitch()
    printLog("战斗技巧开关："  .. tostring(cloudSwitch))
    if cloudSwitch == false then
        return
    end

    gameAssistant = GameAssistant()
    isServerHeroRecognize = gameAssistant:getServerHeroRecognizeSwitchState();

    initViews();

    initBattleSkillUI();

    registerGameEvents();

    printLog("battle_skill init finish ");
end

local function uninit()
    local cloudSwitch = getFuncCloudSwitch()
    printLog("战斗技巧开关："  .. tostring(cloudSwitch))
    if cloudSwitch == false then
        return
    end
    destroyBattleSkillView()
    unregisterGameEvents();
end

table.insert(common_life_circle_callbacks, { init, uninit, SGAME_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.battle_skill });