--- 显示悬浮窗按钮的脚本

local floatWindow
local floatTipContainer = nil
local gameAssistant
local lastShopMenuPos
local gRecognizeAdapterManager;
local isFloatWindowShowing;
local lastFindFloatWindowTime;
local totalFindFloatWindowCount;

local FLOAT_TAG = "float_window"
local GAMEMASTER_GAME_ASSISTANT_SRV = "gamemaster_game_assistant_srv"
local FLOAT_WINDON_SHOW = 1;
local FLOAT_WINDON_NOT_SHOW = 2;
local hasReportFloatWindowData = false;
local showExpandTip = false;
local KEY_HAS_SHOWED_FLOAT_BALL_TIP = "hasShowedFloatBallTip";
local KEY_HAS_SHOWED_EXPAND_FLOAT_BALL_TIP = "key_has_showed_expand_float_ball_tip";

local FLOAT_TIP_SHOWING_TIME = 2 * 1000;
local FLOAT_TIP_TEXT = "<font color='#3F9FDE'>超人插件</font><font color='#181818'>在这里呦~</font>";
local EXPAND_FLOAT_TIP_TEXT = "<font color='#181818'>点它体验你的狗年美化主题吧~</font>";

local EXPAND_FLOAT_TIP_POS_MENU_LEFT = {
    NOT_HAS_PAUSE_BUTTON = {
        anchor = Anchor().TOPRIGHT,
        x = -760,
        y = 142
    },
    HAS_PAUSE_BUTTON = {
        anchor = Anchor().TOPRIGHT,
        x = -810,
        y = 133
    }
}

local FLOAT_TIP_POS_WHEN_SHOP_MENU_POSITION_LEFT = {
    NOT_HAS_PAUSE_BUTTON = {
        anchor = Anchor().TOPRIGHT,
        x = -610,
        y = 142
    },
    HAS_PAUSE_BUTTON = {
        anchor = Anchor().TOPRIGHT,
        x = -660,
        y = 133
    }
}

local FLOAT_TIP_POS_WHEN_SHOP_MENU_POSITION_RIGHT = {
    NOT_HAS_PAUSE_BUTTON = {
        anchor = Anchor().TOPLEFT,
        x = 240,
        y = 439
    },
    HAS_PAUSE_BUTTON = {
        anchor = Anchor().TOPLEFT,
        x = 336,
        y = 439
    }
}

local FLOAT_WINDOW_POS_WHEN_GAME_NOT_START = {
    anchor = Anchor().TOPRIGHT,
    x = -86,
    y = 145
}

local FLOAT_WINDOW_LAST_X = "float_window_last_x";
local FLOAT_WINDOW_LAST_Y = "float_window_last_y";

local gIsFullCover;

local function printLog(msg)
    commonlib_print(FLOAT_TAG, msg)
end

local function reportFloatEntranceShowState(state)
    printLog("float_window===================" .. "埋点测试" .. tostring(state));
    local reportLib = Report();
    if reportLib ~= nil then
        printLog("float_window===================" .. "埋点测试");
        reportLib:report({
            ["table_name"] = GAMEMASTER_GAME_ASSISTANT_SRV,
            ["report_data"] = { ["show_float"] = state }
        })
    end
end

local function moveFloatWindowTo(position)
    commonlib_runOnUIThread(function()
        floatWindow:moveCenterTo(position.anchor, position.x, position.y);
    end)
end


local function destroyFloatTipContainer()
    if floatTipContainer ~= nil then
        floatTipContainer:destroy()
        floatTipContainer = nil;
    end
end

local function createFloatTipContainer()
    if floatTipContainer == nil then
        floatTipContainer = commonlib_getUnClickableFloatView():addSGameFloatViewControl(ZOrder().zorder_bottom)
    end
end

local function hideFloatTipContainer()
    commonlib_runOnUIThread(function()
        if floatTipContainer ~= nil then
            floatTipContainer:hide()
        end
    end)
end

local function showFloatTipContainer()
    commonlib_runOnUIThread(function()
        if floatTipContainer ~= nil then
            floatTipContainer:show()
        end
    end)
end

local function showFloatTip(text, position)
    commonlib_runOnUIThread(function()
        createFloatTipContainer()
        floatTipContainer:addFloatTipRemindView(text, FLOAT_TIP_SHOWING_TIME, position.anchor, position.x,
            position.y, false, ZOrder().zorder_top, nil);
    end)
end

-- 根据商店菜单的位置移动悬浮窗
local function moveFloatWindow(shopMenuPosition)
    printLog("开始移动悬浮球位置：");
    printLog("商店菜单的位置：" .. tostring(shopMenuPosition));
    printLog("是否有暂定按钮：" .. tostring(commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON)));

    local posKey;
    if shopMenuPosition == SHOP_MENU_POSITION_LEFT then
        if commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON) then
            posKey = "shopmenu_left_and_has_pause_button";
        else
            posKey = "shopmenu_left_and_not_has_pause_button";
        end
    else
        if commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON) then
            posKey = "shopmenu_right_and_has_pause_button";
        else
            posKey = "shopmenu_right_and_not_has_pause_button";
        end
    end

    moveFloatWindowTo(gRecognizeAdapterManager:getItem(KEY_FLOAT_WINDOW_ON_GAMERUNNING_SHOW_POSS)[posKey]);
end

local function showFloatWindow()
    printLog("showFloatWindow")
    commonlib_runOnUIThread(function()
        if not floatWindow:isShowing() then
            floatWindow:show()
            if not hasReportFloatWindowData then
                reportFloatEntranceShowState(FLOAT_WINDON_SHOW);
                hasReportFloatWindowData = true;
            end
        end
    end)

    -- 悬浮窗显示完成, 设置值
    if not commonlib_getSharedPrefBoolean(KEY_HAS_SHOWED_FLOAT_WINDOW, false) then
        printLog("设置已经显示过悬浮球");
        commonlib_setSharedPrefBoolean(KEY_HAS_SHOWED_FLOAT_WINDOW, true);
        printLog("设置悬浮球的显示时间");
        commonlib_setSharedPrefString(KEY_FLOAT_WINDOW_FIRST_SHOW_TIME, tostring(commonlib_getCurrentTime()));
    end
end

local function hideFloatWindow()
    printLog("hideFloatWindow")
    commonlib_runOnUIThread(function()
        floatWindow:hide();
    end)
end

local function handleShowFirstGuideTip()
    if commonlib_getSharedPrefBoolean(KEY_HAS_SHOWED_FLOAT_BALL_TIP, false) then
        printLog("已经展示过悬浮球的提醒，不再展示")
        return false;
    end

    if not commonlib_getSharedPrefBoolean(KEY_HAS_SHOW_SKIN_SELECT_VIEW, false) then
        printLog("还未展示皮肤选择窗口，需先展示皮肤选择窗口")
        return false;
    end
    printLog("handleShowFirstGuideTip")
    showFloatWindow()
    local shopMenuPosition = commonlib_getGameParam(KEY_SHOP_MENU_POSITION)
    local hasPauseButton = commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON)
    local floatTipPosByShopMenu = nil;
    if shopMenuPosition == SHOP_MENU_POSITION_LEFT then
        floatTipPosByShopMenu = FLOAT_TIP_POS_WHEN_SHOP_MENU_POSITION_LEFT;
    else
        floatTipPosByShopMenu = FLOAT_TIP_POS_WHEN_SHOP_MENU_POSITION_RIGHT;
    end

    if hasPauseButton then
        showFloatTip(FLOAT_TIP_TEXT, floatTipPosByShopMenu.HAS_PAUSE_BUTTON)
    else
        showFloatTip(FLOAT_TIP_TEXT, floatTipPosByShopMenu.NOT_HAS_PAUSE_BUTTON)
    end
    commonlib_setSharedPrefBoolean(KEY_HAS_SHOWED_FLOAT_BALL_TIP, true)
    return true;
end

local function handleShowExpandTip()
    if not commonlib_hasExpandSharedApp() then
        printLog("没有分享成功，不展示Tip")
        return false;
    end
    if commonlib_getSharedPrefBoolean(KEY_HAS_SHOWED_EXPAND_FLOAT_BALL_TIP, false) then
        printLog("已经展示过推广提醒，不再展示")
        return false;
    end
    printLog("handleShowExpandTip")
    showFloatWindow()
    local shopMenuPosition = commonlib_getGameParam(KEY_SHOP_MENU_POSITION)
    local hasPauseButton = commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON)
    local floatTipPosByShopMenu = nil;
    if shopMenuPosition == SHOP_MENU_POSITION_LEFT then
        floatTipPosByShopMenu = EXPAND_FLOAT_TIP_POS_MENU_LEFT;
    else
        floatTipPosByShopMenu = FLOAT_TIP_POS_WHEN_SHOP_MENU_POSITION_RIGHT;
    end

    if hasPauseButton then
        showFloatTip(EXPAND_FLOAT_TIP_TEXT, floatTipPosByShopMenu.HAS_PAUSE_BUTTON)
    else
        showFloatTip(EXPAND_FLOAT_TIP_TEXT, floatTipPosByShopMenu.NOT_HAS_PAUSE_BUTTON)
    end
    commonlib_setSharedPrefBoolean(KEY_HAS_SHOWED_EXPAND_FLOAT_BALL_TIP, true)
    return true;
end

local function handleShowFloatTip(shopMenuPosition)
    if showExpandTip then
        handleShowExpandTip();
    else
        handleShowFirstGuideTip();
    end
end

local function isShowExpandTip()
    return (commonlib_hasExpandSharedApp() and not commonlib_getSharedPrefBoolean(KEY_HAS_SHOWED_EXPAND_FLOAT_BALL_TIP, false));
end

local function onGameStart()
    printLog("onGameStart")
    commonlib_runOnUIThread(function()
        commonlib_setFloatBallIcon("img/icon_floatball.png");
        commonlib_setFloatBallDragAndClick(false);
    end)
    gIsFullCover = false;
    showExpandTip = isShowExpandTip();
    showFloatWindow();
end

local function onGameOver()
    printLog("onGameOver")
    hideFloatWindow()
    if lastShopMenuPos ~= nil then
        lastShopMenuPos = nil
    end
    hasReportFloatWindowData = false;
    commonlib_setSharedPrefBoolean(FLOAT_BALL_IS_SHOW_ALWAYS_KEY, false);
    commonlib_setSharedPrefBoolean(GAME_LOBBY_FLOAT_BALL_IS_SHOW_KEY, false);
end

local function initVariable()
    floatWindow = TopSmallView()
    floatWindow:setTargetPackage("com.tencet.tmgp.sgame")
    gameAssistant = GameAssistant()
    commonlib_setSharedPrefBoolean(GAME_LOBBY_FLOAT_BALL_IS_SHOW_KEY, true);
    commonlib_setSharedPrefBoolean(FLOAT_BALL_IS_SHOW_ALWAYS_KEY, true);

    gRecognizeAdapterManager = AdapterManagerClass:getRecognizeInstance();

    isFloatWindowShowing = false;
    lastFindFloatWindowTime = 0;
    totalFindFloatWindowCount = 0;
    gIsFullCover = false;
end

local function addReferImage()
    printLog(" addReferImage begin ")

    gRecognizeAdapterManager:recognizeAddImageByKeys({
        KEY_FIND_FLOAT_WINDOW_RECOGNIZE_RECT,
    });
end

local function unInitVariable()
    floatWindow = nil
    lastShopMenuPos = nil
    isFloatWindowShowing = false;
    lastFindFloatWindowTime = 0;
    totalFindFloatWindowCount = 0;
    destroyFloatTipContainer()
end

local function findFloatWindow()
    -- 最大识别次数
    local MAX_RETRY_COUNT = 15;
    if totalFindFloatWindowCount > MAX_RETRY_COUNT then
        return;
    end

    -- 悬浮球是否已展示(UI逻辑)
    if isFloatWindowShowing ~= true then
        commonlib_runOnUIThread(function()
            isFloatWindowShowing = floatWindow:isShowing();
            printLog("findFloatWindow: isFloatWindowShowing " .. tostring(isFloatWindowShowing));
        end);
    end

    if isFloatWindowShowing == true and commonlib_getCurrentTime() - lastFindFloatWindowTime > 1000
    then
        local item = gRecognizeAdapterManager:getItem(KEY_FIND_FLOAT_WINDOW_RECOGNIZE_RECT);
        local scale = commonlib_getScale();
        if item ~= nil and scale ~= 0 then
            local rc = floatWindow:getViewPos();
            printLog("findFloatWindow: " .. tostring(rc["x"]) .. ", " .. tostring(rc["y"]) .. ", " .. tostring(rc["cx"])  .. ", scale:" .. tostring(scale));
            item.rect["left"] = math.floor(rc["x"] / scale + 0.5);
            item.rect["top"] = math.floor(rc["y"] / scale + 0.5);
            item.rect["width"] = math.floor(rc["cx"] / scale + 0.5);
            item.rect["height"] = math.floor(rc["cy"] / scale + 0.5);
            printLog("findFloatWindow: " .. tostring(item.rect["left"]) .. ", " .. tostring(item.rect["top"]) .. ", " .. tostring(item.rect["width"]));
            local found = commonlib_doImageRecognize(item);
            if found == true then
                commonlib_reportGameRecogSuccess(SGAME_APP_NAME, ACTION_SHOW_FLOAT_BALL, 1);
                commonlib_reportFunctionDisableReason(SGAME_APP_NAME, SETP_SHOW_FLOAT_BALL, 1);
                printLog("findFloatWindow: true  ");
                totalFindFloatWindowCount = MAX_RETRY_COUNT + 1;
            else
                printLog("findFloatWindow: false ");
                totalFindFloatWindowCount = totalFindFloatWindowCount + 1;
            end
        end
        lastFindFloatWindowTime = commonlib_getCurrentTime();
    end
end

local function onFullCoverStateChange(isFullCover)
    printLog("onFullCoverStateChange isFullCover: " .. tostring(isFullCover))
    gIsFullCover = isFullCover;
    if isFullCover then
        printLog("界面被全遮挡，不显示悬浮窗")
        hideFloatWindow()
        hideFloatTipContainer()
    else
        showFloatWindow()
        showFloatTipContainer()
    end
end

local function onMapModeChange(mapMode)
    printLog("onMapModeChange mapMode: " .. tostring(mapMode))
    if mapMode == LARGE_MAP_LEFT_ZOOMOUT then
        if lastShopMenuPos == SHOP_MENU_POSITION_RIGHT then
            hideFloatWindow()
        else
            showFloatWindow()
        end
    elseif mapMode == LARGE_MAP_RIGHT_ZOOMOUT then
        if lastShopMenuPos == SHOP_MENU_POSITION_LEFT then
            hideFloatWindow()
        else
            showFloatWindow()
        end
    elseif mapMode == LARGE_MAP_HIDE then
        showFloatWindow()
    end
end

local function onChatWindowOpenStateChange(isOpen)
    printLog("onChatWindowOpenStateChange isOpen: " .. tostring(isOpen))
    if isOpen and lastShopMenuPos == SHOP_MENU_POSITION_LEFT then
        hideFloatWindow()
    elseif gIsFullCover == false then
        showFloatWindow()
    end
end

local function onEquipmentChange(shopMenuPosition)
    printLog("onEquipmentChange equipment: " .. tostring(shopMenuPosition))
    if lastShopMenuPos ~= shopMenuPosition then
        moveFloatWindow(shopMenuPosition)
    end
    showFloatWindow()
    lastShopMenuPos = shopMenuPosition
end

local function onGameNotStart()
    printLog("onGameNotStart")

    findFloatWindow();

    local gameLobbyFloatViewSwitchState = gameAssistant:getGameLobbyFloatBallSwitchState();
    local isGameLobbyFloatViewShowing = commonlib_getSharedPrefBoolean(GAME_LOBBY_FLOAT_BALL_IS_SHOW_KEY, false)
            and commonlib_getSharedPrefBoolean(SHOW_FLOAT_BALL_DELAY_SIX_SECONDS, false);
    local isFloatWindowShowAlways = commonlib_getSharedPrefBoolean(FLOAT_BALL_IS_SHOW_ALWAYS_KEY, true)
            and commonlib_getSharedPrefBoolean(SHOW_FLOAT_BALL_DELAY_SIX_SECONDS, false);
    printLog("gameLobbyFloatViewSwitchState = " .. tostring(gameLobbyFloatViewSwitchState));
    printLog("isGameLobbyFloatViewShowing = " .. tostring(isGameLobbyFloatViewShowing));
    printLog("isFloatWindowShowAlways = " .. tostring(isFloatWindowShowAlways));

    commonlib_runOnUIThread(function()
        if not gameLobbyFloatViewSwitchState then
            return;
        end

        if isGameLobbyFloatViewShowing then
            commonlib_setFloatBallIcon("img/icon_game_lobby_floatball.png");
            commonlib_setFloatBallDragAndClick(true);

            local floatWindowLastX = commonlib_getSharedPrefInt(FLOAT_WINDOW_LAST_X, 0);
            local floatWindowLastY = commonlib_getSharedPrefInt(FLOAT_WINDOW_LAST_Y, 0);
            if floatWindowLastX == 0 and floatWindowLastY == 0 then
                moveFloatWindowTo(FLOAT_WINDOW_POS_WHEN_GAME_NOT_START);
            else
                commonlib_runOnUIThread(function()
                    floatWindow:moveTo(Anchor().TOPLEFT, floatWindowLastX, floatWindowLastY, false);
                end)
            end

            printLog("float_window show onGameNotStart")
            showFloatWindow();
            commonlib_setSharedPrefBoolean(GAME_LOBBY_FLOAT_BALL_IS_SHOW_KEY, false);
        else
            if not guideView:isShowing() and not floatWindow:isShowing() and isFloatWindowShowAlways then
                printLog("guideView is not showing and flostBall is not showing, show the float ball");
                showFloatWindow();
            end
        end

        if commonlib_getScreenState() == SKIN_ORIENTATION_VERTICAL then
            printLog("screen state is vertical, hide the float ball before");
            hideFloatWindow();
            return
        end
    end)
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, handleShowFloatTip)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_registerCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
    commonlib_registerCallback(common_game_events_callbacks.common_chat_window, onChatWindowOpenStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_equipment, onEquipmentChange)
    commonlib_registerCallback(common_game_events_callbacks.common_game_not_start, onGameNotStart)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, handleShowFloatTip)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_unregisterCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_chat_window, onChatWindowOpenStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_equipment, onEquipmentChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_not_start, onGameNotStart)
end

local function init()
    printLog("init begin")
    registerGameEvents()
    initVariable()
    addReferImage();
end

local function uninit()
    printLog("uninit")
    unInitVariable()
    unregisterGameEvents()
end

table.insert(common_life_circle_callbacks, { init, uninit, SGAME_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.float_window })