--
-- Created by IntelliJ IDEA.
-- User: zhoufeng
-- Date: 2018/5/18
-- Time: 10:45
--

local DEBUG = commonlib_isLogWriteAble()

local TAG = "GloryMoment"
local function printLog(msg)
    commonlib_print(TAG, msg)
end

local KEY_STRING_KILL = "kill"
local KEY_STRING_ASSISTS = "assists"
local KEY_STRING_DEATH = "death"

local MIN_RECORD_VIDEO_TIME = 8500

local INVALID_NUMBER = -1;--无效的数字
local VALID_MAX_INCREASE = 3;--有效的最大增长数,解决当用户杀了4个人，按home键退出，然后在从超人进入，此时被识别成一次性杀了4个人

local gRecognizeAdapterManager;
local screenRecorder;
local gloryMomentView;

local gloryMomentFloatView;

local isGameOverDetail = false;
local hasShowedVideoWindowInOnceGame = false;--在一次游戏中是否展示过视频弹窗

local KEY_IS_GLORY_MOMENT_ENABLE = "key_is_glory_moment_enable"
local KEY_LIMITED_TIME_3_KILL = "key_is_glory_3_kill_enable"
local KEY_LIMITED_TIME_4_KILL = "key_is_glory_4_kill_enable"
local KEY_LIMITED_TIME_5_KILL = "key_is_glory_5_kill_enable"
local KEY_NO_DEATH_7_KILL = "key_is_glory_7_kill_enable"
local KEY_NO_DEATH_15_KILL = "key_is_glory_15_kill_enable"
local KEY_NO_DEATH_20_KILL = "key_is_glory_20_kill_enable"
local KEY_TOTAL_MORE_THEN_20_KILL = "key_is_glory_30_kill_enable"
local KEY_NO_KILL_NO_DEATH_20_ASSISTS = "key_no_kill_no_death_20_assists"
local KEY_NO_KILL_NO_DEATH_10_ASSISTS = "key_no_kill_no_death_10_assists"
local KEY_TOTAL_MORE_THEN_30_ASSISTS = "key_total_more_then_30_assists"
local KEY_TOTAL_MORE_THEN_20_ASSISTS = "key_total_more_then_20_assists"
local KEY_NO_KILL_NO_ASSISTS_7_DEATH = "key_no_kill_no_assists_7_death"
local KEY_NO_KILL_NO_ASSISTS_10_DEATH = "key_no_kill_no_assists_10_death"

local limitedTime3KillSwitchEnable = true;
local limitedTime4KillSwitchEnable = true;
local limitedTime5KillSwitchEnable = true;
local noDeath7KillSwitchEnable = true;
local noDeath15KillSwitchEnable = true;
local noDeath20KillSwitchEnable = true;
local totalMoreThen20KillSwitchEnable = true;
local noKillNoDeath20AssistsSwitchEnable = true;
local noKillNoDeath10AssistsSwitchEnable = true;
local totalMoreThen30AssistsSwitchEnable = true;
local totalMoreThen20AssistsSwitchEnable = true;
local noKillNoAssists7DeathSwitchEnable = true;
local noKillNoAssists10DeathSwitchEnable = true;

local restoreSwitch;
local restoreDescTextView
local isRestoreSwitchChecked = true;

local cbSwitch
local gloryTextView;
local honourMomentSwitchEnable = true

local FILE_NAME_SEPARATOR = "-"
local HONOUR_MOMENT_TYPE_LIMITED_TIME_3TO5_KILL = 1;---3-5杀类型
local HONOUR_MOMENT_TYPE_NO_DEATH_7TO20_KILL = 2;---7-20杀类型
local HONOUR_MOMENT_TYPE_TOTAL_MORE_THEN_20_KILL = 3;---总杀超过20的类型
local HONOUR_MOMENT_TYPE_NO_KILL_NO_DEATH_10TO20_ASSISTS = 4;---10-20助攻类型
local HONOUR_MOMENT_TYPE_TOTAL_MORE_THEN_20_ASSISTS = 5;---总助攻超过20的类型
local HONOUR_MOMENT_TYPE_NO_KILL_NO_ASSISTS_7TO10_DEATH = 6;---7-10死亡类型


local TOTAL_KILL_MORE_THEN_20_COUNT = 20

local heroKillAssistsDeathData = {

    [KEY_STRING_KILL] = {
        latestNumber = 0,
        latestTimeMills = 0,
        lastNumber = 0,
        lastTimeMills = 0,
    },

    [KEY_STRING_ASSISTS] = {
        latestNumber = 0,
        latestTimeMills = 0,
        lastNumber = 0,
        lastTimeMills = 0,
    },

    [KEY_STRING_DEATH] = {
        latestNumber = 0,
        latestTimeMills = 0,
        lastNumber = 0,
        lastTimeMills = 0,
    }
}

local recognizeConfirmedData = {
    [KEY_STRING_KILL] = {
        recognizeNumber = 0,
        numberConfirmedCount = 0,
    },

    [KEY_STRING_ASSISTS] = {
        recognizeNumber = 0,
        numberConfirmedCount = 0,
    },

    [KEY_STRING_DEATH] = {
        recognizeNumber = 0,
        numberConfirmedCount = 0,
    }
}

local limitedTime3To5KillData = {
    KILL_PREV_VIDEO_TIME = 4 * 1000,
    KILL_AFTER_VIDEO_TIME = 10 * 1000,

    LIMITED_TIME_MIN_3_KILL_COUNT = 3,
    LIMITED_TIME_4_KILL_COUNT = 4,
    LIMITED_TIME_5_KILL_COUNT = 5,
    firstKillTime = 0,
    lastKillTime = 0,
    continueKillCount = 0,
    maxContinueKillCount = 0
}

local noDeath7To20KillData = {
    KILL_PREV_VIDEO_TIME = 3 * 1000,
    KILL_AFTER_VIDEO_TIME = 1800,

    CONNECT_TIME_OUT = 10 * 1000,

    NO_DEATH_MIN_7_KILL_COUNT = 7,
    NO_DEATH_15_KILL_COUNT = 15,
    NO_DEATH_20_KILL_COUNT = 20,

    firstKillTime = 0,--第一次杀人时间

    onceKillCount = 0,--一次杀人个数

    continueKillCount = 0,--当前连杀个数
    maxContinueKillCount = 0,--最大连杀个数

    continueKillVideoId = 0,
    maxContinueKillVideoId = 0,
}

local noKillNoDeath10To20AssistsData = {
    ASSISTS_PREV_VIDEO_TIME = 3 * 1000,
    ASSISTS_AFTER_VIDEO_TIME = 1800,
    CONNECT_TIME_OUT = 10 * 1000,

    ASSISTS_COUNT_LEVEL_10 = 10,
    ASSISTS_COUNT_LEVEL_20 = 20,
    --测试代码
    --ASSISTS_COUNT_LEVEL_10 = 1,
    --ASSISTS_COUNT_LEVEL_20 = 2,

    continueAssistsCount = 0,
    maxContinueAssistsCount = 0,

    firstAssistsTimeMills = 0,

    onceAssistsCount = 0,

    continueAssistsVideoId = 0,
    maxContinueAssistsVideoId = 0           --最大连续助攻数的相关视频ID
}

local noKillNoAssists7To10DeathData = {
    DEATH_PREV_VIDEO_TIME = 3 * 1000,
    DEATH_AFTER_VIDEO_TIME = 1800,
    CONNECT_TIME_OUT = 3 * 1000,

    DEATH_COUNT_LEVEL_7 = 7,
    DEATH_COUNT_LEVEL_10 = 10,
    ----测试代码
    --DEATH_COUNT_LEVEL_7 = 1,
    --DEATH_COUNT_LEVEL_10 = 3,

    continueDeathCount = 0,
    maxContinueDeathCount = 0,

    firstDeathTimeMills = 0,

    onceDeathCount = 0,

    continueDeathVideoId = 0,
    maxContinueDeathVideoId = 0     --最大连续死亡数的相关视频ID
}

local EVENT_PRIORITY_LIMITED_TIME_3_KILL = 7;
local EVENT_PRIORITY_LIMITED_TIME_4_KILL = 2;
local EVENT_PRIORITY_LIMITED_TIME_5_KILL = 1;

local EVENT_PRIORITY_NO_DEATH_20_KILL = 3;
local EVENT_PRIORITY_NO_DEATH_15_KILL = 4;
local EVENT_PRIORITY_NO_DEATH_7_KILL = 6;
local EVENT_PRIORITY_TOTAL_MORE_THEN_20_KILL = 5;

local EVENT_PRIORITY_NO_KILL_NO_DEATH_20_ASSISTS = 8;
local EVENT_PRIORITY_NO_KILL_NO_DEATH_10_ASSISTS = 10;
local EVENT_PRIORITY_TOTAL_MORE_THEN_20_ASSISTS = 11;
local EVENT_PRIORITY_TOTAL_MORE_THEN_30_ASSISTS = 9;

local EVENT_PRIORITY_NO_KILL_NO_ASSISTS_7_DEATH = 12;
local EVENT_PRIORITY_NO_KILL_NO_ASSISTS_10_DEATH = 13;

local currentEventPriority = 100;
local eventPriority = {
    [KEY_LIMITED_TIME_5_KILL] = EVENT_PRIORITY_LIMITED_TIME_5_KILL,
    [KEY_LIMITED_TIME_4_KILL] = EVENT_PRIORITY_LIMITED_TIME_4_KILL,
    [KEY_NO_DEATH_20_KILL] = EVENT_PRIORITY_NO_DEATH_20_KILL,
    [KEY_NO_DEATH_15_KILL] = EVENT_PRIORITY_NO_DEATH_15_KILL,
    [KEY_TOTAL_MORE_THEN_20_KILL] = EVENT_PRIORITY_TOTAL_MORE_THEN_20_KILL,
    [KEY_NO_DEATH_7_KILL] = EVENT_PRIORITY_NO_DEATH_7_KILL,
    [KEY_LIMITED_TIME_3_KILL] = EVENT_PRIORITY_LIMITED_TIME_3_KILL,
    [KEY_NO_KILL_NO_DEATH_20_ASSISTS] = EVENT_PRIORITY_NO_KILL_NO_DEATH_20_ASSISTS,
    [KEY_TOTAL_MORE_THEN_30_ASSISTS] = EVENT_PRIORITY_TOTAL_MORE_THEN_30_ASSISTS,
    [KEY_NO_KILL_NO_DEATH_10_ASSISTS] = EVENT_PRIORITY_NO_KILL_NO_DEATH_10_ASSISTS,
    [KEY_TOTAL_MORE_THEN_20_ASSISTS] = EVENT_PRIORITY_TOTAL_MORE_THEN_20_ASSISTS,
    [KEY_NO_KILL_NO_ASSISTS_7_DEATH] = EVENT_PRIORITY_NO_KILL_NO_ASSISTS_7_DEATH,
    [KEY_NO_KILL_NO_ASSISTS_10_DEATH] = EVENT_PRIORITY_NO_KILL_NO_ASSISTS_10_DEATH,
}

local switchState = {}

local limitedTime3To5KillConnectTime = {
    [0] = 0,
    [1] = 10000,
    [2] = 10000,
    [3] = 13000,
    [4] = 20000,
    [5] = 10000,
}


local needRecordVideoTime = {
    limitedTime3To5Kill = MIN_RECORD_VIDEO_TIME,
    noDeath7To20Kill = 0,
    noKillNoDeath10To20Assists = 0,
    noKillNoAssists7To10Death = 0
}

local LEFT = "left"
local RIGHT = "right"
local killNumPosition = {}

local assistsPosition = {}

local deathPosition = {}

local showVideoData = {
    showCount = 0,
    outVideoPath = nil,
    honourMomentType = -1
}

local needRecordVideoCacheTime = MIN_RECORD_VIDEO_TIME

local continueKillTempDir
local continueAssistsTempDir
local continueDeathTempDir

--針對应用宝的新安裝用戶渠道，新增一個功能開關，不受全網開關狀態的影響
local FUNC_CLOUD_SWITCH_KEY_FOR_YYB_CHANNEL = "sgame_glory_moment_cloud_switch_key"

local function videoFileExists(videoPath)
    return videoPath ~= nil and screenRecorder ~= nil and screenRecorder:videoHonourFileIsExists(videoPath)
end

local function initScreenRecord()
    if screenRecorder == nil then
        screenRecorder = ScreenRecorder()
    end
    screenRecorder:init()
end


--开始录屏
local function startScreenRecord()
    if screenRecorder ~= nil then
        screenRecorder:start()
    end
end

--释放录屏资源
local function releaseScreenRecord()
    if screenRecorder ~= nil then
        screenRecorder:uninit()
    end
end

local function deleteCacheFile()
    if screenRecorder ~= nil then
        screenRecorder:deleteHonourCacheVideo()
        screenRecorder:deleteKillAssistDeathTempDir()
    end
end


local function getTextColor(enable)
    if enable == true then
        return "#FF00DEFF";
    else
        return "#FF979797";
    end
end

local function setTextViewColorBySwitch(textView, switchOpen)
    if textView == nil or switchOpen == nil then
        return;
    end
    textView:setTextColor(getTextColor(switchOpen));
end

local function setRestoreSwitch(killSwitch, killSwitchChecked)
    if DEBUG then
        printLog("killswitch:" .. tostring(killSwitchChecked) .. " isCb:"  .. tostring(honourMomentSwitchEnable))
    end
    if killSwitch ~= nil then
        killSwitch:setEnabled(honourMomentSwitchEnable);
        if honourMomentSwitchEnable == false and killSwitchChecked then
            killSwitch:setChecked(false);
        elseif honourMomentSwitchEnable then
            killSwitch:setChecked(true)
        end
    end
end

local function onCheckChangeListener(checkboxId, isChecked)
    if DEBUG then
        printLog("onCheckChangeListener" .. tostring(isChecked))
    end
    honourMomentSwitchEnable = isChecked
    setTextViewColorBySwitch(gloryTextView, honourMomentSwitchEnable);

    if honourMomentSwitchEnable then
        setTextViewColorBySwitch(restoreDescTextView, isRestoreSwitchChecked);
        setRestoreSwitch(restoreSwitch, isRestoreSwitchChecked)
    else
        setTextViewColorBySwitch(restoreDescTextView, false);
        restoreSwitch:setChecked(false)
        restoreSwitch:setEnabled(false)
    end

    commonlib_setSharedPrefBoolean(KEY_IS_GLORY_MOMENT_ENABLE, honourMomentSwitchEnable)
    onHonourSettingsChange(isChecked)

    if isChecked then
        initScreenRecord()
        startScreenRecord()
    end
end

local function onRestoreSwitchCheckChangeListener(checkboxId, isChecked)
    if DEBUG then
        printLog("onRestoreSwitchCheckChangeListener" .. tostring(isChecked))
    end
    isRestoreSwitchChecked = isChecked;
    setTextViewColorBySwitch(restoreDescTextView, isRestoreSwitchChecked);
    if isChecked then
        commonlib_setSharedPrefBoolean(KEY_LIMITED_TIME_3_KILL, true)
        commonlib_setSharedPrefBoolean(KEY_LIMITED_TIME_4_KILL, true)
        commonlib_setSharedPrefBoolean(KEY_LIMITED_TIME_5_KILL, true)
        commonlib_setSharedPrefBoolean(KEY_NO_DEATH_7_KILL, true)
        commonlib_setSharedPrefBoolean(KEY_NO_DEATH_15_KILL, true)
        commonlib_setSharedPrefBoolean(KEY_NO_DEATH_20_KILL, true)
        commonlib_setSharedPrefBoolean(KEY_TOTAL_MORE_THEN_20_KILL, true)
        commonlib_setSharedPrefBoolean(KEY_NO_KILL_NO_DEATH_20_ASSISTS, true)
        commonlib_setSharedPrefBoolean(KEY_NO_KILL_NO_DEATH_10_ASSISTS, true)
        commonlib_setSharedPrefBoolean(KEY_TOTAL_MORE_THEN_30_ASSISTS, true)
        commonlib_setSharedPrefBoolean(KEY_TOTAL_MORE_THEN_20_ASSISTS, true)
        commonlib_setSharedPrefBoolean(KEY_NO_KILL_NO_ASSISTS_7_DEATH, true)
        commonlib_setSharedPrefBoolean(KEY_NO_KILL_NO_ASSISTS_10_DEATH, true)
    end
    onHonourSettingsRestoreChange(isChecked)
end

local function initSwitchState()
    limitedTime3KillSwitchEnable = commonlib_getSharedPrefBoolean(KEY_LIMITED_TIME_3_KILL, true);
    limitedTime4KillSwitchEnable = commonlib_getSharedPrefBoolean(KEY_LIMITED_TIME_4_KILL, true);
    limitedTime5KillSwitchEnable = commonlib_getSharedPrefBoolean(KEY_LIMITED_TIME_5_KILL, true);
    noDeath7KillSwitchEnable = commonlib_getSharedPrefBoolean(KEY_NO_DEATH_7_KILL, true);
    noDeath15KillSwitchEnable = commonlib_getSharedPrefBoolean(KEY_NO_DEATH_15_KILL, true);
    noDeath20KillSwitchEnable = commonlib_getSharedPrefBoolean(KEY_NO_DEATH_20_KILL, true);
    totalMoreThen20KillSwitchEnable = commonlib_getSharedPrefBoolean(KEY_TOTAL_MORE_THEN_20_KILL, true);
    noKillNoDeath20AssistsSwitchEnable  = commonlib_getSharedPrefBoolean(KEY_NO_KILL_NO_DEATH_20_ASSISTS, true);
    noKillNoDeath10AssistsSwitchEnable  = commonlib_getSharedPrefBoolean(KEY_NO_KILL_NO_DEATH_10_ASSISTS, true);
    totalMoreThen30AssistsSwitchEnable  = commonlib_getSharedPrefBoolean(KEY_TOTAL_MORE_THEN_30_ASSISTS, true);
    totalMoreThen20AssistsSwitchEnable  = commonlib_getSharedPrefBoolean(KEY_TOTAL_MORE_THEN_20_ASSISTS, true);
    noKillNoAssists7DeathSwitchEnable = commonlib_getSharedPrefBoolean(KEY_NO_KILL_NO_ASSISTS_7_DEATH, true)
    noKillNoAssists10DeathSwitchEnable = commonlib_getSharedPrefBoolean(KEY_NO_KILL_NO_ASSISTS_10_DEATH, true)
    isRestoreSwitchChecked = honourMomentSwitchEnable
            and limitedTime3KillSwitchEnable
            and limitedTime4KillSwitchEnable
            and limitedTime5KillSwitchEnable
            and noDeath7KillSwitchEnable
            and noDeath15KillSwitchEnable
            and noDeath20KillSwitchEnable
            and totalMoreThen20KillSwitchEnable
            and noKillNoDeath20AssistsSwitchEnable
            and noKillNoDeath10AssistsSwitchEnable
            and totalMoreThen30AssistsSwitchEnable
            and totalMoreThen20AssistsSwitchEnable
            and noKillNoAssists7DeathSwitchEnable
            and noKillNoAssists10DeathSwitchEnable
end

local function initSettingView()
    local TAB_NAME = "荣耀时刻"
    local settingView = commonlib_getSettingView()
    local tableView = settingView:addTableView(TAB_NAME)

    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    relativeLayoutParam:setLayoutParam(paramValues)

    local defaultValue = commonlib_getSgameFuncAbcTestEnable(FUNC_CLOUD_SWITCH_KEY_FOR_YYB_CHANNEL, false)

    honourMomentSwitchEnable = commonlib_getSharedPrefBoolean(KEY_IS_GLORY_MOMENT_ENABLE, defaultValue)
    cbSwitch = tableView:addCheckBoxView("荣耀时刻", honourMomentSwitchEnable, relativeLayoutParam, onCheckChangeListener)

    local relativeLayoutParamText1 = create("RelativeLayoutParam");
    relativeLayoutParamText1:setLayoutParam({
        layout_marginTop = "20dp",
        layout_marginLeft = "40dp",
        layout_marginRight = "40dp",
        layout_below = cbSwitch:getId(),
    });

    gloryTextView = tableView:addTextView("开启后将自动记录你在对战中击杀精彩瞬间，并剪辑成视频。录制的视频会保存在游戏超人-我-精彩时刻内部",
            getTextColor(honourMomentSwitchEnable),
            "12sp",
            relativeLayoutParamText1,
            nil);
    initSwitchState()

    local relativeLayoutParamRestore = create("RelativeLayoutParam")
    relativeLayoutParamRestore:setLayoutParam({
        layout_marginTop = "20dp",
        layout_marginLeft = "40dp",
        layout_below = gloryTextView:getId(),
    });
    restoreSwitch = tableView:addCheckBoxView("恢复默认设置", isRestoreSwitchChecked, relativeLayoutParamRestore, onRestoreSwitchCheckChangeListener)

    local relativeLayoutParamRestoreDesc = create("RelativeLayoutParam")
    relativeLayoutParamRestoreDesc:setLayoutParam({
        layout_marginTop = "20dp",
        layout_marginLeft = "40dp",
        layout_below = restoreSwitch:getId(),
    });
    restoreDescTextView = tableView:addTextView("开启后，所有的精彩时刻都将被录制，包含3-5杀、7连杀、15连杀等等",
            getTextColor(isRestoreSwitchChecked),
            "12sp",
            relativeLayoutParamRestoreDesc,
            nil);
end

local function getHeroId()
    local heroNameId = commonlib_getGameParam(KEY_CURRENT_HERO_ID);
    local heroNameIdStr = "999"
    if (heroNameId ~= -1) then
        heroNameIdStr = tostring(heroNameId);
    end
    return heroNameIdStr
end

local function getOutVideoPath(type, killCount)
    local path
    local heroId = getHeroId()
    local fileName = type .. FILE_NAME_SEPARATOR
            .. heroId .. FILE_NAME_SEPARATOR
            .. killCount .. FILE_NAME_SEPARATOR
            .. commonlib_getCurrentTime() .. ".mp4"
    if screenRecorder ~= nil then
        local dir = screenRecorder:getHonourVideoTempDir()
        path = dir .. "/" .. fileName
    end
    if DEBUG then
        printLog("save path:" .. tostring(path))
    end
    return path
end

local function saveVideoInLimitedTime3To5Kill(firstKillTime, lastKillTime, continueKillCount)
    local startTime = firstKillTime - limitedTime3To5KillData.KILL_PREV_VIDEO_TIME
    local endTime = lastKillTime + limitedTime3To5KillData.KILL_AFTER_VIDEO_TIME
    showVideoData.outVideoPath = getOutVideoPath(HONOUR_MOMENT_TYPE_LIMITED_TIME_3TO5_KILL, continueKillCount)
    if screenRecorder ~= nil then
        screenRecorder:signalSaveHonourVideo(startTime, endTime, showVideoData.outVideoPath)
    end
end

local function getLimitedTime3To5KillConnectTime(continueKillCount)
    if (continueKillCount >= 5) then
        continueKillCount = 4
    end
    return limitedTime3To5KillConnectTime[continueKillCount]
end

local function isConnectedTimeoutInLimitedTime3To5Kill(lastKillTimeMills, currentTimeMills, continueKillCount)
    return (currentTimeMills - lastKillTimeMills) > getLimitedTime3To5KillConnectTime(continueKillCount)
end

local function isConnectedTimeoutInNoDeath7To20Kill(lastKillTimeMills, currentTimeMills)
    return (currentTimeMills - lastKillTimeMills) > noDeath7To20KillData.CONNECT_TIME_OUT
end

local function updateHeroDataByRecognizeNumber(regNumber, currentTimeMills, heroSomeTypeData)
    if heroSomeTypeData.lastNumber ~= heroSomeTypeData.latestNumber then
        heroSomeTypeData.lastNumber = heroSomeTypeData.latestNumber
        heroSomeTypeData.lastTimeMills = heroSomeTypeData.latestTimeMills
    end

    if regNumber ~= INVALID_NUMBER then
        ---容错机制：当识别数和上次识别数差值大于3时，认为识别错误
        local diffNumber = math.abs(regNumber - heroSomeTypeData.latestNumber)
        if diffNumber > 0 and diffNumber <= VALID_MAX_INCREASE then
        heroSomeTypeData.latestNumber = regNumber
        heroSomeTypeData.latestTimeMills = currentTimeMills
    end
    end
end

local function getConfirmRecognizeNumber(recognizeNumber, confirmData)
    if recognizeNumber ~= INVALID_NUMBER then
        if recognizeNumber == confirmData.recognizeNumber then
            confirmData.numberConfirmedCount = confirmData.numberConfirmedCount + 1
        else
            confirmData.recognizeNumber = recognizeNumber
            confirmData.numberConfirmedCount = 1
        end

        if confirmData.numberConfirmedCount >= 3 then
            return confirmData.recognizeNumber
        end
        return INVALID_NUMBER
    else
        return INVALID_NUMBER
    end
end

local function recognizeNumberByShopMenuPos(shopMenuPos, numberPosition)
    if shopMenuPos == nil or gRecognizeAdapterManager == nil then
        return INVALID_NUMBER
    end

    local rect;
    if shopMenuPos == SHOP_MENU_POSITION_LEFT then
        rect = gRecognizeAdapterManager:getItem(numberPosition[LEFT]).rect
    elseif shopMenuPos == SHOP_MENU_POSITION_RIGHT then
        rect = gRecognizeAdapterManager:getItem(numberPosition[RIGHT]).rect
    end

    local killNumString = commonlib_getImgNum(rect)
    if commonlib_isTextEmpty(killNumString) then
        return INVALID_NUMBER
    end

    local killNum = tonumber(killNumString)

    if killNum < 0 then
        return INVALID_NUMBER
    end

    return killNum
end


local function updateHeroKillAssistsDeathData(currentTimeMills)
    local shopMenuPos = commonlib_getGameParam(KEY_SHOP_MENU_POSITION)

    local regKillNumber = recognizeNumberByShopMenuPos(shopMenuPos, killNumPosition)
    if DEBUG then
        printLog("识别killNumber:" .. tostring(regKillNumber))
    end
    regKillNumber = getConfirmRecognizeNumber(regKillNumber, recognizeConfirmedData[KEY_STRING_KILL])

    local regAssistNumber = recognizeNumberByShopMenuPos(shopMenuPos, assistsPosition)
    if DEBUG then
        printLog("识别assistNumber:" .. tostring(regAssistNumber))
    end
    regAssistNumber = getConfirmRecognizeNumber(regAssistNumber, recognizeConfirmedData[KEY_STRING_ASSISTS])

    local regDeathNumber = recognizeNumberByShopMenuPos(shopMenuPos, deathPosition)
    if DEBUG then
        printLog("识别deathNumber:" .. tostring(regDeathNumber))
    end
    regDeathNumber = getConfirmRecognizeNumber(regDeathNumber, recognizeConfirmedData[KEY_STRING_DEATH])

    updateHeroDataByRecognizeNumber(regKillNumber, currentTimeMills, heroKillAssistsDeathData[KEY_STRING_KILL])
    updateHeroDataByRecognizeNumber(regAssistNumber, currentTimeMills, heroKillAssistsDeathData[KEY_STRING_ASSISTS])
    updateHeroDataByRecognizeNumber(regDeathNumber, currentTimeMills, heroKillAssistsDeathData[KEY_STRING_DEATH])

    if DEBUG then
        printLog("确认killNumber:" .. tostring(regKillNumber) .. " 确认assistNumber:" .. tostring(regAssistNumber) .. " 确认deathNumber:" .. tostring(regDeathNumber))
    end

end

local function updateNeedRecordVideoCacheTime()
    local needTime = needRecordVideoTime.limitedTime3To5Kill

    if needTime < needRecordVideoTime.noDeath7To20Kill then
        needTime = needRecordVideoTime.noDeath7To20Kill
    end

    if needTime < needRecordVideoTime.noKillNoDeath10To20Assists then
        needTime = needRecordVideoTime.noKillNoDeath10To20Assists
    end

    if needTime < needRecordVideoTime.noKillNoAssists7To10Death then
        needTime = needRecordVideoTime.noKillNoAssists7To10Death
    end

    if needTime ~= needRecordVideoCacheTime then
        if screenRecorder ~= nil then
            screenRecorder:setNeedRecorderMillis(needTime)
            needRecordVideoCacheTime = needTime
        end
        if DEBUG then
            printLog("update 录屏时间：" .. tostring(needTime))
        end
    end

end

local function getLimitedTime3To5KillKey(killCount)
    if killCount == limitedTime3To5KillData.LIMITED_TIME_MIN_3_KILL_COUNT then
        return KEY_LIMITED_TIME_3_KILL
    end
    if killCount == limitedTime3To5KillData.LIMITED_TIME_4_KILL_COUNT then
        return KEY_LIMITED_TIME_4_KILL
    end
    if killCount == limitedTime3To5KillData.LIMITED_TIME_5_KILL_COUNT then
        return KEY_LIMITED_TIME_5_KILL
    end
end

---连杀超时，或者游戏结束时，处理3-5杀逻辑
local function updateLimitedTime3To5KillData()
    local continueKillCount = limitedTime3To5KillData.continueKillCount
    if DEBUG then
        printLog("3-5kill continueKillCount:" .. tostring(continueKillCount) .. " currentEventPriority:" .. tostring(currentEventPriority))
    end
    if continueKillCount >= limitedTime3To5KillData.LIMITED_TIME_MIN_3_KILL_COUNT and
            continueKillCount >= limitedTime3To5KillData.maxContinueKillCount then
        local key = getLimitedTime3To5KillKey(continueKillCount)
        local switchEnable = switchState[key]
        local priority = eventPriority[key]
        if switchEnable == true and priority <= currentEventPriority then
            limitedTime3To5KillData.maxContinueKillCount = continueKillCount
            currentEventPriority = priority
            saveVideoInLimitedTime3To5Kill(limitedTime3To5KillData.firstKillTime, heroKillAssistsDeathData[KEY_STRING_KILL].lastTimeMills, limitedTime3To5KillData.continueKillCount)
        end
    end
end


local function handleLimitedTime3To5Kill(currentTimeMills)

    local killData = heroKillAssistsDeathData[KEY_STRING_KILL]
    local increaseKillCount = killData.latestNumber - killData.lastNumber

    --计算之前的连杀是否已经不能再形成下一次连杀了，即超时了
    local isContinueKillTimeout = isConnectedTimeoutInLimitedTime3To5Kill(killData.lastTimeMills, currentTimeMills, limitedTime3To5KillData.continueKillCount)

    --1、更新3-5杀数据
    if isContinueKillTimeout and limitedTime3To5KillData.firstKillTime >0 then
        updateLimitedTime3To5KillData()
        limitedTime3To5KillData.continueKillCount = 0
        limitedTime3To5KillData.firstKillTime = 0
    end

    if increaseKillCount > 0 and increaseKillCount <= VALID_MAX_INCREASE then
        if limitedTime3To5KillData.firstKillTime == 0 then
            limitedTime3To5KillData.firstKillTime = currentTimeMills
        end
        limitedTime3To5KillData.lastKillTime = currentTimeMills
        limitedTime3To5KillData.continueKillCount = limitedTime3To5KillData.continueKillCount + increaseKillCount
        if DEBUG then
            printLog("3-5kill continueKillCount:" .. tostring(limitedTime3To5KillData.continueKillCount))
        end
    end

    --3、下面更新需要记录视频缓存的时长
    if limitedTime3To5KillData.continueKillCount > 0 then
        needRecordVideoTime.limitedTime3To5Kill = (killData.latestTimeMills - limitedTime3To5KillData.firstKillTime)
                + limitedTime3To5KillData.KILL_PREV_VIDEO_TIME
                + getLimitedTime3To5KillConnectTime(limitedTime3To5KillData.continueKillCount)
        --if DEBUG then
        --    printLog("3-5 kill latestTime:" .. tostring(killData.latestTimeMills) .. " firstTime:" .. tostring(limitedTime3To5KillData.firstKillTime))
        --end
    end
end

---文件名格式“0-1-2-5000” 表示 “视频id-当前时间戳-一次杀人个数-视频时长”
local function buildSingleVideoFileName(saveVideoId, currentTimeMills, onceContinueCount, videoDuration)
    local fileName = saveVideoId .. FILE_NAME_SEPARATOR
            .. currentTimeMills .. FILE_NAME_SEPARATOR
            .. onceContinueCount .. FILE_NAME_SEPARATOR .. videoDuration
    return fileName;
end

local function buildOnceKillVideoSavePath(startTime, endTime, onceKillCount, currentTimeMills, saveVideoId)
    local videoDuration = endTime - startTime
    local fileName = buildSingleVideoFileName(saveVideoId, currentTimeMills, onceKillCount, videoDuration)
    if continueKillTempDir == nil then
        continueKillTempDir = screenRecorder:getContinuousKillTempDir()
    end
    local path = continueKillTempDir .. "/" .. fileName
    return path
end

local function buildOnceAssistsVideoSavePath(startTime, endTime, onceKillCount, currentTimeMills, saveVideoId)
    local videoDuration = endTime - startTime
    local fileName = buildSingleVideoFileName(saveVideoId, currentTimeMills, onceKillCount, videoDuration)
    if continueAssistsTempDir == nil then
        continueAssistsTempDir = screenRecorder:getContinuousAssistTempDir()
    end
    local path = continueAssistsTempDir .. "/" .. fileName
    return path
end

local function buildOnceDeathVideoSavePath(startTime, endTime, onceKillCount, currentTimeMills, saveVideoId)
    local videoDuration = endTime - startTime
    local fileName = buildSingleVideoFileName(saveVideoId, currentTimeMills, onceKillCount, videoDuration)
    if continueDeathTempDir == nil then
        continueDeathTempDir = screenRecorder:getContinueDeathTempDir()
    end
    local path = continueDeathTempDir .. "/" .. fileName
    return path
end


local function saveOnceKillVideo(firstKillTime, lastKillTime, currentTimeMills, onceKillNum, saveVideoId)
    if screenRecorder == nil then
        printLog("screenRecorder=nil")
        return
    end
    local startTime = firstKillTime - noDeath7To20KillData.KILL_PREV_VIDEO_TIME
    local endTime = lastKillTime + noDeath7To20KillData.KILL_AFTER_VIDEO_TIME
    local savePath = buildOnceKillVideoSavePath(startTime, endTime, onceKillNum, currentTimeMills, saveVideoId)
    screenRecorder:signalSaveOnceKillVideo(startTime, endTime, savePath)
    if DEBUG then
        printLog("saveOneKillVideo start:" .. tostring(startTime) .. " end:"
                .. tostring(endTime) .. " path:" .. tostring(savePath) .. "screenRecorder:" .. tostring(screenRecorder))
    end
end

local function getNoDeath7To20KillKey(killCount)
    if killCount >= noDeath7To20KillData.NO_DEATH_20_KILL_COUNT then
        return KEY_NO_DEATH_20_KILL
    elseif killCount >= noDeath7To20KillData.NO_DEATH_15_KILL_COUNT then
        return KEY_NO_DEATH_15_KILL
    elseif killCount >= noDeath7To20KillData.NO_DEATH_MIN_7_KILL_COUNT then
        return KEY_NO_DEATH_7_KILL
    end
    return KEY_NO_DEATH_7_KILL
end


---游戏死亡或者结束时，更新7-20杀数据
local function updateNoDeath7To20KillData()
    local continueKillCount = noDeath7To20KillData.continueKillCount;
    if DEBUG then
        printLog("7-20 kill continueKillCount:" .. tostring(continueKillCount)
                .. " currentEventPriority:" .. tostring(currentEventPriority)
                .. " videoId:" .. tostring(noDeath7To20KillData.continueKillVideoId))
    end
    if continueKillCount >= noDeath7To20KillData.NO_DEATH_MIN_7_KILL_COUNT and
            continueKillCount >= noDeath7To20KillData.maxContinueKillCount then
        local key = getNoDeath7To20KillKey(continueKillCount)
        local switchEnable = switchState[key]
        local priority = eventPriority[key]
        if switchEnable == true and priority <= currentEventPriority then
            currentEventPriority = priority
            noDeath7To20KillData.maxContinueKillCount = continueKillCount
            noDeath7To20KillData.maxContinueKillVideoId = noDeath7To20KillData.continueKillVideoId
        end
    end
end


local function handleNoDeath7To20Kill(currentTimeMills)
    local deathData = heroKillAssistsDeathData[KEY_STRING_DEATH]
    local increaseDeathCount = deathData.latestNumber - deathData.lastNumber

    --如果死亡了，则中断连杀，开始处理是否达到连杀逻辑
    if increaseDeathCount > 0 then
        updateNoDeath7To20KillData()
        noDeath7To20KillData.continueKillVideoId = noDeath7To20KillData.continueKillVideoId + 1
        noDeath7To20KillData.firstKillTime = 0
        noDeath7To20KillData.continueKillCount = 0
        noDeath7To20KillData.onceKillCount = 0
    end

    local killData = heroKillAssistsDeathData[KEY_STRING_KILL]
    local increaseKillCount = killData.latestNumber - killData.lastNumber

    --计算之前的连杀是否已经不能再形成下一次连杀了，即超时了
    local isContinueKillTimeout = isConnectedTimeoutInNoDeath7To20Kill(killData.lastTimeMills, currentTimeMills)

    --连接下一杀超时，保存一次杀人视频
    if isContinueKillTimeout and noDeath7To20KillData.firstKillTime > 0 then
        saveOnceKillVideo(noDeath7To20KillData.firstKillTime, killData.lastTimeMills,
                currentTimeMills,
                noDeath7To20KillData.onceKillCount,
                noDeath7To20KillData.continueKillVideoId)
        noDeath7To20KillData.firstKillTime = 0
        noDeath7To20KillData.onceKillCount = 0
    end

    if increaseKillCount > 0 and increaseKillCount <= VALID_MAX_INCREASE then
        if noDeath7To20KillData.firstKillTime == 0 then
            noDeath7To20KillData.firstKillTime = currentTimeMills
        end
        noDeath7To20KillData.onceKillCount = noDeath7To20KillData.onceKillCount + increaseKillCount
        noDeath7To20KillData.continueKillCount = noDeath7To20KillData.continueKillCount + increaseKillCount
        if DEBUG then
            printLog("7-20kill continueKillCount:" .. tostring(noDeath7To20KillData.continueKillCount))
        end
    end
    if noDeath7To20KillData.onceKillCount > 0 then
        needRecordVideoTime.noDeath7To20Kill =  (killData.latestTimeMills - noDeath7To20KillData.firstKillTime)
                + noDeath7To20KillData.KILL_PREV_VIDEO_TIME
                + noDeath7To20KillData.CONNECT_TIME_OUT
        --
        --if DEBUG then
        --    printLog("7-20 kill latestTime:" .. tostring(killData.latestTimeMills) .. " firstTime:" .. tostring(noDeath7To20KillData.firstKillTime))
        --end

    end
end

---游戏结束时，处理7-20杀逻辑
local function handleNoDeath7To20KillOnGameOver(currentTimeMills)
    local isContinueKillTimeout = isConnectedTimeoutInNoDeath7To20Kill(heroKillAssistsDeathData[KEY_STRING_KILL].lastTimeMills, currentTimeMills)
    if DEBUG then
        printLog("7-20 kill onGameOver firstKillTime:" .. tostring(noDeath7To20KillData.firstKillTime) .. " timeout:" .. tostring(isContinueKillTimeout))
    end

    ---游戏结束时，连杀未超时，则保存最后一杀视频
    if isContinueKillTimeout  == false and noDeath7To20KillData.firstKillTime > 0 then
        saveOnceKillVideo(noDeath7To20KillData.firstKillTime,
                heroKillAssistsDeathData[KEY_STRING_KILL].lastTimeMills,
                currentTimeMills,
                noDeath7To20KillData.onceKillCount,
                noDeath7To20KillData.continueKillVideoId)
    end
    updateNoDeath7To20KillData()
end

---游戏结束时，处理3-5杀逻辑
local function handleLimitedTime3To5KillOnGameOver(currentTimeMills)
    local isContinueKillTimeout = isConnectedTimeoutInLimitedTime3To5Kill(limitedTime3To5KillData.lastKillTime, currentTimeMills, limitedTime3To5KillData.continueKillCount)
    if isContinueKillTimeout == false then
        updateLimitedTime3To5KillData()
    end
end

---游戏结束时，处理大于20杀的逻辑
local function handleTotalMoreThen20KillOnGameOver()
    local killData = heroKillAssistsDeathData[KEY_STRING_KILL]
    local totalKillCount = killData.lastNumber
    if DEBUG then
        printLog("total 20 kill: totalKillCount：" .. tostring(totalKillCount) .. " currentEventPriority:" .. tostring(currentEventPriority))
    end
    if totalKillCount >= TOTAL_KILL_MORE_THEN_20_COUNT then
        local priority = eventPriority[KEY_TOTAL_MORE_THEN_20_KILL]
        if totalMoreThen20KillSwitchEnable == true and priority < currentEventPriority then
            currentEventPriority = priority
        end
    end
end

local totalMoreThen20AssistsData = {
    TOTAL_MORE_THEN_20_ASSISTS = 20,
    TOTAL_MORE_THEN_30_ASSISTS = 30,
}

---游戏结束时，处理超过20助攻的逻辑
local function handleTotalMoreThen20AssistsOnGameOver()
    local key
    local assistsData = heroKillAssistsDeathData[KEY_STRING_ASSISTS]
    local totalAssistsCount = assistsData.lastNumber
    if totalAssistsCount >= totalMoreThen20AssistsData.TOTAL_MORE_THEN_30_ASSISTS then
        key = KEY_TOTAL_MORE_THEN_30_ASSISTS
    elseif totalAssistsCount >= totalMoreThen20AssistsData.TOTAL_MORE_THEN_20_ASSISTS then
        key = KEY_TOTAL_MORE_THEN_20_ASSISTS
    end
    if DEBUG then
        printLog("assistsCount:" .. tostring(totalAssistsCount))
    end
    if key ~= nil then
        local priority = eventPriority[key]
        local switchEnable = switchState[key]
        if switchEnable == true and priority < currentEventPriority then
            currentEventPriority = priority
        end
    end
end


local function isConnectedTimeoutInNoKillNoDeath10To20Assists(lastAssistsTimeMills, currentTimeMills)
    return currentTimeMills - lastAssistsTimeMills > noKillNoDeath10To20AssistsData.CONNECT_TIME_OUT;
end

local function saveSingleVideoInNoKillNoDeath10To20Assists(firstAssistsTimeMills, lastAssistsTimeMills, currentTimeMills, saveVideoId, onceAssistsCount)
    if screenRecorder == nil then
        printLog("screenRecorder=nil")
        return
    end
    local startTime = firstAssistsTimeMills - noKillNoDeath10To20AssistsData.ASSISTS_PREV_VIDEO_TIME
    local endTime = lastAssistsTimeMills + noKillNoDeath10To20AssistsData.ASSISTS_AFTER_VIDEO_TIME

    local savePath = buildOnceAssistsVideoSavePath(startTime, endTime, onceAssistsCount, currentTimeMills, saveVideoId)
    screenRecorder:signalSaveOnceKillVideo(startTime, endTime, savePath)
    if DEBUG then
        printLog("save10To20Assists start:" .. tostring(startTime) .. " end:"
                .. tostring(endTime) .. " path:" .. tostring(savePath) .. "screenRecorder:" .. tostring(screenRecorder))
    end
end

local function getNoKillNoDeath10To20AssistsKey(continueAssistsCount)
    if continueAssistsCount >= noKillNoDeath10To20AssistsData.ASSISTS_COUNT_LEVEL_20 then
        return KEY_NO_KILL_NO_DEATH_20_ASSISTS
    elseif continueAssistsCount >= noKillNoDeath10To20AssistsData.ASSISTS_COUNT_LEVEL_10 then
        return KEY_NO_KILL_NO_DEATH_10_ASSISTS
    end
    return KEY_NO_KILL_NO_DEATH_10_ASSISTS
end

local function updateNoKillNoDeath10To20AssistsData()
    local continueAssistsCount = noKillNoDeath10To20AssistsData.continueAssistsCount
    if DEBUG then
        printLog("10-20 assists: continueAssistsCount:" .. tostring(continueAssistsCount)
                .. " currentEventPriority:" .. tostring(currentEventPriority)
                .. " videoId:" .. tostring(noKillNoDeath10To20AssistsData.continueAssistsVideoId))
    end
    if continueAssistsCount >= noKillNoDeath10To20AssistsData.ASSISTS_COUNT_LEVEL_10
            and continueAssistsCount >= noKillNoDeath10To20AssistsData.maxContinueAssistsCount then
        local key = getNoKillNoDeath10To20AssistsKey(continueAssistsCount)
        local switchEnable = switchState[key]
        local priority = eventPriority[key]
        if switchEnable == true and priority <= currentEventPriority then
            currentEventPriority = priority
            noKillNoDeath10To20AssistsData.maxContinueAssistsCount = continueAssistsCount
            noKillNoDeath10To20AssistsData.maxContinueAssistsVideoId = noKillNoDeath10To20AssistsData.continueAssistsVideoId
        end
    end
end

--期间无杀人、无死亡，有10到20次的助攻
local function handleNoKillNoDeath10To20Assists(currentTimeMills)
    local increaseAssistsCount = heroKillAssistsDeathData[KEY_STRING_ASSISTS].latestNumber - heroKillAssistsDeathData[KEY_STRING_ASSISTS].lastNumber
    local increaseKillCount = heroKillAssistsDeathData[KEY_STRING_KILL].latestNumber - heroKillAssistsDeathData[KEY_STRING_KILL].lastNumber
    local increaseDeathCount = heroKillAssistsDeathData[KEY_STRING_DEATH].latestNumber - heroKillAssistsDeathData[KEY_STRING_DEATH].lastNumber

    local isConnectedTimeout = isConnectedTimeoutInNoKillNoDeath10To20Assists(heroKillAssistsDeathData[KEY_STRING_ASSISTS].lastTimeMills, currentTimeMills)

    if noKillNoDeath10To20AssistsData.firstAssistsTimeMills > 0 and isConnectedTimeout then
        saveSingleVideoInNoKillNoDeath10To20Assists(
                noKillNoDeath10To20AssistsData.firstAssistsTimeMills,
                heroKillAssistsDeathData[KEY_STRING_ASSISTS].lastTimeMills,
                currentTimeMills,
                noKillNoDeath10To20AssistsData.continueAssistsVideoId,
                noKillNoDeath10To20AssistsData.onceAssistsCount)
        noKillNoDeath10To20AssistsData.firstAssistsTimeMills = 0
        noKillNoDeath10To20AssistsData.onceAssistsCount = 0
    end

    if increaseAssistsCount > 0 and increaseAssistsCount <= VALID_MAX_INCREASE then
        if noKillNoDeath10To20AssistsData.firstAssistsTimeMills == 0 then
            noKillNoDeath10To20AssistsData.firstAssistsTimeMills = currentTimeMills
        end
        noKillNoDeath10To20AssistsData.onceAssistsCount = noKillNoDeath10To20AssistsData.onceAssistsCount + increaseAssistsCount
        noKillNoDeath10To20AssistsData.continueAssistsCount = noKillNoDeath10To20AssistsData.continueAssistsCount + increaseAssistsCount
        if DEBUG then
            printLog("10-20 assists:continueAssistsCount:" .. tostring(noKillNoDeath10To20AssistsData.continueAssistsCount))
        end
    end

    --if noKillNoDeath10To20AssistsData.continueAssistsCount > 0 and noKillNoDeath10To20AssistsData.firstAssistsTimeMills == 0 then
    --    noKillNoDeath10To20AssistsData.firstAssistsTimeMills = currentTimeMills
    --end

    --有死亡或者杀人，就要重置助攻的计数
    if (increaseKillCount > 0 and increaseKillCount <= VALID_MAX_INCREASE) or (increaseDeathCount > 0 and increaseDeathCount < VALID_MAX_INCREASE) then
        updateNoKillNoDeath10To20AssistsData()

        noKillNoDeath10To20AssistsData.continueAssistsVideoId = noKillNoDeath10To20AssistsData.continueAssistsVideoId + 1
        noKillNoDeath10To20AssistsData.continueAssistsCount = 0
    end

    if noKillNoDeath10To20AssistsData.onceAssistsCount > 0 then
        local latestTime = heroKillAssistsDeathData[KEY_STRING_ASSISTS].latestTimeMills;
        local firstTime = noKillNoDeath10To20AssistsData.firstAssistsTimeMills
        needRecordVideoTime.noKillNoDeath10To20Assists =  (latestTime - firstTime)
                + noKillNoDeath10To20AssistsData.ASSISTS_PREV_VIDEO_TIME
                + noKillNoDeath10To20AssistsData.CONNECT_TIME_OUT
        --if DEBUG then
        --    printLog("10-20 assists latestTime:" .. tostring(latestTime) .. " firstTime:" .. tostring(firstTime))
        --end
    end

end

local function handleNoKillNoDeath10To20AssistsOnGameOver(currentTimeMills)
    local isConnectedTimeout = isConnectedTimeoutInNoKillNoDeath10To20Assists(heroKillAssistsDeathData[KEY_STRING_ASSISTS].lastTimeMills, currentTimeMills)
    if DEBUG then
        printLog("10-20 assists onGameOver firstAssistsTimeMills:" .. tostring(noKillNoDeath10To20AssistsData.firstAssistsTimeMills) .. " timeout:" .. tostring(isConnectedTimeout))
    end
    if noKillNoDeath10To20AssistsData.firstAssistsTimeMills > 0 and isConnectedTimeout == false then
        saveSingleVideoInNoKillNoDeath10To20Assists(
                noKillNoDeath10To20AssistsData.firstAssistsTimeMills,
                heroKillAssistsDeathData[KEY_STRING_ASSISTS].lastTimeMills,
                currentTimeMills,
                noKillNoDeath10To20AssistsData.continueAssistsVideoId,
                noKillNoDeath10To20AssistsData.onceAssistsCount)
    end
    updateNoKillNoDeath10To20AssistsData()
end


local function isConnectedTimeoutInNoKillNoAssists7To10Death(lastDeathTimeMills, currentTimeMills)
    return currentTimeMills - lastDeathTimeMills > noKillNoAssists7To10DeathData.CONNECT_TIME_OUT;
end

local function saveSingleVideoInNoKillNoAssists7To10Death(firstDeathTimeMills, lastDeathTimeMills, currentTimeMills, saveVideoId, onceDeathCount)
    if screenRecorder == nil then
        printLog("screenRecorder=nil")
        return
    end
    local startTime = firstDeathTimeMills - noKillNoAssists7To10DeathData.DEATH_PREV_VIDEO_TIME
    local endTime = lastDeathTimeMills + noKillNoAssists7To10DeathData.DEATH_AFTER_VIDEO_TIME

    local savePath = buildOnceDeathVideoSavePath(startTime, endTime, onceDeathCount, currentTimeMills, saveVideoId)
    screenRecorder:signalSaveOnceKillVideo(startTime, endTime, savePath)
    if DEBUG then
        printLog("save7To10Death start:" .. tostring(startTime) .. " end:"
                .. tostring(endTime) .. " path:" .. tostring(savePath) .. "screenRecorder:" .. tostring(screenRecorder))
    end
end

local function getNoKillNoAssists7To10DeathKey(continueDeathCount)
    if continueDeathCount >= noKillNoAssists7To10DeathData.DEATH_COUNT_LEVEL_10 then
        return KEY_NO_KILL_NO_ASSISTS_10_DEATH
    elseif continueDeathCount >= noKillNoAssists7To10DeathData.DEATH_COUNT_LEVEL_7 then
        return KEY_NO_KILL_NO_ASSISTS_7_DEATH
    end
    return KEY_NO_KILL_NO_ASSISTS_7_DEATH
end

local function updateNoKillNoAssists7To10DeathData()
    local continueDeathCount = noKillNoAssists7To10DeathData.continueDeathCount
    if DEBUG then
        printLog("7-10 death: continueDeathCount:" .. tostring(continueDeathCount)
                .. " currentEventPriority:" .. tostring(currentEventPriority)
                .. " videoId:" .. tostring(noKillNoAssists7To10DeathData.continueDeathVideoId))
    end
    if continueDeathCount >= noKillNoAssists7To10DeathData.DEATH_COUNT_LEVEL_7
            and continueDeathCount >= noKillNoAssists7To10DeathData.maxContinueDeathCount then
        local key = getNoKillNoAssists7To10DeathKey(continueDeathCount)
        local switchEnable = switchState[key]
        local priority = eventPriority[key]
        if switchEnable == true and priority <= currentEventPriority then
            currentEventPriority = priority
            noKillNoAssists7To10DeathData.maxContinueDeathCount = continueDeathCount
            noKillNoAssists7To10DeathData.maxContinueDeathVideoId = noKillNoAssists7To10DeathData.continueDeathVideoId
        end
    end

end

--期间无杀人、无助攻，有10到20次的杀人
local function handleNoKillNoAssists7To10Death(currentTimeMills)
    local increaseDeathCount = heroKillAssistsDeathData[KEY_STRING_DEATH].latestNumber - heroKillAssistsDeathData[KEY_STRING_DEATH].lastNumber
    local increaseAssistsCount = heroKillAssistsDeathData[KEY_STRING_ASSISTS].latestNumber - heroKillAssistsDeathData[KEY_STRING_ASSISTS].lastNumber
    local increaseKillCount = heroKillAssistsDeathData[KEY_STRING_KILL].latestNumber - heroKillAssistsDeathData[KEY_STRING_KILL].lastNumber

    if DEBUG then
        printLog("increaseDeathCount:" .. tostring(increaseDeathCount) .. " increaseAssistsCount:" .. tostring(increaseAssistsCount) .. " increaseKillCount:"..tostring(increaseKillCount))
    end

    local isConnectedTimeout = isConnectedTimeoutInNoKillNoAssists7To10Death(heroKillAssistsDeathData[KEY_STRING_DEATH].lastTimeMills, currentTimeMills)

    if noKillNoAssists7To10DeathData.firstDeathTimeMills > 0 and isConnectedTimeout then
        saveSingleVideoInNoKillNoAssists7To10Death(
                noKillNoAssists7To10DeathData.firstDeathTimeMills,
                heroKillAssistsDeathData[KEY_STRING_DEATH].lastTimeMills,
                currentTimeMills,
                noKillNoAssists7To10DeathData.continueDeathVideoId,
                noKillNoAssists7To10DeathData.onceDeathCount)
        noKillNoAssists7To10DeathData.firstDeathTimeMills = 0
        noKillNoAssists7To10DeathData.onceDeathCount = 0
    end

    if increaseDeathCount > 0 and increaseDeathCount <= VALID_MAX_INCREASE then
        if noKillNoAssists7To10DeathData.firstDeathTimeMills == 0 then
            noKillNoAssists7To10DeathData.firstDeathTimeMills = currentTimeMills
        end
        noKillNoAssists7To10DeathData.continueDeathCount = noKillNoAssists7To10DeathData.continueDeathCount + increaseDeathCount
        noKillNoAssists7To10DeathData.onceDeathCount = noKillNoAssists7To10DeathData.onceDeathCount + increaseDeathCount
        if DEBUG then
            printLog("7-10death: continueDeathCount:" .. tostring(noKillNoAssists7To10DeathData.continueDeathCount))
        end
    end

    if (increaseAssistsCount > 0 and increaseAssistsCount <= VALID_MAX_INCREASE) or (increaseKillCount > 0 and increaseKillCount <= VALID_MAX_INCREASE) then
        updateNoKillNoAssists7To10DeathData()

        noKillNoAssists7To10DeathData.continueDeathVideoId = noKillNoAssists7To10DeathData.continueDeathVideoId + 1
        noKillNoAssists7To10DeathData.continueDeathCount = 0
    end

    if noKillNoAssists7To10DeathData.onceDeathCount > 0  then
        local latestTime = heroKillAssistsDeathData[KEY_STRING_DEATH].latestTimeMills;
        local firstTime = noKillNoAssists7To10DeathData.firstDeathTimeMills
        needRecordVideoTime.noKillNoAssists7To10Death =  (latestTime - firstTime)
                + noKillNoAssists7To10DeathData.DEATH_PREV_VIDEO_TIME
                + noKillNoAssists7To10DeathData.CONNECT_TIME_OUT
        --if DEBUG then
        --    printLog("7-10 death latestTime:" .. tostring(latestTime) .. " firstTime:" .. tostring(firstTime))
        --end
    end
end

local function handleNoKillNoAssists7To10DeathOnGameOver(currentTimeMills)
    local isConnectedTimeout = isConnectedTimeoutInNoKillNoAssists7To10Death(heroKillAssistsDeathData[KEY_STRING_DEATH].lastTimeMills, currentTimeMills)
    ---游戏结束时，上次死亡视频还未保存，则先保存视频
    if DEBUG then
        printLog("7-10 death onGameOver firstDeathTime:" .. tostring(noKillNoAssists7To10DeathData.firstDeathTimeMills) .. " timeout:" .. tostring(isConnectedTimeout))
    end
    if noKillNoAssists7To10DeathData.firstDeathTimeMills > 0 and isConnectedTimeout == false then
        saveSingleVideoInNoKillNoAssists7To10Death(
                noKillNoAssists7To10DeathData.firstDeathTimeMills,
                heroKillAssistsDeathData[KEY_STRING_DEATH].lastTimeMills,
                currentTimeMills,
                noKillNoAssists7To10DeathData.continueDeathVideoId,
                noKillNoAssists7To10DeathData.onceDeathCount)
    end
    updateNoKillNoAssists7To10DeathData()
end

local function dismissGloryMomentOnUIThread()
    commonlib_runOnUIThread(function ()
        if DEBUG then
            printLog("dismiss PreviewWindowOnUIThread")
        end
        if gloryMomentFloatView ~= nil then
            gloryMomentFloatView:destroy()
            gloryMomentFloatView = nil
        end
        if gloryMomentView ~= nil then
            gloryMomentView:destroy()
            gloryMomentView = nil
        end
    end)
end

local function isFullScreen()
    local solution = commonlib_getCommonAbTestSolution("section_glory_moment_fullscreen", true)
    printLog("solution : " .. tostring(solution))
    return solution ~= nil and  tostring(solution) == "1";
end

local function addGloryMomentView()
    commonlib_runOnUIThread(function()
        if isFullScreen() then
            gloryMomentFloatView = commonlib_getFloatViewMgrEx():create(
                    0, 0,
                    COMMON_LAYOUTPARAM.MATCH_PARENT, COMMON_LAYOUTPARAM.MATCH_PARENT,
                    Anchor().TOPLEFT,
                    true);
            gloryMomentFloatView:setGravity(Anchor().TOP);
        else
            local realScreenSize = commonlib_getScreenRealSize();
            local width = math.max(realScreenSize.w, realScreenSize.h)
            local height = math.min(realScreenSize.w, realScreenSize.h)
            printLog(tostring(realScreenSize.w).."_"..tostring(realScreenSize.h))
            printLog(tostring(width * 0.8).."_"..tostring(height*0.8))
            gloryMomentFloatView = commonlib_getFloatViewMgrEx():create(
                    0, 0,
                    width * 0.8 / commonlib_getScale(), height * 0.8 / commonlib_getScale(),
                    Anchor().TOPLEFT,
                    true);
            gloryMomentFloatView:setGravity(Anchor().CENTER);
        end
        gloryMomentView = gloryMomentFloatView:addGloryMomentView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top, 1,
                showVideoData.outVideoPath, showVideoData.honourMomentType, showVideoData.showCount);
        gloryMomentView:setOnEventListener(function (action)
            printLog("on event ："  .. action)
            if action == "action_click_close" then
                dismissGloryMomentOnUIThread()
            end
        end)
        gloryMomentFloatView:show()
        gloryMomentFloatView:addStatusChangedListener(function(action)
            printLog("on status changed : " .. tostring(action))
            if gloryMomentView ~= nil then
                if action == "hide" then
                    gloryMomentView:onPause()
                elseif action == "show" then
                    gloryMomentView:onResume()
                end
            end
        end)
    end)
end

local function showHonourWindow()
    ---总开关关闭时，不弹窗
    if  honourMomentSwitchEnable == false then
        if DEBUG then
            printLog("isCbSwitchChecked:" .. tostring(honourMomentSwitchEnable))
        end
        return;
    end

    if hasShowedVideoWindowInOnceGame == true then
        if DEBUG then
            printLog("已经展示过弹窗")
        end
        return;
    end

    ---文件不存在，不弹出
    if not videoFileExists(showVideoData.outVideoPath) then
        if DEBUG then
            printLog("文件不存在:" .. tostring(showVideoData.outVideoPath))
        end
        return;
    end

    addGloryMomentView()

    if DEBUG then
        printLog("show window success")
    end
    hasShowedVideoWindowInOnceGame = true;
end

local function initSwitchStateMap()
    switchState = {
        [KEY_LIMITED_TIME_3_KILL] = limitedTime3KillSwitchEnable,
        [KEY_LIMITED_TIME_4_KILL] = limitedTime4KillSwitchEnable,
        [KEY_LIMITED_TIME_5_KILL] = limitedTime5KillSwitchEnable,
        [KEY_NO_DEATH_7_KILL] = noDeath7KillSwitchEnable,
        [KEY_NO_DEATH_15_KILL] = noDeath15KillSwitchEnable,
        [KEY_NO_DEATH_20_KILL] = noDeath20KillSwitchEnable,
        [KEY_TOTAL_MORE_THEN_20_KILL] = totalMoreThen20KillSwitchEnable,
        [KEY_TOTAL_MORE_THEN_30_ASSISTS] = totalMoreThen30AssistsSwitchEnable,
        [KEY_TOTAL_MORE_THEN_20_ASSISTS] = totalMoreThen20AssistsSwitchEnable,
        [KEY_NO_KILL_NO_DEATH_20_ASSISTS] = noKillNoDeath20AssistsSwitchEnable,
        [KEY_NO_KILL_NO_DEATH_10_ASSISTS] = noKillNoDeath10AssistsSwitchEnable,
        [KEY_NO_KILL_NO_ASSISTS_7_DEATH] = noKillNoAssists7DeathSwitchEnable,
        [KEY_NO_KILL_NO_ASSISTS_10_DEATH] = noKillNoAssists10DeathSwitchEnable,
    }
end

local function resetSwitchState()
    initSwitchState()
    initSwitchStateMap()
    commonlib_runOnUIThread(function()
        if restoreSwitch ~= nil then
            restoreSwitch:setChecked(isRestoreSwitchChecked)
        end
        setTextViewColorBySwitch(restoreDescTextView, isRestoreSwitchChecked)
    end)
    if DEBUG then
        printLog("总开关:" .. tostring(honourMomentSwitchEnable))
        printLog("3kill:" .. tostring(limitedTime3KillSwitchEnable))
        printLog("4kill:" .. tostring(limitedTime4KillSwitchEnable))
        printLog("5kill:" .. tostring(limitedTime5KillSwitchEnable))
        printLog("7kill:" .. tostring(noDeath7KillSwitchEnable))
        printLog("15kill:" .. tostring(noDeath15KillSwitchEnable))
        printLog("20kill:" .. tostring(noDeath20KillSwitchEnable))
        printLog("20总杀:" .. tostring(totalMoreThen20KillSwitchEnable))
        printLog("20 assists:" .. tostring(noKillNoDeath20AssistsSwitchEnable))
        printLog("10 assists:" .. tostring(noKillNoDeath10AssistsSwitchEnable))
        printLog("30总助:" .. tostring(totalMoreThen30AssistsSwitchEnable))
        printLog("20总助:" .. tostring(totalMoreThen20AssistsSwitchEnable))
        printLog("7 death:" .. tostring(noKillNoAssists7DeathSwitchEnable))
        printLog("10 death:" .. tostring(noKillNoAssists10DeathSwitchEnable))

    end
end

---重置杀人，助攻，死亡数据
local function resetHeroKillAssistsDeathData(key)
    local killAssistsDeathData = heroKillAssistsDeathData[key]
    killAssistsDeathData.latestNumber = 0;
    killAssistsDeathData.latestTimeMills = 0;
    killAssistsDeathData.lastNumber = 0;
    killAssistsDeathData.lastTimeMills = 0;
end

local function resetLimitedTime3To5KillData()
    limitedTime3To5KillData.maxContinueKillCount = 0;
    limitedTime3To5KillData.continueKillCount = 0;
    limitedTime3To5KillData.firstKillTime = 0;
end

local function resetNoDeath7To20KillData()
    noDeath7To20KillData.firstKillTime = 0;
    noDeath7To20KillData.maxContinueKillCount = 0;
    noDeath7To20KillData.maxContinueKillVideoId = 0;
    noDeath7To20KillData.continueKillCount = 0;
    noDeath7To20KillData.onceKillCount = 0;
    noDeath7To20KillData.continueKillVideoId = 0;
end

local function resetNoKillNoDeath10To20Assists()
    noKillNoDeath10To20AssistsData.firstAssistsTimeMills = 0;
    noKillNoDeath10To20AssistsData.maxContinueAssistsCount = 0;
    noKillNoDeath10To20AssistsData.maxContinueAssistsVideoId = 0;
    noKillNoDeath10To20AssistsData.continueAssistsCount = 0;
    noKillNoDeath10To20AssistsData.onceAssistsCount = 0;
    noKillNoDeath10To20AssistsData.continueAssistsVideoId = 0;
end

local function resetNoKillNoAssists7To10Death()
    noKillNoAssists7To10DeathData.firstDeathTimeMills = 0;
    noKillNoAssists7To10DeathData.maxContinueDeathCount = 0;
    noKillNoAssists7To10DeathData.maxContinueDeathVideoId = 0;
    noKillNoAssists7To10DeathData.continueDeathCount = 0;
    noKillNoAssists7To10DeathData.onceDeathCount = 0;
    noKillNoAssists7To10DeathData.continueDeathVideoId = 0;
end

local function resetShowVideoData()
    showVideoData.showCount = 0;
    showVideoData.outVideoPath = nil;
    showVideoData.honourMomentType = -1;
end

local function resetData()
    currentEventPriority = 100
    hasShowedVideoWindowInOnceGame = false
    resetShowVideoData()
    resetLimitedTime3To5KillData()
    resetNoDeath7To20KillData()
    resetNoKillNoDeath10To20Assists()
    resetNoKillNoAssists7To10Death()
    resetHeroKillAssistsDeathData(KEY_STRING_KILL)
    resetHeroKillAssistsDeathData(KEY_STRING_ASSISTS)
    resetHeroKillAssistsDeathData(KEY_STRING_DEATH)
end

local function onGameStart()
    if commonlib_isFlameMountainMap() then
        printLog("onGameStart unsupport FlameMountainMap")
        return;
    end
    if DEBUG then
        printLog("onGameStart")
    end
    resetSwitchState()
    resetData()
    if honourMomentSwitchEnable then
        initScreenRecord()
        startScreenRecord()
        deleteCacheFile()
    end
end

local function onGameRunning()
    if commonlib_isFlameMountainMap() then
        printLog("onGameRunning unsupport FlameMountainMap")
        return;
    end
    if honourMomentSwitchEnable == false then
        return;
    end
    --1、更新识别的数字
    local currentTimeMills = commonlib_getCurrentTime()
    updateHeroKillAssistsDeathData(currentTimeMills)

    --2、处理各种记录行为
    handleLimitedTime3To5Kill(currentTimeMills)

    handleNoDeath7To20Kill(currentTimeMills)

    handleNoKillNoDeath10To20Assists(currentTimeMills)

    handleNoKillNoAssists7To10Death(currentTimeMills)

    --3、计算最长的记录时间
    updateNeedRecordVideoCacheTime()

    if DEBUG then
        printLog("once running total time:" .. tostring(commonlib_getCurrentTime() - currentTimeMills))
    end
end

---合并视频成功的回调
local function combineVideoCallback()
    if DEBUG then
        printLog("合并视频成功 isGameOverDetail:" .. tostring(isGameOverDetail))
    end
    if isGameOverDetail then
        showHonourWindow()
    end
end

---合并视频
local function combineVideo(outVideoPath, combineVideoId, fileDir)
    if DEBUG then
        printLog("combineVideo:screenRecorder:" .. tostring(screenRecorder) .. " fileDir:" .. tostring(fileDir))
    end
    if screenRecorder ~= nil and fileDir ~= nil then
        screenRecorder:combineHonourVideo(fileDir, combineVideoId, outVideoPath, combineVideoCallback)
    end
end

local function buildLimitedTime3To5KillShowVideoData()
    showVideoData.honourMomentType = HONOUR_MOMENT_TYPE_LIMITED_TIME_3TO5_KILL
    showVideoData.showCount = limitedTime3To5KillData.maxContinueKillCount

    if DEBUG then
        printLog("show 3-5 kill, showKillNum:" .. tostring(showVideoData.showCount))
    end
end

local function buildNoDeath7To20KillShowVideoData()
    showVideoData.honourMomentType = HONOUR_MOMENT_TYPE_NO_DEATH_7TO20_KILL
    showVideoData.showCount = noDeath7To20KillData.maxContinueKillCount
    showVideoData.outVideoPath = getOutVideoPath(showVideoData.honourMomentType, showVideoData.showCount)

    if DEBUG then
        printLog("show 7-20 kill, showKillNum:" .. tostring(showVideoData.showCount))
    end
end

local function buildTotalMoreThen20KillShowVideoData()
    showVideoData.honourMomentType = HONOUR_MOMENT_TYPE_TOTAL_MORE_THEN_20_KILL
    local killData = heroKillAssistsDeathData[KEY_STRING_KILL]
    showVideoData.showCount = killData.lastNumber
    showVideoData.outVideoPath = getOutVideoPath(showVideoData.honourMomentType, showVideoData.showCount)

    if DEBUG then
        printLog("show total more than 20 kill, showKillNum:" .. tostring(showVideoData.showCount))
    end
end

local function buildTotalMoreThen20AssistsShowVideoData()
    showVideoData.honourMomentType = HONOUR_MOMENT_TYPE_TOTAL_MORE_THEN_20_ASSISTS
    local assistsData = heroKillAssistsDeathData[KEY_STRING_ASSISTS]
    showVideoData.showCount = assistsData.lastNumber
    showVideoData.outVideoPath = getOutVideoPath(showVideoData.honourMomentType, showVideoData.showCount)

    if DEBUG then
        printLog("show total more than 20 assists, showKillNum:" .. tostring(showVideoData.showCount))
    end
end

local function buildNoKillNoDeath10To20AssistsShowVideoData()
    showVideoData.honourMomentType = HONOUR_MOMENT_TYPE_NO_KILL_NO_DEATH_10TO20_ASSISTS
    showVideoData.showCount = noKillNoDeath10To20AssistsData.maxContinueAssistsCount
    showVideoData.outVideoPath = getOutVideoPath(showVideoData.honourMomentType, showVideoData.showCount)

    if DEBUG then
        printLog("show 10-20 assists, showKillNum:" .. tostring(showVideoData.showCount))
    end
end

local function buildNoKillNoAssists7To10DeathShowVideoData()
    showVideoData.honourMomentType = HONOUR_MOMENT_TYPE_NO_KILL_NO_ASSISTS_7TO10_DEATH
    showVideoData.showCount = noKillNoAssists7To10DeathData.maxContinueDeathCount
    showVideoData.outVideoPath = getOutVideoPath(showVideoData.honourMomentType, showVideoData.showCount)

    if DEBUG then
        printLog("show 7-10 death, showKillNum:" .. tostring(showVideoData.showCount))
    end
end


---根据优先级，选择可展示的视频
local function choiceShowVideoByPriority()
    if DEBUG then
        printLog("currentEventPriority:" .. tostring(currentEventPriority))
    end

    if currentEventPriority == EVENT_PRIORITY_LIMITED_TIME_3_KILL
            or currentEventPriority == EVENT_PRIORITY_LIMITED_TIME_4_KILL
            or currentEventPriority == EVENT_PRIORITY_LIMITED_TIME_5_KILL then
        buildLimitedTime3To5KillShowVideoData()
    elseif currentEventPriority == EVENT_PRIORITY_NO_DEATH_20_KILL
            or currentEventPriority == EVENT_PRIORITY_NO_DEATH_15_KILL
            or currentEventPriority == EVENT_PRIORITY_NO_DEATH_7_KILL then
        buildNoDeath7To20KillShowVideoData()
        combineVideo(showVideoData.outVideoPath, noDeath7To20KillData.maxContinueKillVideoId, continueKillTempDir)
    elseif currentEventPriority == EVENT_PRIORITY_TOTAL_MORE_THEN_20_KILL then
        buildTotalMoreThen20KillShowVideoData()
        combineVideo(showVideoData.outVideoPath, -1, continueKillTempDir)
    elseif currentEventPriority == EVENT_PRIORITY_TOTAL_MORE_THEN_30_ASSISTS
            or currentEventPriority == EVENT_PRIORITY_TOTAL_MORE_THEN_20_ASSISTS then
        buildTotalMoreThen20AssistsShowVideoData()
        combineVideo(showVideoData.outVideoPath, -1, continueAssistsTempDir)
    elseif currentEventPriority == EVENT_PRIORITY_NO_KILL_NO_DEATH_10_ASSISTS
            or currentEventPriority == EVENT_PRIORITY_NO_KILL_NO_DEATH_20_ASSISTS then
        buildNoKillNoDeath10To20AssistsShowVideoData()
        combineVideo(showVideoData.outVideoPath, noKillNoDeath10To20AssistsData.maxContinueAssistsVideoId, continueAssistsTempDir)
    elseif currentEventPriority == EVENT_PRIORITY_NO_KILL_NO_ASSISTS_7_DEATH
            or currentEventPriority == EVENT_PRIORITY_NO_KILL_NO_ASSISTS_10_DEATH then
        buildNoKillNoAssists7To10DeathShowVideoData()
        combineVideo(showVideoData.outVideoPath, noKillNoAssists7To10DeathData.maxContinueDeathVideoId, continueDeathTempDir)
    end
end

local function onGameOver()
    if commonlib_isFlameMountainMap() then
        printLog("onGameOver unsupport FlameMountainMap")
        return;
    end
    if DEBUG then
        printLog("onGameOver")
    end

    if honourMomentSwitchEnable then
        local currentTimeMills = commonlib_getCurrentTime()
        handleLimitedTime3To5KillOnGameOver(currentTimeMills)
        handleNoDeath7To20KillOnGameOver(currentTimeMills)
        handleTotalMoreThen20KillOnGameOver()
        handleNoKillNoDeath10To20AssistsOnGameOver(currentTimeMills)
        handleTotalMoreThen20AssistsOnGameOver()
        handleNoKillNoAssists7To10DeathOnGameOver(currentTimeMills)

        choiceShowVideoByPriority()
    end
end

local function onGameOverDetail(isDetail)
    if commonlib_isFlameMountainMap() then
        printLog("onGameOverDetail unsupport FlameMountainMap")
        return;
    end
    if DEBUG then
        printLog("isGameOverDetail:"..tostring(isDetail))
    end
    isGameOverDetail = isDetail
    if isDetail and honourMomentSwitchEnable then
        showHonourWindow()
        releaseScreenRecord()
    end
end

local function registerGameEventCallbacks()
    commonlib_registerCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over_detail, onGameOverDetail)
end

local function unregisterGameEventCallbacks()
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over_detail, onGameOverDetail)
end

local function initNumberPosition()
    killNumPosition = {
        [LEFT] = KEY_SSCB_KILL_NUM_RECOGNIZE_ON_SHOP_MENU_POSITION_LEFT,
        [RIGHT] = KEY_SSCB_KILL_NUM_RECOGNIZE_ON_SHOP_MENU_POSITION_RIGHT
    }

    assistsPosition = {
        [LEFT] = KEY_GM_ASSISTS_NUM_RECOGNIZE_LEFT,
        [RIGHT] = KEY_GM_ASSISTS_NUM_RECOGNIZE_RIGHT
    }

    deathPosition = {
        [LEFT] = KEY_GM_DEATH_NUM_RECOGNIZE_LEFT,
        [RIGHT] = KEY_GM_DEATH_NUM_RECOGNIZE_RIGHT
    }
end

local function initData()
    gRecognizeAdapterManager = AdapterManagerClass:getRecognizeInstance();
    initNumberPosition()
end

local globalCloudSwitch;

local function getCloudSwitch()
    if globalCloudSwitch ~= nil then
        return globalCloudSwitch;
    end
    globalCloudSwitch = commonlib_getSgameFuncCloudSwitch(FUNC_CLOUD_SWITCH_KEY_FOR_YYB_CHANNEL, false)
    --测试代码
    --globalCloudSwitch = true

    return globalCloudSwitch;
end

local function init()
    if DEBUG then
        printLog("init")
    end
    local cloudSwitch = getCloudSwitch();
    printLog("cloudSwitch:" .. tostring(cloudSwitch))
    if cloudSwitch == false then
        return
    end
    initData()
    initSettingView()
    registerGameEventCallbacks()
end

local function uninit()
    if DEBUG then
        printLog("uninit")
    end
    local cloudSwitch = getCloudSwitch();
    if cloudSwitch == false then
        return
    end
    unregisterGameEventCallbacks()
end

table.insert(common_life_circle_callbacks, { init, uninit, SGAME_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.glory_moment })
