---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by yefeng.
--- DateTime: 2018/4/12 16:49
---

local SETTING_PANEL_NAME = "超人键盘"
local SWITCH_CHECKBOX_TEXT = "开启超人键盘";
local KEYBOARD_OPEN_INTRODUCTION = "您已开启超人键盘，可以愉快地怼人了。";
local KEYBOARD_CLOSE_INTRODUCTION_1 = "*您需要在“游戏超人-我的页面-超人键盘”里开启超人键盘。";
local KEYBOARD_CLOSE_INTRODUCTION_2 = "只需两步，就可轻松怼人，说别人的话，让别人无话可说。";

local keyboardModule
local gRecognizeAdapterManager;

local settingView
local cbSwitch
local cbFirstTextView
local cbSecondTextView
local keyboardEntryView

local KEYBOARD_TAG = "keyboard_setting"

local ACTION_START_SHOW = "action_start_show";
local ACTION_CLICK_SWITCH = "action_click_switch";

local hasLoading = false


local function printLog(msg)
    commonlib_print(KEYBOARD_TAG, msg)
end

--- 检测当前是否已开启游戏超人键盘
local function isSetKeyboardAsDefault()
    local res = keyboardModule:isGameMasterKeyboardAsDefault(null)
    --printLog("isOpenSuperMasterKeybaord " .. tostring(res))
    return res
end

local function isAddKeyboardToSystem()
    local res = keyboardModule:isAddGameMaterKeyboardToSystem(null)
    --printLog("isAddKeyboardToSystem " .. tostring(res))
    return res
end

local function isEnableKeyboardLocal()
    local res = keyboardModule:isEnableLocal()
    --printLog("isEnableKeyboardLocal " .. tostring(res))
    return res
end

local function isEnableKeyboardCloud()
    local res = keyboardModule:isEnable()
    --printLog("isEnableKeyboardCloud " .. tostring(res))
    return res
end

local function isEnableKeyboard()
    if isEnableKeyboardCloud() and isEnableKeyboardLocal() and isAddKeyboardToSystem() then
        return true
    end
    return false
end

local function updateKeyboardSettingView(isOpenKeyboard)
    if (isOpenKeyboard) then
        cbFirstTextView:setText(KEYBOARD_OPEN_INTRODUCTION, "#FFFFFF");
        cbSecondTextView:hide();
    else
        cbFirstTextView:setText(KEYBOARD_CLOSE_INTRODUCTION_1, "#FFAB00");
        cbSecondTextView:show();
    end
end

local function onCheckboxSelected(checkboxId, isChecked)
    --printLog("onCheckboxSelected ischeck")
end

local function onCheckBoxClick()
    --printLog("onCheckboxSelected click")
    if (isAddKeyboardToSystem()) then
        local lastStatus = isSetKeyboardAsDefault()
        updateKeyboardSettingView(not lastStatus);
        keyboardModule:switchSystemKeyboard(null);
        commonlib_runOnUIThread(function()
            settingView:hide()
        end)
        onKeyboardSettingsRestoreChange(lastStatus);
    end
end

local function enableKeyboardCheckBox()
    if (isAddKeyboardToSystem()) then
        cbSwitch:setClickable(true);
    else
        cbSwitch:setClickable(false);
    end
end

--- 设置面板相关
local function initConfigUI()
    printLog("initConfigUI begin")

    settingView = SettingView()
    local tabPage = settingView:addTableView(SETTING_PANEL_NAME)

    local cbParam = create("RelativeLayoutParam");
    local cbParamProperty = {
        layout_marginTop = "20dp",
        layout_marginLeft = "25dp"
    };
    cbParam:setLayoutParam(cbParamProperty);

    local keyboardSwitch = isSetKeyboardAsDefault();
    isCbSwitchChecked = keyboardSwitch;
    cbSwitch = tabPage:addCheckBoxView(SWITCH_CHECKBOX_TEXT, isCbSwitchChecked, cbParam, onCheckboxSelected);
    cbSwitch:setClickListener(onCheckBoxClick)
    enableKeyboardCheckBox();

    cbParam = create("RelativeLayoutParam");
    cbParamProperty = {
        layout_marginTop = "20dp",
        layout_marginLeft = "40dp",
        layout_marginRight = "40dp",
        layout_width = "wrap_content",
        layout_height = "40dp",
        layout_below = cbSwitch:getId()
    };
    cbParam:setLayoutParam(cbParamProperty);

    cbFirstTextView = tabPage:addTextView(KEYBOARD_CLOSE_INTRODUCTION_1, "#FFAB00", "14sp", cbParam, null);
    cbParam = create("RelativeLayoutParam");
    cbParamProperty = {
        layout_marginTop = "20dp",
        layout_marginLeft = "40dp",
        layout_marginRight = "40dp",
        layout_width = "wrap_content",
        layout_height = "40dp",
        layout_below = cbFirstTextView:getId()
    };
    cbParam:setLayoutParam(cbParamProperty);
    cbSecondTextView = tabPage:addTextView(KEYBOARD_CLOSE_INTRODUCTION_2, "#FFAB00", "14sp", cbParam, null);
end

local function setSettingViewListener()
    local settingView = SettingView()
    local EVENT_ID_ON_GAME_KEYBOARD = 201;

    settingView:putOnEventListener(EVENT_ID_ON_GAME_KEYBOARD,
            function()

                -- 未开启则设置check不可点击
                enableKeyboardCheckBox();

                -- 更新对应文案
                if (isSetKeyboardAsDefault()) then
                    updateKeyboardSettingView(true);
                    cbSwitch:setChecked(true);
                else
                    updateKeyboardSettingView(false);
                    cbSwitch:setChecked(false);
                end
            end, function()
            end);
end

--- 游戏加载过程中的键盘输入法切换入口相关
local function updateKeyboardSwitchButtonStatus(isShow)
    commonlib_runOnUIThread(function()
        if (isShow) then
            keyboardEntryView:show();
        else
            keyboardEntryView:hide();
        end
    end)
end

local tipsFloatView
local tipsView
local curIsFullCover
local isKeyboardEnable
--local isSetDefault
local fullCoverTime
local isSetDefaultOnStart
local isSwitchKeyboardClick

local ACTION_CLICK = "action_click"

local function dismissTips()
    commonlib_runOnUIThread(function ()
        printLog("dismiss PlayWindowOnUIThread")
        if tipsFloatView ~= nil then
            tipsFloatView:destroy()
            tipsFloatView = nil
        end
        if tipsView ~= nil then
            tipsView:destroy()
            tipsView = nil
        end
    end)
end

local function addTipsView(offsetY)
    commonlib_runOnUIThread(function ()
        printLog("addTipsView ："  .. tostring(offsetY / commonlib_getScale()))
        if tipsFloatView == nil then
            tipsFloatView = commonlib_getFloatViewMgrEx():create(
                    0, ((offsetY  - commonlib_dp2Pix(26)) / commonlib_getScale()),
                    COMMON_LAYOUTPARAM.WRAP_CONTENT, COMMON_LAYOUTPARAM.WRAP_CONTENT,
                    Anchor().TOPLEFT,
                    true);
            if tipsView == nil then
                tipsView = tipsFloatView:addKeyboardTipsView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top);
                tipsView:setOnEventListener(function (action)
                    printLog("on event ："  .. action)
                    if action == ACTION_CLICK then
                        dismissTips()
                        keyboardModule:switchSystemKeyboard(null)
                    end
                end)
            else
                printLog("tips view not null, check for reason")
            end
            tipsFloatView:show();
        else
            printLog("tips float view not null, check for reason")
        end
    end)
end

local function handleShowTips()
    if curIsFullCover == false then
        --printLog("return : not full cover")
        return
    end
    if isSwitchKeyboardClick == true then
        printLog("return : switch keyboard click by user")
        return
    end
    local currentTime = commonlib_getCurrentTime()
    if fullCoverTime == nil or currentTime - fullCoverTime < 1000 or currentTime - fullCoverTime > 5000 then
        printLog("return : time check fail ")
        printLog("currentTime : " .. tostring(currentTime))
        printLog("fullCoverTime : " .. tostring(fullCoverTime))
        return
    end
    if isSetKeyboardAsDefault() == true then
        printLog("return : is set keyboard as default")
        return
    end
    if isKeyboardEnable == false then
        printLog("return : keyboard disable")
        return
    end
    if tipsFloatView ~= nil then
        printLog("return : tips is showing")
        return
    end
    local offsetY = gRecognizeAdapterManager:doRecognizeByKeyOnIntResult(KEY_KB_DETECT_METHOD_OPENED_REG_INFO);
    printLog("offsetY : " .. tostring(offsetY))
    if offsetY > 0 then
        addTipsView(offsetY)
    end
end

local function onGameLoading()
    --printLog("onGameLoading")
    if hasLoading then
        return
    end
    hasLoading = true

    updateKeyboardSwitchButtonStatus(true);
end

local function onGameRunning()
    --printLog("onGameRunning")
    hasLoading = false

    updateKeyboardSwitchButtonStatus(false);
    handleShowTips()
end

local function onGameStart()
    --printLog("onGameStart")
    isSetDefaultOnStart = isSetKeyboardAsDefault()
end

local function onFullCover(isFullCover)
    printLog("FullCover state=>" .. tostring(isFullCover))
    curIsFullCover = isFullCover
    if isFullCover then
        fullCoverTime = commonlib_getCurrentTime() --- 更新全遮挡时间
        if isKeyboardEnable == nil then
            isKeyboardEnable = isEnableKeyboard() --- 是否开启超人键盘
        end
        --isSetDefault = isSetKeyboardAsDefault() --- 是否已设置为默认键盘
    else
        fullCoverTime = 0
        dismissTips()
    end
end

local function onGameOver()
    dismissTips()
    isKeyboardEnable = nil
    --isSetDefault = nil
    curIsFullCover = nil
    fullCoverTime = nil
    isSetDefaultOnStart = nil
    isSwitchKeyboardClick = nil
end

local function registerGameEvents()
    --printLog("registerGameEvents")
    commonlib_registerCallback(common_game_events_callbacks.common_game_loading, onGameLoading)
    commonlib_registerCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks.common_full_cover, onFullCover)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
end

local function unregisterGameEvents()
    --printLog("unregisterGameEvents")
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_loading, onGameLoading)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks.common_full_cover, onFullCover)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
end

local function destroyView(view)
    if view ~= nil then
        view:destroy()
        view = nil
    end
end

local function destroyViews()
    destroyView(cbSwitch)
    destroyView(cbFirstTextView)
    destroyView(cbSecondTextView)
end

local function initFloatBall()
    --printLog("initFloatBall")
    if isEnableKeyboard() then
        local floatViewMgr = commonlib_getFloatViewMgrEx()
        keyboardEntryView = floatViewMgr:createKeyboardFloat()
        registerGameEvents()
    end
end

local function unInitFloatBall()
    --
end

local function initSettingTab()
    if isEnableKeyboard() then
        initConfigUI()
        setSettingViewListener()
    end
end

local function unInitSettingTab()
    destroyViews()
    unregisterGameEvents()
end

local function initKeyboardModule()
    keyboardModule = KeyboardModule()
    keyboardModule:setOnKeyboardEventListenerForLua(function (param1, param2)
        printLog("on event " .. tostring(param1) .. tostring(param2))
        if param1 == ACTION_START_SHOW then
            dismissTips()
        elseif param1 == ACTION_CLICK_SWITCH then
            dismissTips()
            if isSetDefaultOnStart == true then --- 游戏开始时默认为超人键盘
                isSwitchKeyboardClick = true --- 用户主动点击了切换回上一个输入法
            end
        end
    end)
    gRecognizeAdapterManager = AdapterManagerClass:getRecognizeInstance()
end

local function unInitKeyboardModule()
    if keyboardModule ~= nil then
        keyboardModule:removeKeyboardEventListener()
    end
end

local function init()
    printLog("keyboard init")
    initKeyboardModule()
    initFloatBall()
    initSettingTab()
end

local function uninit()
    printLog("keyboard uninit")
    unInitFloatBall()
    unInitSettingTab()
    dismissTips()
    unInitKeyboardModule()
end

table.insert(common_life_circle_callbacks, { init, uninit, SGAME_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.keyboard })
