---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by jinghao.
--- DateTime: 08/04/2018 14:53
---
local TAB_NAME = "死亡回放"
local CHECKBOX_TEXT = "开启死亡回放"
local KEY_IS_REPLAY_ENABLE = "key_is_replay_enable"

local cbSwitch
local isCbSwitchChecked = true
local isCloseReplay = false
local isRecordStarted = false --是否已经开始录制视频

local TAG = "lua_replay"
local ACTION_CLICK_PREVIEW = "action_click_preview";
local ACTION_CLICK_CLOSE = "action_click_close";
local ACTION_CLICK_REPLAY = "action_click_replay";
local ACTION_START_PLAY = "action_start_play";
local ACTION_PLAY_COMPLETE = "action_play_complete";

local lastDeathTimeMills = 0
local MIN_VALID_DEATH_TIME = 21 * 1000

local screenRecorder

local HERO_STATE_LIFE = 1;--英雄复活
local HERO_STATE_DIE = 2;--英雄死亡
local lastHeroState = HERO_STATE_LIFE;

local previewFloatView
local previewView
local replayView
local replayFloatView
local gRecognizeAdapterManager;

local curIsFullCover
local lastFullCoverTime = 0
local FULL_COVER_TIME_OUT = 1200

local gameMasterSettingOpen = false
local videoWindowIsShowing = false

local FUNC_CLOUD_SWITCH_KEY = "sgame_replay_cloud_switch_key"

local function printLog(msg)
    commonlib_print(TAG, msg)
end

--移除播放窗口

local function destroyPlayWindow()
    printLog("destroyPlayWindow")
    if replayFloatView ~= nil then
        replayFloatView:destroy()
        replayFloatView = nil
    end
    if replayView ~= nil then
        replayView:destroy()
        replayView = nil
    end
end

local function dismissPlayWindowOnUIThread()
    printLog("dismissPlayWindowOnUIThread")
    commonlib_runOnUIThread(function ()
        destroyPlayWindow()
    end)
end

local function destroyPreviewWindow()
    printLog("destroyPreviewWindow")
    if previewFloatView ~= nil then
        previewFloatView:destroy()
        previewFloatView = nil
    end
    if previewView ~= nil then
        previewView:destroy()
        previewView = nil
    end
end

local function dismissPreviewWindowOnUIThread()
    printLog("dismiss PreviewWindowOnUIThread")
    commonlib_runOnUIThread(function ()
        destroyPreviewWindow()
    end)
end

local addReplayPreview

local function dismissPlayWindow(force)
    videoWindowIsShowing = false
    printLog("dismissPlayWindow " .. tostring(force))
    if force then
        dismissPlayWindowOnUIThread()
        dismissPreviewWindowOnUIThread()
        return
    end
    if replayView ~= nil and replayView:isPlaying() then
        local delay = replayView:getRemainTime()
        commonlib_runOnUIThreadDelayed(function ()
            if replayFloatView ~= nil then
                replayFloatView:destroy()
                replayFloatView = nil
            end
        end, delay)
        printLog("video is playing, delay : " .. tostring(delay))
    else
        dismissPlayWindowOnUIThread()
    end
    dismissPreviewWindowOnUIThread()
end

local function addReplayView()
    printLog("add replay view")
    replayFloatView = commonlib_getFloatViewMgrEx():create(
            0, 110,
            COMMON_LAYOUTPARAM.WRAP_CONTENT, COMMON_LAYOUTPARAM.WRAP_CONTENT,
            Anchor().TOPLEFT,
            true);
    replayFloatView:setGravity(Anchor().TOP);
    replayView = replayFloatView:addReplayView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top);
    replayView:setOnEventListener(function (action)
        printLog("replay on event ："  .. action)
        if action == ACTION_CLICK_CLOSE then
            videoWindowIsShowing = false
            isCloseReplay = true
            dismissPlayWindow(true)
            if lastHeroState == HERO_STATE_DIE then
                commonlib_runOnUIThreadDelayed(function ()
                    addReplayPreview()
                end, 100)
            end
            --elseif action == ACTION_CLICK_PREVIEW then
            --elseif action == ACTION_CLICK_REPLAY then
            --elseif action == ACTION_START_PLAY then
            --elseif action == ACTION_PLAY_COMPLETE then
        end
    end)
    replayView:setUri(screenRecorder:getDieVideoPath());
    replayFloatView:show();
    replayView:start()
end

addReplayPreview = function ()
    printLog("add replay preview")
    destroyPreviewWindow()
    previewFloatView = commonlib_getFloatViewMgrEx():create(
            0, 110,
            COMMON_LAYOUTPARAM.WRAP_CONTENT, COMMON_LAYOUTPARAM.WRAP_CONTENT,
            Anchor().TOPLEFT,
            true);
    previewFloatView:setGravity(Anchor().TOP);
    previewView = previewFloatView:addReplayPreview(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top);
    previewView:setOnEventListener(function (action)
        printLog("replay preview on event ："  .. action)
        if action == ACTION_CLICK_PREVIEW then
            videoWindowIsShowing = true;
            addReplayView()
            dismissPreviewWindowOnUIThread()
        end
    end)
    --replayVideoPath = "/sdcard/test.mp4"
    --replayVideoPath = screenRecorder:getDieVideoPath()
    previewFloatView:show()
end

local function videoFileExists()
    return screenRecorder ~= nil and screenRecorder:videoDieFileIsExists()
end

--展示播放窗口
local function showPlayWindow()
    printLog("showPlayWindow")
    if isCbSwitchChecked and previewFloatView == nil then
        isCloseReplay = false
        commonlib_runOnUIThread(function()
            if  videoFileExists() then
                addReplayPreview()
            end
        end)
    end
end

--初始化录屏
local function initScreenRecord()
    if screenRecorder == nil then
        screenRecorder = ScreenRecorder()
    end
    screenRecorder:init()
end

--开始录屏
local function startScreenRecord()
    if isCbSwitchChecked and screenRecorder ~= nil then
        printLog("start recorder")
        isRecordStarted = true
        screenRecorder:start()
    end
end

--停止录屏
local function saveVideo()
    if not isCbSwitchChecked or screenRecorder == nil then
        return
    end
    screenRecorder:saveDieVideo(function()
        printLog("quit callback start play")
        showPlayWindow()
    end)
end


--释放录屏资源
local function releaseScreenRecord()
    if screenRecorder ~= nil then
        screenRecorder:uninit()
    end
end

local function deleteCacheVideoFile()
    if screenRecorder ~= nil then
        screenRecorder:deleteDieCacheVideo()
    end
end

local function onCheckChangeListener(checkboxId, isChecked)
    printLog("onCheckChangeListener" .. tostring(isChecked))
    isCbSwitchChecked = isChecked
    commonlib_setSharedPrefBoolean(KEY_IS_REPLAY_ENABLE, isChecked)
    onReplaySettingsChange(isChecked)
    if isChecked then
        initScreenRecord()
        if lastHeroState ~= HERO_STATE_DIE then
            startScreenRecord()
        end
    else
        if screenRecorder ~= nil then
            --screenRecorder:stop()
            --screenRecorder = nil
            isRecordStarted = false
        end
    end
end

local function initSettingView()
    local settingView = commonlib_getSettingView()
    local moneyTab = settingView:addTableView(TAB_NAME)

    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}
    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    relativeLayoutParam:setLayoutParam(paramValues)

    local isEnable = commonlib_getSgameFuncAbcTestEnable(FUNC_CLOUD_SWITCH_KEY, true);
    isCbSwitchChecked = commonlib_getSharedPrefBoolean(KEY_IS_REPLAY_ENABLE, isEnable)
    cbSwitch = moneyTab:addCheckBoxView(CHECKBOX_TEXT, isCbSwitchChecked, relativeLayoutParam, onCheckChangeListener)
end

--英雄复活
local function onHeroLife()
    printLog("onHeroRevive")
    videoWindowIsShowing = false;
    dismissPlayWindow(false)
end

--英雄死亡
local function onHeroDeath()
    printLog("onHeroDie")
    saveVideo()
    ---增加死亡识别保存视频容错机制，当距离上次死小于20s，则认为是误识别
    --local currentTime = commonlib_getCurrentTime()
    --if (currentTime - lastDeathTimeMills) > MIN_VALID_DEATH_TIME then
    --    saveVideo()
    --else
    --    showPlayWindow()
    --end
    --lastDeathTimeMills = currentTime
end

local function settingBtnIsVisible()
    local hasSettingButton = false
    local shopMenuPos = commonlib_getGameParam(KEY_SHOP_MENU_POSITION)
    if (shopMenuPos == SHOP_MENU_POSITION_LEFT) then
        hasSettingButton = gRecognizeAdapterManager:doRecognizeItemByKey(KEY_SETTING_BTN_VISIBLE_RIGHT)
    else
        hasSettingButton = gRecognizeAdapterManager:doRecognizeItemByKey(KEY_SETTING_BTN_VISIBLE_LEFT)
    end
    printLog("showMenuPos=>" .. shopMenuPos .. " hasSettingButton=>" .. tostring(hasSettingButton))
    return hasSettingButton
end

local function handleHeroLifeState()
    if gRecognizeAdapterManager:doRecognizeItemByKey(KEY_REPLAY_HERO_DIE_RECOGNIZE_RECT) then
        if lastHeroState == HERO_STATE_LIFE then
            lastHeroState = HERO_STATE_DIE
            onHeroDeath()
            printLog("hero die")
        elseif gameMasterSettingOpen == false and videoWindowIsShowing == false then
            showPlayWindow()
        end
    else
        if lastHeroState == HERO_STATE_DIE and settingBtnIsVisible()then
            lastHeroState = HERO_STATE_LIFE
            onHeroLife()
            printLog("hero revive")
        end
    end
end


local function resetData()
    isCloseReplay = false;
    isRecordStarted = false;
end

local function onGameStart()
    if commonlib_isFlameMountainMap() then
        printLog("onGameStart unsupport FlameMountainMap")
        return;
    end
    printLog("onGameStart")
    lastHeroState = HERO_STATE_LIFE;
    if isCbSwitchChecked then
        initScreenRecord()
        startScreenRecord()
    end
    deleteCacheVideoFile()
end

local function onGameOver()
    if commonlib_isFlameMountainMap() then
        printLog("onGameOver unsupport FlameMountainMap")
        return;
    end
    printLog("onGameOver")
    --releaseScreenRecord()
    --deleteCacheVideoFile()
    dismissPlayWindow(true)
    resetData()
end


--恢复展示播放窗口
local function recoveryShowPlayWindow()
    if lastHeroState == HERO_STATE_DIE and not isCloseReplay and isRecordStarted then
        showPlayWindow()
    end
end

local function onFullCover(isFullCover)
    if commonlib_isFlameMountainMap() then
        printLog("onFullCover unsupport FlameMountainMap")
        return;
    end
    printLog("FullCover state=>" .. tostring(isFullCover))
    curIsFullCover = isFullCover
    if isFullCover then
        dismissPlayWindow(true)
    else
        --recoveryShowPlayWindow()
        lastFullCoverTime = commonlib_getCurrentTime()
    end
end


local function onSettingViewOpen()
    if commonlib_isFlameMountainMap() then
        printLog("onSettingViewOpen unsupport FlameMountainMap")
        return;
    end
    printLog("setting view open replay.lua")
    gameMasterSettingOpen = true
    dismissPlayWindow(true)
end

local function onSettingViewClose()
    if commonlib_isFlameMountainMap() then
        printLog("onSettingViewClose unsupport FlameMountainMap")
        return;
    end
    printLog("setting view close replay.lua")
    gameMasterSettingOpen = false
    --recoveryShowPlayWindow()
end

local function onGameOverDetail(isGameOverDetail)
    if commonlib_isFlameMountainMap() then
        printLog("onGameOverDetail unsupport FlameMountainMap")
        return;
    end
    if isGameOverDetail then
        releaseScreenRecord()
    end
end


local function onGameRunning()
    if commonlib_isFlameMountainMap() then
        printLog("onGameRunning unsupport FlameMountainMap")
        return;
    end

    if curIsFullCover == false and isCbSwitchChecked then
        local diffTime = commonlib_getCurrentTime() - lastFullCoverTime
        if diffTime > FULL_COVER_TIME_OUT then
            handleHeroLifeState()
        end
    end
end

local function registerGameEventCallbacks()
    commonlib_registerCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_registerCallback(common_game_events_callbacks.common_full_cover, onFullCover)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_registerSettingViewOpenCallback(onSettingViewOpen)
    commonlib_registerSettingViewCloseCallback(onSettingViewClose)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over_detail, onGameOverDetail)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, onGameRunning)
end

local function unregisterGameEventCallbacks()
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks.common_full_cover, onFullCover)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_unRegisterSettingViewOpenCallback(onSettingViewOpen)
    commonlib_unRegisterSettingViewCloseCallback(onSettingViewClose)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over_detail, onGameOverDetail)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, onGameRunning)
end

local funcCloudSwitch

local function getFuncCloudSwitch()
    if funcCloudSwitch ~= nil then
        return funcCloudSwitch
    end
    funcCloudSwitch = commonlib_getSgameFuncCloudSwitch(FUNC_CLOUD_SWITCH_KEY, true)
    return funcCloudSwitch
end

local function init()
    printLog("init replay.lua")
    local cloudSwitch = getFuncCloudSwitch()
    printLog("死亡回放开关:" .. tostring(cloudSwitch))
    if cloudSwitch == false then
        return
    end
    gRecognizeAdapterManager = AdapterManagerClass:getRecognizeInstance();
    initSettingView()
    registerGameEventCallbacks()
end

local function uninit()
    printLog("unint replay.lua")
    local cloudSwitch = getFuncCloudSwitch()
    if cloudSwitch == false then
        return
    end
    unregisterGameEventCallbacks()
    releaseScreenRecord()
    dismissPreviewWindowOnUIThread()
    dismissPlayWindowOnUIThread()
end

table.insert(common_life_circle_callbacks, { init, uninit, SGAME_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.replay })


