--- 界面美化脚本
local SKIN_BUTTON = "皮肤美化"
local SKIN_SWITCH_TEXT = "开启皮肤美化"

--- 脚本里面界面配置项相关的
local KEY_SKIN_TYPE = "key_skin_type"
local KEY_IS_SKIN_CHECKED = "key_is_skin_checked"

local KEY_SKIN_SHARE_GUITAR = "key_skin_share_guitar"

--界面资源字段提取
local SKIN_TABLE_STAT_FIELD = "stat"
local SKIN_TABLE_EXCLUDE = "exclude"
local SKIN_TABLE_RESTORE = "restore"

local SKIN_TABLE_HERO_ATTACK_MODE = "heroAttackMode"
local SKIN_TABLE_HERO_ATTACK_MODE_FREE = "FREE"
local SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE = "ADVANCED_FREE"
local SKIN_TABLE_HERO_ATTACK_MODE_LOCK = "LOCK"

local SKIN_TABLE_SHOP = "shop";
local SKIN_TABLE_SHOP_LEFT = "LEFT"
local SKIN_TABLE_SHOP_RIGHT = "RIGHT"

local SKIN_TABLE_FLOAT_WINDOW = "float_window";
local SKIN_TABLE_FLOAT_LEFT_WINDOW = "LEFT_WINDOW"
local SKIN_TABLE_FLOAT_RIGHT_WINDOW = "RIGHT_WINDOW"

local SKIN_TABLE_SUMMONER_SKILL_COUNT = "summonerSkillCount"

local SKIN_TABLE_LARGE_MAP = "largeMap"
local SKIN_TABLE_LARGE_MAP_HIDE = "HIDE"
local SKIN_TABLE_LARGE_MAP_LEFT = "LEFT"
local SKIN_TABLE_LARGE_MAP_RIGHT = "RIGHT"
local SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT = "leftEquipment"
local SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT = "rightEquipment"
local SKIN_TABLE_VALUE_TUITA = "43"

local SKIN_TABLE_CHAT = "chat"

local SKIN_TABLE_ORDER = "order"

local SKIN_TABLE_HERO_SKILL_COUNT = "heroSkillCount"

local LEFT_FLOAT_BALL_ID_TABLE = { "52", "54" }
local RIGHT_FLOAT_BALL_ID_TABLE = { "51", "53" }

local skin_type
local skin_checkBox
local skin_isChecked = true
local skin_is18To9 = false
local skin_radioGroupController
local skin_settingPanel

local mapTypeKey

local skinViewContainer
local floatBallView

local filterOnceSkinTable = {}
local skinDisplayTable = {}

local isFirstEnterSkin = true

local skin_lastMapMode
local skin_lastEquipment
local skin_lastAttackMode
local skin_lastChat
local skin_lastOrder

local skinSelectView
local skinTypeTable
local skinSettingCheckboxTable = {}
local skinSettingImageViewTable = {}
local skinSettingProgressView = {}
local skinDataForSkinManager = {};


local skinInfoMap

local skinTypeReportMap

local hasReportShowSkin = false
local hasReportSkinType = false
local REASON_NOT_CHOOSE_SKIN_CHECK_BOX = 9

local KEY_OP = "op"
local KEY_MODE = "mode"
local TABLE_GAMEMASTER_END_COUNT = "gamemaster_end_count"
local OP_GAME_OVER_COUNT = 1
local MODE_NOT_FIVE_ARMY_BATTLE = 1
local MODE_FIVE_ARMY_BATTLE = 2

local WindowManager_FIRST_SYSTEM_WINDOW = 2000;
local WindowManager_TYPE_PHONE = WindowManager_FIRST_SYSTEM_WINDOW + 2;
local WindowManager_TYPE_SYSTEM_ALERT = WindowManager_FIRST_SYSTEM_WINDOW + 3;
local WindowManager_TYPE_SYSTEM_ERROR = WindowManager_FIRST_SYSTEM_WINDOW + 10;

--- 契约模式
local lastHeroSkillCount = 0;
local lastSummonerSkillCount = 0;
local lastContractState;

local gSkinAdapterManager;

local funcCloudSwitch

local SGAME_FUNC_SKIN_CLOUD_SWITCH_KEY = "sgame_skin_cloud_switch_key"

local gbInited
local gEventId
local SKIN_EVENT = "event.skin"

local TAG = "skin_script"
local function printLog(msg)
    commonlib_print(TAG, msg)
end

--将产品配置表的字符串anchor转换为整形数字
local function shiftStrAnchorToInt(anchor)
    local value = 0
    if anchor == "TOPLEFT" then
        value = Anchor().TOPLEFT
    elseif anchor == "LEFT" then
        value = Anchor().LEFT
    elseif anchor == "BOTTOMLEFT" then
        value = Anchor().BOTTOMLEFT
    elseif anchor == "TOP" then
        value = Anchor().TOP
    elseif anchor == "CENTER" then
        value = Anchor().CENTER
    elseif anchor == "BOTTOM" then
        value = Anchor().BOTTOM
    elseif anchor == "TOPRIGHT" then
        value = Anchor().TOPRIGHT
    elseif anchor == "RIGHT" then
        value = Anchor().RIGHT
    elseif anchor == "BOTTOMRIGHT" then
        value = Anchor().BOTTOMRIGHT
    end
    return value
end

local REPORT_TABLE_GAMEMASTER_WZGAME_SKINCHOOSE = "gamemaster_wzgame_skinchoose_new"
local GAMEMASTER_WZGAME_SKINCHOOSE_KEY_OP = "op"
local GAMEMASTER_WZGAME_SKINCHOOSE_KEY_SKIN = "skin"
local GAMEMASTER_WZGAME_SKINCHOOSE_OP_SHOW = 1
local GAMEMASTER_WZGAME_SKINCHOOSE_OP_CLICK = 2

local function getSkinDataByType(skinType)
    return gSkinAdapterManager:getItem(skinType);
end

local function getSkinStateData(skinType, mapTypeKey)
    local skinData = getSkinDataByType(skinType);
    if skinData == nil then
        return nil;
    end

    return gSkinAdapterManager:getItem(skinData[KEY_SKIN_STAT][mapTypeKey]);
end

local function destroySkinViewContainer()
    if skinViewContainer ~= nil then
        skinViewContainer:destroy()
        skinViewContainer = nil;
    end
end

local function createSkinViewContainer()
    if skinViewContainer == nil then
        skinViewContainer = commonlib_getUnClickableFloatView():addSGameFloatViewControl(ZOrder().zorder_bottom)
    end
end

local function isContractMode()
    return commonlib_getGameParam(KEY_IS_CONTRACT_MODE) == true;
end

local function reportSkinShow()
    if commonlib_isTableEmpty(skinTypeTable) then
        return
    end
    for index, skinType in pairs(skinTypeTable) do
        printLog(" 开始上报皮肤展示：" .. tostring(skinType))

        local reportData = {
            [GAMEMASTER_WZGAME_SKINCHOOSE_KEY_OP] = GAMEMASTER_WZGAME_SKINCHOOSE_OP_SHOW,
            [GAMEMASTER_WZGAME_SKINCHOOSE_KEY_SKIN] = skinTypeReportMap[skinType]
        }
        commonlib_report(REPORT_TABLE_GAMEMASTER_WZGAME_SKINCHOOSE, reportData)
    end
end

function reportShowSkin(reason, reReport)
    if reReport then
        commonlib_reportFunctionDisableReason(SGAME_APP_NAME, STEP_SHOW_SKIN, reason)
    elseif not hasReportShowSkin then
        commonlib_reportFunctionDisableReason(SGAME_APP_NAME, STEP_SHOW_SKIN, reason)
        hasReportShowSkin = true
    end
end

local function reportSkinClick()
    if skin_type == nil then
        return
    end
    printLog(" 开始上报皮肤点击：" .. tostring(skin_type))
    local reportData = {
        [GAMEMASTER_WZGAME_SKINCHOOSE_KEY_OP] = GAMEMASTER_WZGAME_SKINCHOOSE_OP_CLICK,
        [GAMEMASTER_WZGAME_SKINCHOOSE_KEY_SKIN] = skinTypeReportMap[skin_type]
    }
    commonlib_report(REPORT_TABLE_GAMEMASTER_WZGAME_SKINCHOOSE, reportData)
end

local function reportEndCount()
    local mode
    printLog("mapTypeKey = " .. tostring(mapTypeKey))
    if mapTypeKey == MAP_TYPE_FIVE_ARMY_BATTLE then
        mode = MODE_FIVE_ARMY_BATTLE
    else
        mode = MODE_NOT_FIVE_ARMY_BATTLE
    end
    printLog("mode = " .. tostring(mode))
    commonlib_report(TABLE_GAMEMASTER_END_COUNT, {
        [KEY_OP] = OP_GAME_OVER_COUNT,
        [KEY_MODE] = mode
    })
end

------------------------------------- 每局游戏只需要检测一次的情况---------------------------------------------------
local function summonerWithSkills(skinType, skillCount)
    printLog(" summonerWithSkills : skinType = " .. tostring(skinType) .. ", skillCount = " .. tostring(skillCount))

    local statData = getSkinStateData(skinType, mapTypeKey)
    local summonerSkillExclude = statData[SKIN_TABLE_SUMMONER_SKILL_COUNT][tostring(skillCount)][SKIN_TABLE_EXCLUDE]
    if summonerSkillExclude == nil then
        return;
    end

    for index, value in pairs(summonerSkillExclude) do
        table.insert(filterOnceSkinTable, value);
    end
end

local function heroWithSkills(skinType, skillCount)
    printLog(" heroWithSkills : skinType = " .. tostring(skinType) .. ", skillCount = " .. tostring(skillCount))
    local statData = getSkinStateData(skinType, mapTypeKey)
    local heroSkillExclude = statData[SKIN_TABLE_HERO_SKILL_COUNT][tostring(skillCount)][SKIN_TABLE_EXCLUDE];
    if heroSkillExclude == nil then
        printLog("heroSkillExclude is nil")
        return
    end

    for index, value in pairs(heroSkillExclude) do
        table.insert(filterOnceSkinTable, value)
    end
end

--- 处理聊天窗口的遮挡情况，当有暂停按钮时，打开聊天窗口，不会遮挡43号皮肤，这是不应该将它隐藏
local function handleChatWindowStat(hasPauseButton)
    if hasPauseButton == nil then
        printLog(" handleChatWindowStat hasPauseButton is nil")
        return
    end
    printLog(" handleChatWindowStat hasPauseButton : " .. tostring(hasPauseButton))
    for _, skinType in pairs(skinTypeTable) do
        local skinTable = getSkinDataByType(skinType);
        for _, skinStatTableKey in pairs(skinTable[KEY_SKIN_STAT]) do
            local skinStatTable = gSkinAdapterManager:getItem(skinStatTableKey);
            local chatWindowStat = skinStatTable.chat
            if hasPauseButton then
                commonlib_removeValueInTable(chatWindowStat.exclude, "43")
                commonlib_removeValueInTable(chatWindowStat.restore.leftEquipment, "43")
                commonlib_removeValueInTable(chatWindowStat.restore.rightEquipment, "43")
            else
                commonlib_insertValueWithoutRepeat(chatWindowStat.exclude, "43")
                commonlib_insertValueWithoutRepeat(chatWindowStat.restore.leftEquipment, "43")
                commonlib_insertValueWithoutRepeat(chatWindowStat.restore.rightEquipment, "43")
            end
        end
    end
    printLog("handleChatWindowStat:end")
end

local function filterHeroAndSkillType()
    --- 首先检测是否是大乔或者干将莫邪(四个技能)
    local heroCount = commonlib_getGameParam(KEY_HERO_SKILL_COUNT)
    printLog("filterHeroAndSkillType heroCount = " .. tostring(heroCount))
    heroWithSkills(skin_type, heroCount);

    local summonerSkillCount = commonlib_getGameParam(KEY_SUMMONER_SKILL_COUNT)
    printLog("filterHeroAndSkillType summonerSkillCount = " .. tostring(summonerSkillCount))
    summonerWithSkills(skin_type, summonerSkillCount);

    local mapType = commonlib_getMapType()

    if mapType == MAP_TYPE_1V1 then
        table.insert(filterOnceSkinTable, "35")
        table.insert(filterOnceSkinTable, "36")
        table.insert(filterOnceSkinTable, "33")
        table.insert(filterOnceSkinTable, "34")
    end

    if mapType == MAP_TYPE_3V3 then
        table.insert(filterOnceSkinTable, "35")
        table.insert(filterOnceSkinTable, "36")
    end

    if commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON) then
        table.insert(filterOnceSkinTable, "35")
        table.insert(filterOnceSkinTable, "36")
        table.insert(filterOnceSkinTable, "33")
        table.insert(filterOnceSkinTable, "34")

        table.insert(filterOnceSkinTable, "51")
        table.insert(filterOnceSkinTable, "52")
    else
        table.insert(filterOnceSkinTable, "53")
        table.insert(filterOnceSkinTable, "54")
    end

    if commonlib_getMapType() == MAP_TYPE_TRAINING_CAMP then
        table.insert(filterOnceSkinTable, "3")
        table.insert(filterOnceSkinTable, "4")
        table.insert(filterOnceSkinTable, "19")
    end

    if skin_is18To9 then
        table.insert(filterOnceSkinTable, "45")
        table.insert(filterOnceSkinTable, "50")
    end

    handleChatWindowStat(commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON))
end

----------------------------------------- 需要多次检测的情况---------------------------------------------------
local function setSkinDisplyTableShowFalse(skinDisplyTableExclude)
    if not skinDisplyTableExclude then
        return;
    end
    for index, value in pairs(skinDisplyTableExclude) do
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = false;
        end
    end
end

local function setSkinDisplyTableShowTrue(skinDisplyTableExclude)
    if not skinDisplyTableExclude then
        return;
    end
    for index, value in pairs(skinDisplyTableExclude) do
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = true;
        end
    end
end

local function heroAttackModes(skinType, attackMode, includeAttackModeOne, includeAttackModeTwo)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local heroAttackExclude = statData[SKIN_TABLE_HERO_ATTACK_MODE][attackMode][SKIN_TABLE_EXCLUDE];
    local heroAttackIncludeOne = statData[SKIN_TABLE_HERO_ATTACK_MODE][includeAttackModeOne][SKIN_TABLE_EXCLUDE];
    if heroAttackIncludeOne ~= nil then
        setSkinDisplyTableShowTrue(heroAttackIncludeOne)
    end

    local heroAttackIncludeTwo = statData[SKIN_TABLE_HERO_ATTACK_MODE][includeAttackModeTwo][SKIN_TABLE_EXCLUDE];
    if heroAttackIncludeTwo ~= nil then
        setSkinDisplyTableShowTrue(heroAttackIncludeTwo)
    end
    if heroAttackExclude ~= nil then
        setSkinDisplyTableShowFalse(heroAttackExclude)
    end
end

local function heroFreeAttackMode(skinType)
    --printLog("heroFreeAttackMode=====")
    heroAttackModes(skinType, SKIN_TABLE_HERO_ATTACK_MODE_FREE, SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE, SKIN_TABLE_HERO_ATTACK_MODE_LOCK);
end

local function heroAdvancedFreeAttackMode(skinType)
    --printLog("heroAdvancedFreeAttackMode=====")
    heroAttackModes(skinType, SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE, SKIN_TABLE_HERO_ATTACK_MODE_FREE, SKIN_TABLE_HERO_ATTACK_MODE_LOCK);
end

local function heroLockAttackMode(skinType)
    --printLog("heroLockAttackMode=====")
    heroAttackModes(skinType, SKIN_TABLE_HERO_ATTACK_MODE_LOCK, SKIN_TABLE_HERO_ATTACK_MODE_FREE, SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE);
end

--- 悬浮球皮肤的处理
local function FloatBallWindow(skinType, position)
    local pauseButtonKey;
    if commonlib_getGameParam(KEY_HAS_PAUSE_BUTTON) then
        pauseButtonKey = "HAS_PAUSE_BUTTON";
    else
        pauseButtonKey = "NOT_HAS_PAUSE_BUTTON";
    end

    local statData = getSkinStateData(skinType, mapTypeKey)
    local floatBallExclude = statData[SKIN_TABLE_FLOAT_WINDOW][position][pauseButtonKey][SKIN_TABLE_EXCLUDE];
    if floatBallExclude == nil then
        return
    end

    for index, value in pairs(floatBallExclude) do
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = false
        end
    end
end

local function leftFloatBallWindow(skinType)
    FloatBallWindow(skinType, SKIN_TABLE_FLOAT_RIGHT_WINDOW)
end

local function rightFloatBallWindow(skinType)
    FloatBallWindow(skinType, SKIN_TABLE_FLOAT_LEFT_WINDOW)
end

--- 左右出装皮肤处理
local function shopPosition(skinType, position, includePosition)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local shopPositionExclude = statData[SKIN_TABLE_SHOP][position][SKIN_TABLE_EXCLUDE]
    if shopPositionExclude == nil then
        return;
    end

    local shopPositionInclude = statData[SKIN_TABLE_SHOP][includePosition][SKIN_TABLE_EXCLUDE]
    if shopPositionInclude == nil then
        return;
    end
    setSkinDisplyTableShowTrue(shopPositionInclude)
    setSkinDisplyTableShowFalse(shopPositionExclude)
end

local function leftShop(skinType)
    shopPosition(skinType, SKIN_TABLE_SHOP_LEFT, SKIN_TABLE_SHOP_RIGHT)
end

local function rightShop(skinType)
    shopPosition(skinType, SKIN_TABLE_SHOP_RIGHT, SKIN_TABLE_SHOP_LEFT)
end

--- 地图皮肤处理
local function largeMap(skinType, position, includePositionOne, includePositionTwo)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local largeMapExclude = statData[SKIN_TABLE_LARGE_MAP][position][SKIN_TABLE_EXCLUDE];
    if largeMapExclude == nil then
        return
    end
    setSkinDisplyTableShowFalse(largeMapExclude)
end

--- 从大地图模式切换回小地图
local function largeMapHide(skinType, lastPosition, equipment)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local largeMapInclude = statData[SKIN_TABLE_LARGE_MAP][lastPosition][SKIN_TABLE_RESTORE][equipment];
    if largeMapInclude ~= nil then
        for index, value in pairs(largeMapInclude) do
            if skinDisplayTable[value] ~= nil then
                skinDisplayTable[value].show = true
            end
        end
        if lastPosition == SKIN_TABLE_LARGE_MAP_RIGHT and not (skin_lastAttackMode == HERO_ATTACK_MODE_ADVANCED_FREE) and
        skinDisplayTable[SKIN_TABLE_VALUE_TUITA] ~= nil then
            skinDisplayTable[SKIN_TABLE_VALUE_TUITA].show = false
        end
    end
end

local function hideLargeMap(skinType)
    if skin_lastMapMode == nil or skin_lastEquipment == nil then
        return
    end

    if skin_lastMapMode == LARGE_MAP_LEFT_ZOOMOUT then
        if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_LEFT, SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT)
        elseif skin_lastEquipment == SHOP_MENU_POSITION_RIGHT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_LEFT, SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT)
        end
    elseif skin_lastMapMode == LARGE_MAP_RIGHT_ZOOMOUT then
        if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_RIGHT, SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT)
        elseif skin_lastEquipment == SHOP_MENU_POSITION_RIGHT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_RIGHT, SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT)
        end
    end
end

local function leftLargeMap(skinType)
    largeMap(skinType, SKIN_TABLE_LARGE_MAP_LEFT, SKIN_TABLE_LARGE_MAP_HIDE, SKIN_TABLE_LARGE_MAP_RIGHT);
end

local function rightLargeMap(skinType)
    largeMap(skinType, SKIN_TABLE_LARGE_MAP_RIGHT, SKIN_TABLE_LARGE_MAP_HIDE, SKIN_TABLE_LARGE_MAP_LEFT);
end

--- 聊天窗口皮肤处理
local function openChatWindow(skinType)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local openChatWindowExclude = statData[SKIN_TABLE_CHAT][SKIN_TABLE_EXCLUDE];
    if openChatWindowExclude == nil then
        return
    end
    setSkinDisplyTableShowFalse(openChatWindowExclude)
end

local function chatWindowClosed(skinType, equipment)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local closeChatWindowInclude = statData[SKIN_TABLE_CHAT][SKIN_TABLE_RESTORE][equipment]
    if closeChatWindowInclude == nil then
        return
    end

    for index, value in pairs(closeChatWindowInclude) do
        --printLog("chatWindowClosed" .. tostring(value))
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = true
        end
    end

    if not (skin_lastAttackMode == HERO_ATTACK_MODE_ADVANCED_FREE) and
    skinDisplayTable[SKIN_TABLE_VALUE_TUITA] ~= nil then
        skinDisplayTable[SKIN_TABLE_VALUE_TUITA].show = false
    end
end

--- 关闭聊天窗口
local function closeChatWindow(skinType)
    if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
        chatWindowClosed(skinType, SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT)
    elseif skin_lastEquipment == SHOP_MENU_POSITION_RIGHT then
        chatWindowClosed(skinType, SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT)
    end
end

--- 指令窗口皮肤处理
local function openOrderWindow(skinType)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local openOrderWindowExclude = statData[SKIN_TABLE_ORDER][SKIN_TABLE_EXCLUDE]
    if openOrderWindowExclude == nil then
        return
    end
    setSkinDisplyTableShowFalse(openOrderWindowExclude)
end

--- 关闭指令窗口
local function closeOrderWindow(skinType)
    local statData = getSkinStateData(skinType, mapTypeKey)
    local openOrderWindowExclude = statData[SKIN_TABLE_ORDER][SKIN_TABLE_RESTORE]
    for index, value in pairs(openOrderWindowExclude) do
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = true;
        end
    end
end

local function showFloatBallSkinByParam(positionTable)
    --printLog("wqh showFloatBallSkinByParam position: " .. tostring(position) .. " skinview: " .. tostring(skinDisplayTable[position].skinview))
    for index, position in pairs(positionTable) do
        if skinDisplayTable[position] ~= nil and skinDisplayTable[position].skinview ~= nil then
            commonlib_runOnUIThread(function()
                local isShow = floatBallView:isShowing()
                if isShow then
                    skinDisplayTable[position].show = true
                else
                    skinDisplayTable[position].show = false
                end
            end)
        end
    end
end

local function handleMapByMode(mapMode)
    if mapMode == LARGE_MAP_LEFT_ZOOMOUT then
        leftLargeMap(skin_type)
    elseif mapMode == LARGE_MAP_RIGHT_ZOOMOUT then
        rightLargeMap(skin_type)
    else
        hideLargeMap(skin_type)
    end
    skin_lastMapMode = mapMode
end

local function handleChatWindow(isOpen)
    if skin_lastMapMode ~= LARGE_MAP_RIGHT_ZOOMOUT then
        if isOpen then
            openChatWindow(skin_type)
        else
            closeChatWindow(skin_type)
        end
    end
    skin_lastChat = isOpen
end

local function handleOrderWindow(isOpen)
    if commonlib_getGameParam(KEY_MAP_TYPE) ~= MAP_TYPE_TRAINING_CAMP then
        printLog("不是训练营地图，无命令窗口");
        return;
    end

    if isOpen == nil then
        return;
    end

    if skin_lastMapMode ~= LARGE_MAP_LEFT_ZOOMOUT then
        if isOpen then
            openOrderWindow(skin_type)
        else
            closeOrderWindow(skin_type)
        end
    end
    skin_lastOrder = isOpen
end

local function handleQuipment(equipment)
    printLog( " handleQuipment " .. tostring(equipment))
    if equipment == SHOP_MENU_POSITION_LEFT then
        leftShop(skin_type)
        leftFloatBallWindow(skin_type)
    else
        rightShop(skin_type)
        rightFloatBallWindow(skin_type)
    end
    skin_lastEquipment = equipment
end

local function handleAttackMode(attackMode)
    printLog( " handleAttackMode " .. tostring(attackMode))
    if attackMode == HERO_ATTACK_MODE_FREE then
        heroFreeAttackMode(skin_type)
    elseif attackMode == HERO_ATTACK_MODE_ADVANCED_FREE then
        heroAdvancedFreeAttackMode(skin_type)
    else
        heroLockAttackMode(skin_type)
    end
    skin_lastAttackMode = attackMode
end

local function handleEquipmentAndAttackMode()
    printLog(" handleEquipmentAndAttackMode ")
    handleQuipment(commonlib_getGameParam(KEY_SHOP_MENU_POSITION))
    handleAttackMode(commonlib_getGameParam(KEY_HERO_ATTACK_MODE))
end

local function handleFloatBallSkin()
    if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
        showFloatBallSkinByParam(RIGHT_FLOAT_BALL_ID_TABLE)
    else
        showFloatBallSkinByParam(LEFT_FLOAT_BALL_ID_TABLE)
    end
end

local function createSkin(key, value)
    printLog("createSkin begin key = " .. tostring(key) .. ", value = " .. tostring(value))
    if key == nil or value == nil then
        return
    end

    local imagePath = skinDataForSkinManager[skin_type].skinImagePrefix .. value[1]
    local AnchorPoint = shiftStrAnchorToInt(value[2])
    local skinImgView = skinViewContainer:addImageView(imagePath, AnchorPoint, value[3], value[4],
    value[5], value[6], ZOrder().zorder_bottom)

    if skinDisplayTable ~= nil and skinImgView ~= nil then
        skinDisplayTable[key] = { skinview = skinImgView, show = true, oldShow = true }
    end
end

local function readTableToCreateSkin(typeSkin)
    printLog("readTableToCreateSkin begin")

    local widgetTypeKey = getSkinDataByType(typeSkin)[KEY_SKIN_WIDGET_TYPE][mapTypeKey];
    local tables = gSkinAdapterManager:getItem(widgetTypeKey);
    for index, filterId in pairs(tables) do
        for i = 1, #filterOnceSkinTable do
            if index == filterOnceSkinTable[i] then
                filterId = nil
            end
        end
        createSkin(index, filterId)
    end
end

local function firstUpdateSkinView(screenState)
    for key, value in pairs(skinDisplayTable) do
        if value.skinview ~= nil then
            if value.show and screenState == SKIN_ORIENTATION_LANDSCAPE then
                printLog("firstUpdateSkinView show skin id: " .. tostring(key))
                value.skinview:show()
            else
                printLog("firstUpdateSkinView hide skin id: " .. tostring(key))
                value.skinview:hide()
            end
        end
        value.oldShow = value.show;
    end
    isFirstEnterSkin = false;
end

local function exceptFirstUpdateSkillView(screenState)
    for key, value in pairs(skinDisplayTable) do
        --printLog("exceptFirstUpdateSkillView show all skin id: " .. tostring(key) .. "   show = " .. tostring(value.show))
        if value.show ~= value.oldShow then
            if value.skinview ~= nil then
                if value.show and screenState == SKIN_ORIENTATION_LANDSCAPE then
                    --printLog("exceptFirstUpdateSkillView show skin id: " .. tostring(key))
                    value.skinview:show()
                else
                    --printLog("exceptFirstUpdateSkillView hide skin id: " .. tostring(key))
                    value.skinview:hide()
                end
            end
        end
        value.oldShow = value.show;
    end
end

--- 真正在界面上显示皮肤的函数
--- 由于需要操作view组件，所以该方法必须要在主线程调用
local function updateSkinView()
    --printLog("updateSkinView begin")
    if skinDisplayTable == nil then
        printLog("updateSkinView skinDisplayTable is nil")
        return
    end

    --- 添加当前屏幕横竖屏状态的判断，竖屏的时候不显示皮肤
    -- screenState横竖屏状态 1代表横屏 2代表竖屏
    local screenState = commonlib_getScreenState();
    reportShowSkin(REASON_SUCCEED, false);
    commonlib_saveShowSkinFlag(GAME_SGAME_PKG_NAME)
    if not hasReportSkinType then
        gameRecogReport(true, ACTION_SHOW_SKIN, skin_type);
        hasReportSkinType = true;
    end
    --printLog("updateSkinView screenState: " .. tostring(screenState));
    if isFirstEnterSkin then
        firstUpdateSkinView(screenState)
    else
        exceptFirstUpdateSkillView(screenState)
    end
end

local function updateSkinViewOnUIThread()
    commonlib_runOnUIThread(function()
        updateSkinView()
    end)
end

--- 重置所有皮肤view，将其都设为显示状态
local function resetAllSkinViews()
    printLog("resetAllSkinView begin")
    if skinViewContainer ~= nil then
        skinViewContainer:fadeIn()
    end
end

--- 隐藏所有皮肤view
local function hideAllSkinViews()
    printLog("hideAllSkinView begin")
    if skinViewContainer ~= nil then
        skinViewContainer:fadeOut()
    end
end

--- 销毁所有皮肤view
local function destroyAllSkinViews()
    printLog("destroyAllSkinView begin")
    if skinDisplayTable == nil then
        printLog("skinDisplayTable is nil")
        return
    end

    destroySkinViewContainer();
    --清空表
    skinDisplayTable = {}
end

--- 由于需要操作view组件，所以该方法必须要在主线程调用
local function initSkinViewResources()
    printLog("initSkinViewResources begin")

    --- 如果皮肤checkbox没被勾选，则不做处理
    if skin_checkBox == nil or not skin_checkBox:isChecked() then
        reportShowSkin(REASON_NOT_CHOOSE_SKIN_CHECK_BOX, false)
        return
    end

    createSkinViewContainer();
    if mapTypeKey == nil then
        printLog("initSkinViewResources mapTypeKey is nil")
        return
    else
        printLog("mapTypeKey = : " .. tostring(mapTypeKey))
    end

    resetAllSkinViews()
    skin_lastMapMode = nil
    skin_lastEquipment = nil
    skin_lastAttackMode = nil
    skin_lastChat = nil
    skin_lastOrder = nil

    --- 待显示皮肤表需要先置空
    if #skinDisplayTable > 0 then
        skinDisplayTable = {}
    end

    --- 过滤英雄技能表需要置空
    if #filterOnceSkinTable > 0 then
        filterOnceSkinTable = {}
    end

    --- 根据英雄技能过滤非本局要显示的皮肤
    filterHeroAndSkillType()

    readTableToCreateSkin(skin_type)
    handleEquipmentAndAttackMode()
    handleOrderWindow(commonlib_getGameParam(KEY_IS_ORDER_WINDOW_OPEN))
    -- 在打开大地图的情况下切换皮肤，需要处理这种情况
    handleMapByMode(commonlib_getGameParam(KEY_LARGE_MAP))
    updateSkinView()
    printLog("initSkinViewResources end")
end

--- 皮肤radiobutton勾选切换的时候调用
local function shiftSkinViewResources()
    printLog("shiftSkinViewResources")
    destroyAllSkinViews()
    initSkinViewResources()
end

local function isViewsNil(views)
    for index, view in pairs(views) do
        if view == nil then
            return true
        end
    end

    return false
end

--- 开启皮肤系统checkbox勾选或者取消的回调函数
local function skinCheckboxUICallback(id, isChecked)
    printLog("skinCheckboxUICallback" .. tostring(id) .. tostring(isChecked))
    if isViewsNil(skinSettingImageViewTable) then
        return
    end

    if isViewsNil(skinSettingCheckboxTable) then
        return
    end

    commonlib_setSharedPrefBoolean(KEY_IS_SKIN_CHECKED, isChecked)

    if isChecked then
        -- 级联选中上次使用的皮肤，并重新渲染皮肤
        printLog("skinevsetting back to skin " .. tostring(skin_type))
        skinSettingCheckboxTable[skin_type]:setChecked(true)
        shiftSkinViewResources()

    else
        commonlib_setCheckboxsChecked(skinSettingCheckboxTable, false)

        destroyAllSkinViews()
    end

    onSkinBeautifySettingsChange(isChecked)
end

--- 皮肤radiobutton选中或者取消的回调函数
local function skinRadioGroupUICallback(id, isChecked)
    printLog("skinevsetting begin " .. tostring(isChecked))

    if not isChecked then
        return
    end

    if isViewsNil(skinSettingCheckboxTable) then
        return
    end

    for skinType, checkbox in pairs(skinSettingCheckboxTable) do
        if id == checkbox:getId() then
            if skin_type ~= skinType then
                local last_skin_ype = skin_type
                skin_type = skinType
                printLog("skinevsetting do on change " .. tostring(skin_type))
                commonlib_setSharedPrefString(KEY_SKIN_TYPE, skin_type)
                reportSkinClick()

                if skin_checkBox:isChecked() then
                    -- 如果一级设置项已勾选，则直接更换新皮肤
                    local needDownload = skinDataForSkinManager[skinType].needDownload
                    local progressView  = skinSettingProgressView[skinType]
                    printLog("need download : " .. tostring(needDownload) .. tostring(progressView))
                    if needDownload then
                        commonlib_getSkinManager():downloadSkin(skinType, function (action, skin_id, status)
                            printLog(action .. " " .. tostring(skin_id) .. " " .. tostring(status))
                            if action == "DownloadResult" then
                                if status == true then
                                    shiftSkinViewResources()
                                    commonlib_runOnUIThreadDelayed(function ()
                                        if progressView ~= nil then
                                            progressView:hide()
                                        end
                                    end, 2000)
                                else --- download failed，restore to last skin type
                                    skin_type = last_skin_ype
                                    commonlib_setSharedPrefString(KEY_SKIN_TYPE, skin_type)
                                    skinSettingCheckboxTable[skin_type]:setChecked(true)
                                    shiftSkinViewResources()
                                    commonlib_runOnUIThread(function ()
                                        if progressView ~= nil then
                                            progressView:stop()
                                        end
                                    end)
                                end

                            elseif action == "DownloadProgress" then
                                commonlib_runOnUIThread(function ()
                                    if progressView ~= nil then
                                        progressView:show()
                                        progressView:setProgress(status)
                                        printLog("progressview set progress: " .. tostring(status))
                                    end
                                end)
                            end
                        end)
                    else
                        shiftSkinViewResources()
                    end
                else
                    -- 否则触发一级设置项的勾选事件来完成后续的更换皮肤工作
                    skin_checkBox:setChecked(true)
                end

            elseif not skin_checkBox:isChecked() then
                -- 取消勾选"开启界面美化"后，再点击选中取消前已选中的那个皮肤的场景
                skin_checkBox:setChecked(true)
            end
            return
        end
    end
end

--- 皮肤设置imageView选中点击的回调函数
local function skinSettingImageViewUICallback(id)
    printLog("skinSettingImageViewUICallback " .. tostring(id))

    if isViewsNil(skinSettingImageViewTable) then
        printLog("skinSettingImageViewTable is nil")
        return
    end

    for skinType, imageView in pairs(skinSettingImageViewTable) do
        if imageView:getId() == id then
            printLog("skinevsetting trigger checkbox checked ops " .. tostring(skinType))
            -- 间接触发上面的 skinRadioGroupUICallback() 方法被调用来完成后续的设置工作
            skinSettingCheckboxTable[skinType]:setChecked(true)
            return
        end
    end
end

local REPORT_TABLE_NAME_DEFAULT_SKIN = "gamemaster_sgame_default_skin"
local KEY_REPORT_DEFAULT_SKIN = "default_skin"
local KEY_HAS_REPORTED_DEFAULT_SKIN = "hasReportedDefaultSkin"
local function handleReportDefaultSkin(defaultSkin)
    printLog(" handleReportDefaultSkin " .. tostring(defaultSkin))
    if commonlib_getSharedPrefBoolean(KEY_HAS_REPORTED_DEFAULT_SKIN, false) then
        printLog("已经上报过默认皮肤，不在上报")
        return
    end

    local skinReportData = -1
    if defaultSkin == KEY_SKIN_TYPE_GOLD then
        skinReportData = 1
    elseif defaultSkin == KEY_SKIN_TYPE_BLUE then
        skinReportData = 2
    end

    if skinReportData == -1 then
        printLog("上报数据有误，不执行上报")
        return
    end

    local reportData = { [KEY_REPORT_DEFAULT_SKIN] = skinReportData }
    printLog("上报数据是否为空：" .. tostring(#reportData))
    commonlib_report(REPORT_TABLE_NAME_DEFAULT_SKIN, reportData)
    commonlib_setSharedPrefBoolean(KEY_HAS_REPORTED_DEFAULT_SKIN, true)
end

local function generateSettingView(settingTab, referView, radioGroupController)
    printLog( " generateSettingView ")
    local topView = referView;
    for index, skinType in pairs(skinTypeTable) do
        printLog("开始生成皮肤" .. tostring(skinType) .. "的设置界面")
        local layoutParam = create("RelativeLayoutParam")
        local cbLayoutParamValues = {}
        local ivLayoutParamValues = {}
        local pvLayoutParamValues = {}

        local skinData = getSkinDataByType(skinType);

        if commonlib_isOddNumber(index) then
            cbLayoutParamValues.layout_marginLeft = "50dp"
            ivLayoutParamValues.layout_marginLeft = "50dp"
        else
            cbLayoutParamValues.layout_marginLeft = "220dp"
            ivLayoutParamValues.layout_marginLeft = "220dp"
        end
        cbLayoutParamValues.layout_marginTop = "12dp"
        cbLayoutParamValues.layout_below = topView:getId()
        layoutParam:setLayoutParam(cbLayoutParamValues)
        local checkbox = settingTab:addRadioButton(skinData[KEY_SKIN_NAME], false, layoutParam, nil, radioGroupController:getId())

        ivLayoutParamValues.layout_marginTop = "12dp"
        ivLayoutParamValues.layout_width = "130dp"
        ivLayoutParamValues.layout_height = "79dp"
        ivLayoutParamValues.layout_below = checkbox:getId()
        layoutParam:setLayoutParam(ivLayoutParamValues)

        local imageView = settingTab:addImageView(skinDataForSkinManager[skinType].settingSampleImagePath, layoutParam, skinSettingImageViewUICallback)
        skinSettingCheckboxTable[skinType] = checkbox
        skinSettingImageViewTable[skinType] = imageView

        if skinDataForSkinManager[skinType].needDownload == true then
            pvLayoutParamValues.layout_marginTop = "12dp"
            pvLayoutParamValues.layout_width = "50dp"
            pvLayoutParamValues.layout_height = "50dp"
            pvLayoutParamValues.layout_below = checkbox:getId()
            layoutParam:setLayoutParam(pvLayoutParamValues)

            local progressView = settingTab:addCircleProgressView(layoutParam, nil)
            skinSettingProgressView[skinType] = progressView

            printLog("add progressview for: " .. tostring(skinType))
        end

        if not commonlib_isOddNumber(index) then
            topView = skinSettingImageViewTable[skinTypeTable[index - 1]]
        end
    end
end

local function isSkinTypeTableExistSKinType(skinType)
    for key, skinType_ in pairs(skinTypeTable) do
        if skinType_ == skinType then
            return true;
        end
    end

    return true;
end

local function getCurrentValidateSkinType()
    skin_type = commonlib_getSharedPrefString(KEY_SKIN_TYPE, KEY_SKIN_TYPE_GOLD);
    if skinDataForSkinManager[skin_type] ~= nil and
            skinDataForSkinManager[skin_type].needDownload == false and
            isSkinTypeTableExistSKinType(skin_type) then
        return skin_type;
    end

    if skin_type ~= KEY_SKIN_TYPE_GOLD and
            skinDataForSkinManager[KEY_SKIN_TYPE_GOLD] ~= nil and
            skinDataForSkinManager[KEY_SKIN_TYPE_GOLD].needDownload == false and
            isSkinTypeTableExistSKinType(KEY_SKIN_TYPE_GOLD) then
        return KEY_SKIN_TYPE_GOLD;
    end

    for key, skinType in pairs(skinTypeTable) do
        if skinDataForSkinManager[skinType] ~= nil and
                skinDataForSkinManager[skinType].needDownload == false then
            return skinType;
        end
    end

    return KEY_SKIN_TYPE_GOLD;
end

--- 初始化Buff设置页面UI函数
local function initSkinSettingUI()
    skin_type = getCurrentValidateSkinType();

    local isEnable = commonlib_getSgameFuncAbcTestEnable(SGAME_FUNC_SKIN_CLOUD_SWITCH_KEY, true);

    skin_isChecked = commonlib_getSharedPrefBoolean(KEY_IS_SKIN_CHECKED, isEnable)
    printLog("initSkinSettingUI begin skin_type: " .. skin_type)

    local settingView = commonlib_getSettingView()

    if nil == skin_settingPanel then
        skin_settingPanel = settingView:addTableView(SKIN_BUTTON)
    end

    local skinSettingParam
    local skinSettingParams

    --- 添加开启皮肤系统的checkbox
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_marginTop = "20dp",
        layout_marginLeft = "25dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    skin_checkBox = skin_settingPanel:addCheckBoxView(SKIN_SWITCH_TEXT, skin_isChecked, skinSettingParam, skinCheckboxUICallback)

    skin_radioGroupController = skin_settingPanel:createRadioGroupController(skinRadioGroupUICallback)

    generateSettingView(skin_settingPanel, skin_checkBox, skin_radioGroupController)
    if skin_isChecked and skinSettingCheckboxTable[skin_type] ~= nil then
        skinSettingCheckboxTable[skin_type]:setChecked(true)
    end

    skin_settingPanel:setOnTabSelectedListener(function()
        reportSkinShow();
    end);
end

local function initSkinFloatView()
    --- 初始化添加皮肤的悬浮窗主view
    createSkinViewContainer();
    floatBallView = commonlib_getFloatBall()
    if (commonlib_isMEIZUFlymeOS()) then
        floatBallView:setSystemWindowType(WindowManager_TYPE_SYSTEM_ERROR);
    end
end

local function handleCloseSkinSelectView(skinSelectView)
    printLog("handleCloseSkinSelectView")
    if skinSelectView == nil then
        return
    end

    commonlib_destroyView(skinSelectView)
    commonlib_setSharedPrefBoolean(KEY_HAS_SHOW_SKIN_SELECT_VIEW, true)
    floatBallView:setEnable(true)

end

local function handleContractMode()
    local currentContractState = commonlib_getGameParam(KEY_CONTRACT_MODE_HERO_STATE);
    if currentContractState ~= lastContractState then
        if currentContractState == CONTRACT_HERO_SWITCHING then
            lastHeroSkillCount = commonlib_getGameParam(KEY_HERO_SKILL_COUNT);
            lastSummonerSkillCount = commonlib_getGameParam(KEY_SUMMONER_SKILL_COUNT);
            printLog("ContractMode: hideAllSkinViews, hero skill " .. tostring(lastHeroSkillCount));
            commonlib_runOnUIThread(hideAllSkinViews);
            
        elseif currentContractState == CONTRACT_HERO_SWITCHED then
            local currentSkillCount = commonlib_getGameParam(KEY_HERO_SKILL_COUNT);
            local currentSummonerSkillCount = commonlib_getGameParam(KEY_SUMMONER_SKILL_COUNT);
            if lastHeroSkillCount == currentSkillCount and lastSummonerSkillCount == currentSummonerSkillCount then
                isFirstEnterSkin = true;
                printLog("ContractMode: updateSkinView, hero skill " .. tostring(lastHeroSkillCount));
                commonlib_runOnUIThread(updateSkinView);
            else
                printLog("ContractMode: initSkinViewResources, hero skill " .. tostring(lastHeroSkillCount) .. " > " ..tostring(currentSkillCount));
                lastHeroSkillCount = currentSummonerSkillCount;
                lastSummonerSkillCount = currentSummonerSkillCount;
                commonlib_runOnUIThread(function()
                    destroyAllSkinViews();
                    initSkinViewResources();
                end)
            end
        else
            printLog("ContractMode: updateSkinView, state " .. tostring(lastContractState) .. " > " .. tostring(currentContractState));
            lastHeroSkillCount = commonlib_getGameParam(KEY_HERO_SKILL_COUNT);
            lastSummonerSkillCount = commonlib_getGameParam(KEY_SUMMONER_SKILL_COUNT);
            commonlib_runOnUIThread(updateSkinView);
        end
        lastContractState = currentContractState;
    end
end

--- gamemaster_game_skinchoose:275 package:string skinname:string
local function reportSkinChoose()
    if skin_isChecked and nil ~= gSkinAdapterManager and nil ~= skin_type then
        local skinData = gSkinAdapterManager:getItem(skin_type)
        if nil ~= skinData then
            commonlib_reportSkinChoose(GAME_SGAME_PKG_NAME, skinData[KEY_SKIN_NAME]);
        end
    end
end

local function onGameStart()
    local mapType = commonlib_getMapType()
    if mapType == nil or mapType == MAP_TYPE_UNKNOW then
        printLog("onGameStart mapType is nil or unkown return")
        return
    end

    printLog("onGameStart mapType is: " .. tostring(mapType))
    if mapType == MAP_TYPE_FIVE_ARMY_BATTLE then
        mapTypeKey = KEY_MAP_TYPE_FIVE_ARMY_BATTLE
    elseif mapType == MAP_TYPE_3V3 then
        mapTypeKey = KEY_MAP_TYPE_3V3
    else
        mapTypeKey = KEY_MAP_TYPE_5V5
    end
    commonlib_runOnUIThread(initSkinViewResources)
end

local function onGameRunning()
    handleFloatBallSkin()

    if isContractMode() then
        handleContractMode();
    else
        updateSkinViewOnUIThread();
    end
end

local function onGameOver()
    printLog("onGameOver")
    reportEndCount()
    commonlib_runOnUIThread(function()
        destroyAllSkinViews()
        handleCloseSkinSelectView(skinSelectView)
    end)
    hasReportShowSkin = false
    hasReportSkinType = false

    lastHeroSkillCount = 0;
    lastSummonerSkillCount = 0;
    lastContractState = nil;
end

local function onFullCoverStateChange(isFullCover)
    printLog("onFullCoverStateChange isFullCover: " .. tostring(isFullCover))
    commonlib_runOnUIThread(function()
        if isFullCover then
            hideAllSkinViews()
        else
            resetAllSkinViews()
        end
    end)
end

local function onMapModeChange(mapMode)
    printLog("onMapModeChange mapMode: " .. tostring(mapMode))
    handleMapByMode(mapMode)
    updateSkinViewOnUIThread()
end

local function onChatWindowOpenStateChange(isOpen)
    printLog("onChatWindowOpenStateChange isOpen: " .. tostring(isOpen))
    handleChatWindow(isOpen)
    updateSkinViewOnUIThread()
end

local function onOrderWindowOpenStateChange(isOpen)
    printLog("onOrderWindowOpenStateChange isOpen: " .. tostring(isOpen))
    handleOrderWindow(isOpen)
    updateSkinViewOnUIThread()
end

local function onEquipmentChange(equipment)
    printLog("onEquipmentChange equipment: " .. tostring(equipment))
    handleQuipment(equipment)
    updateSkinViewOnUIThread()
end

local function onAttackModeChange(attackMode)
    printLog("onAttackModeChange attackMode: " .. tostring(attackMode))
    handleAttackMode(attackMode)
    updateSkinViewOnUIThread()
end

local function onJustEnterGame()
    reportSkinChoose()
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_registerCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
    commonlib_registerCallback(common_game_events_callbacks.common_chat_window, onChatWindowOpenStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_order_window, onOrderWindowOpenStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_equipment, onEquipmentChange)
    commonlib_registerCallback(common_game_events_callbacks.common_attck_mode, onAttackModeChange)
    commonlib_registerCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_unregisterCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_chat_window, onChatWindowOpenStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_order_window, onOrderWindowOpenStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_equipment, onEquipmentChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_attck_mode, onAttackModeChange)
	commonlib_unregisterCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
end

local function initData()

    skinDataForSkinManager = commonlib_getSkinManager():getAllSkinItems();
    if skinDataForSkinManager == nil then
        skinDataForSkinManager = {}
    end

    skinTypeTable = {};

    local allSkinIds = gSkinAdapterManager:getItem(KEY_SUPPORT_SKIN_TYPE_IDS);

    for key_, skinId in pairs(allSkinIds) do
        local canAppend = false;
        if skinDataForSkinManager[skinId] ~= nil then
            canAppend = true;
        end

        if canAppend == true then
            skinTypeTable[#skinTypeTable + 1] = skinId;
        end
    end

    skinTypeReportMap = {
        [KEY_SKIN_TYPE_GOLD] = 1,
        [KEY_SKIN_TYPE_DOG] = 2,
        [KEY_SKIN_TYPE_DRAGON] = 3,
        [KEY_SKIN_TYPE_TIGER] = 4,
        [KEY_SKIN_TYPE_TORTOISE] = 5,
        [KEY_SKIN_TYPE_BIRD] = 6,
        [KEY_SKIN_TYPE_PINK] = 7,
        [KEY_SKIN_TYPE_SILVER] = 8,
        [KEY_SKIN_TYPE_BLUE] = 9,
        [KEY_SKIN_TYPE_MECHA] = 10
    }

    skinInfoMap = {
        { ["skinName"] = SKIN_NAME_GOLD, ["sampleGraphPath"] = SKIN_GOLD_SAMPLE_IMAGE_PATH },
        { ["skinName"] = SKIN_NAME_DRAGON, ["sampleGraphPath"] = SKIN_DRAGON_SAMPLE_IMAGE_PATH },
        { ["skinName"] = SKIN_NAME_TIGER, ["sampleGraphPath"] = SKIN_TIGER_SAMPLE_IMAGE_PATH },
        { ["skinName"] = SKIN_NAME_TORTOISE, ["sampleGraphPath"] = SKIN_TORTOISE_SAMPLE_IMAGE_PATH },
        { ["skinName"] = SKIN_NAME_BIRD, ["sampleGraphPath"] = SKIN_BIRD_SAMPLE_IMAGE_PATH },
        { ["skinName"] = SKIN_NAME_PINK, ["sampleGraphPath"] = SKIN_PINK_SAMPLE_IMAGE_PATH },
        { ["skinName"] = SKIN_NAME_SILVER, ["sampleGraphPath"] = SKIN_SILVER_SAMPLE_IMAGE_PATH },
        { ["skinName"] = SKIN_NAME_BLUE, ["sampleGraphPath"] = SKIN_BLUE_SAMPLE_IMAGE_PATH }
    }

end

local function getFuncCloudSwitch()
    if funcCloudSwitch ~= nil then
        return funcCloudSwitch
    end
    funcCloudSwitch = commonlib_getSgameFuncCloudSwitch(SGAME_FUNC_SKIN_CLOUD_SWITCH_KEY, true)
    return funcCloudSwitch
end

local function skinChange()
    commonlib_runOnUIThread(function ()

        if true ~= gbInited then
            printLog("skinChange, not inited");
            return
        end

        local skin_type_last = skin_type

        commonlib_destroyView(skin_checkBox)
        commonlib_destroyView(skin_radioGroupController)
        commonlib_destroyViews(skinSettingCheckboxTable)
        commonlib_destroyViews(skinSettingImageViewTable)

        initData()
        initSkinSettingUI()

        printLog("skinChange, re-init settingUI, skin_id:" .. tostring(skin_type)
                .. ", last_skin_id:" .. tostring(skin_type_last));

        if skin_type ~= skin_type_last then
            shiftSkinViewResources()

            printLog("skinChange, re-create Skin, skin_id:" .. tostring(skin_type)
                    .. ", last_skin_id:" .. tostring(skin_type_last));
        end
    end)
end

local function initSkinListener()
    gEventId = SKIN_EVENT .. "." .. tostring(commonlib_getCurrentTime())
    commonlib_getEvent():registerEvent(gEventId, SKIN_EVENT, function(event, pkgname, skin_id)

        printLog("skinChange, " .. tostring(event) .. ", skin_id:" .. tostring(skin_id) .. ", pkgname:" .. tostring(pkgname));

        if pkgname == GAME_SGAME_PKG_NAME and true == gbInited then
            skinChange()
        end
    end)
end

local function uninitSkinListener()
    if nil ~= gEventId then
        commonlib_getEvent():unregisterEvent(gEventId, SKIN_EVENT)
    end
end

--- 初始化与反初始化
local function init()
    printLog("init")

    local cloudSwitch = getFuncCloudSwitch()
    printLog("皮肤开关："  .. tostring(cloudSwitch))
    if cloudSwitch == false then
        return
    end

    gSkinAdapterManager = AdapterManagerClass:getSkinInstance();
    registerGameEvents()
    initSkinFloatView()

    initData();

    initSkinSettingUI()

    skin_is18To9 = commonlib_isScreenRatio18To9()

    initSkinListener()
    gbInited = true
end

local function uninit()
    printLog("uninit")

    gbInited = false
    uninitSkinListener()

    local cloudSwitch = getFuncCloudSwitch()
    printLog("皮肤开关："  .. tostring(cloudSwitch))
    if cloudSwitch == false then
        return
    end

    commonlib_destroyView(skin_checkBox)
    commonlib_destroyView(skin_radioGroupController)
    commonlib_destroyViews(skinSettingCheckboxTable)
    commonlib_destroyViews(skinSettingImageViewTable)

    if floatBallView ~= nil then
        floatBallView = nil
    end

    destroySkinViewContainer();

    if skinDisplayTable ~= nil then
        skinDisplayTable = nil
    end

    if filterOnceSkinTable ~= nil then
        filterOnceSkinTable = nil
    end

    unregisterGameEvents()
end

--table.insert(common_life_circle_callbacks, { init, uninit, SGAME_LIFE_CIRCLE_TABLE_ORDER_WEIGHT.skin })