--- 工具类脚本
local TAG = "util"

FOUR_SKILL_HERO_ID_LIST = { 67, 15, 72 }

local imageRecognize = ImageRecognize()
local gameConfig = GlobalGameConfig()

--- 图像识别时间间隔
local IMAGE_RECOGNIZE_INTERVAL = 1000;
local lastImageRecognizeTime = 0

--- 英雄位置
local heroPosition

-- 是否需要做提醒, 包括buff提醒和战斗提醒
function commonlib_shouldDoNotice()
    local mapType = commonlib_getGameParam(KEY_MAP_TYPE);
    return mapType == MAP_TYPE_5V5 or mapType == MAP_TYPE_OTHER
end

-- 是否是火焰山模式
function commonlib_isFlameMountainMap()
    local mapType = commonlib_getGameParam(KEY_MAP_TYPE);
    return mapType == MAP_TYPE_FLAME_MOUNTAIN;
end

-- 用于判断红蓝buffer
function commonlib_recognizeMatchRedBlueBuffer(rect)
    if imageRecognize ~= nil and rect ~= nil then
        return imageRecognize:matchRedBlueBuffer(rect)
    else
        commonlib_print(TAG, "commonlib_recognizeMatchRedBlueBuffer imageRecognize or rect is nil")
        return nil
    end
end

-- 根据匹配的小地图位置检测出英雄数组
function commonlib_recognizeFindObjectPosition(rect)

    commonlib_print(TAG, "commonlib_recognizeFindObjectPosition")
    local currentTime = commonlib_getCurrentTime();
    if currentTime - lastImageRecognizeTime < IMAGE_RECOGNIZE_INTERVAL then
        commonlib_print(TAG, "imageRecogize 时间间隔小于1s")
        return heroPosition
    end

    if imageRecognize ~= nil and rect ~= nil then
        lastImageRecognizeTime = currentTime
        commonlib_print(TAG, "imageRecogize 识别时间" .. tostring(lastImageRecognizeTime))
        heroPosition = imageRecognize:findObjectPosition(rect)
        return heroPosition
    else
        commonlib_print(TAG, "commonlib_recognizeFindObjectPosition imageRecognize or rect is nil")
        return nil
    end
end

--- 识别英雄角色（服务端）
function commonlib_detectHeroRole(rect)
    if imageRecognize ~= nil and rect ~= nil then
        return imageRecognize:detectHeroRole(rect)
    else
        commonlib_print(TAG, "commonlib_detectHeroRole imageRecognize or rect is nil")
        return nil
    end
end

--- 识别英雄角色（本地）
function commonlib_detectLocalHeroRole(rect)
    if imageRecognize ~= nil and rect ~= nil then
        return imageRecognize:detectLocalHeroRole(rect)
    else
        commonlib_print(TAG, "commonlib_detectLocalHeroRole imageRecognize or rect is nil")
        return nil
    end
end

function commonlib_getResult()
    return imageRecognize:getResult()
end

function commonlib_resetResult()
    imageRecognize:resetResult();
end

function commonlib_getMapType()
    return commonlib_getGameParam(KEY_MAP_TYPE)
end

function commonlib_is5V5Map()
    local mapType = commonlib_getMapType()
    if mapType == MAP_TYPE_5V5 then
        return true
    else
        return false
    end
end

-- 根据地图类型获取每一方的玩家人数，-1 表示玩家人数不确定
function commonlib_getPlayerCountByMapType(mapType)
    local playerCount = -1
    if mapType == MAP_TYPE_5V5 or mapType == MAP_TYPE_5V5_SCRIMMAGE or mapType == MAP_TYPE_OTHER or mapType == MAP_TYPE_FLAME_MOUNTAIN then
        playerCount = 5
    elseif mapType == MAP_TYPE_3V3 then
        playerCount = 3
    elseif mapType == MAP_TYPE_1V1 then
        playerCount = 1
    end
    return playerCount
end

-- 判断是否发生了全遮挡或者地图展开
function commonlib_isFullCoverOrMapExpand(fullCover, mapMode)
    return fullCover or mapMode == LARGE_MAP_LEFT_ZOOMOUT or mapMode == LARGE_MAP_RIGHT_ZOOMOUT
end

function commonlib_isFourSkillHero(heroId)

    for index, key in pairs(FOUR_SKILL_HERO_ID_LIST) do
        if key == heroId then
            return true;
        end
    end

    return false;
end

function commonlib_hasExpandSharedApp()
    if gameConfig == nil then
        gameConfig = GlobalGameConfig()
    end
    return gameConfig:hasExpandSharedApp()
end