
--- 确定游戏状态的脚本

--- ******界面元素******----
------------- 界面不可变元素-------------

BOB_APP_NAME = 9

local gNewGameEngine;

KEY_GAME_WORK = "gameWork"

-- 用于回调到各个业务脚本的回调函数表
common_game_events_callbacks = {
    [KEY_GAME_WORK] = {},
}

Tag = "common_state"
local function printLog(msg)
    commonlib_print(Tag, msg)
end

local INIT_INDEX = 1
local UNINIT_INDEX = 2

local COMMON_STATE_RESUME = "bob_common_state_lua_resume"
local COMMON_STATE_PAUSE = "bob_common_state_lua_pause"

local function registerResume()
    commonlib_registerResume(COMMON_STATE_RESUME, function()
        printLog("onResume")
        gNewGameEngine:clearCRectAdjustManager()
        common_skin_clearSkinDataAndDestroySkin()
        common_skin_createSkinData()
    end)
end

local function unregisterResume()
    commonlib_unregisterResume(COMMON_STATE_RESUME)
end

local function registerPause()
    commonlib_registerResume(COMMON_STATE_PAUSE, function()
        printLog("onPause")
        gNewGameEngine:clearCRectAdjustManager()
        common_skin_clearSkinDataAndDestroySkin()
        common_skin_createSkinData()
    end)
end

local function unregisterPause()
    commonlib_unregisterResume(COMMON_STATE_PAUSE)
end

local function callLifeCircleInit()
    --printLog("callLifeCircleInit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleInit common_life_circle_callbacks is nil or empty")
        return
    end
    commonlib_handleNestingTable(common_life_circle_callbacks, INIT_INDEX)
end

local function callLifeCircleUninit()
    --printLog("callLifeCircleUninit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleUninit common_life_circle_callbacks is nil or empty")
        return
    end
    commonlib_handleNestingTable(common_life_circle_callbacks, UNINIT_INDEX)
end

local function initVariable()
    gNewGameEngine = CNewGameEngine:getInstance();
end
local function init()
    initVariable();
    commonlib_putSettingViewsEventListener()
    common_skin_init()
    callLifeCircleInit();
	init_feedback()
    registerResume()
    registerPause()
end

local function uninit()
    common_skin_uninit()
    callLifeCircleUninit();
    unregisterResume()
    unregisterPause()
end

local function isGameRunning()
    return gNewGameEngine:matchCondition("cd_build_group_setting")
end
local gIsGameRunning = false;

local function work()
    printLog("work:start")
    gNewGameEngine:clearCache();

    local nowIsGameRunning = isGameRunning();
    if nowIsGameRunning ~= gIsGameRunning and  nowIsGameRunning == true then
        gNewGameEngine:clearCache({CLEAR_FLAG_FORCE});
        gNewGameEngine:matchCondition("cd_build_group_fullscr")
        gNewGameEngine:matchCondition("cd_build_group_unfullscr")
    end
    gIsGameRunning = nowIsGameRunning;

    common_skin_work()
    commonlib_handleTableWithoutParam(common_game_events_callbacks[KEY_GAME_WORK])
    printLog("work:end")
end

table.insert(core_scripts, { init, uninit, work })