-- adpater parse and mgr

REGFUNCTION_MATCH_RESOURCE_NOMRAL = 1;
REGFUNCTION_MATCH_RESOURCE_WHITH_RGB_BINARIZATION = 2;
REGFUNCTION_MATCH_RESOURCE_WHITH_HSV_BINARIZATION = 3;
REGFUNCTION_COUNT_MATCH_PIXEL_PERCENT = 4;
REGFUNCTION_MATCH_RESOURCE_WITH_BRIGHTNESS = 5;
REGFUNCTION_DETECT_INPUT_METHON_OPEND = 6;
REGFUNCTION_PUBGMHD_PLAYER_SAFETY_POS = 7;

CONDITON_TYPE_RGB = 1;
CONDITON_TYPE_HSV = 2;

---批量适配宏定义

KEY_SKIN_IDS = "skinIds"
KEY_SKIN_EXCLUDE_IDS = "skin_exclude_ids"
KEY_SKIN_ALL = "*";

KEY_SKIN_WIDGET_TYPE_IDS = "widget_type_ids"
KEY_SKIN_WIDGET_TYPE_ALL = "*"

KEY_SUPPORT_SKIN_TYPE_IDS = "key_support_skin_type_ids";
KEY_SUPPORT_SKIN_WIDGET_TYPE_IDS = "key_support_skin_widget_type_ids";

KEY_SKIN_BATCH_ADAPTER = "batch_adapter";
KEY_SKIN_ADAPTER_OPERATION = "adapter_operation"

KEY_SKIN_ADAPTER_FUNCTION = "adapter_function"
KEY_SKIN_ADAPTER_FUNCTION_OFFSET = 1;

KEY_SKIN_ADAPTER_WIDGETIDS = "adapter_widgetids"
KEY_SKIN_ADAPTER_PARAM = "adapter_param"

KEY_SKIN_WIDGET_TYPE = "widget_type"

COMMON_LAYOUTPARAM = {
	MATCH_PARENT = -1,
	WRAP_CONTENT = -2,
}


local function printLog(msg)
	commonlib_print("AdapterManagerClass", msg);
end

AdapterManagerClass = {
};

function AdapterManagerClass:new()
	local realScreenSize = commonlib_getScreenRealSize();
	local object = {
		mapValues = {},
		model = commonlib_getModel(),
		resolution = tostring(realScreenSize.w).."_"..tostring(realScreenSize.h),
		priorAdapterManager = nil;
	};

	setmetatable(object, self);
	self.__index = self;

	return object;
end

function AdapterManagerClass:getPriorAdapterManager()
	return self.priorAdapterManager;
end

function AdapterManagerClass:setPriorAdapterManager(priorAdapterManager)
	self.priorAdapterManager = priorAdapterManager;
end

local recognizeAdapterManager;
function AdapterManagerClass:getRecognizeInstance()
	if recognizeAdapterManager == nil then
		recognizeAdapterManager = AdapterManagerClass:new();
	end

	return recognizeAdapterManager;
end

local skinAdapterManager;
function AdapterManagerClass:getSkinInstance()
	if skinAdapterManager == nil then
		skinAdapterManager = AdapterManagerClass:new();
	end

	return skinAdapterManager;
end

local mapResourceAdapterManager;
function AdapterManagerClass:getMapResourceInstance()
	if mapResourceAdapterManager == nil then
		mapResourceAdapterManager = AdapterManagerClass:new();
	end

	return mapResourceAdapterManager;
end

--config is
--	{
--		MODEL = MODEL,
--		RESOLUTION = RESOLUTION,
--		DEFAULT = DEFAULT,
--	} see new_adapter.lua : function getAdapterConfig()
function AdapterManagerClass:init(config)
	self:parseDefaultConfig(config.DEFAULT);
	self:parseResolutionConfig(config.RESOLUTION);
	self:parseModelConfig(config.MODEL);
end

function AdapterManagerClass:initByArray(config)
	for index, value in pairs(config) do
		if value.condition == "DEFAULT" then
			self:parseDefaultConfig(value.value, value.description);
		elseif value.condition == "RESOLUTION" then
			self:parseCustumConfigImpl(value.description..":", value.value, self.resolution);
		elseif value.condition == "MODE" then
			self:parseCustumConfigImpl(value.description..":", value.value, self.model);
		end
	end
end

---- 此接口专门针对新版皮肤配置新增的函数：目前是只有王者荣耀采用新的皮肤配置
function AdapterManagerClass:initSkin(config)
	self:init(config);
	self:excudeAdapter();
end

function AdapterManagerClass:initSkinByArray(config)
	self:initByArray(config);
	self:excudeAdapter();
end

function AdapterManagerClass:excudeAdapter()
	local batchAdapterArray = self:getItem(KEY_SKIN_BATCH_ADAPTER);
	if batchAdapterArray == nil or #batchAdapterArray == 0 then
		return;
	end

	for key, value in pairs(batchAdapterArray) do
		self:excuteBatchAdapterItem(value);
	end
end

local function findValueInArray(array, value)
	if array == nil then
		return false;
	end

	for _, value2 in pairs(array) do
		if value == value2 then
			return true;
		end
	end

	return false;
end

local function doFilterValue(allValues, filterValues, allPattern)
	if allValues == nil or #allValues == 0 then
		return nil;
	end

	if filterValues == nil or #filterValues == 0 then
		return nil;
	end

	if findValueInArray(filterValues, allPattern) then
		return allValues;
	end

	local newToAdpter = {};
	for _, value in pairs(filterValues) do
		if findValueInArray(allValues, value) then
			table.insert(newToAdpter, value);
		end
	end

	return newToAdpter;
end

function AdapterManagerClass:offsetItemValue(item, index, offset)
	if item == nil or index == nil or offset == nil then
		return;
	end

	if item[index] == nil then
		return;
	end

	item[index] = item[index] + offset;
end

function AdapterManagerClass:excuteWidgetsOperation(widgets, operation)
	if widgets == nil or operation == nil then
		return;
	end

	local functionName = operation[KEY_SKIN_ADAPTER_FUNCTION];
	if functionName == nil then
		return;
	end

	if operation[KEY_SKIN_ADAPTER_FUNCTION] == KEY_SKIN_ADAPTER_FUNCTION_OFFSET then
		local widgetIds = operation[KEY_SKIN_ADAPTER_WIDGETIDS];
		local param = operation[KEY_SKIN_ADAPTER_PARAM];
		if widgetIds == nil or param == nil then
			return;
		end

		for _, id in pairs(widgetIds) do
			local widget = widgets[id];
			if widget ~= nil then
				local rect = widget.rect;
				if rect~= nil then
					self:offsetItemValue(rect, "left", param.left);
					self:offsetItemValue(rect, "top", param.top);
					self:offsetItemValue(rect, "width", param.width);
					self:offsetItemValue(rect, "height", param.height);
				else
					self:offsetItemValue(widget, 3, param.left);
					self:offsetItemValue(widget, 4, param.top);
					self:offsetItemValue(widget, 5, param.width);
					self:offsetItemValue(widget, 6, param.height);
				end
			else
				printLog("excuteWidgetsOperation:widgets[id] = nil:"..tostring(id));
			end
		end
	end

end

function AdapterManagerClass:excuteSkinOperations(skinData, skinMapType, operations)
	if skinData == nil or skinMapType == nil then
		return;
	end

	if operations == nil or #operations == 0 then
		return;
	end

	local allMapWidgets = skinData[KEY_SKIN_WIDGET_TYPE];
	if allMapWidgets == nil then
		return;
	end

	local wigdgets = self:getItem(allMapWidgets[skinMapType]);
	if wigdgets == nil then
	end

	for _, operation in pairs(operations) do
		if operation ~= nil then
			self:excuteWidgetsOperation(wigdgets, operation);
		end
	end
end

function AdapterManagerClass:excuteBatchAdapterItem(batchItem)
	if batchItem == nil then
		return;
	end

	local operations = batchItem[KEY_SKIN_ADAPTER_OPERATION];
	if operations == nil or #operations == 0 then
		return;
	end

	local toAdapterSkinIds = doFilterValue(self:getItem(KEY_SUPPORT_SKIN_TYPE_IDS),
		batchItem[KEY_SKIN_IDS], KEY_SKIN_ALL);
	if toAdapterSkinIds == nil or #toAdapterSkinIds == 0 then
		return;
	end

	local excludeSkinIds = batchItem[KEY_SKIN_EXCLUDE_IDS];
	if excludeSkinIds ~= nil and #excludeSkinIds > 0 then
		local toAdapterSkinIdsNew = {};
		for _, value in pairs(toAdapterSkinIds) do
			if findValueInArray(excludeSkinIds, value) == false then
				table.insert(toAdapterSkinIdsNew, value);
			end
		end
		if #toAdapterSkinIdsNew == 0 then
			return;
		end

		toAdapterSkinIds = toAdapterSkinIdsNew;
	end

	local toAdapterMapIds = doFilterValue(self:getItem(KEY_SUPPORT_SKIN_WIDGET_TYPE_IDS),
		batchItem[KEY_SKIN_WIDGET_TYPE_IDS], KEY_SKIN_WIDGET_TYPE_ALL);
	if toAdapterMapIds == nil or #toAdapterMapIds == 0 then
		return;
	end

	for _, skinId in pairs(toAdapterSkinIds) do
		local skinData = self:getItem(skinId);
		if skinId ~= nil then
			for _, mapId in pairs(toAdapterMapIds) do
				printLog("excuteSkinOperations:skinId="..commonlib_toString(skinId)..",mapId="..commonlib_toString(mapId));
				self:excuteSkinOperations(skinData, mapId, operations);
			end
		end
	end
end

local KEY_DESCRIPTION = "description";
local KEY_VALUE = "value";

function AdapterManagerClass:parseDefaultConfig(tableValue, description)
	if tableValue == nil then
		return;
	end

	if description == nil then
		description = "default";
	end

	for key, value in pairs(tableValue) do
		self.mapValues[key] =
		{
			[KEY_DESCRIPTION] = description,
			[KEY_VALUE] = value,
		};
	end
end

function AdapterManagerClass:replaceInfo(oldInfo, newInfo)
	-- Lua中直接赋值会被当作值传递，只有基于表的操作才是引用操作
	-- oldInfo = newInfo -- 这种方式会被认为是值传递，无法对原来的对象完成赋值
	for key, value in pairs(newInfo) do
		oldInfo[key] = value;
	end
end


function AdapterManagerClass:splitString(str, tagStr)
	if str == nil then
		return {};
	end

	local strs = {};
	local len = string.len(str);

	local index = 1;
	while index <=  len do
		local newIndex , newIndexEnd = string.find(str, tagStr, index);
		if newIndex == nil then
			local temp = string.sub(str, index, -1);
			if temp ~= nil and string.len(temp) > 0 then
				strs[#strs + 1] = temp;
			end
			break;
		end

		local temp = string.sub(str, index, newIndex - 1);
		if temp ~= nil and string.len(temp) > 0 then
			strs[#strs + 1] = temp;
		end
		index = newIndexEnd + 1;
	end
	return strs;
end

function AdapterManagerClass:printLog()
	local str = "printLog:start\n";
	str = str.."printLog:model="..self.model..",resolution="..self.resolution..";\n";
	for key, value in pairs(self.mapValues) do
		str = str.."key="..key..",des="..value[KEY_DESCRIPTION]..";\n";
	end
	str = str.."printLog:end\n";
	printLog(str);
end

function AdapterManagerClass:parseCustumConfigImpl(description, tableValue, condition)
	printLog("parseCustumConfigImpl:start:"..description..condition)
	if tableValue == nil then
		return;
	end

	for keyCondition, value in pairs(tableValue) do
		local subkeyConditionKeys = self:splitString(keyCondition, ";");
		for i = 1, #subkeyConditionKeys do
			if condition == subkeyConditionKeys[i] then
				for key, value2 in pairs(value) do
					local defaultValue = self.mapValues[key];

					if defaultValue == nil then
						self.mapValues[key] = {
							[KEY_DESCRIPTION] = description..condition,
							[KEY_VALUE] = value2,
						};
					else
						defaultValue[KEY_DESCRIPTION] = description..condition;
						local realValue = defaultValue[KEY_VALUE];
						if realValue ~= nil then
							self:replaceInfo(realValue, value2);
						else
							defaultValue[KEY_VALUE] = value2;
						end
					end
				end
			end
		end
	end
	printLog("parseCustumConfigImpl:end:"..description..condition)
end

function AdapterManagerClass:parseResolutionConfig(tableValue)
	self:parseCustumConfigImpl("Resolution:", tableValue, self.resolution);
end

function AdapterManagerClass:parseModelConfig(tableValue)
	self:parseCustumConfigImpl("Model:", tableValue, self.model);
end

function AdapterManagerClass:doRecognizeItemList(items)
	if (items == nil) then
		return false;
	end

	for key, value in pairs(items) do
		if (self:doRecognizeItem(value) == true) then
			return true;
		end
	end

	return false;
end

function AdapterManagerClass:doRecognizeItemByKeys(keys)
	if (keys == nil) then
		return false;
	end

	for key, value in pairs(keys) do
		if (self:doRecognizeItemByKey(value) == true) then
			return true;
		end
	end

	return false;
end

function AdapterManagerClass:recognizeAddImageByKeys(keys)
	if keys == nil then
		return;
	end
	for _, value in pairs(keys) do
		self:recognizeAddImageByKey(value);
	end
end

function AdapterManagerClass:getItem(key)
	local value;

	if self.priorAdapterManager ~= nil then
		value = self.priorAdapterManager:getItem(key);
	end
	if value ~= nil then
		return value;
	end

	if self ~= nil and key ~= nil then
		value = self.mapValues[key];
	end

	if value ~= nil then
		return value[KEY_VALUE];
	end

	return nil;
end

function AdapterManagerClass:recognizeAddImageByKey(key)
	local item = self:getItem(key);
	local path;
	if item ~= nil and item["path"] ~= nil then
		path = item["path"];
	end

	if path ~= nil then
		local type;
		if item.regParam ~= nil then
			type = item.templateType;
		end
		printLog("recognizeAddImageByKey " .. path .. ", type = " .. tostring(type));
		commonlib_recognizeAddImage(path, type);
	end
end

function AdapterManagerClass:doRecognizeItemByKey(key)
	local result = self:doRecognizeItem(self:getItem(key));
	return result;
end

function AdapterManagerClass:doRecognizeItem(item)
	if (item == nil or item.regFunction == nil) then
		return false;
	end

	if item.regParam == nil then
		return false;
	end

	if item.regFunction == REGFUNCTION_MATCH_RESOURCE_WHITH_RGB_BINARIZATION then
		local param = {
			rect = item.rect,
			path = item.path,
			threshold = item.threshold,
			conditions = item.regParam.conditions,
			type = item.regParam.type,
		}
		return commonlib_doImageRecognizeWithRgbBinarization(param, param.type);
	end

	if item.regFunction == REGFUNCTION_MATCH_RESOURCE_NOMRAL then
		local param = {
			rect = item.rect,
			path = item.path,
			threshold = item.threshold,
			type = item.regParam.type,
		}
		return commonlib_doImageRecognizeByType(param, param.type);
	end

	if item.regFunction == REGFUNCTION_MATCH_RESOURCE_WHITH_HSV_BINARIZATION then
		local param = {
			rect = item.rect,
			path = item.path,
			threshold = item.threshold,
			conditions = item.regParam.conditions,
			type = item.regParam.type,
		}
		return commonlib_doImageRecognizeWithHsvBinarization(param, param.type);
	end

	if item.regFunction == REGFUNCTION_COUNT_MATCH_PIXEL_PERCENT then
		local percent = commonlib_countMatchPixelPercent(item.rect, item.regParam.conditions,
			item.regParam.conditionType);
		local percentMax = item.thresholdMax;
		if percentMax == nil then
			percentMax = 100;
		end

		return percent >= item.threshold and percent <= percentMax;
	end

	if item.regFunction == REGFUNCTION_MATCH_RESOURCE_WITH_BRIGHTNESS then
		local percent = commonlib_matchResourceWithBrightness(item.rect, item.path);
		return percent >= item.threshold;
	end

	if item.regFunction == REGFUNCTION_DETECT_INPUT_METHON_OPEND then
		local result = commonlib_detectInputMethodOpened(item.regParam);
		return result > 0;
	end

	if item.regFunction == REGFUNCTION_PUBGMHD_PLAYER_SAFETY_POS then
		return commonlib_pubgmhdFindPlayerSafetyPos(item.rect, item.regParam);
	end

	return false;
end

function AdapterManagerClass:doRecognizeByKeyOnIntResult(key)
	return self:doRecognizeItemOnIntResult(self:getItem(key));
end

function AdapterManagerClass:doRecognizeItemOnIntResult(item)
	if (item == nil or item.regFunction == nil) then
		return -1000;
	end

	if item.regFunction == REGFUNCTION_DETECT_INPUT_METHON_OPEND then
		local result = commonlib_detectInputMethodOpened(item.regParam);
		return result;
	end

	return -1001;
end

function AdapterManagerClass:deepCopy(orig)
	if orig == nil then
		return nil
	end

	if type(orig) ~= "table" then
		return orig;
	end

	local copy = {}
	for orig_key, orig_value in pairs(orig) do
		copy[orig_key] = AdapterManagerClass:deepCopy(orig_value)
	end

	local metaTable = getmetatable(orig)
	if metaTable ~= nil then
		setmetatable(copy, AdapterManagerClass:deepCopy(metaTable))
	end

	return copy;
end