---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by cm.
--- DateTime: 2018/9/29 10:43
---

local function printLog(msg)
    commonlib_print("common_feedback", msg)
end

local TAB_NAME = "反馈"
local FEEDBACK_TOAST_TEXT = "反馈成功~"
local FEEDBACK_TOAST_TEXT_FAILED = "反馈失败~"
local tabContentViews = {}
local tabTitleViews = {}
local tabEditContentViews = {}
local tabEditContentTitleViews = {}

local tabUploadImageViews = {}
local feedbackButtonView

--gamemaster_plugins_feedback:515 gameid:string options:byte screenshot:bit
local function report(option, screenshot, connect, feedback)
    commonlib_report("gamemaster_plugins_feedback",
            {
                ["options"] = option,
                ["screenshot"]  = screenshot,
                ["connect"] = tostring(connect),
                ["feedback"] = tostring(feedback),
                ["gameid"] = commonlib_getGameId()
            });
    printLog("gamemaster_plugins_feedback, options=" .. tostring(option)
            .. ", screenshot=" .. tostring(screenshot) .. ", connect=" .. tostring(connect)
            .. ", feedback=" .. tostring(feedback) .. ", gameId=" .. commonlib_getGameId())
end

local function showToastView(text)
    local toastContainer = commonlib_getFloatViewMgrEx():create(0, 366, Anchor().TOPLEFT, false)
    local toastView = toastContainer:addToastView(text, 3500,
            Anchor().TOPLEFT, 200, 0, ZOrder().zorder_top,
            function()
                toastContainer:destroy();
            end)

    toastContainer:setGravity(Anchor().CENTER);
    toastContainer:show()
    toastView:start();
    printLog("show toast view, " .. text)
end

local function upload(feedback, option)
    if feedback == 1 then
        local heightPx = commonlib_getScreenHeightPx()
        local widthPx = commonlib_getScreenWidthPx()
        local rects = { flag = Anchor().TOPLEFT, left = 0, top = 0, width = widthPx, height = heightPx }
        local filename = commonlib_getGameId() .. "-plugin_feedback_" .. tostring(option)
        commonlib_getUtilTool():uploadbitmap(rects, filename, SHOT_SCREEN_FOR_MAT_TYPE.full_screen)
    end
end

local function getTextColor(enable)
    if enable == true then
        return "#FF00DEFF";
    else
        return "#FF979797";
    end
end

local function getFeedbackContent()
    local gameId = commonlib_getGameId()
    if gameId == nil then
        return nil
    end
    local tabContent = {}
    local tabTitle = {}
    local tabEditContentTitle = {}
    local tabEditContent = {}
    local tabUploadImage = {checked = true, descText = "同意上传截图并协助我们定位问题"}
    if gameId == "com.tencent.tmgp.pubgmhd" then
        tabTitle = {
            {descText = "*超人仅支持在对战中或者训练场中显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "和平精英星球群：468430565", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤或准心错位"},
            {index = 3, checked = false, descText = "没有资源地图"},
            {index = 4, checked = false, descText = "没有装备库"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "number" , maxLength = "20"}
        }
    end

    if gameId == "com.tencent.tmgp.sgame" then
    end
    if gameId == "com.netease.hyxd" then
    end
    if gameId == "com.qqgame.hlddz" then
    end
    if gameId == "com.tencent.cldts" then
    end
    if gameId == "com.tencent.tmgp.cf" then
        tabTitle = {
            {descText = "*超人仅支持在竞技&求生模式显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "穿越火线星球群：808396801", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤或准心错位"},
            {index = 3, checked = false, descText = "没有火线时刻"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.tencent.tmgp.pubgm" then
        tabTitle = {
            {descText = "*超人仅支持在竞技&求生模式显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "全军出击星球群：879361209", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤或准心错位"},
            {index = 3, checked = false, descText = "没有资源地图"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.minitech.miniworld" then
        tabTitle = {
            {descText = "*超人仅支持在游戏对局中才可以显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "迷你世界星球群：742025879", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤错位"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.ztgame.bob" then
        tabTitle = {
            {descText = "*超人仅支持在游戏对局中才可以显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "球球大作战星球群：849040865", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤错位"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.netease.mc" then
        tabTitle = {
            {descText = "*超人仅支持在游戏对局中才可以显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "我的世界星球群：866492429", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤错位"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.sofunny.Chicken" then
        tabTitle = {
            {descText = "*超人仅支持在游戏对局中才可以显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "香肠派对星球群：778906114", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤错位"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.netease.mrzh" then
        tabTitle = {
            {descText = "*超人仅支持在游戏对局中才可以显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "明日之后星球群：849462726", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤错位"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.tencent.tmgp.speedmobile" then
        tabTitle = {
            {descText = "*超人仅支持在游戏对局中才可以显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "QQ飞车星球群：411121312", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "没有皮肤"},
            {index = 2, checked = false, descText = "皮肤错位"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    if gameId == "com.qqgame.hlddz" then
        tabTitle = {
            {descText = "*超人仅支持在游戏对局中才可以显示皮肤，护眼模式下无皮肤时请关闭系统护眼模式再尝试", fontSize = "12sp" },
            {descText = "欢乐斗地主星球群：810639892", fontSize = "14sp" },
            {descText = "请选择你的问题", fontSize = "14sp" },
        }
        tabContent = {
            {index = 1, checked = false, descText = "打牌助手无法使用"},
        }
        tabEditContentTitle = {
            {descText = "其他问题和建议", fontSize = "14sp" },
        }
        tabEditContent = {
            {descText = "反馈问题", fontSize = "12sp", inputType = "text", maxLength = "100" },
            {descText = "联系方式: " , fontSize = "12sp" , inputType = "textEmailAddress" , maxLength = "20"}
        }
    end
    return tabTitle, tabContent, tabEditContentTitle, tabEditContent, tabUploadImage
end

local function onCheckChangeListener(checkBoxId, isChecked)

end

local function onTextChangeListener(editId, text)

end

local function onFeedbackButtonCliecked()
    commonlib_getSettingView():hide()
    printLog("onFeedbackButtonCliecked")
    local connect = "";
    local feedback = "";
    for k, v in pairs(tabEditContentViews) do
        printLog("tabEditContentViews" .. tostring(k) .. " value=" .. tostring(v:getText()))
        if k == 1 then
            feedback = v:getText();
        end

        if k == 2 then
            connect = v:getText();
        end
        v:clearText();
    end

    local option = 0;
    for k, v in pairs(tabContentViews) do
        printLog("tabContentViews" .. tostring(k) .. " isChecked=" .. tostring(v:isChecked()))
        if k == 1 and v:isChecked() then
            option = option + 1
        end
        if k == 2 and v:isChecked() then
            option = option + 2
        end
        if k == 3 and v:isChecked() then
            option = option + 4
        end
        if k == 4 and v:isChecked() then
            option = option + 8
        end
    end

    local screenshot = 0;
    for k, v in pairs(tabUploadImageViews) do
        if v:isChecked() then
            screenshot = 1
        end
        printLog("tabUploadImageViews" .. tostring(k) .. " isChecked=" .. tostring(v:isChecked()))
    end
    report(option, screenshot, connect, feedback)
    if option == 0 then
        if connect ~= nil and connect ~= '' or feedback ~= nil and feedback ~= '' then
            showToastView(FEEDBACK_TOAST_TEXT)
        else
            showToastView(FEEDBACK_TOAST_TEXT_FAILED)
        end
    else
        upload(screenshot, option)
        showToastView(FEEDBACK_TOAST_TEXT)
    end
end

local function initSettingView()
    local tabTitle, tabContent, tabEditContentTitle, tabEditContent, tabUploadImage = getFeedbackContent()
    if commonlib_isTableEmpty(tabContent) then
        return
    end

    local tab = commonlib_getSettingView():addTableView(TAB_NAME)
    local relativeLayoutParam = create("RelativeLayoutParam")
    local paramValues = {}

    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"

    for key, value in pairs(tabTitle) do
        if commonlib_isTableEmpty(tabTitleViews) == false then
            paramValues.layout_marginTop = "10dp"
            paramValues.layout_below = tabTitleViews[#tabTitleViews]:getId()
        end

        relativeLayoutParam:setLayoutParam(paramValues)

        local view = tab:addTextView(value.descText,
            getTextColor(true),
            value.fontSize,
            relativeLayoutParam,
            nil);
        table.insert(tabTitleViews, #tabTitleViews + 1, view)
    end

    if commonlib_isTableEmpty(tabTitleViews) == false then
        paramValues.layout_below = tabTitleViews[#tabTitleViews]:getId()
    end

    paramValues.layout_marginTop = "20dp"
    for key, value in pairs(tabContent) do
        local mod = math.fmod( #tabContentViews ,2)
        if mod == 0 then
            paramValues.layout_marginLeft = "25dp"
            if #tabContentViews > 1 then
                paramValues.layout_below = tabContentViews[#tabContentViews - 1]:getId()
            end
        else
            paramValues.layout_marginLeft = "150dp"
            if #tabContentViews > 1 then
                paramValues.layout_below = tabContentViews[#tabContentViews - 2]:getId()
            end
        end
        relativeLayoutParam:setLayoutParam(paramValues)

        local view = tab:addCheckBoxView(value.descText, value.checked, relativeLayoutParam, onCheckChangeListener)
        table.insert(tabContentViews, #tabContentViews + 1, view)
    end




    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"
    if commonlib_isTableEmpty(tabContentViews) == false then
        local mod = math.fmod( #tabContentViews ,2)
        if mod == 0 then
            paramValues.layout_below = tabContentViews[#tabContentViews - 1]:getId()
        else
            paramValues.layout_below = tabContentViews[#tabContentViews]:getId()
        end
        relativeLayoutParam:setLayoutParam(paramValues)
    end

    for key, value in pairs(tabEditContentTitle) do
        local view = tab:addTextView(value.descText,
            getTextColor(true),
            value.fontSize,
            relativeLayoutParam,
            nil);
        table.insert(tabEditContentTitleViews, #tabEditContentTitleViews + 1, view)
    end

    if commonlib_isTableEmpty(tabEditContentTitleViews) == false then
        paramValues.layout_below = tabEditContentTitleViews[#tabEditContentTitleViews]:getId()
    end

    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "25dp"
    paramValues.layout_marginRight = "25dp"
    paramValues.layout_width = "MATCH_PARENT"
    paramValues.layout_height = "WRAP_CONTENT"

    for key, value in pairs(tabEditContent) do
        if commonlib_isTableEmpty(tabEditContentViews) == false then
            paramValues.layout_marginTop = "10dp"
            paramValues.layout_below = tabEditContentViews[#tabEditContentViews]:getId()
        end

        relativeLayoutParam:setLayoutParam(paramValues)

        local view = tab:addEditText(value.descText,
            "#FFFFFFFF",
            value.fontSize,
            value.maxLength,
            value.inputType,
            relativeLayoutParam,
            onTextChangeListener);
        table.insert(tabEditContentViews, #tabEditContentViews + 1, view)
    end

    if commonlib_isTableEmpty(tabEditContentViews) == false then
        paramValues.layout_below = tabEditContentViews[#tabEditContentViews]:getId()
    end


    paramValues.layout_marginTop = "20dp"
    paramValues.layout_marginLeft = "148dp"
    paramValues.layout_width = "150dp"
    paramValues.layout_height = "WRAP_CONTENT"

    relativeLayoutParam:setLayoutParam(paramValues)

    feedbackButtonView = tab:addButton("反馈", relativeLayoutParam, onFeedbackButtonCliecked)
    feedbackButtonView:setFeedbackBackgroundResource()

    paramValues.layout_below = feedbackButtonView:getId()

    paramValues.layout_marginTop = "15dp"
    paramValues.layout_marginLeft = "25dp"
    paramValues.layout_width = "WRAP_CONTENT"
    paramValues.layout_height = "WRAP_CONTENT"

    relativeLayoutParam:setLayoutParam(paramValues)

    local uploadimageView = tab:addCheckBoxView(
        tabUploadImage.descText,
        tabUploadImage.checked,
        relativeLayoutParam,
        onCheckChangeListener)

    table.insert(tabUploadImageViews, #tabUploadImageViews + 1, uploadimageView)


end

function init_feedback()
    initSettingView()
end