-- 公共库脚本
--[[
-- 该脚本是为其他脚本提供公共的变量，函数的库脚本，类似于java的工具类
-- 该脚本里面的变量和函数都是全局可见的，在Lua里面先加载，其他各个脚本
-- 直接通过变量名或者函数名引用
]]

--- 上报示例
--- 1.report = Report();对应的类为ReportLib
--- ["report_data"]这个key对应的LuaTable中可以传入多个上报字段
--- 2.report:report({"table_name" = "xxx", "report_data" = {"skin" = 1, "battle" = 1}});
---
--- ******游戏运行状态相关******----
KEY_GAME_STATE = "gameState";
GAME_STATE_NOTSTART = -1; -- 游戏未开始
GAME_STATE_LOADING = 0; -- 游戏加载状态
GAME_STATE_START = 3; -- 游戏开始状态
GAME_STATE_RUNNING = 1; -- 游戏运行状态
GAME_STATE_FINISH = 2; -- 游戏结束状态

-- 用于调用到各个业务脚本的生命周期函数表
common_life_circle_callbacks = {}

-- 用于王者荣耀生命周期表的加载顺序，可以确定在悬浮设置面板中的位置
SGAME_LIFE_CIRCLE_TABLE_ORDER_WEIGHT = {
    float_window = 100,
    battle_skill = 99,
    skin = 98,
    buff = 97,
    battle_notice = 96,
    money = 95,
    replay = 94,
    keyboard = 93,
    glory_moment = 92
}

-- 用于和平精英生命周期表的加载顺序，可以确定在悬浮设置面板中的位置
PUBGMHD_LIFE_CIRCLE_TABLE_ORDER_WEIGHT = {
    float_window = 100,
    battle_notice = 99,
    skin = 98,
    arsenal = 97,
    map_resources = 96,
    run_circle = 95,
    gun_sight = 94,
    stimulate_moment = 93,
    teamup = 92
}

-- 用于和平精英生命周期表的加载顺序，可以确定在悬浮设置面板中的位置
CF_LIFE_CIRCLE_TABLE_ORDER_WEIGHT = {
    float_window = 100,
    skin = 99,
    game_mode = 98,
    gun_sight = 97,
    cf_moment = 96
}

-- 用于全军出击生命周期表的加载顺序，可以确定在悬浮设置面板中的位置
PUBGM_LIFE_CIRCLE_TABLE_ORDER_WEIGHT = {
    float_window = 100,
    skin = 99,
    gun_sight = 98,
    map_resources = 97,
}

-- 用于欢乐斗地主生命周期表的加载顺序，可以确定在悬浮设置面板中的位置
HLDDZ_LIFE_CIRCLE_TABLE_ORDER_WEIGHT = {
    float_window = 100,
    game_mode = 99,
    pick_poker = 98,
    card_type_classifier = 97,
}

local LIFE_CIRCLE_TABLE_INDEX_ORDER_WEIGHT = 3
-- 用于事件回调的函数表
common_game_events_callbacks = {}

-- 用于设置页面打开或关闭时的回调
common_setting_view_state_callbacks = {
    ON_SETTING_VIEW_OPEN = {},
    ON_SETTING_VIEW_CLOSE = {}
}

core_scripts = {}

SHOT_SCREEN_FOR_MAT_TYPE = {
    pubgmhd_arsenal = 1,
    pubgmhd_smallmap = 2,
    pubgmhd_teamup_qr_code = 3,
    pubgmhd_blood = 4,
    pubgm_smallmap = 5,
    full_screen = 10086,
}

-- gamemaster_function_disable_reason上报相关
STEP_SHOW_FLOAT_BALL = 5
STEP_GAME_INNER_START = 6
STEP_SHOW_SKIN = 7
SETP_SHOW_FLOAT_BALL = 8
ACTION_GAME_START = 4
ACTION_GAME_RUNNING = 5
ACTION_SHOW_SKIN = 6
ACTION_SHOW_FLOAT_BALL = 7 -- 是否展示了悬浮球
ACTION_SHOW_CAN_NOT_SHOW = 8
ACTION_SHOW_SKIN_SETTING_OPEN = 9
ACTION_SHOW_SKIN_SETTING_CLOSE = 10
REASON_SUCCEED = 0
GAMEMASTER_FUNCTION_DISABLE_REASON = "reason"
GAMEMASTER_FUNCTION_DISABLE_REASON_STEP = "step"
GAMEMASTER_FUNCTION_DISABLE_REASON_GAMENAME = "gamename"
GAMEMASTER_GAMERECOG_SUCCESS_ACTION = "action"
GAMEMASTER_GAMERECOG_SUCCESS_GAMENAME = "gamename"
GAMEMASTER_GAMERECOG_SUCCESS_BUTTONNAME = "buttonname"
GAMEMASTER_FUNCTION_DISABLE_REASON_TABLE = "gamemaster_function_disable_reason"
GAMEMASTER_GAMERECOG_SUCCESS_PKGNAME = "pkgname"
GAMEMASTER_GAMERECOG_SUCCESS_SRC = "src"
GAMEMASTER_GAMERECOG_SUCCESS_TABLE = "gamemaster_gamerecog_success"
GAMEMASTER_SCRIPT_MON_TABLE = "gamemaster_script_mon"
GAMEMASTER_VIDEO_EFFECT_TABLE = "gamemaster_video_effect"
GAMEMASTER_GAMEDATA = "gamemaster_gamedata"
GAMEMASTER_GAME_SKINCHOOSE = "gamemaster_game_skinchoose"

--- 游戏包名信息 --
GAME_SGAME_PKG_NAME = "com.tencent.tmgp.sgame"
GAME_PUBGMHD_PKG_NAME = "com.tencent.tmgp.pubgmhd"
GAME_PUBGM_PKG_NAME = "com.tencent.tmgp.pubgm"
GAME_HYQS_PKG_NAME = "com.netease.hyxd"

--- 脚本退出监控
LAST_GAME_SCRIPT = "last_game_script"
LAST_GAME_SCRIPT_DEF = "none"
GAME_SCRIPT_EXIT_ABNORMAL = 1
GAME_SCRIPT_EXIT_NORMAL = 2

--- 视频录制ABTest，包括死亡回放、荣耀时刻、刺激时刻等
local ABTEST_SECTION_GAME_VIDEO_RECORDER = "GameVideoRecorder";
local ABTEST_GAME_VIDEO_RECORDER_A = "GameVideoRecorderA"; -- enable
local ABTEST_GAME_VIDEO_RECORDER_B = "GameVideoRecorderB"; -- disable

GAME_START_SRC_UNKNOWN        = 0
GAME_START_SRC_TEAMUP_GUIDE   = 1
GAME_START_SRC_TEAMUP_SUCCEED = 2

GAME_COMMON_SHARE_SKIN = 1
GAME_COMMON_SHARE_ARSENAL_SETTING = 2
GAME_COMMON_SHARE_ARSENAL_BACKAGE = 3
GAME_COMMON_SHARE_HLDDZ_SETTING = 4
GAME_COMMON_SHARE_ARSENAL_BOTTOM = 5

local globalCurrentStartGameId      = nil
local globalCurrentStartGameSrc     = nil

local DEFAULT_ALGORITHM = 1

local gameStateMap = {}

local TAG = "common_lib"
local imageRecognize = ImageRecognize()
local gameConfig
local sharedPrefConfig = SharedPrefConfig()
local globalSharePrefConfig = GlobalSharedPrefConfig()
local coordinateTool = CoordinateTool()
local settingView = SettingView()
local floatBall = TopSmallView()
local clickableFloatView
local unClickableFloatView
local gameAssistant = GameAssistant()
local mathLib = require('math')
local isLogWriteAble
local floatViewMgrEx
local utilTool;
local uiThread;
local reportLib

-- 手机相关信息
local deviceInfo  -- 获取手机相关信息，如：手机的宽高、型号等
local deviceModel = nil
local deviceBrand = nil
local deviceManufacturer = nil
local deviceScreenWidthPx = nil
local deviceScreenHeightPx = nil
local isMEIZUFlymeOS_
local isHuaweiMate10_ = nil
local isScreenRatio18To9_ = nil
local is720P_ = nil
local screenScale = nil
local realScreenSize = nil;
local skinManager = nil;
local event = nil;
local gameId = nil;
local gamePackageName = nil;

-- 支持添加tag的打印log函数
function commonlib_print(tag, msg)
    if commonlib_isLogWriteAble() then
        if tag == nil or msg == nil then
            print("tag or msg is nil")
            return
        end
        print("[" .. tag .. "]" .. tostring(msg))
    end
end

--判断是否写入本地日志
function commonlib_isLogWriteAble()
    if isLogWriteAble == nil then
        if GameMasterLogUtils():isLogWriteAble() then
            isLogWriteAble = true
        else
            isLogWriteAble = false
        end
    end
    return isLogWriteAble
end

-- 判断表是否为空的函数
function commonlib_isTableEmpty(table)
    if table == nil then
        return true
    end

    if #table > 0 then
        return false
    end

    for key, value in pairs(table) do
        return false
    end

    return true
end

function commonlib_isTableContainsValue(targetTable, targetValue)
    if commonlib_isTableEmpty(targetTable) then
        return false;
    end

    for index, value in pairs(targetTable) do
        if value == targetValue then
            return true;
        end
    end

    return false;
end

--- 移除表中的某个值
function commonlib_removeValueInTable(targetTable, targetValue)
    if commonlib_isTableEmpty(targetTable) then
        return
    end
    for index, value in pairs(targetTable) do
        if value == targetValue then
            table.remove(targetTable, index)
        end
    end
end

--- 无重复的在表中插入某个值
function commonlib_insertValueWithoutRepeat(targetTable, targetValue)
    if not commonlib_isTableContainsValue(targetTable, targetValue) then
        table.insert(targetTable, targetValue)
    end
end

--- 查找表中的某个值
function commonlib_findValuePositionInTable(targetTable, targetValue)
    if commonlib_isTableEmpty(targetTable) then
        return -1
    end
    for index, value in pairs(targetTable) do
        if value == targetValue then
            return index
        end
    end

    return -1
end

function common_switchValuePosition(targetTable, targetValue, position)
    if commonlib_isTableEmpty(targetTable) then
        return
    end

    if targetValue == nil or position == nil then
        return
    end

    if position < 1 or position > #targetTable then
        return
    end

    local oldPosition = commonlib_findValuePositionInTable(targetTable, targetValue)
    if oldPosition == -1 or oldPosition == position then
        return
    end

    table.remove(targetTable, oldPosition)
    table.insert(targetTable, position, targetValue)
end

-- 获取当前时间的函数
function commonlib_getCurrentTime()
    return os.millis();
end

-- 获取游戏的配置参数函数
function commonlib_getGameParam(key)
    if key ~= nil then
        return gameStateMap[key]
    end
    commonlib_print(TAG, "commonlib_getGameParam key is nil")
    return nil
end

-- 设置游戏的配置参数函数
function commonlib_setGameParam(key, value)
    if key ~= nil and value ~= nil then
        commonlib_print(TAG, "commonlib_setGameParam: " .. tostring(key) .. " = " .. tostring(value))
        gameStateMap[key] = value
    else
        commonlib_print(TAG, "commonlib_setGameParam params is nil")
    end
end

-- 获取游戏偏好设置参数函数
function commonlib_getSharedPrefString(key, def)
    if sharedPrefConfig ~= nil and key ~= nil and def ~= nil then
        return sharedPrefConfig:getString(key, def)
    end
    commonlib_print(TAG, "commonlib_getSharedPrefString params is nil")
    return nil
end

-- 设置游戏偏好参数函数
function commonlib_setSharedPrefString(key, value)
    if sharedPrefConfig ~= nil and key ~= nil and value ~= nil then
        --commonlib_print(TAG, "commonlib_setSharedPrefString: " .. tostring(key) .. " = " .. tostring(value))
        sharedPrefConfig:setString(key, value)
    else
        commonlib_print(TAG, "commonlib_setSharedPrefString params is nil")
    end
end

function commonlib_getSharedPrefBoolean(key, def)
    if sharedPrefConfig ~= nil and key ~= nil and def ~= nil then
        return sharedPrefConfig:getBoolean(key, def)
    end
    commonlib_print(TAG, "commonlib_getSharedPrefBoolean params is nil")
    return nil
end

function commonlib_setSharedPrefBoolean(key, value)
    if sharedPrefConfig ~= nil and key ~= nil and value ~= nil then
        --commonlib_print(TAG, "commonlib_setSharedPrefString: " .. tostring(key) .. " = " .. tostring(value))
        sharedPrefConfig:setBoolean(key, value)
    else
        commonlib_print(TAG, "commonlib_setSharedPrefBoolean params is nil")
    end
end

function commonlib_setSharedPrefInt(key, value)
    if sharedPrefConfig ~= nil and key ~= nil and value ~= nil then
        sharedPrefConfig:setInt(key, value)
    else
        commonlib_print(TAG, "commonlib_setSharedPrefInt params is nil")
    end
end

function commonlib_getSharedPrefInt(key, def)
    if sharedPrefConfig ~= nil and key ~= nil and def ~= nil then
        return sharedPrefConfig:getInt(key, def)
    else
        commonlib_print(TAG, "commonlib_getSharedPrefInt params is nil")
        return nil
    end
end

function commonlib_setSharedPrefLong(key, value)
    if sharedPrefConfig ~= nil and key ~= nil and value ~= nil then
        sharedPrefConfig:setLong(key, value)
    else
        commonlib_print(TAG, "commonlib_setSharedPrefInt params is nil")
    end
end

function commonlib_getSharedPrefLong(key, def)
    if sharedPrefConfig ~= nil and key ~= nil and def ~= nil then
        return sharedPrefConfig:getLong(key, def)
    else
        return def
    end
end

function commonlib_isNewUser()
    if sharedPrefConfig == nil then
        commonlib_print(TAG, "commonlib_isNewUser is nil")
        return nil;
    else
        return sharedPrefConfig:isNewUser()
    end
end

function commonlib_isScreenRatio18To9()
    if isScreenRatio18To9_ == nil then
        isScreenRatio18To9_ = coordinateTool:isScreenRatio18To9()
    end
    return isScreenRatio18To9_
end

function commonlib_getScale()
    if screenScale == nil then
        screenScale = coordinateTool:getScale()
    end
    return screenScale
end

function commonlib_isDevice720P()
    if is720P_ == nil then
        local screenWidth = commonlib_getScreenWidthPx()
        is720P_ = (mathLib.abs(screenWidth - 1280) < 20)
    end
    return is720P_
end

function commonlib_isHuaweiMate10()
    if isHuaweiMate10_ == nil then
        isHuaweiMate10_ = coordinateTool:isHuaweiMate10()
    end
    return isHuaweiMate10_
end

function commonlib_isMEIZUFlymeOS()
    if isMEIZUFlymeOS_ == nil then
        isMEIZUFlymeOS_ = (commonlib_getBrand() == "Meizu")
    end
    return isMEIZUFlymeOS_
end

function commonlib_getDevice()
    if deviceInfo == nil then
        deviceInfo = Device()
    end

    return deviceInfo;
end

function commonlib_getModel()
    if deviceModel == nil then
        deviceModel = commonlib_getDevice():getModel()
    end
    return deviceModel
end

function commonlib_getBrand()
    if deviceBrand == nil then
        deviceBrand = commonlib_getDevice():getBrand()
    end
    return deviceBrand
end

function commonlib_getManufacturer()
    if deviceManufacturer == nil then
        deviceManufacturer = commonlib_getDevice():getManufacturer()
    end
    return deviceManufacturer
end

function commonlib_getScreenWidthPx()
    if deviceScreenWidthPx == nil then
        deviceScreenWidthPx = commonlib_getDevice():getScreenWidthPx()
    end
    return deviceScreenWidthPx
end

function commonlib_getScreenHeightPx()
    if deviceScreenHeightPx == nil then
        deviceScreenHeightPx = commonlib_getDevice():getScreenHeightPx()
    end
    return deviceScreenHeightPx
end

function commonlib_getScreenRealSize()
    if realScreenSize == nil then
        realScreenSize = coordinateTool:getScreenRealSize();
    end

    return realScreenSize;
end

function commonlib_getUIThread()
    if uiThread == nil then
        uiThread = UiThread();
    end

    return uiThread;
end

-- 在UI线程调用的函数
function commonlib_runOnUIThread(func)
    if func ~= nil then
        commonlib_getUIThread():run(func)
    else
        commonlib_print(TAG, "commonlib_runOnUIThread uiThread or func is nil")
    end
end

function commonlib_runOnUIThreadDelayed(func, delayTime)
    if func ~= nil then
        commonlib_getUIThread():runDelayed(func, delayTime)
    else
        commonlib_print(TAG, "commonlib_runOnUIThread uiThread or func is nil")
    end
end

-- 注册回调函数的方法
function commonlib_registerCallback(tableName, funcName)
    if tableName ~= nil and funcName ~= nil then
        table.insert(tableName, funcName)
    else
        commonlib_print(TAG, "commonlib_registerCallback tableName or funcName is nil")
    end
end

-- 反注册回调函数的方法
function commonlib_unregisterCallback(tableName, funcName)
    if tableName ~= nil and funcName ~= nil then
        for i = #tableName, 1, -1 do
            if tableName[i] == funcName then
                table.remove(tableName, i)
            end
        end
    else
        commonlib_print(TAG, "commonlib_unregisterCallback tableName or funcName is nil")
    end
end

-- 图像识别相关的函数
-- 添加识别参照系图image
function commonlib_recognizeAddImage(imagePath, type)
    if imageRecognize ~= nil and imagePath ~= nil then
        if type == nil then
            imageRecognize:addImage(imagePath)
        else
            imageRecognize:addImage(imagePath, type)
        end
    else
        commonlib_print(TAG, "commonlib_recognizeAddImage imageRecognize or imagePath is nil")
    end
end

-- 根据参照图检测匹配度，识别图像是否存在
function commonlib_recognizeMatchResource(rect, path, type)
    if type == nil then
        type = DEFAULT_ALGORITHM
    end
    if imageRecognize ~= nil and rect ~= nil and path ~= nil then
        return imageRecognize:matchResource(rect, path, type)
    else
        commonlib_print(TAG, "commonlib_recognizeMatchResource imageRecognize or rect or path is nil")
        return nil
    end
end

--- 进行图像识别，判断识别区域与参考图片是否相同
--- @param recognizeInfoTable 识别信息表，包含三个部分：rect、path 和 threshold
--- @return isSame 是否相同
function commonlib_doImageRecognize(recognizeInfoTable)
    local similarity = getImageSimilarity(recognizeInfoTable);
    commonlib_print(TAG, "path : " .. recognizeInfoTable.path .. ", similarity : " .. tostring(similarity) .. ", threshold : " .. recognizeInfoTable.threshold);
    return similarity > recognizeInfoTable.threshold;
end

function commonlib_recognizeMatchResourceWithRgbBinarization(rect, path, conditions, type)
    if imageRecognize ~= nil and
            rect ~= nil and
            path ~= nil and
            conditions ~= nil then
        if type == nil then
            type = DEFAULT_ALGORITHM;
        end

        return imageRecognize:mathResourceWithRgbBinarization(rect, path, conditions, type);
    end

    commonlib_print(TAG, "commonlib_recognizeMatchResourceWithRgbBinarization imageRecognize or rect or path or conditions is nil")
    return nil;
end

function commonlib_doImageRecognizeWithRgbBinarization(recognizeInfoTable, type)
    if recognizeInfoTable == nil then
        commonlib_print(TAG, " commonlib_doImageRecognizeWithRgbBinarization param is nil");
        return false
    end

    local similarity = commonlib_recognizeMatchResourceWithRgbBinarization(
        recognizeInfoTable.rect,
        recognizeInfoTable.path,
        recognizeInfoTable.conditions,
        type);
    if similarity == nil then
        return false;
    end

    commonlib_print(TAG, "doImageRecognizeWithRgbBinarization:path : " .. recognizeInfoTable.path .. ", similarity : " .. tostring(similarity) .. ", threshold : " .. recognizeInfoTable.threshold);
    return similarity > recognizeInfoTable.threshold;
end

function commonlib_recognizeMatchResourceWithHsvBinarization(rect, path, conditions, type)
    if imageRecognize ~= nil and
            rect ~= nil and
            path ~= nil and
            conditions ~= nil then
        if type == nil then
            type = DEFAULT_ALGORITHM;
        end

        return imageRecognize:mathResourceWithHsvBinarization(rect, path, conditions, type);
    end

    commonlib_print(TAG, "commonlib_recognizeMatchResourceWithHsvBinarization imageRecognize or rect or path or conditions is nil")
    return nil;
end

function commonlib_doImageRecognizeWithHsvBinarization(recognizeInfoTable, type)
    if recognizeInfoTable == nil then
        commonlib_print(TAG, " commonlib_doImageRecognizeWithRgbBinarization param is nil");
        return false
    end

    local similarity = commonlib_recognizeMatchResourceWithHsvBinarization(
        recognizeInfoTable.rect,
        recognizeInfoTable.path,
        recognizeInfoTable.conditions,
        type);
    if similarity == nil then
        return false;
    end

    commonlib_print(TAG, "doImageRecognizeWithHsvBinarization:path : " .. recognizeInfoTable.path .. ", similarity : " .. tostring(similarity) .. ", threshold : " .. recognizeInfoTable.threshold);
    return similarity > recognizeInfoTable.threshold;
end

function commonlib_doImageRecognizeByType(recognizeInfoTable, type)
    if recognizeInfoTable == nil or type == nil then
        commonlib_print(TAG, " commonlib_doImageRecognizeByType param is nil");
        return false
    end
    local similarity = commonlib_recognizeMatchResourceByType(recognizeInfoTable.rect, recognizeInfoTable.path, type);
    commonlib_print(TAG, "path : " .. recognizeInfoTable.path .. ", similarity : " .. tostring(similarity) .. ", threshold : " .. recognizeInfoTable.threshold);
    return similarity > recognizeInfoTable.threshold;
end

-- 根据参照图检测匹配度，识别图像是否存在
function commonlib_recognizeMatchResourceByType(rect, path, type)
    if imageRecognize ~= nil and rect ~= nil and path ~= nil then
        return imageRecognize:matchResource(rect, path, type)
    else
        commonlib_print(TAG, "commonlib_recognizeMatchResourceByType imageRecognize or rect or path is nil")
        return nil
    end
end

--- 根据识别信息列表判断识别区域与参考图片是否相同
function commonlib_doImageRecognizeByInfos(infoList)
    for index, recognizeInfo in pairs(infoList) do
        if commonlib_doImageRecognize(recognizeInfo) then
            return true
        end
    end
    return false
end

--- 获取图片的相似度
function getImageSimilarity(rectInfo, type)
    if rectInfo == nil then
        return 0
    end
    if type == nil then
        type = DEFAULT_ALGORITHM
    end
    return commonlib_recognizeMatchResource(rectInfo.rect, rectInfo.path, type)
end

function commonlib_countMatchPixelPercent(rect, conditions, conditionType)
    if imageRecognize == nil or rect == nil or conditions == nil or conditionType == nil then
        commonlib_print(TAG, "commonlib_countMatchPixelPercent param is nil ")
        return -1;
    end

    local percent = imageRecognize:countMatchPixelPercent(rect, conditions, conditionType);
    commonlib_print(TAG, "commonlib_countMatchPixelPercent:percent="..commonlib_toString(percent));
    return percent;
end

function commonlib_matchResourceWithBrightness(rect, path)
    if imageRecognize == nil or rect == nil or path == nil then
        commonlib_print(TAG, "commonlib_matchResourceWithBrightness param is nil ")
        return -1;
    end

    local threshold = imageRecognize:matchResourceWithBrightness(rect, path, 3);
    commonlib_print(TAG, "commonlib_matchResourceWithBrightness:differ="..commonlib_toString(threshold));
    return threshold;
end

function commonlib_detectInputMethodOpened(params)
    if imageRecognize == nil or params == nil then
        commonlib_print(TAG, "commonlib_detectInputMethodOpened param is nil ")
        return -1;
    end

    local result = imageRecognize:detectInputMethodOpened(params);
    commonlib_print(TAG, "detectInputMethodOpened:result="..commonlib_toString(result));
    return result;
end

function commonlib_pubgmhdFindPlayerSafetyPos(rect, params)
    if imageRecognize == nil or rect == nil or params == nil then
        commonlib_print(TAG, "commonlib_pubgmhdFindPlayerSafetyPos param is nil ")
        return -1;
    end

    local result = imageRecognize:findPubgmhdPlayerSafetyPos(rect, params);
    if result == nil or result < 0 then
        commonlib_print(TAG, "commonlib_pubgmhdFindPlayerSafetyPos: result="..tostring(result));
        return -1;
    end
--[[
    local start = commonlib_getCurrentTime();
    for i = 1,1000,1 do
        imageRecognize:findPubgmhdPlayerSafetyPos(rect, params);
    end
    commonlib_print(TAG, "commonlib_pubgmhdFindPlayerSafetyPos: loop-1000 = " .. tostring(commonlib_getCurrentTime() - start) );
--]]
    commonlib_print(TAG, "commonlib_pubgmhdFindPlayerSafetyPos: result=" .. tostring(result) );
    return result;
end

function commonlib_getImgNum2(rect, confidence)
    if rect == nil then
        return 0
    end

    return imageRecognize:recognizeImageKillNumberText(rect, confidence)
end

function commonlib_getImgNumWithAdapter(rect, from)
    if rect == nil then
        return 0
    end

    return imageRecognize:recognizeAdapterNumberText(rect, from)
end

function commonlib_getImgNum(rect)
    if rect == nil then
        return 0
    end

    return imageRecognize:recognizeImageKillNumberText(rect)
end

function commonlib_getImgNum3(rect, confidence)
    if rect == nil then
        return - 1
    end
    return imageRecognize:recognizeImageGoldNumberText(rect, confidence)
end

function commonlib_getImgNum4(rect, confidence)
    if rect == nil then
        return - 1
    end
    return imageRecognize:recognizeImageCJKillNumberText(rect, confidence)
end

FINDCIRCLE_DEFAULT_PARAM = 30
FINDCIRCLE_DEFAULT_MUSTIN = true
function commonlib_findCircle(rects, minRadius, maxRadius, param, mustIn)
    if rects == nil or minRadius == nil or maxRadius == nil then
        commonlib_print(TAG,"commonlib_findCircle rects is nil")
        return -1
    end

    if param == nil then
        param = FINDCIRCLE_DEFAULT_PARAM
    end
    if mustIn == nil then
        mustIn = FINDCIRCLE_DEFAULT_MUSTIN
    end

    return imageRecognize:findCircle(rects, param, minRadius, maxRadius, mustIn)
end

----------------------------------------- 表处理相关的函数-------------------------------------------
function commonlib_handleTableWithoutParam(srcTable)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i]()
        end
    end
end

function commonlib_handleTableWithOneParam(srcTable, param)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i](param)
        end
    end
end

function commonlib_handleTableWithBoolParam(srcTable, boolValue)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i](boolValue)
        end
    end
end

function commonlib_handleTableWithTwoParam(srcTable, param1, param2)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i](param1, param2)
        end
    end
end

function commonlib_handleTableWithStringParam(srcTable, stringValue)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i](stringValue)
        end
    end
end

function commonlib_handleNestingTable(srcTable, index)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil and srcTable[i][index] ~= nil then
            srcTable[i][index]()
        end
    end
end

local function lifeCircleSortCompare(left, right)
    if left[LIFE_CIRCLE_TABLE_INDEX_ORDER_WEIGHT] ~= nil and right[LIFE_CIRCLE_TABLE_INDEX_ORDER_WEIGHT] ~= nil then
        return left[LIFE_CIRCLE_TABLE_INDEX_ORDER_WEIGHT] > right[LIFE_CIRCLE_TABLE_INDEX_ORDER_WEIGHT]
    end
    return false
end

function commonlib_lifeCircleSort()
    commonlib_print(TAG,"callLifeCircleOrderWeight begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        commonlib_print(TAG,"callLifeCircleOrderWeight common_life_circle_callbacks is nil or empty")
        return
    end
    table.sort(common_life_circle_callbacks, lifeCircleSortCompare)
end

function commonlib_saveImage(rect, name)
    imageRecognize:saveImage(rect, name)
end


function commonlib_printTableInfo(tag, targetTable)
    for key, value in pairs(targetTable) do
        commonlib_print(tag, tostring(key) .. " = " .. tostring(value))
    end
end

function commonlib_isTableSame(oneTable, otherTable)
    if oneTable == nil and otherTable == nil then
        return true
    end

    if oneTable == nil or otherTable == nil then
        return false
    end

    for index, oneValue in pairs(oneTable) do
        if not commonlib_isTableContainsValue(otherTable, oneValue) then
            return false
        end
    end

    return true
end

function commonlib_getSettingView()
    if settingView == nil then
        settingView = SettingView()
    end

    return settingView
end

function commonlib_getUnClickableFloatView()
    if unClickableFloatView == nil then
        unClickableFloatView = UnClickableFloatView()
    end

    return unClickableFloatView
end

function commonlib_getClickableFloatView()
    if clickableFloatView == nil then
        clickableFloatView = ClickableFloatView()
    end

    return clickableFloatView
end

function commonlib_getFloatViewMgrEx()
    if floatViewMgrEx == nil then
        floatViewMgrEx = FloatViewMgrEx()
    end
    return floatViewMgrEx
end

-- 获取悬浮球
function commonlib_getFloatBall()
    if floatBall == nil then
        floatBall = TopSmallView()
    end
    return floatBall
end

function commonlib_getImageRecognize()
    if imageRecognize == nil then
        imageRecognize = ImageRecognize()
    end

    return imageRecognize
end

local LuaAnchor_ = {
    TOPLEFT = 1,
    LEFT = 2,
    BOTTOMLEFT = 3,
    TOP = 4,
    CENTER = 5,
    BOTTOM = 6,
    TOPRIGHT = 7,
    RIGHT = 8,
    BOTTOMRIGHT = 9,
}
function Anchor()
    return LuaAnchor_;
end


local LuaZOrder_ = {
    zorder_bottom = 1,
    zorder_middle = 2,
    zorder_top = 3,
}
function ZOrder()
    return LuaZOrder_;
end

---------------------------- 界面设置相关 ---------------------------------
function commonlib_setSettingViewIcon(imagePath)
    if settingView ~= nil and imagePath ~= nil then
        settingView:setIcon(imagePath)
    end
end

function commonlib_setSettingViewIconSize(width, height)
    if settingView ~= nil then
        settingView:setIconSize(width, height)
    end
end

function commonlib_setSettingViewIconMargin(marginLeft, marginTop, marginRight, marginBottom)
    if settingView ~= nil then
        settingView:setIconMargin(marginLeft, marginTop, marginRight, marginBottom)
    end
end

function commonlib_setSettingViewIconExtrudeHeight(extrudeHeight)
    if settingView ~= nil then
        settingView:setIconExtrudeHeight(extrudeHeight)
    end
end

function commonlib_setFloatBallIcon(imagePath)
    if floatBall ~= nil and imagePath ~= nil then
        floatBall:setIcon(imagePath)
    end
end

function commonlib_showTipsAnimation(message)
    if floatBall~= nil and message ~= nil then
        floatBall:showTipsAnimation(message)
    end
end

function commonlib_registerSettingViewOpenCallback(callback)
    commonlib_registerCallback(common_setting_view_state_callbacks.ON_SETTING_VIEW_OPEN, callback)
end

function commonlib_registerSettingViewCloseCallback(callback)
    commonlib_registerCallback(common_setting_view_state_callbacks.ON_SETTING_VIEW_CLOSE, callback)
end

function commonlib_unRegisterSettingViewOpenCallback(callback)
    commonlib_unregisterCallback(common_setting_view_state_callbacks.ON_SETTING_VIEW_OPEN, callback)
end

function commonlib_unRegisterSettingViewCloseCallback(callback)
    commonlib_unregisterCallback(common_setting_view_state_callbacks.ON_SETTING_VIEW_CLOSE, callback)
end

--- 设置设置界面关闭或打开时的回调
function commonlib_putSettingViewsEventListener()
    local settingView = commonlib_getSettingView()

    -- 这个值对应于 com.cm.plugin.gameassistant.setting.viewinterface.ISGameSettingView.EVENT_ID_ON_GAME_ASSISTING
    -- 用于避免每个游戏在初始化时都调用这个方法导致 add 多次的问题
    local EVENT_ID_ON_GAME_ASSISTING = 200

    settingView:putOnEventListener(EVENT_ID_ON_GAME_ASSISTING,
    function()
        commonlib_print(TAG, "设置页面被打开")
        for index, callback in pairs(common_setting_view_state_callbacks.ON_SETTING_VIEW_OPEN) do
            commonlib_print(TAG, "开始回调第几个回调参数：" .. tostring(index))
            callback()
        end
    end, function()
        commonlib_print(TAG, "设置页面被关闭")
        for index, callback in pairs(common_setting_view_state_callbacks.ON_SETTING_VIEW_CLOSE) do
            commonlib_print(TAG, "开始回调第几个回调参数：" .. tostring(index))
            callback()
        end
    end)
end

function commonlib_isTextEmpty(text)
    return text == nil or string.len(text) == 0
end


function commonlib_getReport()
    if reportLib == nil then
        reportLib = Report()
    end

    return reportLib;
end

-- 埋点上报
function commonlib_report(tableName, reportData)
    if commonlib_isTextEmpty(tableName) then
        commonlib_print(TAG, "commonlib_report tableName is empty")
        return
    end

    if reportData == nil then
        commonlib_print(TAG, "commonlib_report reportData is empty")
        return
    end

    commonlib_getReport():report({
        ["table_name"] = tableName,
        ["report_data"] = reportData
    })
end

function commonlib_reportGameRecogSuccess(game, action, buttonname)
    local src = commonlib_getCurrentGameStartSrc()
    commonlib_report(GAMEMASTER_GAMERECOG_SUCCESS_TABLE,
            {
                [GAMEMASTER_GAMERECOG_SUCCESS_ACTION] = commonlib_toString(action),
                [GAMEMASTER_GAMERECOG_SUCCESS_GAMENAME] = commonlib_toString(commonlib_getGameId()),
                [GAMEMASTER_GAMERECOG_SUCCESS_BUTTONNAME] = commonlib_toString(buttonname),
                [GAMEMASTER_GAMERECOG_SUCCESS_SRC] = src,
                [GAMEMASTER_GAMERECOG_SUCCESS_PKGNAME] = commonlib_toString(commonlib_getGamePackageName())
            });
    commonlib_print(TAG, "gamemaster_gamerecog_success"
            .. ", " .. GAMEMASTER_GAMERECOG_SUCCESS_ACTION .. "=" .. tostring(action)
            .. ", " .. GAMEMASTER_GAMERECOG_SUCCESS_GAMENAME .. "=" .. tostring(game)
            .. ", " .. GAMEMASTER_GAMERECOG_SUCCESS_BUTTONNAME .. "=" .. tostring(buttonname)
            .. ", " .. GAMEMASTER_GAMERECOG_SUCCESS_PKGNAME .. "=" .. commonlib_getGameId()
            .. ", " .. GAMEMASTER_GAMERECOG_SUCCESS_SRC .. "=" .. src)
end

function commonlib_reportFunctionDisableReason(game, step, reason)
    commonlib_report(GAMEMASTER_FUNCTION_DISABLE_REASON_TABLE,
            {
                [GAMEMASTER_FUNCTION_DISABLE_REASON_STEP] = step,
                [GAMEMASTER_FUNCTION_DISABLE_REASON_GAMENAME] = game,
                [GAMEMASTER_FUNCTION_DISABLE_REASON] = reason
            });
end

function commonlib_reportVideoEffect(ABTestName)
    commonlib_report(GAMEMASTER_VIDEO_EFFECT_TABLE,
            {
                ["state"]  = ABTestName
            });
end

function commonlib_reportScriptMonitor(game, state)
    commonlib_report(GAMEMASTER_SCRIPT_MON_TABLE,
            {
                ["gamename"]  = game,
                ["scriptbz"]  = state,
                ["typestate"] = 1 --- 1表示lua的上报，2表示java上报
            });
end

function commonlib_reportGameData(gameType, numberType, number)
    commonlib_report(GAMEMASTER_GAMEDATA,
            {
                ["op"] = numberType, --数据类型 1-杀人数 2-助攻数 3-死亡数
                ["type1"] = gameType, -- 游戏类型 1-王者时刻 2-刺激时刻
                ["count1"] = number -- 数量
            });
end

--- gamemaster_game_skinchoose:275 package:string skinname:string
function commonlib_reportSkinChoose(gamePkgName, skinName)
    if nil ~= gamePkgName and nil ~= skinName then
        commonlib_report(GAMEMASTER_GAME_SKINCHOOSE,
            {
                ["package"] = gamePkgName,
                ["skinname"] = skinName,
            })
    end
end

function commonlib_reportScriptMonitorAbnormal(game, state)
    local lastGame = commonlib_getSharedPrefString(LAST_GAME_SCRIPT, LAST_GAME_SCRIPT_DEF);
    if string.len(lastGame) > 0 and lastGame ~= LAST_GAME_SCRIPT_DEF then
        commonlib_reportScriptMonitor(lastGame, GAME_SCRIPT_EXIT_ABNORMAL);
        commonlib_setSharedPrefString(LAST_GAME_SCRIPT, "");
        commonlib_print(TAG, "ScriptMonitor last abnormal exit [" .. game .."] " .. state);
    end
end
function commonlib_initScriptMonitor(game)
    commonlib_print(TAG, "ScriptMonitor game start " .. game);
    commonlib_reportScriptMonitorAbnormal(game, "start");
    commonlib_setSharedPrefString(LAST_GAME_SCRIPT, tostring(game));
end

function commonlib_uninitScriptMonitor(game, state)
    local lastGame = commonlib_getSharedPrefString(LAST_GAME_SCRIPT, LAST_GAME_SCRIPT_DEF);
    if string.len(lastGame) > 0 and lastGame ~= LAST_GAME_SCRIPT_DEF then
        commonlib_setSharedPrefString(LAST_GAME_SCRIPT, "");
        commonlib_print(TAG, "ScriptMonitor normal exit [" .. game .. "] " ..state);
        commonlib_reportScriptMonitor(game, GAME_SCRIPT_EXIT_NORMAL);
    end
end

function commonlib_gamemaster_skin2_0_elementshow(skinId, elementId, isShow)
    ---gamemaster_skin2_0_elementshow:435 pkgname:string element:string isshow:bit reason:byte gameid:string skinid:string
    commonlib_report("gamemaster_skin2_0_elementshow",
        {
            ["pkgname"] = commonlib_toString(commonlib_getGamePackageName()),
            ["element"] = commonlib_toString(elementId),
            ["isshow"] = commonlib_boolToNumber(isShow),
            ["reason"] = 0,
            ["gameid"] = commonlib_toString(commonlib_getGameId()),
            ["skinid"] = commonlib_toString(skinId)
        });
end

function commonlib_boolToNumber(boolValue)
    if type(boolValue) ~= 'boolean' then
        return 0;
    end

    if boolValue == true then
        return 1;
    end

    return 0;
end

--- 判断是否是AB 测试中的A渠道

function commonlib_getGameConfig()
    if gameConfig == nil then
        gameConfig = GlobalGameConfig()
    end

    return gameConfig;
end

function commonlib_isAidTestA()
    return commonlib_getGameConfig():isAidTestA()
end

function commonlib_isOddNumber(number)
    return number % 2 ~= 0
end

function commonlib_setViewsEnable(viewTable, isEnable)
    if viewTable == nil then
        return
    end

    for index, view in pairs(viewTable) do
        commonlib_setViewEnable(view, isEnable)
    end
end

function commonlib_setViewEnable(view, isEnable)
    if view ~= nil then
        view:setEnabled(isEnable)
    end
end

function commonlib_setCheckboxsChecked(checkboxTable, isEnable)
    if checkboxTable == nil then
        return
    end

    for index, view in pairs(checkboxTable) do
        commonlib_setCheckboxChecked(view, isEnable)
    end
end

function commonlib_setCheckboxChecked(checkbox, isChecked)
    if checkbox ~= nil then
        checkbox:setChecked(isChecked)
    end
end

function commonlib_destroyViews(views)
    for index, view in pairs(views) do
        commonlib_destroyView(view)
    end
end

function commonlib_destroyView(view)
    if view ~= nil then
        view:destroy()
        view = nil
    end
end

function commonlib_getScreenState()
    -- 横竖屏状态 1代表横屏 2代表竖屏
    return gameAssistant:screenState()
end

function commonlib_setFloatBallDragAndClick(isDrag)
    floatBall:setDragAndClickView(isDrag)
end

----------------------- Lua 与 Java通信的一些接口 -----------------------
-- 游戏状态发生改变时调用
function commonlib_notifyGameStateChange(lastGameState, currentGameState, gameResult, heroIdListString)
    commonlib_print(TAG, "commonlib_notifyGameStateChange lastGameState = " .. tostring(lastGameState) .. ", currentGameState = " .. tostring(currentGameState))
    if lastGameState == nil or currentGameState == nil then
        commonlib_print(TAG, "commonlib_notifyGameStateChange param is nil")
        return
    end

    if lastGameState ~= currentGameState then
        commonlib_getGameConfig():notifyGameStateChange(lastGameState, currentGameState, tostring(gameResult), heroIdListString)
    end
end

--- 通用的工具类
-- 进行对象的深拷贝
function commonlib_deepCopy(orig)
    if orig == nil then
        commonlib_print(TAG, "commonlib_deepCopy orig is nil")
        return {}
    end

    local copy
    if type(orig) == "table" then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[commonlib_deepCopy(orig_key)] = commonlib_deepCopy(orig_value)
        end
        local metaTable = getmetatable(orig)
        if metaTable ~= nil then
            setmetatable(copy, commonlib_deepCopy(getmetatable(orig)))
        end
    else
        copy = orig
    end
    return copy
end
-- 分割字符串
function commonlib_split(str, reps)
    local resultStrList = {}
    string.gsub(str, '[^' .. reps .. ']+', function(w)
        table.insert(resultStrList, w)
    end)
    return resultStrList
end

function commonlib_getGlobalSharedPrefString(key, def)
    if globalSharePrefConfig ~= nil and key ~= nil and def ~= nil then
        return globalSharePrefConfig:getString(key, def)
    end
    commonlib_print(TAG, "commonlib_getGlobalSharedPrefString params is nil")
    return nil
end

function commonlib_setGlobalSharedPrefString(key, val)
    if globalSharePrefConfig ~= nil and key ~= nil then
        globalSharePrefConfig:setString(key, val)
    end
    commonlib_print(TAG, "commonlib_setGlobalSharedPrefString params is nil")
end

function commonlib_saveShowSkinFlag(pkgName)
    commonlib_print(TAG, "commonlib_saveShowSkinFlag" .. pkgName)
    if (commonlib_isTextEmpty(pkgName)) then
        return
    end
    local key = "use_skin_" .. pkgName;
    local time = globalSharePrefConfig:getString(key);
    if (commonlib_isTextEmpty(time)) then
        globalSharePrefConfig:setString( key, tostring(commonlib_getCurrentTime()) )
    end
end

function commonlib_needSaveSkinFlag(pkgName)
    if (commonlib_isTextEmpty(pkgName)) then
        return false;
    end
    local key = "use_skin_" .. pkgName;
    local time = globalSharePrefConfig:getString(key);
    if (commonlib_isTextEmpty(time)) then
        return true;
    end

    return false;
end

function commonlib_getUtilTool()
    if utilTool == nil then
        utilTool = UtilTool();
    end

    return utilTool;
end

function commonlib_getChannelId()
    if commonlib_getUtilTool() ~= nil then
        return commonlib_getUtilTool():getChannelId();
    end
    return nil;
end

---
-- 通过公用的ab测试生成和保存器，获取当前功能应该使用哪个方案section
-- 内部流程：通过在func=4的魔方模块配置 方案section列表与对应的概率列表；使用该函数将返回对应的方案section;
-- 内部会将其当前生成的随机数方案通过SharePreference保存,以供下次使用;
-- @param key ab测试功能唯一标识key
-- @param isFromLocal 是否需要方案本地持久化(是否读写本地SharePreference)
-- @return 返回当前命中哪套方案的魔方section，概率参数不合法默认使用第一套section
--
function commonlib_getCommonAbTestSection(section, isFromLocal)
    if section == nil and isFromLocal == nil then
        return nil;
    end

    return commonlib_getUtilTool():getCommonAbTestSection(section, isFromLocal);
end

--新的abtest获取方法
function commonlib_getCommonAbTestSolution(section, isFromLocal)
    if section == nil and isFromLocal == nil then
        return nil;
    end

    return commonlib_getUtilTool():getCommonAbTestSolution(section, isFromLocal);
end


---王者荣耀所有功能开关 abc test
function commonlib_getSgameFuncAbcTestEnable(key, defaultValue)
    if commonlib_getUtilTool() == nil or key == nil or defaultValue == nil then
        return defaultValue
    end
    return commonlib_getUtilTool():getSgameFuncCloudAbcTestEnable(key, defaultValue)
end

function commonlib_getSgameFuncCloudSwitch(key, defaultValue)
    if commonlib_getUtilTool() == nil or key == nil or defaultValue == nil then
        return defaultValue
    end
    return commonlib_getUtilTool():getSgameFuncCloudSwitch(key, defaultValue)
end

function commonlib_getCloudConfigBoolValue(section, key, defaultValue)
    if section == nil or key == nil or defaultValue == nil then
        return nil;
    end
    return commonlib_getUtilTool():getCloudConfigBoolValue(section, key, defaultValue);
end

function commonlib_getCloudConfigIntValue(section, key, defaultValue)
    if section == nil or key == nil or defaultValue == nil then
        return defaultValue;
    end
    return commonlib_getUtilTool():getCloudConfigIntValue(section, key, defaultValue);
end

function commonlib_getGameDefaultCustomCloudSwitch(switchName, gameId)
    if switchName == nil then
        return false;
    end

    if gameId == nil then
        gameId = commonlib_getGameId();
    end

    return commonlib_getUtilTool():getGameDefaultCustomCloudSwitch(gameId, switchName, false);
end

function commonlib_toString(value)
    if value == nil then
        return "nil";
    end

    return tostring(value);
end

function commonlib_isStringEmpty(s)
    if s == nil then
        return true;
    end

    return string.len(s) == 0;
end

function commonlib_dp2Pix(value)
    return coordinateTool:dp2Pix(value);
end

function commonlib_getSkinManager()
    if skinManager == nil then
        skinManager = SkinManager();
    end

    return skinManager;
end

function commonlib_getEvent()
    if nil == event then
        event = Event();
    end
    return event;
end

function commonlib_getGameId()
    if gameId == nil then
        gameId = commonlib_getSkinManager():getGameId();
    end

    return gameId;
end

function commonlib_getGamePackageName()
    if gamePackageName == nil then
        gamePackageName = commonlib_getSkinManager():getGamePackageName();
    end

    return gamePackageName;
end

--app第一次安装时间
function commonlib_getFirstInstallTime()
    return sharedPrefConfig:getFirstInstallTime()
end

function commonlib_registerPause(id, func)
    commonlib_getEvent():registerEvent(id, "event.assist.pause", func)
end

function commonlib_unregisterPause(id)
    commonlib_getEvent():unregisterEvent(id, "event.assist.pause")
end

function commonlib_getStartParams()
    return commonlib_getEvent():getStartParams()
end

function commonlib_registerResume(id, func)
    commonlib_getEvent():registerEvent(id, "event.assist.resume", func)
end

function commonlib_unregisterResume(id)
    commonlib_getEvent():unregisterEvent(id, "event.assist.resume")
end

--- 暂时只有和平精英使用
function commonlib_updateCurrentGameStartSrc(gameId, src)
    globalCurrentStartGameId  = gameId
    globalCurrentStartGameSrc = src
end
function commonlib_getCurrentGameStartSrc()
    local gameId = globalCurrentStartGameId
    local src    = globalCurrentStartGameSrc
    local currentGameId = commonlib_getGameId()
    if nil == currentGameId or nil == gameId or nil == src or currentGameId ~= gameId then
        return GAME_START_SRC_UNKNOWN
    end
    return src
end

function uploadBitmapMat(rectString, filename, index)
    local rects = CNewGameEngine:getInstance():getConditionRect(rectString)
    if rects == nil then
        return
    end
    local str = filename
    commonlib_getUtilTool():uploadbitmap(rects, str, index)
    commonlib_print("ScreenshotDataForMat",
            "rectString=" .. tostring(rectString)
            .. ", filename=" .. tostring(str)
            .. ", index=" .. tostring(index))
end
