
local TAG = "common_skin"

local KEY_IS_SWITCH_CHECKBOX_SELECTED;
local SP_KEY_SKIN_TYPE;

local SKIN_TAB_PAGE_NAME = "皮肤美化"
local SKIN_SWITCH_CHECKBOX_TEXT = "开启皮肤美化"

local skin_type;

local skinContainerView
local skin_checkBox
local skin_radioGroupController
local skinTypeTable
local skinDataForSkinManager = {};
local gSkinCount = 0;

local skinSettingCheckboxTable = {}
local skinSettingImageViewTable = {}
local skinSettingImageLockedTable = {}
local skinSettingImageDiyTable = {}
local skinSettingProgressView = {}
local skinSettingTabView
local isCbSwitchSelected = true
local skinSwitchCheckStatusCallback = nil;
local isManualClickCheckBox = true;

local skinContainerShowing = false;
local skinContainerShouldShow = false;
local gEventId
local SKIN_EVENT = "event.skin"

local gNewGameEngine;
local gSkinsTable = {}

local gCurrentSkinFragmentId;
local gToCreateSkinElements;
local gToRefreshSkinElementStatus;


local DOWNLOAD_SKIN_SUCCESS_TOAST = "皮肤主题更换成功"
local DOWNLOAD_SKIN_FAILED_TOAST = "下载失败，请检查网络后重试"
local SKIN_LOCKED_TOAST = "前往游戏超人APP【游戏皮肤中心】，可解锁所有皮肤哦！"
local SKIN_SHARED_TITLE = "价值66元的皮肤礼包免费送"
local SKIN_SHARED_SUCC_TOAST = "恭喜，你已免费获得该皮肤，快去体验吧~"
local SKIN_SHARED_FAIL_TOAST = "分享失败"

local shouldLoadSkin;

local gSharedSkinType = nil;
local gSkinShareView = nil;
local gSkinShareFloatView = nil;

local isNeedChangedSettingView = false

local gReportDatas = {
    hasReportSkinCannotShow = false,
    skinIdForReportSkinShow = nil,
    elements = {
    }
}

local function printLog(msg)
    commonlib_print(TAG, msg)
end

local SKIN_LOCKED_SHOW = 1
local SKIN_LOCKED_CLICK = 2
local LOCKED_SKIN_REPORT_TABLE = "gamemaster_game_skinlock";
local skinLockedReport = {}
local function reportLockedSkin(skinId, action)
    if nil ~= skinId and action ~= nil then
        if skinLockedReport[skinId] ~= action then
            local game = commonlib_getSkinManager():getGameId()
            commonlib_report(LOCKED_SKIN_REPORT_TABLE,
                    {
                        ["gamename"] = game,
                        ["op"] = action,
                        ["skin_op"] = skinId
                    })
            printLog("report: "..LOCKED_SKIN_REPORT_TABLE .. " game=" .. game .. ",skin=" .. skinId .. ",op=" .. tostring(action) )
            skinLockedReport[skinId] = action;
        end
    end
end

--- 上报皮肤使用量
local function uploadSkinUsedCount()
    if not commonlib_isTextEmpty(skin_type) then
        local gameId = commonlib_getSkinManager():getGameId();
        if not commonlib_isTextEmpty(gameId) then
            commonlib_getSkinManager():uploadSkinUsedCount(gameId, skin_type);
        end
    end
end

local function showToastView(text)
    local toastContainer = commonlib_getFloatViewMgrEx():create(0, 366, Anchor().TOPLEFT, false)
    local toastView = toastContainer:addToastView(text, 3000,
            Anchor().TOPLEFT, 200, 0, ZOrder().zorder_top,
            function()
                toastContainer:destroy();
            end)
    toastContainer:setGravity(Anchor().CENTER);
    toastContainer:show()
    toastView:start();
    printLog("show toast view, " .. text)
end
--- 皮肤分享
local function destroySkinShareView()
    commonlib_runOnUIThread(function()
        if gSkinShareFloatView ~= nil then
            gSkinShareFloatView:destroy()
            gSkinShareFloatView = nil
        end
        if gSkinShareView ~= nil then
            gSkinShareView:setOnEventListener(nil)
            gSkinShareView:destroy()
            gSkinShareView = nil
        end
    end)
end

local function downloadSharedSkin(sharedSkinType, lastSkinType)
    printLog("downloadSharedSkin " .. sharedSkinType);
    commonlib_getSkinManager():downloadSkin(sharedSkinType, function (action, skin_id, status)
        printLog("downloadSharedSkin action=" .. action .. ",  skin=" .. tostring(skin_id) .. ", status=" .. tostring(status))
        if action == "DownloadResult" then
            if status == true then
                commonlib_runOnUIThreadDelayed(function ()
                    commonlib_setSharedPrefString(SP_KEY_SKIN_TYPE, gSharedSkinType)
                    showToastView(SKIN_SHARED_SUCC_TOAST);
                    commonlib_getSkinManager():updateSkinSharedStatus(commonlib_getGamePackageName(), gSharedSkinType);
                    isNeedChangedSettingView = true
                end, 2000)
            else --- download failed，restore to last skin type
                commonlib_setSharedPrefString(SP_KEY_SKIN_TYPE, lastSkinType)
                commonlib_runOnUIThread(function ()
                    showToastView(SKIN_SHARED_FAIL_TOAST);
                end)
            end
        end
    end)
end

local function showSkinShareView(skinType)
    local skinAbTest = commonlib_getCommonAbTestSolution("section_gameassitant_skin_share", true)
    printLog("skin share abtest =  " .. tostring(skinAbTest))
    if skinAbTest == 1 then --方案A
        showToastView(SKIN_LOCKED_TOAST)
        return;
    end

    -- 方案B直接分享
    gSharedSkinType = skinType;
    commonlib_runOnUIThread(function()
        if gSkinShareFloatView == nil then
            gSkinShareFloatView = commonlib_getFloatViewMgrEx():create(0, 0, Anchor().TOPLEFT, true);
            gSkinShareFloatView:setGravity(Anchor().CENTER);

            local skinShareParams = {}
            skinShareParams.ShareType = tostring(GAME_COMMON_SHARE_SKIN);
            skinShareParams.ShareTitle = SKIN_SHARED_TITLE;
            skinShareParams.GameId = commonlib_getGameId();
            skinShareParams.ShareSkinId = gSharedSkinType;
            skinShareParams.ShareDesc = commonlib_getSkinManager():getSkinShareDesc(gSharedSkinType)
            skinShareParams.ShareUrl = commonlib_getSkinManager():getSkinShareUrl(gSharedSkinType)
            skinShareParams.ShareImageUrl = commonlib_getSkinManager():getShareImageUrl();
            printLog("show skin share: " .. gSharedSkinType .. ", " .. tostring(skinShareParams.ShareDesc) ..
                    ", " .. tostring(skinShareParams.ShareUrl) .. ", " .. tostring(skinShareParams.ShareImageUrl))

            gSkinShareView = gSkinShareFloatView:addCommonShareView(Anchor().TOPLEFT, 0, 0, ZOrder().zorder_top, skinShareParams);
            gSkinShareView:setOnEventListener(function(type, action)
                printLog("skin share event: " .. type .. "." .. action)
                if type == tostring(GAME_COMMON_SHARE_SKIN) then
                    destroySkinShareView();
                    if action == "common_share_succ" then
                        printLog("download shared skin : " .. gSharedSkinType .. ", current skin: " .. skin_type);
                        downloadSharedSkin(gSharedSkinType, skin_type);
                    else
                        showToastView(SKIN_SHARED_FAIL_TOAST);
                    end
                end
            end)
        end

        if gSkinShareView ~= nil then
            gSkinShareFloatView:show()
        end
    end)
end

local function createSkinViewContainer()
    if skinContainerView == nil then
        skinContainerView = commonlib_getUnClickableFloatView():addSGameFloatViewControl(ZOrder().zorder_bottom)
        skinContainerShowing = true;
        skinContainerShouldShow = true;
    end
end

local function doLoadSkin()
    if shouldLoadSkin == false or skin_type == nil then
        return;
    end

    gReportDatas.elements = {}
    shouldLoadSkin = false;
    gNewGameEngine:setCurrentSkinId(skin_type);
    local success = gNewGameEngine:loadSkin(skin_type);
    printLog("doLoadSkin:result="..commonlib_toString(success))
    uploadSkinUsedCount();
end

local function destroySkins()
    if nil ~= skinContainerView then
        skinContainerView:destroy()
        skinContainerView = nil
    end

    gSkinsTable = {}
    skinContainerShowing = false;
    skinContainerShouldShow = false;
    printLog("destroySkins")
end

local function createSkins(bShow)
    printLog("createSkins, show:" .. tostring(bShow))
    destroySkins();
    --- 如果皮肤checkbox没被勾选，则不做处理
    if skin_checkBox == nil or not skin_checkBox:isChecked() then
        printLog("createSkins, skin_checkBox is not checked, show:" .. tostring(bShow))
        return
    end

    gToCreateSkinElements = gNewGameEngine:getSkinFragmentElements(skin_type, gCurrentSkinFragmentId);

    if gToCreateSkinElements == nil then
        return;
    end

    createSkinViewContainer()
    skinContainerShowing = bShow;
    skinContainerShouldShow = bShow;
    if not bShow then
        skinContainerView:hide()
    end

    for index, elementData in pairs(gToCreateSkinElements) do
        local rect = elementData.rect;
        local elementId = elementData.id;
        local skinImage = skinContainerView:addImageView(elementData.image,
                rect.flag, rect.left, rect.top, rect.width, rect.height,
                ZOrder().zorder_bottom);

        local canShow = elementData.show;
        if gToRefreshSkinElementStatus ~= nil then
            local canShowTemp = gToRefreshSkinElementStatus[elementId];
            if canShowTemp ~= nil then
                canShow = canShowTemp;
            end
        end

        gSkinsTable[elementId] = {
            isShowing = canShow,
            skinView = skinImage,
        }
        if canShow ~= true then
            skinImage:hide();
        end
    end
    printLog("createSkins end, show:" .. tostring(bShow) .. ", skin_type:" .. tostring(skin_type))
end


local function clearSkinDataAndDestroySkin()
    gCurrentSkinFragmentId = nil;
    gToCreateSkinElements = nil;
    gToRefreshSkinElementStatus = nil;
    shouldLoadSkin = true
    destroySkins();
end


local function showSkinViewContainer(shouldShow)
    if skinContainerView == nil then
        return
    end

    if skinContainerShouldShow == shouldShow then
        return;
    end

    skinContainerShouldShow = shouldShow;
    skinContainerShowing = skinContainerShouldShow;

    if skinContainerShowing then
        skinContainerView:show()

        if gReportDatas.skinIdForReportSkinShow ~= skin_type then
            gReportDatas.skinIdForReportSkinShow = skin_type;
            commonlib_reportGameRecogSuccess(0, ACTION_SHOW_SKIN, skin_type)
        end
    else
        skinContainerView:hide()
    end
end

local function doShowSkinViewContainerOnUiThread(show)
    commonlib_runOnUIThread(function()
        local canShow = (isCbSwitchSelected == true and show == true);
        showSkinViewContainer(canShow);
    end)
end

local function isViewsNil(views)
    if nil == views then
        return true
    end

    local hasData = false
    for _, view in pairs(views) do
        hasData = true
        if view == nil then
            return true
        end
    end

    return (not hasData)
end

local function onSkinCheckboxSelected(checkBoxId, isChecked)
    printLog("onSkinCheckboxSelected chckBoxId=" .. tostring(checkBoxId) .. ", isChecked=" .. tostring(isChecked))
    if skinSwitchCheckStatusCallback ~= nil then
        skinSwitchCheckStatusCallback(isChecked);
    end

    isCbSwitchSelected = isChecked
    if isChecked then
        commonlib_reportGameRecogSuccess(0, ACTION_SHOW_SKIN_SETTING_OPEN, commonlib_toString(skin_type))
    else
        commonlib_reportGameRecogSuccess(0, ACTION_SHOW_SKIN_SETTING_CLOSE, commonlib_toString(skin_type))
    end
    commonlib_setSharedPrefBoolean(KEY_IS_SWITCH_CHECKBOX_SELECTED, isChecked)

    if not isViewsNil(skinSettingCheckboxTable) then
        if isChecked then
            -- 级联选中上次使用的皮肤，并重新渲染皮肤
            printLog("skinevsetting back to skin " .. commonlib_toString(skin_type))
            local checkBoxView;
            if skin_type ~= nil then
                checkBoxView = skinSettingCheckboxTable[skin_type];
            end
            if checkBoxView ~= nil then
                checkBoxView:setChecked(true)
            end
        else
            commonlib_setCheckboxsChecked(skinSettingCheckboxTable, false)
        end
    end

    if isChecked == false then
        showSkinViewContainer(false);
    end
end


local function executeDownloadSkin(progressView, skin_type, last_skin_ype)
    commonlib_getSkinManager():downloadSkin(skin_type, function (action, skin_id, status)
        printLog(action .. " " .. tostring(skin_id) .. " " .. tostring(status))
        if action == "DownloadResult" then
            if status == true then
                clearSkinDataAndDestroySkin()
                commonlib_runOnUIThreadDelayed(function ()
                    if progressView ~= nil then
                        progressView:hide()
                    end
                    showToastView(DOWNLOAD_SKIN_SUCCESS_TOAST)
                    skinDataForSkinManager[skin_type].needDownload = false
                end, 2000)
            else --- download failed，restore to last skin type
                skin_type = last_skin_ype
                commonlib_setSharedPrefString(SP_KEY_SKIN_TYPE, skin_type)
                skinSettingCheckboxTable[skin_type]:setChecked(true)
                clearSkinDataAndDestroySkin()
                commonlib_runOnUIThread(function ()
                    if progressView ~= nil then
                        progressView:stop()
                    end
                    showToastView(DOWNLOAD_SKIN_FAILED_TOAST)
                end)
            end
        elseif action == "DownloadProgress" then
            --commonlib_runOnUIThread(function ()
            --    if progressView ~= nil then
            --        progressView:show()
            --        progressView:setProgress(status)
            printLog("progressview set progress: " .. tostring(status))
            --end
            --end)
        end
    end)
    if progressView ~= nil then
        progressView:start()
    end
end

--- 皮肤是否被锁定
local function isSkinLocked(skinId)
    for key, skinData in pairs(skinDataForSkinManager) do
        if skinData ~= nil and skinData.id == skinId and skinData.locked == true then
            return true;
        end
    end
    return false;
end

--- 恢复使用上次的皮肤
local function restoreSkin()
    if skin_type ~= nil then
        for skinType, checkbox in pairs(skinSettingCheckboxTable) do
            if skinType == skin_type and checkbox ~= nil then
                checkbox:setChecked(true);
            end
        end
    end
end

--- 皮肤radiobutton选中或者取消的回调函数
local function skinRadioGroupUICallback(id, isChecked)
    printLog("skinevsetting begin " .. tostring(isChecked))

    if not isChecked then
        return
    end

    if isViewsNil(skinSettingImageViewTable) then
        printLog("ENABLE_SETTING_SKIN_IMAGE isViewsNil(skinSettingImageViewTable)")
        return
    end

    if isViewsNil(skinSettingCheckboxTable) then
        printLog("isViewsNil(skinSettingCheckboxTable)")
        return
    end

    for skinType, checkbox in pairs(skinSettingCheckboxTable) do
        if id == checkbox:getId() then
            -- 检查皮肤是否可用，不可用则不能触发下载
            printLog("skin " .. skinType .. ", manual click " .. tostring(isManualClickCheckBox) .. " locked " .. tostring(isSkinLocked(skinType)));
            if isManualClickCheckBox == true and isSkinLocked(skinType) == true then
                printLog("skinRadioGroupUICallback isSkinLocked showToastView " .. skinType);
                showSkinShareView(skinType);
                reportLockedSkin(skinType, SKIN_LOCKED_CLICK)
                checkbox:setChecked(false)
                restoreSkin();
                return;
            end

            isManualClickCheckBox = true;
            printLog("skin_type=" .. commonlib_toString(skin_type) .. ", " .. commonlib_toString(skinType))
            local last_skin_type = skin_type
            skin_type = skinType
            printLog("skinevsetting do on change " .. commonlib_toString(skin_type) .. ", skin_checkBox status:" .. tostring(skin_checkBox:isChecked()))
            commonlib_setSharedPrefString(SP_KEY_SKIN_TYPE, skin_type)

            -- reportSkinClick() --- TODO

            -- 如果一级设置项已勾选，则直接更换新皮肤
            local needDownload = skinDataForSkinManager[skin_type].needDownload
            local progressView  = skinSettingProgressView[skin_type]
            if needDownload then
                executeDownloadSkin(progressView, skin_type, last_skin_type)
            else
                clearSkinDataAndDestroySkin()
            end

            if not skin_checkBox:isChecked() then
                -- 否则触发一级设置项的勾选事件来完成后续的更换皮肤工作
                isCbSwitchSelected = true
                skin_checkBox:setChecked(true)
            end
            return
        end
    end
    printLog("skinRadioGroupUICallback end")
end

--- 皮肤设置imageView选中点击的回调函数
local function skinSettingImageViewUICallback(id)
    printLog("skinSettingImageViewUICallback " .. tostring(id))

    if isViewsNil(skinSettingImageViewTable) then
        printLog("skinSettingImageViewTable is nil")
        return
    end

    for skinType, imageView in pairs(skinSettingImageViewTable) do
        if imageView:getId() == id then
            -- 检查皮肤是否可用，不可用则不能触发下载
            if isSkinLocked(skinType) then
                printLog("skinSettingImageViewUICallback isSkinLocked showToastView " .. skinType);
                showSkinShareView(skinType);
                reportLockedSkin(skinType, SKIN_LOCKED_CLICK)
                return;
            end

            printLog("skinevsetting trigger checkbox checked ops " .. tostring(skinType))
            -- 间接触发上面的 skinRadioGroupUICallback() 方法被调用来完成后续的设置工作

            local checkBoxView = skinSettingCheckboxTable[skinType]
            if nil ~= checkBoxView then
                checkBoxView:setChecked(true)
            end

            return
        end
    end
end

--- 皮肤解锁提示
local function skinSettingImageLockedUICallback(id)
    printLog("skinSettingImageLockedUICallback " .. tostring(id))
    if isViewsNil(skinSettingImageLockedTable) then
        printLog("skinSettingImageLockedUICallback is nil")
        return
    end

    for skinType, imageView in pairs(skinSettingImageLockedTable) do
        if imageView:getId() == id then
            printLog("skinSettingImageLockedUICallback showToast " .. skinType)
            showSkinShareView(skinType);
            reportLockedSkin(skinType, SKIN_LOCKED_CLICK)
            return
        end
    end
end

local function generateSettingView(settingTab, referView, radioGroupController)

    if nil == skinTypeTable then
        printLog("generateSettingView , skinTypeTable is nil")
        return
    end

    printLog( " generateSettingView ")
    local topView = referView;
    for index, skinType in pairs(skinTypeTable) do
        printLog("开始生成皮肤" .. tostring(skinType) .. "的设置界面")
        local layoutParam = create("RelativeLayoutParam")
        local cbLayoutParamValues = {}
        local ivLayoutParamValues = {}
        local pvLayoutParamValues = {}
        if commonlib_isOddNumber(index) then
            cbLayoutParamValues.layout_marginLeft = "50dp"
            ivLayoutParamValues.layout_marginLeft = "50dp"
        else
            cbLayoutParamValues.layout_marginLeft = "220dp"
            ivLayoutParamValues.layout_marginLeft = "220dp"
        end
        cbLayoutParamValues.layout_marginTop = "12dp"
        cbLayoutParamValues.layout_below = topView:getId()
        layoutParam:setLayoutParam(cbLayoutParamValues)

        local skinData = skinDataForSkinManager[skinType];
        local checkbox = settingTab:addRadioButton(skinData.name, false, layoutParam, nil, radioGroupController:getId())
        skinSettingCheckboxTable[skinType] = checkbox

        ivLayoutParamValues.layout_marginTop = "12dp"
        ivLayoutParamValues.layout_width = "130dp"
        ivLayoutParamValues.layout_height = "79dp"
        ivLayoutParamValues.layout_below = checkbox:getId()
        layoutParam:setLayoutParam(ivLayoutParamValues)
        local imageView = settingTab:addImageView(skinData.settingSampleImagePath, layoutParam, skinSettingImageViewUICallback)
        skinSettingImageViewTable[skinType] = imageView

        if skinData.diy == true then
            if commonlib_isOddNumber(index) then
                ivLayoutParamValues.layout_marginLeft = "55dp"
            else
                ivLayoutParamValues.layout_marginLeft = "225dp"
            end
            ivLayoutParamValues.layout_marginTop = "68dp"
            ivLayoutParamValues.layout_width = "40dp"
            ivLayoutParamValues.layout_height = "18dp"
            layoutParam:setLayoutParam(ivLayoutParamValues)
            imageView = settingTab:addImageView("common://image/skin_diy.png", layoutParam, nil)
            skinSettingImageDiyTable[skinType] = imageView
        elseif skinData.locked == true then
            reportLockedSkin(skinType, SKIN_LOCKED_SHOW)
            if commonlib_isOddNumber(index) then
                ivLayoutParamValues.layout_marginLeft = "97dp"
            else
                ivLayoutParamValues.layout_marginLeft = "265dp"
            end
            ivLayoutParamValues.layout_marginTop = "31dp"
            ivLayoutParamValues.layout_width = "42dp"
            ivLayoutParamValues.layout_height = "44dp"
            layoutParam:setLayoutParam(ivLayoutParamValues)
            imageView = settingTab:addImageView("common://image/skin_no_have.png", layoutParam, skinSettingImageLockedUICallback)
            skinSettingImageLockedTable[skinType] = imageView
            skinSettingImageViewTable[skinType]:setColorFilter("#81000000")
        elseif skinData.needDownload == true then
            pvLayoutParamValues.layout_marginTop = "12dp"
            pvLayoutParamValues.layout_width = "130dp"
            pvLayoutParamValues.layout_height = "79dp"
            pvLayoutParamValues.layout_below = checkbox:getId()
            layoutParam:setLayoutParam(pvLayoutParamValues)

            local progressView = settingTab:addCircleProgressView(layoutParam, nil)
            skinSettingProgressView[skinType] = progressView

            printLog("add progressview for: " .. tostring(skinType))
        end

        if not commonlib_isOddNumber(index) then
            topView = skinSettingImageViewTable[skinTypeTable[index - 1]]
        end
    end
end

local function isSkinTypeTableExistSKinType(skinType)
    for key, skinType_ in pairs(skinTypeTable) do
        if skinType_ == skinType then
            return true;
        end
    end

    return true;
end

local function getDefaultSelectSkinId()
    if commonlib_getGameId() == GAME_PUBGMHD_PKG_NAME then
        return "skin_type_steel"
    end

    return "";
end

local function getCurrentValidateSkinType()
    skin_type = commonlib_getSharedPrefString(SP_KEY_SKIN_TYPE, getDefaultSelectSkinId());
    printLog("getCurrentValidateSkinType:" .. commonlib_toString(skin_type))

    if commonlib_isStringEmpty(skin_type) == false and
            skinDataForSkinManager[skin_type] ~= nil and
            skinDataForSkinManager[skin_type].needDownload == false and
            isSkinTypeTableExistSKinType(skin_type) then
        return skin_type;
    end

    for key, skinType in pairs(skinTypeTable) do
        if skinDataForSkinManager[skinType] ~= nil and
                skinDataForSkinManager[skinType].needDownload == false then
            return skinType;
        end
    end

    return nil;
end

local function getSkinSwitchCheckedDefaultValue()
    local defalultValue = true;
    if commonlib_getGameId() == GAME_PUBGMHD_PKG_NAME then
        defalultValue = commonlib_getGameDefaultCustomCloudSwitch("skin");
        if defalultValue ~= true then
            defalultValue = false;
        end
    end

    return defalultValue;
end

-- 皮肤列表排序
local function sortSkins(skinCurrent)
    local sortedSkinTable = {};
    local unlockedSkins = {};
    if skinCurrent ~= nil then
        -- 1.当前使用的皮肤放在第一
        sortedSkinTable[#sortedSkinTable+1] = skinCurrent;
        printLog("current using skin " .. skinCurrent)
    end

    local newSkinType = commonlib_getGlobalSharedPrefString(SP_NEW_SKIN_KEY, "")
    if (commonlib_isStringEmpty(newSkinType) == false  and skinCurrent ~= newSkinType) then
    --  上新皮肤排第二
        if skinDataForSkinManager[newSkinType].locked == true then
            sortedSkinTable[#sortedSkinTable+1] = newSkinType;
        else
            unlockedSkins[#unlockedSkins+1] = newSkinType;
        end
    end

    for key, skinId in pairs(skinTypeTable) do
        if skinId ~= skinCurrent and skinId ~= newSkinType then
            if skinDataForSkinManager[skinId] ~= nil then
                if skinDataForSkinManager[skinId].locked == true then
                    sortedSkinTable[#sortedSkinTable+1] = skinId;
                    printLog("locked skin " .. skinId)
                else
                    unlockedSkins[#unlockedSkins+1] = skinId;
                    printLog("unlock skin " .. skinId)
                end
            end
        end
    end

    for key, skinId in pairs(unlockedSkins) do
        sortedSkinTable[#sortedSkinTable+1] = skinId;
    end

    skinTypeTable = sortedSkinTable;
end

local function initSkinData()
    skinDataForSkinManager = commonlib_getSkinManager():getAllSkinItems();
    if skinDataForSkinManager == nil then
        skinDataForSkinManager = {}
    end

    skinTypeTable = {};
    gSkinCount = 0;

    for key_, skinData in pairs(skinDataForSkinManager) do
        skinTypeTable[#skinTypeTable + 1] = skinData.id;
        printLog("initSkinData:add:"..commonlib_toString(skinData.id))
        gSkinCount = gSkinCount + 1;
    end
end

local CF_TIPS_TEXT = "*调整游戏显示比例可能导致超人插件失效，请还原默认显示比例。\n还原方法：1.游戏大厅右上角设置按钮 2.选择“系统设置” 3.点击“屏幕调整”4.点击“立即还原”"
local cfTextView = nil

local function gameIdIsCf()
    local gameId = commonlib_getGameId()
    if gameId ~= nil and gameId == "com.tencent.tmgp.cf" then
        return true
    end
    return false
end

local function initSettingUI()
    printLog(" initSettingUI ")

    skin_type = getCurrentValidateSkinType();

    sortSkins(skin_type);

    local settingView = commonlib_getSettingView();
    if nil == skinSettingTabView then
        skinSettingTabView = settingView:addTableView(SKIN_TAB_PAGE_NAME)
    end

    local Param = create("RelativeLayoutParam")
    local cbParamProperty = {
        layout_marginTop = "20dp",
        layout_marginLeft = "25dp"
    }

    if gameIdIsCf() then
        local relativeLayoutParamText1 = create("RelativeLayoutParam");
        relativeLayoutParamText1:setLayoutParam({
            layout_marginTop = "20dp",
            layout_marginLeft = "40dp",
            layout_marginRight = "40dp",
        });

        cfTextView =  skinSettingTabView:addTextView(CF_TIPS_TEXT,
                "#FF00DEFF",
                "12sp",
                relativeLayoutParamText1,
                nil);
        if skinContainerShowing then
            cfTextView:gone()
        else
            cfTextView:show()
        end
        cbParamProperty.layout_below = cfTextView:getId()
    end

    Param:setLayoutParam(cbParamProperty)

    local defalutValue = getSkinSwitchCheckedDefaultValue();
    printLog(" initSettingUI:SkinSwitchCheckedDefaultValue="..commonlib_toString(defalutValue))
    isCbSwitchSelected = commonlib_getSharedPrefBoolean(KEY_IS_SWITCH_CHECKBOX_SELECTED, defalutValue)
    skin_checkBox = skinSettingTabView:addCheckBoxView(SKIN_SWITCH_CHECKBOX_TEXT, isCbSwitchSelected, Param, onSkinCheckboxSelected)
    if isCbSwitchSelected then
        report_gamemaster_game_pubgm_state(7, 1)
    else
        report_gamemaster_game_pubgm_state(7, 2)
    end
    skin_radioGroupController = skinSettingTabView:createRadioGroupController(skinRadioGroupUICallback)
    generateSettingView(skinSettingTabView, skin_checkBox, skin_radioGroupController)
    if isCbSwitchSelected and skin_type ~= nil then
        local skinCheckboxView = skinSettingCheckboxTable[skin_type]
        if nil ~= skinCheckboxView then
            isManualClickCheckBox = false;
            skinCheckboxView:setChecked(true)
        end
    end

    local newSkin = commonlib_getGlobalSharedPrefString(SP_NEW_SKIN_KEY, "")
    local haveClick = commonlib_getSharedPrefBoolean(SP_SKIN_RED_DOT_CLICKED, false)
    printLog("initSettingUI work:haveNew : " .. commonlib_toString(newSkin) .." clicked:".. commonlib_toString(haveClick));

    if (commonlib_isStringEmpty(newSkin) == false  and (not haveClick)) then
        skinSettingTabView:updateTab(true)
        skinSettingTabView:setOnTabSelectedListener(function()
            commonlib_setSharedPrefBoolean(SP_SKIN_RED_DOT_CLICKED, true)
            skinSettingTabView:updateTab(false)
        end);
    end

end

local function onSettingViewClose()
    if cfTextView ~= nil then
        if skinContainerShowing then
            cfTextView:gone()
        else
            cfTextView:show()
        end
    end
end

local function refreshSkinViews()
    if nil == gSkinsTable or
            gToRefreshSkinElementStatus == nil then
        return;
    end

    for elemetId, canShow in pairs(gToRefreshSkinElementStatus) do
        local skinInfo = gSkinsTable[elemetId];

        --gReportDatas.elements
        if skinInfo ~= nil then
            if skinInfo.isShowing ~= canShow then
                if canShow then
                    skinInfo.skinView:show()
                else
                    skinInfo.skinView:hide()
                end
                skinInfo.isShowing = canShow;
            end

            local lastReportStatue = gReportDatas.elements[elemetId];
            if lastReportStatue == nil or lastReportStatue ~= canShow then
                gReportDatas.elements[elemetId] = canShow;
                commonlib_gamemaster_skin2_0_elementshow(skin_type, elemetId, canShow);
            end
        end
    end
end

local function work()
    printLog("work:start")

    if isCbSwitchSelected ~= true or
            skin_type == nil then
        if gReportDatas.hasReportSkinCannotShow ~= true then
            gReportDatas.hasReportSkinCannotShow = true;
            commonlib_reportGameRecogSuccess(0, ACTION_SHOW_CAN_NOT_SHOW, commonlib_toString(skin_type))
        end

        printLog("work:end:1")
        return;
    end

    printLog("work:doLoadSkin: " .. commonlib_toString(skin_type));
    doLoadSkin();
    local newSkinFragmentId = gNewGameEngine:getSkinCanCreateFragment(skin_type);
    printLog("work:gCurrentSkinFragmentId, newSkinFragmentId:"
            ..commonlib_toString(gCurrentSkinFragmentId)..","..commonlib_toString(newSkinFragmentId))
    if gCurrentSkinFragmentId == nil and newSkinFragmentId == nil then
        return;
    end

    if gCurrentSkinFragmentId ~= newSkinFragmentId then
        if newSkinFragmentId ~= nil then
            local needShowSkin = gNewGameEngine:isSkinFragmentCanShow(skin_type, newSkinFragmentId);
            printLog("work:needShowSkin="..commonlib_toString(needShowSkin))
            if needShowSkin ~= true then
                printLog("work:end:by first needShowSkin is false");
                return;
            end

            gCurrentSkinFragmentId = newSkinFragmentId;
            gToCreateSkinElements = gNewGameEngine:getSkinFragmentElements(skin_type, gCurrentSkinFragmentId);
            gToRefreshSkinElementStatus = nil;
            printLog("work:gToCreateSkinElements:gToCreateSkinElements="..commonlib_toString(gToCreateSkinElements))
            commonlib_runOnUIThread(function()
                destroySkins();
                createSkins(false);
            end)
            doShowSkinViewContainerOnUiThread(needShowSkin);
        else
            doShowSkinViewContainerOnUiThread(false);
        end
    else
        local needShowSkin = gNewGameEngine:isSkinFragmentCanShow(skin_type, gCurrentSkinFragmentId);
        printLog("work:needShowSkin="..commonlib_toString(needShowSkin) .. ", " .. commonlib_toString(skin_type))
        doShowSkinViewContainerOnUiThread(needShowSkin);
        if needShowSkin then
            gToRefreshSkinElementStatus = gNewGameEngine:getSkinElementsShowStatus(skin_type, gCurrentSkinFragmentId);
            printLog("work:gToCreateSkinElements:gToCreateSkinElements="..commonlib_toString(gToRefreshSkinElementStatus))
            commonlib_runOnUIThread(function()
                refreshSkinViews();
            end)
        end
    end
    printLog("work:end:2")
end

local function initVariable()
	gNewGameEngine = CNewGameEngine:getInstance();
    shouldLoadSkin = true;
    local gameId = commonlib_getGameId();

    if gameId == GAME_PUBGMHD_PKG_NAME then
        SP_KEY_SKIN_TYPE = "key_skin_type__pubgmhd"
        KEY_IS_SWITCH_CHECKBOX_SELECTED = "is_pubgmhd_switch_checkbox_selected"
    else
        SP_KEY_SKIN_TYPE = "key_skin_type_"..gameId;
        KEY_IS_SWITCH_CHECKBOX_SELECTED = "is_switch_checkbox_selected_"..gameId
    end

    printLog("gameId=" .. gameId)
end

local function uninitSettingUI()
    commonlib_destroyView(skin_checkBox)
    commonlib_destroyView(skin_radioGroupController)
    commonlib_destroyViews(skinSettingCheckboxTable)
    skinSettingCheckboxTable = {}
    commonlib_destroyViews(skinSettingImageViewTable)
    commonlib_destroyViews(skinSettingProgressView)
    commonlib_destroyViews(skinSettingImageLockedTable)
    skinSettingImageLockedTable = {}
    commonlib_destroyViews(skinSettingImageDiyTable)
    skinSettingImageDiyTable = {}
end

local function skinChange()
    commonlib_runOnUIThread(function ()
        local skin_type_last = skin_type;

        uninitSettingUI()
        initSkinData()
        initSettingUI()
        printLog("skinChange, re-init settingUI, skin_id:" .. tostring(skin_type)
                .. ", last_skin_id:" .. tostring(skin_type_last));
        if skin_type ~= skin_type_last then
            clearSkinDataAndDestroySkin()
            printLog("skinChange, re-create Skin, skin_id:" .. tostring(skin_type)
                    .. ", last_skin_id:" .. tostring(skin_type_last));
        end
    end)
end

local function onSettingViewOpen()
    if cfTextView ~= nil then
        if skinContainerShowing then
            cfTextView:gone()
        else
            cfTextView:show()
        end
    end
    printLog("isNeedChangedSettingView=" .. tostring(isNeedChangedSettingView))
    if isNeedChangedSettingView == true then
        skinChange()
        isNeedChangedSettingView = false
    end
end

local function initSkinListener()
    gEventId = SKIN_EVENT .. "." .. tostring(commonlib_getCurrentTime())
    commonlib_getEvent():registerEvent(gEventId, SKIN_EVENT, function(event, pkgname, skin_id)

        printLog("skinChange, " .. tostring(event) .. ", skin_id:" .. tostring(skin_id) .. ", pkgname:" .. tostring(pkgname));
        if pkgname == commonlib_getGameId() then
            skinChange()
        end
    end)
end

local function uninitSkinListener()
    if nil ~= gEventId then
        commonlib_getEvent():unregisterEvent(gEventId, SKIN_EVENT)
    end
end

local function init()
    printLog("init:start")
    initVariable();
    initSkinData();
    initSettingUI();
    initSkinListener();

    commonlib_registerSettingViewOpenCallback(onSettingViewOpen)
    commonlib_registerSettingViewCloseCallback(onSettingViewClose)

    printLog("init:end")
end

local function uninit()
    uninitSkinListener();
    uninitSettingUI();
    skinLockedReport = {}

    commonlib_unRegisterSettingViewOpenCallback(onSettingViewOpen)
    commonlib_unRegisterSettingViewCloseCallback(onSettingViewClose)
end

function common_skin_init()
    init()
end

function common_skin_uninit()
    uninit()
end

function common_skin_work()
    work()
end

function common_skin_getSkinCount()
    return gSkinCount;
end

function common_skin_isSwitchOpen()
    return isCbSwitchSelected;
end

function common_skin_setSkinSwitchCheckStatusCallback(callback)
    skinSwitchCheckStatusCallback = callback;
end


function common_skin_getCurrentSkinId()
    if common_skin_isSwitchOpen() == false then
        return nil;
    end

    return skin_type;
end

function common_skin_createSkinData()
    if skinContainerView == nil then
        commonlib_runOnUIThread(function()
            createSkins(false);
        end)
    end
end

function common_skin_clearSkinDataAndDestroySkin()
    if skinContainerView ~= nil then
        commonlib_runOnUIThread(function()
            destroySkins();
        end)
    end
end